#!/usr/local/bin/perl
$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
# !+-------------------------------------------------------------------------
#    Name:  dbamon_check.pl
#
#  Author:  Bill Border
#
#    Note:  
# !*-------------------------------------------------------------------------
# Changes:
#   27Jan05 bb - If the REMOTE_HOST is null, DON'T pass the ? 
#----------------------------------------------------------------------------

$P = "dbamon_magnify_run.pl";
require "cgi_handlers.pl";

# Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

# Read WWW_Check:
chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
if ($font =~ /%/)
{
  $font =~ s/%/ /g;
  $font = "'$font'";
}


# Require the DBI module and the DBD::mysql driver
use DBI;
require "cgi_handlers.pl";

# General parms required
$date          = `date`;
$keyStart      = 1000;

$| = 1;
$readfile      = "/tmp/dbamon_text.txt";

$data_source = "dbi:mysql";
$database = "dbamon";

# See if DBAmon is configured to use Oracle
chop($use_oracle  = `grep Use_Oracle:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc | awk '{ print \$2 }'`);
if ($use_oracle eq "Y" && $ORACLE_SID ne "" && $ORACLE_HOME ne "")
{
  $ENV{'ORACLE_SID'}  = $ORACLE_SID;
  $ENV{'ORACLE_HOME'} = $ORACLE_HOME;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $ORACLE_SID;
  $dbms = "oracle";
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = @_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  print "$date ${P} | $msgmsg\n"; 
}

# Main  

# #
# # Get form data
# #
# &get_request;
# $pw = $rqpairs{'pw'};
# print "pw=$pw \n";

@words = split(/,/,@ARGV[0]);
$verb    = @words[0];
$mode    = @words[1];
$instnum = @words[2];
$ck      = @words[3];
$title   = @words[4];
$dbms    = @words[5];
$action  = @words[6];
$confirm = @words[7];

$dbms = "OracleUX" if $dbms eq "";

if ($dbms eq "oracledbnt")
{
  if (length($verb) > 3)
  {
    $dis = "orantadmin $verb";
  }
  else
  {
    $dis = "orantstat $verb";
  }
}
elsif ($dbms eq "oracledbux")
{
  if (length($verb) > 3)
  {
    $dis = "oraadmin $verb";
  }
  else
  {
    $dis = "orastat $verb";
  }
}
else
{
  $dis = "AutoCmd: $verb";
}

print "Content-type: text/html\n\n
<title>DBAmon One Instance 'Magnify' - $dis</title>
<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>
<table width=700><tr><td><img src='/dbamon/img/dbamonlogo.jpg' width=700>
<tr bgcolor=wheat><td><font face=$font size=5>
    <center><img src='/dbamon/img/dbamon_magnif.gif'> $dbms 'Magnify' - $dis - $title</center>
</table><pre><hr>";

chop($host = `hostname`);
chop($dbamonid = `ls -l /opt/dbamon/adm/dbamonrc | awk '{ print \$3 }'`);
$logfile = "/opt/dbamon/log/dbamon_magnify.log";

if ($ENV{'REMOTE_HOST'}) 
{
  $zclient = $ENV{'REMOTE_HOST'};
}
elsif ($ENV{'REMOTE_ADDR'})
{
  $zclient = $ENV{'REMOTE_ADDR'};
}
else
{
  $zclient = "UnknownClient";
}

chop($date = `date +%Y/%m/%d-%H:%M:%S`);
system("env > /tmp/magnify_env.txt");
##system("echo ' ' | mailx -s '$P.pl ($zclient) $verb' bill_border\@agilent.com");
##system("echo '$date - $P $zclient $verb $title $dbms $action $dis' >> /tmp/dbamon_magnify_run.log");
##system("echo '$date - $P $zclient $verb $title' >> $logfile 2>/dev/null");

if ($ENV{"HTTP_USER_AGENT"} =~ /HP-UX/) { $browser = "NS"; }
else                                    { $browser = "IE"; }

if ($action eq "A" && $confirm ne "YES")
{
  chop($fqhost = `nslookup $host | grep Name: | awk '{ print \$2 }'`);
  print "<script language='JavaScript'>
    input_box = confirm('Are you sure that you want to run $dis on $title?');
    if (input_box==true)
    {
      location = 'http://$fqhost/cgi-bin/$P?$verb,$mode,$instnum,$ck,$title,$dbms,$action,YES';
    }
    else
    {
      history.go(-1);
    }
  </script>\n";
  exit;
}

$cmd = "remsh $host -l $dbamonid '/opt/dbamon/bin/dbamon_www_magnify.pl $verb $mode $instnum $ck $browser $zclient $action $title'";
&msg("Invoking $cmd - client=$zclient");

#print "<pre>\n";
$s_time = time;
$rc = system("$cmd 2>&1");
$e_time = time;
$rc /= 256 if $rc != 0;

$elapsed = $e_time - $s_time;
&msg("dbamon_www_magnify.pl rc=$rc - Execution elapsed time: $elapsed second(s)");

print "</pre><hr><font face=$font color=black>\n";
#Click <b>Back</b> to return to Magnify Menu\n";

if    ($action eq "D") { $goback = "-1"; }
elsif ($action eq "A") { $goback = "-2"; }
print "<script language='JavaScript'>
  function back() { history.go($goback); }
</script>";

#print "<b><a href='javascript:back()'>Click Here</a> to return to the previous page.</b>";

$links_include = `cat /opt/dbamon/lib/trans_links.txt`;
print "<font size=2><b>DBAmon Links:</font></b>
</table>
<table width=750>

 $links_include

</table>
<hr>
";

exit 0;
