#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************
#
# Changes:
#      08Jun02 bb - Added event_limit code
# 1.10 25Oct02 bb - Better diag code.
# 1.11 14Jan04 bb - Recoded to not batch SQL statements
# 1.12 24Jan04 bb - Now, PERLPATH will always contain ../perl.exe
# 1.13 07Mar04 bb - New code to detect rsh service
# 1.14 19Apr04 bb - Fixed pslist code to end on error invoking 
# 1.15 14May04 bb - New NTRESKIT code. Now, try to find it in the default path
# 1.16 13Aug04 bb - New checkTLogs logic.
# 1.17 19Aug04 bb - New code for TLogs to check disk utilization
# 1.18 24Nov04 bb - Line 576 - added sort to the foreach
# 1.19 20Dcc04 bb - Added code to change color of WWW display if agent is down 
# 1.20 29Apr05 bb - New logic to query MSSQL version from db @@version 
# 1.21 11Aug05 bb - For MSSQL version, pad right node if < 4 chars (8.00.761 becomes 8.00.0761)
# 1.22 26Feb07 bb - New doubletake logic 
# 1.23 17Jul07 bb - Added dbatools to srvinfo search logic 
# 1.24 16Oct07 bb - For TEMPDB, we will now skip sp_spaceused and select max refdate
# 1.25 12Dec07 bb - New no_sp_spaceused up parm to skip sp_spaceused 
# 1.26 18Dec07 bb - Gather DB attributes (like snapshot, readonly)
# 1.27 07Jan07 bb - oldPerl - Changed hours threshold from 12 to 24 
# 1.28 16Jan07 bb - Suppress errors from cluster and srvinfo. Also recorded connect
#                     logic and new connectDB subroutine. Also, added isolation level
# 1.29 29Jan07 bb - Implement isolation level change for all servers 
#***************************************************************************
$version = "1.29";

# --------------------------------------------------------------
# Variables
# --------------------------------------------------------------

use Win32::Registry;
use Time::Local;
use DBI;

$userid = Win32::LoginName();

$debug = 1;
$| = 1;
#$# = 2;
$P = "dbamon_mssql.pl";

$event_limit = 100;

$fs = "<font size=2>"; 

$verb = $ARGV[0];
$arg1 = $ARGV[1];
$arg2 = $ARGV[2];
$arg3 = $ARGV[3];
$arg4 = $ARGV[4];

$WWW = 1 if $arg1 eq "WWW";

$system_root = $ENV{"SYSTEMROOT"};
$root_fs = substr($system_root,0,2);
$temp_dir = "$root_fs\\temp\\dbamon";

if (!(-d $temp_dir))
{
  mkdir ("$temp_dir",0777);
}

%values="";
$Register = "System\\CurrentControlset\\Services\\tcpip\\Parameters";
$HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry $Register - $!";
$hkey->GetValues(\%values);
foreach $value (keys(%values))
{
  $RegType      = $values{$value}->[1];
  $RegValue     = $values{$value}->[2];
  $RegKey       = $values{$value}->[0];
  $host = $RegValue if $RegKey eq "Hostname";
}
$hkey->Close();

%values="";
$Register = "System\\CurrentControlset\\Services\\tcpip\\Parameters";
$HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry $Register - $!";
$hkey->GetValues(\%values);
foreach $value (keys(%values))
{
  $RegType      = $values{$value}->[1];
  $RegValue     = $values{$value}->[2];
  $RegKey       = $values{$value}->[0];
  $domain = $RegValue if $RegKey eq "Domain";
  $compwork=$domain;
}
$hkey->Close();

# Save Company name

@words = split(/\./,$compwork);
$nexttolast = $#words - 1;
$company = $words[$nexttolast];

$driver = "DBAmonMSSQL";

# Get registry entries for Perl and MSSQL
%values="";
$Register = "Software\\Perl";
$HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry $Register - $!";
$hkey->GetValues(\%values);
foreach $value (keys(%values))
{
  $RegType      = $values{$value}->[1];
  $RegValue     = $values{$value}->[2];
  $RegKey       = $values{$value}->[0];
  $PERLPATH = $RegValue if $RegKey eq "";
}
$hkey->Close();
#&msg("DEBUG - PERLPATH=$PERLPATH"); 

$path_length = length($PERLPATH);
if (substr($PERLPATH,$pathlength - 1,1) eq "\\")
  {
    chop($PERLPATH)
  }
$PERLPATH = "$PERLPATH\\bin";
if ($PERLPATH !~ /exe$/)
{
  $PERLPATH .= "\\perl.exe";
}

%values="";
$Register = "Software\\Microsoft\\mssqlserver\\setup";
$HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry $Register - $!";
$hkey->GetValues(\%values);
foreach $value (keys(%values))
{
  $RegType      = $values{$value}->[1];
  $RegValue     = $values{$value}->[2];
  $RegKey       = $values{$value}->[0];
  ##print "$RegKey $RegValue \n";
  $SQLPATH = $RegValue if $RegKey eq "SQLPath";
}
$hkey->Close();

$sqlpathfile = "c:\\SQLPATH.txt";
if ($SQLPATH eq "" && -e "$sqlpathfile")
{
  &msg("SQLPATH Being set from file $sqlpathfile"); 
  chop($SQLPATH = `type $sqlpathfile`); 
  &msg("New SQLPATH=$SQLPATH"); 
}

#---- Get MS SQL version
$ver="";
%values="";
$Register = "Software\\Microsoft\\MSSQLServer\\MSSQLServer\\CurrentVersion";
$HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry $Register - $!";
$hkey->GetValues(\%values);
foreach $value (keys(%values))
{
  $RegType      = $values{$value}->[1];
  $RegValue     = $values{$value}->[2];
  $RegKey       = $values{$value}->[0];
  $ver = $RegValue if lc($RegKey) eq "csdversion";
  $ver = $RegValue if lc($RegKey) eq "currentversion" && $ver eq "";
}
$hkey->Close();

#---- See if we can see if this is 64bit mode
$key = "HKEY_LOCAL_MACHINE\\software\\wow6432node\\microsoft\\microsoft sql server\\90\\tools\\setup";
foreach (`reg query \"$key\" `)
{
  #print;
  @words = split;
  if (/64-bit/) { $mssql64bit = 1; }
}
##&msg( "DEBUG mssql64bit=$mssql64bit"); 
   
if (length((split(/\./,$ver)) [2]) == 3)
{
  $ver = (split(/\./,$ver)) [0] . '.' .
         (split(/\./,$ver)) [1] . '.' .
         "0" . (split(/\./,$ver)) [2];
  &msg("DEBUG = Padding right node of version with 0 - ver=$ver"); 
}

$vershort = substr($ver,0,3);
$vershort =~ s/\.//;

if ($ver eq "6.50.0213") { $ver = "${ver}(SP1)";  }
if ($ver eq "6.50.0240") { $ver = "${ver}(SP2)";  }
if ($ver eq "6.50.0258") { $ver = "${ver}(SP3)";  }
if ($ver eq "6.50.0281") { $ver = "${ver}(SP4)";  }
if ($ver eq "6.50.0415") { $ver = "${ver}(SP5)";  } 
if ($ver eq "6.50.0416") { $ver = "${ver}(SP5a)"; }
if ($ver eq "7.00.0699") { $ver = "${ver}(SP1)";  }
if ($ver eq "7.00.0842") { $ver = "${ver}(SP2)";  }
if ($ver eq "7.00.0842") { $ver = "${ver}(SP2)";  }
if ($ver eq "7.00.0961") { $ver = "${ver}(SP3)";  }
if ($ver eq "8.00.0384") { $ver = "${ver}(SP1)";  }
if ($ver eq "8.00.0534") { $ver = "${ver}(SP2)";  }
if ($ver =~ /9.00.2047/) { $ver = "${ver}(SP1)";  }
if ($ver =~ /9.00.3042/) { $ver = "${ver}(SP2)";  }

&msg("Starting - company=$company host=$host verb=$verb arg1=$arg1 arg2=$arg2 arg3=$arg3 arg4=$arg");
&msg("SQLPATH=$SQLPATH PERLPATH=$PERLPATH ver=$ver WWW=$WWW userid=$userid vershort=$vershort mssql64bit=$mssql64bit");

#------------------------------------------------------------------------------
#
# Subroutines
#
#------------------------------------------------------------------------------

#------------------------------------------------------------------------------
sub timeToNum
#------------------------------------------------------------------------------
{
  $zz_text = $_[0];
  $zz_text =~ s/-/\//g;
  $zz_text =~ s/:/\//g;
  ##print "zz_text=$zz_text\n";
  @words = split(/\//,$zz_text);

  if ($#words != 5)
  {
    &error("Input Target_End_Time ($zz_text) should be in the format: YYYY/MM/DD-HH:MM:SS","DOC116");
  }

  $zz_yyyy = $words[0];
  $zz_mon  = $words[1];
  $zz_dd   = $words[2];
  $zz_hh   = $words[3];
  $zz_mm   = $words[4];
  $zz_ss   = $words[5];
  ##print "zz_yyyy=$zz_yyyy zz_mon=$zz_mon zz_dd=$zz_dd zz_hh=$zz_hh zz_mm=$zz_mm zz_ss=$zz_ss\n";

  &error("Input Target_End_Time - YYYY must be 2002-2099","DOC116") if ($zz_yyyy < 2002 || $zz_yyyy > 2099);
  &error("Input Target_End_Time - MON  must be 1-12     ","DOC116") if ($zz_mon  <    1 || $zz_mon  >   12);
  &error("Input Target_End_Time - DD   must be 1-31     ","DOC116") if ($zz_dd   <    1 || $zz_dd   >   31);
  &error("Input Target_End_Time - HH   must be 0-23     ","DOC116") if ($zz_hh   <    0 || $zz_hh   >   23);
  &error("Input Target_End_Time - MM   must be 0-59     ","DOC116") if ($zz_mm   <    0 || $zz_mm   >   59);
  &error("Input Target_End_Time - SS   must be 0-59     ","DOC116") if ($zz_ss   <    0 || $zz_ss   >   59);

  @zz_date=($zz_ss,$zz_mm,$zz_hh,$zz_dd,--$zz_mon,$zz_yyyy);
  $zz_result = &timelocal(@zz_date);

  return $zz_result;
}

#------------------------------------------------------------------------------
sub getDBAttrs
#------------------------------------------------------------------------------
{
  #---- 1.26 START - Gather DB attributes (2005+ only)
  if ($ver >= 9)
  {
    ##&msg("DEBUG: This is an MSSQL 2005+ DB - Checking for DB attributes");
    $sql = "select source_database_id, is_read_only from sys.databases where name = '$dbname';";
    ##&msg("DEBUG: Running sql=$sql");

    $sth = $dbh->prepare("$sql") || &error("Prepare");
    $sth->execute || &error("Execute_Select");
    $db_attrs = ""; 
    while (@Data = $sth->fetchrow_array)
    {
      $source_database_id = $Data[0];
      $is_read_only       = $Data[1];
      &msg("DEBUG: source_database_id=$source_database_id is_read_only=$is_read_only");
    }

    if ($source_database_id > 0) { $db_attrs .= "Snapshot,"; }
    if ($is_read_only == 1)      { $db_attrs .= "Readonly,"; }

    if ($db_attrs)
    {
      chop $db_attrs;    #---- Remove trailing comma
      print "$P DB_ATTRS: $dbname $db_attrs\n"; 
    }
  }
  else
  {
    ##&msg("DEBUG: This is NOT a MSSQL 2005+ DB - Not checking DB attributes");
  }
  #---- 1.26 END
}

#------------------------------------------------------------------------------
sub get_date
#------------------------------------------------------------------------------
{
  # Return date in format supplied as argument. Valid formats are:
  #   Y/M/D-H:M:S
  #   YMD_HMS
  #   YMD
  $format = @_[0];

  @sysdate = localtime;
  for ($i = 0; $i <= 5; $i++)
  {
    if (@sysdate[$i] < 10)
    {
      @sysdate[$i] = 0 . @sysdate[$i];
    }
  }

  if ($format eq "Y/M/D-H:M:S")
  {
    $sysdate = @sysdate[5]+1900 . "/" . ++@sysdate[4] . "/" . @sysdate[3] . "-" . @sysdate[2] . ":" . @sysdate[1] . ":" . @sysdate[0];
  }
  elsif ($format eq "YMD_HMS")
  {
    $sysdate = @sysdate[5]+1900 . ++@sysdate[4] . @sysdate[3] . "_" . @sysdate[2] . @sysdate[1] . @sysdate[0];
  }
  elsif ($format eq "YMD")
  {
    $sysdate = @sysdate[5]+1900 . ++@sysdate[4] . @sysdate[3];
  }
  else
  {
    &error("Invalid format passed to get_date. Must be Y/M/D-H:M:S or YMD_HMS");
  }
  return $sysdate;
}


#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  $date = &get_date("Y/M/D-H:M:S");
  print "$date ${P} $version | $msgmsg\n";
}

#------------------------------------------------------------------------------
sub dbError 
#------------------------------------------------------------------------------
{
   local($errorMsg,@error_fields) = @_;
   print "======== D B   E r r o r   E n c o u n t e r e d =========\n";
   print "Error: DB Error Encountered While: $errorMsg\n";
   print "Error: DB Error String: $DBI::errstr\n";
   print "==========================================================\n";
   $dberror = 1;
   @errors = split ("Database",$DBI::errstr);
   $chk_str = lc(@errors[1]);
   $db      = lc $dbname;
   if ($chk_str =~ " \'$db\' cannot be opened because it is offline")
     {
       $offline = 1;
     }
   &msg("END_OF_PROBE");
   exit 1;
}

#------------------------------------------------------------------------------
sub dbErrorOK 
#------------------------------------------------------------------------------
{
   local($errorMsg,@error_fields) = @_;
   print "======== D B   E r r o r   E n c o u n t e r e d =========\n";
   print "Error: DB Error Encountered While: $errorMsg\n";
   print "Error: DB Error String: $DBI::errstr\n";
   print "==========================================================\n";
   $dberror = 1;
   @errors = split ("Database",$DBI::errstr);
   $chk_str = lc(@errors[1]);
   $db      = lc $dbname;
   if ($chk_str =~ " \'$db\' cannot be opened because it is offline")
     {
       $offline = 1;
     }
}

# ----------------------------------------------------------------------
sub error
# ----------------------------------------------------------------------
{
  $msg = $_[0];
  print "\n";
  print "$P | Fatal Error: $msg\n";
  print "Error: $msg\n";
  &msg("<font color=red><b>ERROR: $msg</b></font>");
  print "$P | Exiting\n";
  &msg("END_OF_PROBE");
  exit 1;
}

# ----------------------------------------------------------------------
sub bkbl
# ----------------------------------------------------------------------
{
  $dbname = $arg1;
  $bktype = $arg2;

  $dbname =~ s/\[HYPHEN\]/\-/g;
  $dbname =~ s/\[BLANK\]//g;
  
  if ($dbname eq "ALL")
  {
    if (-e "$SQLPATH\\dba_bkup_log\\ALL.txt")
    {
      $logpath = "$SQLPATH\\dba_bkup_log\\ALL.txt";
    }
    else
    {
      &msg("Looking for ALL.log in alternate location");
      $logpath = "\\temp\\ALL.txt";
    }
  }
  else
  {
    $logpath = "$SQLPATH\\dba_bkup_log\\${dbname}_${bktype}_backlog.txt";
  }

  &msg("bkbl1() - dbname=$dbname bktype=$bktype logpath=$logpath");

  if (! -e $logpath)
  {
    &error("Log file $logpath does not exist");
  }

  print "<table bgcolor=skyblue>
  <tr><td><pre>
<b>Start of mssql_backup Log: $logpath</b><hr>";

# - added by Scott.  I added the \" around the $logpath variable to accept spaces
# - in the file name and/or path.
  system("type \"$logpath\" 2>&1");

  print "<hr>
<b>End of mssql_backup Log: $logpath</b></table>\n"; }

# ----------------------------------------------------------------------
sub checklog
# ----------------------------------------------------------------------
{
  # Vars
  $tsfile = "$temp_dir\\dbamon_mssql_ts.txt";
  $events = 0;

  # For now I will hardcode the min severity that we will report
  $minsev = 17;
  &msg("I will be looking for minsev=$minsev");

  &msg("Reading ts file $tsfile");
  system("dir $tsfile");
  system("type $tsfile");

  # Read TS file
  open(TS, "$tsfile") || print "$P | Can't open input $tsfile - $!\n";;
  while (<TS>)
  {
    @words = split;
    $tsdate = $words[0];
    $tstime = $words[1];
  }
  &msg("Input timestamps - tsdate=$tsdate tstime=$tstime");
  close(TS);

  #---- diagnostics for wbbntm03 problem
  if (-e "$tsfile" && $tsdate ne "" && $tsdate !~ /^20/)
  {
    system("$PERLPATH C:\\dbatools\\socketmail.pl dbaadmin\@dba.it.agilent.com dbaadmin\@dba.it.agilent.com \"dbamon_mssql.pl TSDATE INvalid (tsdata=$tsdate)\" \@$tsfile");
  }
   
  # use strict;
  use DBI;

  # Attempt to connect to the master database on the server, to verify MSSQL availability.
  ##&msg("Connecting to MSSQL - driver=driver");
  ##$dbh = DBI->connect("DBI:ODBC:$driver",'guest','' ) || &dbError("Connect_To_DB");
  &connectDB;

  if (!$dberror)
  {
    # Get info for this DB

    &msg("Invoking master:xp_readerrorlog");

    $dbh->do("use master")                       || &dbError("Use_Master_1");
    $sth = $dbh->prepare("exec xp_readerrorlog") || &dbError("Prepare");
    $sth->execute                                || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      @words = split ' ', $Data[0];

      $rdate = $words[0];
      $rtime = $words[1];
      $rpid  = $words[2];
      $verb  = $words[3];

      if ($rdate =~ /^20/)
      {
        $save_rdate = $rdate;
        $save_rtime = $rtime;
      }

      if ($firstflag != 1)
      {
        &msg("First Date/Time $rdate/$rtime");
        $firstflag = 1;
      }

      ##print "DIAG verb=$verb rdate=$rdate rtime=$rtime flag2nd=$flag2nd [$Data[0]] \n";

      if ($flag2nd)
      {
        $errmsg = substr($Data[0],32);
        if ($errsev >= $minsev)
        {
          ++$events;
          print "DIAG events=$events\n";

          #---- Events that we don't want to report
          next if $errnum eq "17805";

          #---- Report this event 
          print "\n";
          print "=========================================================================\n";
          print "Event: $rdate $rtime $errnum $errsev $errsta $errmsg\n";
          print "=========================================================================\n";
          print "\n";
        }
        $flag2nd = 0;
        next; 
      }
      if ($verb eq 'Error:' && $rdate ge $tsdate && $rtime gt $tstime)
      {
        print "DIAG verb=$verb rdate=$rdate rtime=$rtime flag2nd=$flag2nd [$Data[0]] \n";

        if ($events > $event_limit)
        {
          print "$P | Event count of $events exceeds limit of $event_limit - will not process an more events\n";
          last;
        }

        $errnum = $words[4]; 
        chop($errnum);
        $errsev = $words[6];
        chop($errsev);
        $errsta = $words[8];
        chop($errsta);
        $flag2nd = 1; # We want to read the next line
      }
    }  # End of fetch while

    &msg("Last  Date/Time $rdate/$rtime");

    &msg("Found $events new events");

    # Save the last timestamp that we checked
    &msg("Saving timestamps: $save_rdate $save_rtime to $tsfile");
    open(TS, "> $tsfile")    || die "Error: Can't open output file: $tsfile\n";
    print TS "$save_rdate $save_rtime\n";
    close(TS);
  }
}

# ----------------------------------------------------------------------
sub checkTLog
# ----------------------------------------------------------------------
{
  &msg("Checking transaction logs for all databases");

  if ($WWW)
  {
    print "<br>\n";
    &msg("Transaction Log Status:");
    print "<br><table border=1 bgcolor=skyblue>\n";
    print "<tr bgcolor=slate>
      <th><h5>Database<br>(One Row Per TLOG)
      <th><h5>TLog Size<br>(mB)
      <th><h5>TLog<br>Percent<br>Full<br>Internal
      <th><h5>TLog<br>Percent<br>Full<br>vs. Max
      <th><h5>Is DB In<br>Trunc-Log-<br>On-Ckpt<br>Mode?
      <th><h5>TLog<br>Max<br>Size
      <th><h5>TLog<br>Path
      <th><h5>TLog<br>Drive
      <th><h5>TLog<br>Drive<br>Size<br>(Mb)
      <th><h5>TLog<br>Drive<br>Free<br>(Mb)
      <th><h5>TLog<br>Drive<br>Used<br>(Mb)
      <th><h5>TLog<br>Drive<br>Percent<br>Full
    \n";
  }

  $sql = "exec ('DBCC SQLPERF (LOGSPACE)')";

  $dbh->do("use master") || &dbError("Use_Master");
  $sth3 = $dbh->prepare($sql) || &error("Could not prepare sql=$sql");
  $sth3->execute() || &error("Could not execute sql=$sql");
  while (@Data = $sth3->fetchrow_array)
  {
    $selectcount++;

    $ctl_dbname  = $Data[0];
    $ctl_size{"$ctl_dbname"}    = sprintf("%.2f",$Data[1]);
    $ctl_pctused{"$ctl_dbname"} = sprintf("%.2f",$Data[2]);
  }
  $sth3->finish() || &dbError("Could not execute FINISH");

  @sorted = sort keys %ctl_size;
  foreach (@sorted)
  {
    $dbname = $_;   
    $size    = $ctl_size{"$dbname"};
    $pctused = $ctl_pctused{"$dbname"};

    &dbProperties($dbname);

    $dbp_rawdata = "";
    &dbProperties2($dbname);
    foreach (split('\n',$dbp_rawdata))
    {
      @words = split;

      ##$dbp_rawdata .= "$dbp_log_fname $dbp_log_space $dbp_log_fsize\n";

      $dbp_log_fname = $words[0];
      $dbp_log_space = $words[1];
      $dbp_log_fsize = $words[2];

      #---- Start
      if ($dbp_trunc_on_ckpt == 1)
      {
	$trunc = "Yes";
      }
      else
      {
	$trunc = "No";
      }

      #---- See how full the TLog disk is
      $this_drive_letter = uc substr($dbp_log_fname,0,1);
      $this_drive_size   = (split(" ",$disks{"$this_drive_letter"})) [2];
      $this_drive_free   = (split(" ",$disks{"$this_drive_letter"})) [3];
      $this_drive_used   = (split(" ",$disks{"$this_drive_letter"})) [4];
      $this_drive_pctused = sprintf("%.2f",($this_drive_used / $this_drive_size) * 100) if $this_drive_size > 0;

      if ($WWW)
      {
	if    ($trunc eq "Yes") { $color = "skyblue"; }
	elsif ($pctused >= 90 || $this_drive_pctused >= 90)  { $color = "pink"; }
	elsif ($pctused >= 80 || $this_drive_pctused >= 80)  { $color = "yellow"; }
	else                    { $color = "lime"; }

        if ($dbp_log_space ne "Unlimited")
        {
          $pctused_vs_max = sprintf "%.2f", ($dbp_log_fsize / $dbp_log_space) * 100;
	  if    ($pctused_vs_max >= 99) { $color = "pink"; }
	  elsif ($pctused_vs_max >= 95) { $color = "yellow"; }
        }
        else
        {
          $pctused_vs_max = "N/A";
        }
	
	print "<tr bgcolor=$color>
	  <td><h5> $dbname
	  <td align=right><h5> $dbp_log_fsize
	  <td align=right><h5> ${pctused}%
	  <td align=right><h5> ${pctused_vs_max}%
	  <td><h5> $trunc
	  <td><h5> $dbp_log_space
	  <td><h5> $dbp_log_fname
	  <td><h5> $this_drive_letter
	  <td align=right><h5> $this_drive_size
	  <td align=right><h5> $this_drive_free
	  <td align=right><h5> $this_drive_used
	  <td align=right><h5> ${this_drive_pctused}%
	\n";
      }
      else
      {
        $this_drive_pctused = "." if $this_drive_pctused eq ""; 
	print "$P TLOG: $dbname $trunc $dbp_log_fsize $pctused $this_drive_letter $this_drive_pctused $dbp_log_fname $dbp_log_space\n";
      } 

      #---- End
    }
  }

  if ($WWW)
  {
    print "</table><br>\n";
  }

  &msg("Found $selectcount databases");

  if ($WWW)
  {
    print "<br>\n";
    &msg("Drives Which Contain MSSQL Data Files:");
    print "<br><table border=1 bgcolor=skyblue>\n";
    print "<tr bgcolor=slate>
	<th><h5>Drive 
	<th><h5>Size (mB)
	<th><h5>Used (mB)
	<th><h5>Free (mB)
	<th><h5>Percent<br>Full
    ";

  }

  #---- TEST
  foreach (sort @db_drivelist)
  {
    $this_drive = $_;
    if ($_ ne $last)
    {
      $this_drive_size   = (split(" ",$disks{"$this_drive"})) [2];
      $this_drive_free   = (split(" ",$disks{"$this_drive"})) [3];
      $this_drive_used   = (split(" ",$disks{"$this_drive"})) [4];
      $this_drive_pctused = sprintf("%.2f",($this_drive_used / $this_drive_size) * 100) if $this_drive_size > 0;

      if    ($this_drive_pctused >= 99) { $color = "pink"; }
      elsif ($this_drive_pctused >= 95) { $color = "yellow"; }
      else                              { $color = "lime"; }

      if ($WWW)
      {
	print "<tr bgcolor=$color>
	    <td><h5> $this_drive
	    <td align=right><h5> $this_drive_size
	    <td align=right><h5> $this_drive_used
	    <td align=right><h5> $this_drive_free
	    <td align=right><h5> ${this_drive_pctused}%
	";
      }
      else
      {
	print "$P DRIVESTATUS: $this_drive $this_drive_size $this_drive_used $this_drive_free $this_drive_pctused \n";
      }
    }
    $last = $_;
  }

  if ($WWW)
  {
    print "</table><br>\n";

    &msg("WWWTEST");
    &test;
  }

  return 0;
}

# ----------------------------------------------------------------------
sub dbProperties2
# ----------------------------------------------------------------------
{
   my $dbname = $_[0];

   #&msg("dbProperties2 - executing sp_helpdb \@dbname='$dbname'"); 

   $sth = $dbh->prepare("exec sp_helpdb \@dbname='$dbname'") || &dbError("Prepare");
   $sth->execute || &dbErrorOK("sp_helpdb db=$dbname");

   $dbp_log_space = "";

   do
   {
     ##print "BEFORE WHILE\n";
     while(@Data = $sth->fetchrow_array)
     {
       #$i = -1;
       #foreach (@Data)
       #{
       #  $i++;
       #  $z = $_;
       #  print "Data[$i]=$z\n"; 
       #}
       
       if ($Data[7] eq "log only") 
       { 
         $dbp_log_fname = $Data[2]; 
         $dbp_log_fsize = $Data[4]; 
         $dbp_log_space = $Data[5]; 

	 $dbp_log_fname =~ s/ //g;
	 $dbp_log_fsize =~ s/ //g;
	 $dbp_log_space =~ s/ //g;

	 if ($dbp_log_space =~ /KB$/)
	 {
	   chop $dbp_log_space;
	   chop $dbp_log_space;
	   $dbp_log_space = sprintf "%.2f", ($dbp_log_space * 1000) / 1000000;
	 }
	 if ($dbp_log_fsize =~ /KB$/)
	 {
	   chop $dbp_log_fsize;
	   chop $dbp_log_fsize;
	   $dbp_log_fsize = sprintf "%.2f", ($dbp_log_fsize * 1000) / 1000000;
	 }

         $dbp_rawdata .= "$dbp_log_fname $dbp_log_space $dbp_log_fsize\n";

         ##print "<tr bgcolor=white><td colspan=99>dbp_log_fname=$dbp_log_fname dbp_log_space=$dbp_log_space dbp_log_fsize=$dbp_log_fsize\n";
       }
     }
   } 
   while($sth->{odbc_more_results} && $dbp_log_space eq "");

   $sth->finish || &dbErrorOK("Finish1");

   return;
}


# ----------------------------------------------------------------------
sub dbFiles
# ----------------------------------------------------------------------
{
   my $dbname = $_[0];

   $sth = $dbh->prepare("exec sp_helpdb \@dbname='$dbname'") || &dbError("Prepare");
   $sth->execute || &dbErrorOK("execute helpdb db=$dbname");

   my $db_filelist = "";

   do
   {
     while(@Data = $sth->fetchrow_array)
     {
       #$i = -1;
       #foreach (@Data)
       #{
       #  $i++;
       #  $z = $_;
       #  print "Data[$i]=$z\n"; 
       #}
       
       if ($Data[7] eq "data only") 
       { 
         $db_filelist .= " $Data[2]"; 
         my $db_filesize =  $Data[4]; 

	 my $db_filedrive = substr($Data[2],0,1);
         push(@db_drivelist,uc $db_filedrive);
       }
     }
   } 
   while($sth->{odbc_more_results});
   $sth->finish || &dbErrorOK("Finish1");
   return $db_filelist;
}


# ----------------------------------------------------------------------
sub dbProperties
# ----------------------------------------------------------------------
{
   my $dbname = $_[0];

   $dbp_trunc_on_ckpt = -999;

   ##&msg("  Checking logging option for: $dbname...");

   my $sth4 = $dbh->prepare(<<End_SQL) or die "COULD NOT PREPARE SQL";
   select databaseproperty('$dbname','IsTruncLog') as log_option
End_SQL
   $sth4->execute() || &dbError("COULD NOT EXECUTE SQL STATEMENT");

   while (($log_option) = $sth4->fetchrow_array() )
   {
      $dbp_trunc_on_ckpt = $log_option;
   }
   $sth4->finish() || &dbError("COULD NOT EXECUTE SQL STATEMENT");

   return;
}

# ----------------------------------------------------------------------
sub up
# ----------------------------------------------------------------------
{
  #---- Test START
  ## $arg2 = "no_sp_spaceused" if $host eq "wcosdba2"; 
  #---- Test END
  
  #---- See if this file exists (this logic is for the lightbulb)
  $sp_file = "C:\\temp\\DBAmon_no_sp_spaceused.txt";
  $sp_hours = 24;
  if (-e "$sp_file")
  {
    system("dir $sp_file"); 
    $sp_file_mtime = ( stat $sp_file )[9];
    $sp_file_age_hrs = (time - $sp_file_mtime) / 3600;
    &msg("up() sp_file=$spfile Does exist - sp_file_age_hrs=$sp_file_age_hrs sp_file_mtime=$sp_file_mtime"); 
    if ($sp_file_age_hrs <= $sp_hours)
    {
      $arg2 = "no_sp_spaceused"; 
      &msg("  Since sp_file has been updated within the last $sp_hours hours, I will set arg2=$arg2"); 
    }
    else
    {
      &msg("  Since sp_file has NOT been updated within the last $sp_hours hours, no action taken"); 
    }
  }

  &msg("up() Checking DB up and collecting space data - arg1=$arg1 arg2=$arg2"); 

  $numcpus = $ENV{"NUMBER_OF_PROCESSORS"};

  %values="";
  $Register = "Hardware\\Description\\System\\CentralProcessor\\0";
  $HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry $Register - $!";
  $hkey->GetValues(\%values);
  foreach $value (keys(%values))
  {
    $RegType      = $values{$value}->[1];
    $RegValue     = $values{$value}->[2];
    $RegKey       = $values{$value}->[0];
    $MHz = $RegValue if $RegKey eq "\~MHz";
    $vendor = $RegValue if $RegKey eq "VendorIdentifier";
    $identifier = $RegValue if $RegKey eq "Identifier";
  }
  $hkey->Close();
  @cpu_ident = split (' ',$identifier); 
  $cpumodel = ${cpu_ident[0]} . "/" . ${cpu_ident[2]};
  $cpu = $vendor . " " . " " . $MHz . " MHz ";
 

  %values="";
  $Register = "Software\\Microsoft\\Windows NT\\CurrentVersion";
  $HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry $Register - $!";
  $hkey->GetValues(\%values);
  foreach $value (keys(%values))
  {
    $RegType      = $values{$value}->[1];
    $RegValue     = $values{$value}->[2];
    $RegKey       = $values{$value}->[0];
    $CurrentVersion = $RegValue if $RegKey eq "CurrentVersion";
    $CSDVersion = $RegValue if $RegKey eq "CSDVersion";
  }

  if ($CSDVersion ne "")
  {
    @sp_info = split(' ',$CSDVersion);
    $osver = $CurrentVersion . ",SP" . ${sp_info[2]};
  }
  else
  {
    $osver = $CurrentVersion;
  }

  $rsh_service = "?";

  # See if the MSSQLServer is running
  open(NET, 'net start|') || print "Error: Running net start";
  while(<NET>)
  {
    ##print;

    if ($rsh_service eq "?")
    {
      if (/Remote Shell Daemon/)  { $rsh_service="RSD"; }
      if (/Remote Shell Service/) { $rsh_service="RSS"; }
      if (/CYGWIN sshd/)          { $rsh_service="CYGWIN"; }
    }

    @words = split;
    if (lc($words[0]) eq "mssqlserver") { $servicestat="[Running]"; }
    if (/SQL Server \(/)                 { $servicestat="[Running]"; }
  }
  close(NET);

  #---- Get MSSQL license key 
  $mssql_regkey = "?"; 
  if    ($vershort == 80) { $swver_regkey = "Software\\Microsoft\\Microsoft SQL Server\\80\\Registration"; }
  elsif ($vershort == 70) { $swver_regkey = "Software\\Microsoft\\Microsoft SQL Server 7.0\\7.00.000\\Product ID"; }
  ##elsif ($vershort == 90) { $swver_regkey = "Software\\Microsoft\\Microsoft SQL Server 7.0\\7.00.000\\Product ID"; }
  
  if ($swver_regkey)
  {
    %values="";
    $Register = "Software\\Microsoft\\Microsoft SQL Server\\$vershort\\Registration";
    &msg("Looking for LK - swver_regkey=$swver_regkey"); 
    $HKEY_LOCAL_MACHINE->Open($swver_regkey,$hkey) || print "Uh-Oh1\n"; 
    if ($hkey)
    {
      $hkey->GetValues(\%values) || print "Uh-Oh\n";
      foreach $value (keys(%values))
      {
	$RegKey        = $values{$value}->[0];
	$RegType       = $values{$value}->[1];
	$RegValue      = $values{$value}->[2];
	##print "DEBUG RegKey=$RegKey RegValue=$RegValue\n"; 
	$mssql_regkey  = $RegValue if $RegKey eq "CD_KEY";
      }
      $hkey->Close();
    }
  }
  print "MSSQLSWKEY: $mssql_regkey\n";

  if ($servicestat eq "")
  {
    $servicestat="[Not Running]";
  } 

  if (!$WWW)
  {
    print "OSVer: $osver\n";
    print "SQLVer: $ver\n";

    print "MSSQLServiceStatus: $servicestat\n";
    print "NumCPUs: $numcpus\n";
    print "CPU: $cpu\n";
    print "CPUModel: $cpumodel\n";
    print "HOSTNAME: $host\n";
    print "RSHService: $rsh_service\n";
  }
   
  ##use DBI;
  ##$dbh = DBI->connect("DBI:ODBC:$driver",'guest','' ) || &dbError("Connect_To_DB");
  &connectDB;

  # Get memory Info
  $dbh->do("use master")                || &dbError("Use_Master");
  $mem = $dbh->prepare("exec xp_msver") || &dbError("Prepare");
  $mem->execute                         || &dbError("Execute_Select");

  while (($index_val,$name,$internal_val,$char_val) = $mem->fetchrow_array() )
  {
     if (lc($name) eq "physicalmemory")
     {
        $ram = $internal_val;
        last;
     }
  }

  if (defined($ram) && !$WWW)
  {
     print "RAM: $ram MB\n";
  }

  # See if the agent is running
  &msg("Running 'net start' to see if the Agent is running");
  open(NET, 'net start|') 
    || print "Error: Running net start";
  while(<NET>)
  {
    print if / SQL/;
    ## print;
    @words = split;
    if (/SQL Server Agent/)
    {
      $agentrunning = 1;
      last;
    }
    if (lc($words[0]) eq "sqlserveragent")
    {
      $agentrunning = 1;
      last;
    }
    if (lc($words[0]) eq "sqlexecutive")
    {
      $agentrunning = 1;
      last;
    }
  }
  close(NET);

  # Attempt to connect to the master database on the server, to verify MSSQL availability.
  ##&msg("Connecting to MSSQL - driver=$driver");
  ##$dbh = DBI->connect("DBI:ODBC:$driver",'guest','' ) || &dbError("Connect_To_DB");
  &connectDB;

  if (!$dberror)
  {
    &msg("Checking database=master");
    $dbh->do("use master") || &dbError("Use_Master");

    # Read from master
    $sql = "select name from sysdatabases order by 1; ";
    $sth = $dbh->prepare("$sql") || &dbError("Prepare");
    $sth->execute                || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      $dbname = $Data[0];
      push(@dblist,$dbname);
      ++$numdbs;
    }

    &msg("DEBUG - selecting current_user"); 
    # Get session userid
    $sql = "select current_user; ";
    $sth = $dbh->prepare("$sql") 
      || &dbError("Prepare");
    $sth->execute
      || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      $user = $Data[0];
    }
    ##print "Current_User: $user\n";

    # Process DB names
    foreach $dbname (@dblist)
    {
      $dbname_out = lc $dbname;
      $dbname_out =~ s/ /[BLANK]/g;
      $dbname_out =~ s/\-/[HYPHEN]/g;

      # Get info for this DB   
      &getDBAttrs;

      $sth->finish()        || &dbError("Finish");
      $dbh->do("use \"$dbname\"")        || &dbError("Use_$dbname");
      # Query space 

      ##&msg("DEBUG - Running exec sp_helpdb \@dbname='$dbname'"); 

      $sth = $dbh->prepare("exec sp_helpdb \@dbname='$dbname'") || &dbError("Prepare");
      $sth->execute || &dbErrorOK("sp_helpdb db=$dbname");

      $db_status = "";
      $db_created = "";
      $db_owner = "";

      while (@Data = $sth->fetchrow_array)
      {
        $db_owner   = $Data[2];
        $db_created = $Data[4];
        $db_status  = $Data[5];
        ##print "dbname=$dbname db_owner=$db_owner db_status=$db_status db_created=$db_created\n";   # Test
      }

      $db_spacealloc = "?";
      $db_spacefree  = "?";
      $db_spaceused  = "?";

      if ($arg2 eq "no_sp_spaceused")
      {
        &msg("Skipping sp_spaceused for dbname=$dbname since Probe_Parm: = no_sp_spaceused"); 
        $sp_file = "C:\\temp\\DBAmon_no_sp_spaceused.txt";
        &msg("Touching file $sp_file for other utilities"); 
        system("echo x > $sp_file"); 
      }
      elsif ($dbname eq "tempdb")
      {
        &msg("Skipping sp_spaceused for tempdb (hostname/DB $host/$dbname)"); 
      }
      else
      {
	&msg("Running exec sp_spaceused for dbname='$dbname'"); 
	$sth = $dbh->prepare("exec sp_spaceused") || &dbError("Prepare");
	$dberror = 0;
	$sth->execute || &dbErrorOK("sp_spaceused db=$dbname");
	if ($dberror)
	{
	  ++$numdbsoffline;
	  print "DB:     $dbname_out CONNECTERROR \n";
	  next;
	}
	while (@Data = $sth->fetchrow_array)
	{
	  ##print "Data0=$Data[0]\n";   # Test
	  ##@words = split ' ', $Data[0];
	  ##$verb = $words[0];
	  ##if ($verb eq $dbname)
	  if (uc $Data[0] eq uc $dbname)
	  {
	    $db_spacealloc = $Data[1];
	    chop $db_spacealloc ; chop $db_spacealloc ;chop $db_spacealloc ;
	    $db_spacefree  = $Data[2];
	    chop $db_spacefree ; chop $db_spacefree ;chop $db_spacefree ;
	    $db_spaceused  = $db_spacealloc - $db_spacefree;
	  }
	}
        $db_spacealloc = sprintf("%.2f", $db_spacealloc);
        $db_spaceused  = sprintf("%.2f", $db_spaceused );
      }

      $db      = lc $dbname;

      #---- Check last-accessed date
      $db_lastrefdate = "?"; 
      if ($dbname eq "tempdb")
      {
        &msg("Skipping select max refdate for tempdb (hostname/DB $host/$dbname)"); 
      }
      else
      {
	&msg("  Running 'select max(refdate) from sysobjects (nolock)' for dbname='$dbname'"); 
	$sth = $dbh->prepare("select max(refdate) from sysobjects (nolock)") || &dbError("Prepare");
	$sth->execute || &dbErrorOK("select sysobjects to db=$dbname");
	$db_lastrefdate = "?";
	while (@Data = $sth->fetchrow_array)
	{
	  $db_lastrefdate = $Data[0]; 
	}
      }

      print "DB:     $dbname_out $db_spacealloc $db_spaceused $db_lastrefdate\n" if !$WWW;

      $dbfilelist = &dbFiles($dbname);

      push @www_dbs,"<td><h5>$dbname_out
                     <td align=right><h5> $db_spacealloc</td>
                     <td align=right><h5> $db_spaceused</td>
                     <td nowrap><h5> $db_created</td>
                     <td nowrap><h5> $db_lastrefdate</td>
                     <td nowrap><h5> $db_owner</td>
                     <td nowrap><h5> $dbfilelist</td>
                     <td nowrap><h5> $db_status</td>
      ";

      $tot_spacealloc += $db_spacealloc if $db_spacealloc ne "?";
      $tot_spaceused  += $db_spaceused  if $db_spaceused  ne "?";
    }

    if (!$WWW)
    {
      print "NUMDBs: $numdbs\n";
      print "SpaceAlloc: $tot_spacealloc\n";
      print "SpaceUsed: $tot_spaceused\n";
    }
 
  }

  # Decide status
  if ($numdbs > 0) 
  {
    $num_up = $numdbs - $numdbsoffline;
    print "DBStatus: UP \($num_up\)" if !$WWW;
    if ($offline)
     {
       print "; DOWN \($numdbsoffline\)" if !$WWW;
     }
    print "\n" if !$WWW;
  }
  else
  {
    print "DBStatus: DOWN\n if !$WWW";
  }

  if ($agentrunning) 
  {
    print "AgentStatus: UP\n" if !$WWW;
    $www_agent_status = "Up";
  }
  else
  {
    print "AgentStatus: DOWN\n" if !$WWW;
    $www_agent_status = "Down";
  }

  #---- Old way
  ##if ($ENV{"NTRESKIT"}) { $srvinfo_cmd = '%NTRESKIT%\srvinfo -ns'; }
  ##else                  { $srvinfo_cmd = 'srvinfo -ns'; }
  ##&msg("Running srvinfo - srvinfo_cmd=$srvinfo_cmd");

  #---- New way
  #---- See if srvinfo is in the system path
  #if (-e "C:\\dbatools\\srvinfo_dbamon.exe") 
  #{
  #  $srvinfo_cmd = "C:\\dbatools\\srvinfo_dbamon.exe";
  #}
  if (system("srvinfo -ns >NUL") == 0)
  {
    $srvinfo_cmd = "srvinfo -ns";
  }
  elsif ($ENV{'NTRESKIT'})
  {
    $srvinfo_cmd = "$ENV{'NTRESKIT'}\\srvinfo -ns";
  }
  else
  {
    &msg("Hmmmm... Could not find srvinfo in default path and NTRESKIT not in env");
  }

  &msg("Running srvinfo - srvinfo_cmd=$srvinfo_cmd (x)");

  open(SRVINFO, "$srvinfo_cmd 2>&1 |") || print "Error: Running srvinfo";
  $uptime = "?";
  while(<SRVINFO>)
  {
    ##print;
    @words = split;

    $os64bit = 1 if /EM64/;

    if (/^System Up Time:/)
    {
      chop($uptime = substr($_,16));
    }

    #---- 1.17 - Save this for later
    #if ($#words == 4 && ($words[1] eq "FAT" || $words[1] eq "NTFS"))
    if (length($words[0]) == 2 && ($words[1] eq "FAT" || $words[1] eq "NTFS"))
    {
      $drive = substr($words[0],0,1);
      $disks{"$drive"} = $_;
    }
  }
  &msg("Ran srvinfo to capture uptime - uptime=$uptime");

  #&msg("Disk info:");
  #foreach $disk (sort keys %disks)
  #{
  #  &msg("  Disk: $disk"); 
  #}

  #---- Systeminfo START - gather MEM usage info
  if ($osver >= 5.2 && $host =~ /wcosplm/)
  {
    &msg("DEBUG - Running systeminfo to gather memory usage information"); 
    open(SYSINFO, "systeminfo 2>&1 |") || &msg("Error: Running systeminfo - $!");
    while(<SYSINFO>)
    {
      ##print;
      @words = split;
      if (/^Available Physical Memory:/)
      {
        $mem_avail_raw = $words[$#words - 1] . $words[$#words];
        $mem_avail = $words[$#words - 1] if $words[$#words] eq "MB";
        $mem_avail =~ s/\,//g;
      } 
    }
    close(SYSINFO); 
    if ($ram > 0 && $mem_avail ne "")
    {
      $mem_used = $ram - $mem_avail;
      $mem_pct  = sprintf("%.2f",($mem_used / $ram) * 100); 
    }
    
    &msg("DEBUG - mem_avail=$mem_avail mem_avail_raw=$mem_avail_raw ram=$ram mem_used=$mem_used mem_pct=$mem_pct"); 
    if ($mem_avail_raw ne "")
    {
      open(MEM, ">>c:\\temp\\MemAvail.txt") || &msg("Error: Cannot open output file: MemAvail.txt - $!");
      print MEM "$date $mem_avail_raw\n";
      close(MEM);
    }
  }
  #---- Systeminfo END - gather MEM usage info

  #---- Cluster status - START
  $cluster_name = "";
  open(CLUSTERV, "cluster /ver 2>&1 |"); 
  while(<CLUSTERV>)
  {
    ##print;
    #Cluster Name:     LSCASQLC
    @words = split;
    $cluster_name = $words[2] if (/^Cluster Name:/)
  }
  close(CLUSTERV); 
  &msg("cluster /ver Shows cluster_name=$cluster_name"); 
  if ($cluster_name ne "") 
  {
    &msg("Querying cluster status - $cluster_name"); 
    open(CLUSTER, "cluster /cluster:$cluster_name res |") || print "Error: Running srvinfo";
    $cluster_status = "";
    while(<CLUSTER>)
    {
      ##print;
      @words = split;
      if (/^SQL Server  /)
      {
        $cluster_status = $words[$#words - 0];
        $cluster_node   = $words[$#words - 1];
        if ($cluster_status ne "Online")
        {
          $cluster_thisnodestatus   = "Offline"; 
        }
        else
        {
	  if ($cluster_node eq uc $host) { $cluster_thisnodestatus   = "Active"; }
	  else                           { $cluster_thisnodestatus   = "Passive"; }
    
        }
        ##&msg("  cs=$cluster_status cn=$cluster_node"); 
        ##print;
      }
    }
    close(CLUSTER); 

    print "$P CLUSTERNAME: $cluster_name\n"; 
    print "$P CLUSTERSTATUS: $cluster_status\n"; 
    print "$P CLUSTERONNODE: $cluster_node\n"; 
    print "$P CLUSTERTHISNODESTATUS: $cluster_thisnodestatus\n"; 
  }
  #---- Cluster status - END

  &msg("Querying MSSQL for MSSQL software version");
  $sth->finish()        || &dbError("Finish2");
  $sth = $dbh->do("use master") || &dbError("Use_Master");
  $sql = "select \@\@version; ";
  $sth = $dbh->prepare("$sql") || &dbError("Prepare");
  $sth->execute || &dbError("Execute_Select");
  while (@Data = $sth->fetchrow_array)
  {
    $mssql_version_raw  = $Data[0];
    $mssql_version_from_db = (split(/ /,$mssql_version_raw))[6];
    if (length((split(/\./,$mssql_version_from_db)) [2]) == 3)
    {
      $mssql_version_from_db =
             (split(/\./,$mssql_version_from_db)) [0] . '.' .
	     (split(/\./,$mssql_version_from_db)) [1] . '.' .
	     "0" . (split(/\./,$mssql_version_from_db)) [2];
      &msg("DEBUG = Padding right node of version with 0 - mssql_version_from_db=$mssql_version_from_db"); 
    }
  }
  $sth->finish || &dbError("Execute_Finish");
  &msg("DEBUG ver=$ver mssql_version_from_db=$mssql_version_from_db");

  if ($mssql_version_from_db gt $ver && $mssql_version_from_db)
  {
    &msg("Overriding MSSQL version from db since it is higher - mssql_version_from_db=$mssql_version_from_db");
    $ver = $mssql_version_from_db; 
    print "SQLVer: $ver\n" if ! $WWW;
  }

  &msg("Querying MSSQL startup time");
  $sth->finish()        || &dbError("Finish2");
  $sth = $dbh->do("use master") || &dbError("Use_Master");
  $sql = "select 
      login_time,
      datediff(hour,login_time, getdate()) as hours_since
    from  
      sysprocesses where status = 'background' order by spid; ";
  $sth = $dbh->prepare("$sql") || &dbError("Prepare");
  $sth->execute || &dbError("Execute_Select");
  while (@Data = $sth->fetchrow_array)
  {
    $mssql_started  = $Data[0];
    $mssql_hours_up = $Data[1];
    last;
  }
  $sth->finish || &dbError("Execute_Finish");
  &msg("mssql_started=$mssql_started mssql_hours_up=$mssql_hours_up");

  $mssql_started_fix = substr($mssql_started,0,19);
  $mssql_started_fix =~ s/\-/\//g;
  $mssql_started_fix =~ s/ /-/g;
  if ($mssql_started_fix =~ /^1900/)
  {
    $mssql_started_fix =~ s/^1900/2002/;
  }

  &msg("mssql_started_fix=$mssql_started_fix");

  $str_c = $mssql_started_fix;
  if ($str_c)
  {
    $str_n = &timeToNum($str_c);
    $endc = $str_c;
    $calc_date = $date;
    $calc_time = time;

    if (! $WWW)
    {
      print "$P UPTIME:          $str_c $str_n $calc_date $calc_time\n";
      print "$P MSSQL64BIT: 1 \n" if $mssql64bit;
      print "$P OS64BIT: 1 \n"    if $os64bit;
    }
  }

  if ($WWW)
  {
    $www_bgcolor = "pink";
    $www_bgcolor = "lime" if $numdbs > 0;

    #---- Exceptions
    $www_bgcolor = "pink" if $www_agent_status ne "Up";

    $www_status = "Down";
    $www_status = "Up" if $numdbs > 0;

    $daysup = $hoursup / 24;
    $daysup = sprintf("%.2f", $daysup);

    $mssql64bit_out = "64bit" if $mssql64bit;
    $os64bit_out = "64bit"    if $os64bit;

    &msg("WWW Status Summary:");
    print "<table border=1 bgcolor=skyblue>\n";
    print "<tr bgcolor=slate><th><h5>Item<th><h5>Status\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Hostname<td><h5>$host\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Cluster Name (If Any)<td><h5>$cluster_name\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Cluster Global Status (If Any)<td><h5>$cluster_status\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Cluster Active On Node (If Any)<td><h5>$cluster_node\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Cluster This-Node Status (If Any)<td><h5>$cluster_thisnodestatus\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>MSSQL Status<td><h5>$www_status\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>MSSQL Service Status<td><h5>$servicestat\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>MSSQL Agent Status<td><h5>$www_agent_status\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>MSSQL Start Date<td><h5>$mssql_started_fix\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>MSSQL Hours Active<td><h5>$mssql_hours_up\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Database Count<td><h5>$numdbs\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Database Space Alloc.<td><h5>$tot_spacealloc mB\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Database Space Used<td><h5>$tot_spaceused mB\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>MSSQL Version<td><h5>$ver $mssql64bit_out\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>CPU Info<td><h5>$cpu $cpumodel\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>CPU Count<td><h5>$numcpus\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>RAM Total<td><h5>$ram mB\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>RAM Available<td><h5>$mem_avail mB\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>RAM Used<td><h5>$mem_used mB\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>RAM % Used<td><h5>${mem_pct}%\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>OS Version<td><h5>$osver $os64bit_out\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Server Uptime<td><h5>$uptime\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Remote Shell Service<td><h5>$rsh_service\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>DoubleTake Status<td><h5>$doubletake_status\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>DoubleTake Dir<td><h5>$doubletake_dir\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>DoubleTake File<td><h5>$doubletake_file\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>DoubleTake FileAge Mins<td><h5>$doubletake_fileage_mins\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>MSSQL LK<td><h5>$mssql_regkey\n";
    print "</table><br>\n";

    print "<table border=1 bgcolor=skyblue>\n";
    print "<tr bgcolor=slate>
      <th><h5>Database<br>Name
      <th><h5>Alloc.<br>(mB)
      <th><h5>Used<br>(mB)
      <td><h5>Date<br>Created
      <td><h5>Most Recent Object <br>Created Date
      <td><h5>Owner
      <th><h5>Datafile(s)
      <td><h5>Status
    \n";
    foreach (@www_dbs)
    {
      print "<tr bgcolor=$www_bgcolor>$_ \n";
    }
    print "<tr bgcolor=slate><td><b> $fs Total:
      <td align=right><b> $fs $tot_spacealloc
      <td align=right><b> $fs $tot_spaceused 
    </table>";
  
    &checkTLog;
    #&msg("TEST"); 
    #&bkup;

    &msg("Done");
    &msg("END_OF_PROBE");
    exit 0;
  }
}

# ----------------------------------------------------------------------
sub bkrun
# ----------------------------------------------------------------------
{
  $db     = $arg1;
  $method = $arg2;
  $cmd    = $arg3;
  print "$P bkrun: Running backup for DB=$db Method=$method\n";
  print "$P bkrun: Command before {DB}, {SQLPATH}, {PERLPATH} and backslash substitution: $cmd\n";

  # 24Jan04 - Now PERLPATH contains the path to the executable
  #  If they specified perl.exe in the CMD, that is wrong. 
  if ($cmd =~ /perl.exe/ && $cmd =~ /PERLPATH/)
  {
    &msg("NOTE: PERLPATH is wrong - It specifies perl.exe - modifying"); 
    $cmd =~ s/\/perl.exe//g;
    &msg("Modified Command after substitution: $cmd");
    $modified = 1;
  }

  $cmd =~ s/\{DB\}/\"$db\"/g;
  $cmd =~ s'\[BLANK\]' 'g;
  $cmd =~ s'\[HYPHEN\]'-'g;

  $cmd =~ s/\{SQLPATH\}/$SQLPATH/g;
  $cmd =~ s/\{PERLPATH\}/$PERLPATH/g;

  $cmd =~ s/\//\\/g;
  print "$P bkrun: Command after substitution: $cmd\n";

  #DEBUG START
  system("$PERLPATH C:\\dbatools\\socketmail.pl dbaadmin\@dba.it.agilent.com dbaadmin\@dba.it.agilent.com \"dbamon_mssql.pl Modified_CMD   PERLPATH=$PERLPATH host=$host modified=$modified cmd=$cmd [AUTO]\" $dbname/$backup_type") if $modified;

  system("$PERLPATH C:\\dbatools\\socketmail.pl dbaadmin\@dba.it.agilent.com dbaadmin\@dba.it.agilent.com \"dbamon_mssql.pl PERLPATH_Not_E PERLPATH=$PERLPATH host=$host modified=$modified cmd=$cmd [AUTO]\" $dbname/$backup_type") if ! -e $PERLPATH;
  #DEBUG END 

  if ($method eq "B") { $syscmd = "start/b \"MSSQL $db Backup\" $cmd"; }
  else                { $syscmd = "$cmd"; }

  &msg("$bkrun: About to issue: $syscmd");
  $s_time = time;
  $rc = system($syscmd);
  $e_time = time;
  $el_time = $e_time - $s_time;
  &msg("bkrun: Back from issuing: $syscmd - rc=$rc el_time=$el_time");

  $rc /= 256 if $rc != 0;
  if ($rc != 0)
  {
    print "$P | ERROR: Invoked Backup_Command: ended with non-zero rc=$rc\n";
  }
}

# ----------------------------------------------------------------------
sub bkhi
# ----------------------------------------------------------------------
{
  $dbname = $arg1; 

  $dbname =~ s/\[HYPHEN\]/\-/g;
  $dbname =~ s/\[BLANK\]/\ /g;
  
  # use strict;
  use DBI;

  # Attempt to connect to the master database on the server, to verify MSSQL availability.
  ##$dbh = DBI->connect("DBI:ODBC:$driver",'guest','' ) || &dbError("Connect_To_DB");
  &connectDB;
  
  $dbh->do("use msdb")         || &dbError("Use_MSDB");

  if (!$dberror)
  {
    # Create a report of all backups for this DB
    if ($ver =~ "6.5")
    { 
      # Check backup age for this db
      $sql = "
       select
	  substring(database_name,1,16) as db,
	  backup_type,
	  backup_finish,
	  datediff(hour,backup_finish, getdate()) as hours_since
       from
	  sysbackuphistory 
       where
	  backup_type = 1 
	  and database_name = '$dbname'
	  and datediff(day, backup_finish, getdate()) <= 50
       order by
	  3 desc";
    }
    else
    {
      # Check backup age for this db
      $sql = "
	 select
	    substring(database_name,1,16) as db,
	    type,
	    backup_finish_date,
	    datediff(hour, backup_finish_date, getdate()) as hours_since
	 from
	    backupset
	 where
	    database_name = '$dbname'
	    --and datediff(day, backup_finish_date, getdate()) <= 50
	 order by
	    3 desc";
    }

    &msg("Running query of MSDB for Backup History Report for database $dbname");
    $sth = $dbh->prepare("$sql") 
      || &dbError("Prepare");
    $sth->execute
      || &dbError("Execute_Select");

    print "\n<table border=1 bgcolor=skyblue>
    <tr bgcolor=slate> 
      <th><font size=2>Backup<br>Type
      <th><font size=2>Timestamp
      <th><font size=2>Age<br>(Hours)
    \n";
    $count = 0;
    while (@Data = $sth->fetchrow_array)
    {
      ++$count;
      $db      = lc $Data[0];
      $bcktype = $Data[1];
      if ($bcktype eq "1") { $bcktype = "D" }; 
      $bckts   = $Data[2];
      $bckage  = $Data[3];

      if    ($bcktype eq "D") { $bt_out = "Database"; }
      elsif ($bcktype eq "I") { $bt_out = "Database Differential"; }
      elsif ($bcktype eq "L") { $bt_out = "Log"; }
      elsif ($bcktype eq "F") { $bt_out = "File"; }
      else                        { $bt_out = "?"; }

      $bt = "($bcktype)$bt_out";

      printf "<tr>
        <td><font size=2>%-4s </font>
        <td><font size=2>%-24s </font>
        <td align=right><font size=2>%-6s</font>
      \n",
      $bt,
      $bckts,
      $bckage
      ;
      $backup_count++;
    }
    print "</table>\n";
    print "\n<b>Total Backups: $backup_count</b>\n\n"; 
  }
}

# ----------------------------------------------------------------------
sub bkup
# ----------------------------------------------------------------------
{
  # use strict;
  use DBI;

  if (-e "\\temp\\ALL.txt")
  {
    $all_log = "\\temp\\ALL.txt";
  }
  else
  {
    $all_log = "$SQLPATH\\dba_bkup_log\\ALL.txt";
  }

  &msg("Trying to determine backup method from $all_log"); 

  if (-e $all_log && ! -r $all_log)
  {
    system("$PERLPATH C:\\dbatools\\socketmail.pl dbaadmin\@dba.it.agilent.com dbaadmin\@dba.it.agilent.com \"dbamon_mssql.pl ALL Log Not Readable - all_log=$all_log [AUTO]\" $dbname/$backup_type") if $modified;
  }

  open(ALL_LOG, "$all_log") || print "$P | Cannot open $all_log - $!\n";
  $lines_read = 0;
  while (<ALL_LOG>)
  {
    $lines_read++;
    if (/Backup_Method:/)
    {
      @words  = split(' ',$_); 
      $backup_method = $words[$#words];
    }
  }
  close(ALL_LOG);
  &msg("Read $lines_read lines from $all_log - backup_method=$backup_method"); 

  # Attempt to connect to the master database on the server, to verify MSSQL availability.
  ##print "$P | Connecting to MSSQL\n";
  ##$dbh = DBI->connect("DBI:ODBC:$driver",'guest','' ) || &dbError("Connect_To_DB");
  &connectDB;

  if (!$dberror)
  {
    print "$P | Checking for database master\n";

    $sth = $dbh->do("use master") || &dbError("Use_Master");

    # Read from master
    $sql = "select name from sysdatabases order by 1; ";
    $sth = $dbh->prepare("$sql") || &dbError("Prepare");
    $sth->execute || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      $dbname = $Data[0];
      push(@dblist,$dbname);
      ++$numdbs;
    }

    # Process DB names
    foreach $dbname (@dblist)
    {
      $dbname_out  = $dbname;
      $dbname_out  =~ s/ /[BLANK]/g;
      $dbname_out  =~ s/\-/[HYPHEN]/g;

      $dbname_out2 = $dbname_out; 
      $dbname_out2 = substr($dbname_out2,0,40) . "..." if length($dbname_out2) > 40; 

      if ($ver =~ "6.5")
        { 
           # Check backup age for this db
           $sql = "
       	   select
	      substring(database_name,1,16) as db,
	      max(backup_finish) as maxdate,
	      datediff(hour, max(backup_finish), getdate()) as hours_since
	   from
              sysbackuphistory 
	   where
	      backup_type =1
	      and database_name = '$dbname'
	   group by
	      database_name
           order by database_name, 3 desc";
        }
      else
        {
           # Check backup age for this db
           $sql = "
       	   select
	      substring(database_name,1,16) as db,
	      max(backup_finish_date) as maxdate,
	      datediff(hour, max(backup_finish_date), getdate()) as hours_since
	   from
              backupset
	   where
	      type in ('D','I')
	      and database_name = '$dbname'
	   group by
	      database_name 
           order by 1, 3 desc";
        }

      $dbh->do("use msdb")         || &dbError("Use_MSDB2");
      $sth = $dbh->prepare("$sql") || &dbError("Prepare");
      $sth->execute                || &dbError("Execute_Select");
      $bckfound = 0;
      while (@Data = $sth->fetchrow_array)
      {
        $bckfound = 1;
	$db      = lc $Data[0];
	$bckts   = $Data[1];
	$bckage  = $Data[2];

        print "BckAge: $dbname_out $bckage $bckts $backup_method \n";
      }
      if (!$bckfound)
      {
	$db      = lc $dbname;
        print "BckAge: $dbname_out -1\n";
      }

      #---- Create backup report
      $sql = "select
        substring(database_name,1,16) as db,
        type,
        max(backup_finish_date) as maxdate,
        datediff(hour, max(backup_finish_date), getdate()) as hours_since
      from
        backupset
      where
	database_name = '$dbname'
      group by
        database_name,
        type
      order by 
        1, 2";
      $dbh->do("use msdb")         || &dbError("Use_MSDB2");
      $sth = $dbh->prepare("$sql") || &dbError("Prepare");
      $sth->execute                || &dbError("Execute_Select");
      $bckfound = 0;

      print "BckDet: <tr bgcolor=lightblue><th colspan=9>$fs Database: $dbname_out\n";

      while (@Data = $sth->fetchrow_array)
      {
	$db             = lc $Data[0];
	$bck_type       = $Data[1];
	$bck_maxts_raw  = $Data[2];
	$bck_agehr      = $Data[3];
    
        #---- 2007-11-15 11:46:23.000
        $bck_maxts = substr($bck_maxts_raw,0,10);
        $bck_maxts =~ s/\-/\//g; 
        $bck_maxts .= "-" . substr($bck_maxts_raw,11,8);
        $bck_agedy = sprintf("%.2f", ($bck_agehr / 24));

        if    ($bck_type eq "D") { $bck_type_out = "(D) Database Full"; }
        elsif ($bck_type eq "I") { $bck_type_out = "(I) Database Differential"; }
        elsif ($bck_type eq "L") { $bck_type_out = "(L) Transaction Log"; }
        else                     { $bck_type_out = $bck_type; }

        ##print "BckDetTEST: $dbname_out bck_type=($bck_type) bck_maxts=($bck_maxts) bck_agehr=($bck_agehr)\n";
        print "BckDet: <tr><td>$fs $dbname_out2<td>$fs $bck_type_out<td>$fs $bck_maxts<td align=right>$fs $bck_agehr<td align=right>$fs $bck_agedy\n";
      }
    }
  }
}

# ----------------------------------------------------------------------
sub backupJobs
# ----------------------------------------------------------------------
{
  &msg("Querying backup jobs ");
 
  if (! defined $dbh)
  {
    ##&msg("Connecting to MSSQL");
    ##$dbh = DBI->connect("DBI:ODBC:$driver",'guest','' ) || &dbError("Connect_To_DB");
    &connectDB;
  }

  if ($sth)
  {
    $sth->finish();
  }

  $sth = $dbh->do("use msdb") || &dbError("Use_Master");

  $sql = "select 
      j.name, 
      s.command,
      j.enabled
    from  
      sysjobs j,
      sysjobsteps s
    where 
      j.job_id = s.job_id 
     
    ;";

  $sth = $dbh->prepare("$sql") || &dbError("Prepare");
  $sth->execute                || &dbError("Execute_Select");
  while (@Data = $sth->fetchrow_array)
  {
    $jobname    = $Data[0];
    $jobcmd     = $Data[1];
    $jobenabled = $Data[2];

    ##&msg("DEBUG jobname=$jobname jobenabled=$jobenabled");

    $jobcmd  =~ s/'/QUOTE/g;
    
    $jobcmd  = substr($jobcmd,0,200) if length($jobcmd) > 200;
    $jobname = substr($jobname,0,75) if length($jobname) > 75;

    if    ($jobcmd  =~ /call_backup/)         { $jobtype = "BackupVeritas"; }
    elsif ($jobcmd  =~ /call_disk_backup.pl/) { $jobtype = "BackupDisk"; }
    elsif ($jobcmd  =~ /OBII_backup/)         { $jobtype = "BackupOB"; }
    elsif ($jobname =~ /^billtest/)           { $jobtype = "BBTEST"; }
    else                                      { $jobtype = "Other"; }

    print "$P BACKUPJOB: \$jobname='$jobname'\; \$jobcmd='$jobcmd'\; \$jobtype='$jobtype'\; \n";

    $rundisable = $arg1;  # Set by Run_Surgery: DBC parameter

    if ($rundisable)
    {
      if ($jobtype =~ /^Backup/ && $jobenabled)
      {
        push(@sqltorun,"exec sp_update_job \@job_name='$jobname',\@enabled=0");
      }
    }
  }

  $jobsupdated = 0;
  
  &msg("Looking for jobs to update");

  if ($sqltorun[0])
  {
    foreach $sql (@sqltorun)
    { 
      &msg("Running sp_update_job - sql=$sql");
      $dbh->do("use msdb")          || &dbError("Use_MSDB");
      ##$sth2->finish()             || &dbError("Finish");
      $sth2 = $dbh->prepare("$sql") || &dbError("Prepare");
      $sth2->execute                || &dbError("Execute_Disable");
    }
  }

  &msg("Done processing jobs");
}

# ----------------------------------------------------------------------
sub oldPerl
# ----------------------------------------------------------------------
{
  $pslist_loc = "C:\\dbatools\\pslist.exe";
  $oldperl_t  = 24;    #---- 1.27
  $oldperl_cnt = 0;
 
  if (! -e $pslist_loc)
  {
    &msg("pslist is not found at $pslist_loc - Skipping");
    return;
  }

  &msg("Looking for old Perl procesess that have been running for at least $oldperl_t hours under userid=$userid - pslist_loc=$pslist_loc");

  $cmd = "$pslist_loc > NUL 2>&1";
  &msg("Testing $pslist_loc to make sure that it works on this server - cmd=$cmd");
  if (system("$cmd") != 0)
  {
    &msg("pslist Error encountered - Skipping");
    return;
  }

  open(CMD, "$pslist_loc |") || &error("Cannot invoke $pslist_loc - $!");
  while (<CMD>)
  {
    @words  = split;
    $pname  = $words[0];
    $pid    = $words[1];
    $utime  = $words[6];
    $ktime  = $words[7];
    $etime  = $words[8];

    $hours = (split(":",$etime)) [0];

    next if $pname !~ /Perl/;
    next if $hours < $oldperl_t;

    # Get username
    open(CMD2, "pulist  |") || print "$P | Cannot invoke $pslist_loc - $!\n";;
    while (<CMD2>)
    {
      @words  = split;
      $pgm2   = $words[0];
      $pid2   = $words[1];
      $usr2   = $words[2];

      ##print "pgm2=$pgm2 pid2=$pid2 usr2=$usr2\n"; 
 
      next if $pid2 ne $pid;

      $user   = $words[2];
    }
    close(CMD2);

    next if index($user,$userid) == -1;

    print "$P OLDPERL: pid=$pid pname=$pname etime=$etime hours=$hours user=$user utime=$utime ktime=$ktime\n";
    $oldperl_cnt++;
  }
  close(CMD);
  &msg("Found $oldperl_cnt old perl processes"); 
}

# ----------------------------------------------------------------------
sub checkDoubleTake
# ----------------------------------------------------------------------
{
  &msg("Checking DoubleTake (registry)"); 

  #---- See if it is installed
  %values="";
  $Register = "Software\\NSI Software\\Double-Take\\CurrentVersion";
  $HKEY_LOCAL_MACHINE->Open($Register,$hkey); 
  &msg("  hkey=$hkey"); 
  if ($hkey eq "")
  {
    &msg("  DoubleTake is NOT installed"); 
    return;
  }
  $hkey->GetValues(\%values) || &msg("  Cannot find DoubleTake in registry");
  foreach $value (keys(%values))
  {
    $RegType      = $values{$value}->[1];
    $RegValue     = $values{$value}->[2];
    $RegKey       = $values{$value}->[0];
    $doubletake_version = $RegValue if $RegKey eq "VersionInfo";
  }
  $hkey->Close();
  if ($doubletake_version eq "")
  {
    &msg("  DoubleTake is NOT installed"); 
    return;
  }
  &msg("  DoubleTake version $doubletake_version is installed"); 

  #---- Get MSSQL base dir
  %values="";
  $Register = "Software\\Microsoft\\MSSQLServer\\MSSQLServer\\Parameters";
  $HKEY_LOCAL_MACHINE->Open($Register,$hkey); 
  $hkey->GetValues(\%values);
  foreach $value (keys(%values))
  {
    $RegType       = $values{$value}->[1];
    $RegValue      = $values{$value}->[2];
    $RegKey        = $values{$value}->[0];
    $mssql_basedir = substr($RegValue,2) if $RegKey eq "SQLArg0";
  }
  $hkey->Close();

  $zraw = $mssql_basedir;
  $zlookfor = "\\"; 
  $zidx = rindex($zraw,$zlookfor); 
  $doubletake_dir = substr($zraw,0,$zidx);

  &msg("  mssql_basedir=$mssql_basedir doubletake_dir=$doubletake_dir"); 

  $doubletake_fileage_mins = 999999; 
  $doubletake_file = "$doubletake_dir\\DBAmon_Timestamp.txt"; 
  if (-e $doubletake_file) 
  {
    open(TS, "$doubletake_file") || print "$P | Cannot open input $doubletake_file - $!\n";;
    while (<TS>)
    {
      @words = split;
      $tsnum = $words[0];
    }
    $doubletake_fileage_mins = int((time - $tsnum) / 60); 
  }

  #---- See if doubletake is running
  $doubletake_status = "?";
  open(NET, 'net start|') || print "Error: Running net start";
  while(<NET>)
  {
    ##print;
    if (/Double-Take/)            { $doubletake_status="[Running]"; }
  }
  close(NET);

  print "DoubleTakeStatus:      $doubletake_status\n";
  print "DoubleTakeDir:         $doubletake_dir\n";
  print "DoubleTakeFile:        $doubletake_file\n";
  print "DoubleTakeFileAgeMins: $doubletake_fileage_mins\n";

  &msg("Done checking DoubleTake"); 
}

# ----------------------------------------------------------------------
sub connectDB
# ----------------------------------------------------------------------
{
  &msg("connectDB() Connecting to ODBC driver=$driver as 'guest'"); 
  $dbh = DBI->connect("DBI:ODBC:$driver",'guest','' ) || &dbError("Connect_To_DB");

  #if ($host eq "wbbndba1")
  #{
  #  &msg("  Setting isolation level: SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED"); 
  #  $dbh->do("SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED") || &dbError("SET ISO LEVEL");
  #}
  &msg("  Setting isolation level: SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED"); 
  $dbh->do("SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED") || &dbError("SET ISO LEVEL");
}

# ----------------------------------------------------------------------
sub test
# ----------------------------------------------------------------------
{
  &msg("test()"); 

  &msg("Setting isolation level: SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED"); 
  $dbh->do("SET TRANSACTION ISOLATION LEVEL READ UNCOMMITTED") || &dbError("Use_Master_1");


  $dbname = "master";

	&msg("Running exec sp_spaceused for dbname='$dbname'"); 
	$sth = $dbh->prepare("exec sp_spaceused") || &dbError("Prepare");
	$dberror = 0;
	$sth->execute || &dbErrorOK("Connecting to db=$dbname");
	if ($dberror)
	{
	  ++$numdbsoffline;
	  print "DB:     $dbname_out CONNECTERROR \n";
	  next;
	}
	while (@Data = $sth->fetchrow_array)
	{
	  ##print "Data0=$Data[0]\n";   # Test
	  ##@words = split ' ', $Data[0];
	  ##$verb = $words[0];
	  ##if ($verb eq $dbname)
	  if (uc $Data[0] eq uc $dbname)
	  {
	    $db_spacealloc = $Data[1];
	    chop $db_spacealloc ; chop $db_spacealloc ;chop $db_spacealloc ;
	    $db_spacefree  = $Data[2];
	    chop $db_spacefree ; chop $db_spacefree ;chop $db_spacefree ;
	    $db_spaceused  = $db_spacealloc - $db_spacefree;
	  }
	}

  &msg("db_spaceused=$db_spaceused"); 
}

# ----------------------------------------------------------------------
#
# Main
#
# ----------------------------------------------------------------------

$stime = time;

#
# Check to see if Oracle is up
#
if ($verb eq "up") 
{
  $subrc += &checkDoubleTake(); #---- if $host eq "wcosdba2" || $host eq "wgttdrp";
  $subrc += &up();
  $subrc += &oldPerl();
  $subrc += &checkTLog();
}

#
# Check the event log
#
if ($verb eq "checklog") 
{
  $subrc = &checklog();
}

#
# Check TLOGs
#
if ($verb eq "checktlog") 
{
  $subrc = &checkTLog();
}

#
# Backup age
#
if ($verb eq "bkup") 
{
  $subrc = &bkup();
  #---- Not used any more
  # $subrc = &backupJobs();
}

#
# Backup rerun
#
if ($verb eq "bkrun") 
{
  $subrc = &bkrun();
}

#
# Backup logs - run from menu
#
if ($verb eq "bkbl") 
{
  $subrc = &bkbl();
}

#
# Backup history
#
if ($verb eq "bkhi") 
{
  $subrc = &bkhi();
}

#
# Test - Backup history
#
if ($verb eq "testbj") 
{
  $subrc = &backupJobs();
}

#
# Test - Old Perl ProcessesBackup history
#
if ($verb eq "testpl") 
{
  $subrc = &oldPerl();
}

#
# Terminate
#

$etime = time;
$elapsed = $etime - $stime;
&msg("Done - elapsed: $elapsed - subrc: $subrc");
&msg("END_OF_PROBE");
exit 0;
