#!/usr/bin/perl

# ------------------------------------------------------------------
# dbamonTask.pl
#
#  This program is invoked by /opt/dbamon/bin/dbamon. It performs
#  DBAmon processing for 1 task. 
#
# ------------------------------------------------------------------

# Global settings
push(@INC,"/opt/dbamon/lib");
$| = 1;

$SIG{'INT'} = 'intHandler';
sub intHandler
{
   local($signal) = @_;
   print "DBAmon killed by signal=$signal\n";
   exit(0);
}

# Include Subroutines
require "subs.pl" ;
require "subsDB.pl" ;

require "logit.pl" ;
require "readConfig.pl" ;
require "readDBC.pl" ;
require "error_parm_null.pl" ;
require "error_msg.pl" ;
require "log_msg.pl" ;
require "check_sw.pl" ;
require "begin_stuff.pl" ;
require "run_monitor.pl" ;
require "check_inhib.pl" ;
require "remsh.pl" ;
require "function_cleanup.pl" ;
require "logDetails.pl" ;
require "log_file.pl" ;
require "history_dummy.pl" ;
require "histCreate.pl" ;
require "end_stuff.pl" ;
require "summarize.pl" ;
require "sumprint.pl" ;
require "sumtot.pl" ;
require "crit_msg.pl" ;
require "warn_msg.pl" ;
require "info_msg.pl" ;
require "user_msg.pl" ;
require "event.pl" ;
require "eventLog.pl" ;
require "baICheck.pl" ;

require "DownloadSW.pl";
require "DownloadSWNT.pl";

require "sqlUp.pl";
require "sqlBkup.pl";
require "sqlAlerts.pl";

require "orantUp.pl";
require "orantTSFull.pl";
require "orantArclog.pl";
require "orantDatafiles.pl";
require "orantBkup.pl";

require "infUp.pl";
require "infLongTX.pl";
require "infChkDup.pl";
require "infSWVer.pl";
require "infChunksDown.pl";
require "infSaveCfg.pl";
require "infLocks.pl";
require "infNFile.pl";
require "infCkpt.pl";
require "infShmem.pl";
require "infExtents.pl";
require "infDBS.pl";
require "infCleaners.pl";
require "infLlogs.pl";
require "infArc.pl";
require "infHDR.pl";
require "infMLog.pl";
require "infPerf.pl";

require "oraUp.pl";
require "oraSaveCfg.pl";
require "oraLsnr.pl";
require "oraDatafiles.pl";
require "oraBkup.pl";
require "oraTSFull.pl";
require "oraAlerts.pl";
require "oraExtents.pl";
require "oraArclog.pl";

require "oraapUp.pl";

require "sapUp.pl";

# Include Main Section
require "dbamonMain.pl" ;

exit 0;
