#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************
# =========================================================
# dbamon_ba_check.pl
#
# Changes:
# 
#   bb 11Oct99 - Initial
# =========================================================

$P = "dbamon_ba_check.pl";
 
$ProgName = dbamon_ba_inhibit.pl;
use DBI;
#require "cgi_handlers.pl";

# General parms required
$DBdir         = "/var/opt/apache/htdocs/cftasks";
$modlockfile   = "$DBdir/modlock";
$entlockfile   = "$DBdir/entlock";
$conlockfile   = "$DBdir/conlock";
$modfile       = "$DBdir/modEntries";
$cfteamFile    = "$DBdir/cfteam";
$entityFile    = "$DBdir/entities";

chop($hostname = `hostname`);

$data_source = "dbi:mysql";
$database = "dbamon";
$dbms = "mysql";

if ($ENV{"ORACLE_SID"} ne "")
{
  #We must be using Oracle
  $user = "dbamon";
  $passwd = "dbamon";
  $data_source = "DBI:Oracle";
  $database = "DBA";
  $dbms = "oracle";
}

# Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

# =========================================================
# Arguments
# =========================================================

$instance = shift(@ARGV);

# =========================================================
# Global vars
# =========================================================

$test_mode = 0;

$| = 1;

$errstr = "?";
$errno  = 9999;

# =========================================================
# Subs
# =========================================================

#----------------------------------------------------------
sub error
#----------------------------------------------------------
{
  $emsg = @_[0];
  $sqlerror = $DBI::errstr;
  print "==========================================\n";
  print "Fatal Error: $emsg - $sqlerror\n";
  print "==========================================\n";
  system("echo \"$P - DBAmon Master Server: $hostname\" | dbamon_mailer -s \"DBAmon Fatal Error: $P - $emsg - $sqlerror\" $ENV{'ADMIN_EMAIL'}");
  exit 1;
}


#----------------------------------------------------------
sub connectDB
#----------------------------------------------------------
{
  # Connect to the Mysql database
  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
         &error("DB_connect");
}

#----------------------------------------------------------
sub selectData
#----------------------------------------------------------
{
  # Create the SQL SELECT statement

  if ($dbms eq "oracle")
  {
    $statement  = "select 
      to_char(sts,\'YYYY/MM/DD-HH24:MI:SS\'), 
      to_char(ets,\'YYYY/MM/DD-HH24:MI:SS\'), 
      to_char(ts,\'YYYY/MM/DD-HH24:MI:SS\'), 
      zuser, 
      reason 
    from ba_inhibit 
    where 
      instance = '$instance'
      and sysdate >= sts and sysdate <= ets";
  }
  else
  {
    chop($dateraw = `date +%Y%m%d%H%M`);
    $now = $dateraw . "00";

    $statement  = "select 
      sts, ets, ts, reason, user
      from ba_inhibit 
      where 
	instance = '$instance'
        and $now >= sts and $now <= ets";
  }

  ##print "$statement\n";

  $sth = $dbh->prepare($statement) ||
          &error("DB_prepare");
  $sth->execute || &error("DB_execute");

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $sts    = $Data[0];
    $ets    = $Data[1];
    $ts     = $Data[2];
    $user   = $Data[3];
    $reason = $Data[4];
    $selectcount++;
  }
  ##print "selectcount=$selectcount\n";  
  ##print "ts=$ts reason=$reason\n";  
  system("echo '$sts $ets $ts $user $reason' > /opt/dbamon/tmp/ba_check.tmp");
}

#----------------------------------------------------------
sub zerror
#----------------------------------------------------------
{
  $msg = @_[0];
  print "$P | Fatal Error: $msg\n";
  exit 1;
}

# =========================================================
# Main 
# =========================================================

#print "$P | Starting\n";

#
# Connect to DB
#
&connectDB;

#
# Read data in table for this instance
#
&selectData;

#print "$P | Done\n";

exit $selectcount;
