#!/usr/bin/perl

$| = 1;
$P = "dbamon_dbs.pl";

open(IN, "echo '\
set isolation to dirty read;
select
  \"THIS: \" || a.name,
  a.nchunks chks,
  sum(b.chksize) size,
  sum(b.nfree) free
from
  sysdbspaces a,
  syschunks b
where
  a.dbsnum = b.dbsnum
group by
  a.dbsnum,
  a.name,
  a.nchunks
order by
  1;
' | dbaccess sysmaster 2>/dev/null |") || die "Error running dbaccess";

while(<IN>)
{
  @words = split;
  $verb    = @words[0];
  if ($verb eq "THIS:")
  {
    $dbsname = @words[1];
    $chunks  = @words[2];

    $size    = int(@words[3]*2048/1000000);
    $free    = int(@words[4]*2048/1000000);

    $used    = int($size - $free);
    $pct     = int(($used / $size) * 100);
    printf("THIS: %-12s %3d %5d %5d %5d %3d\n",$dbsname,$chunks,$size,$free,$used,$pct);
  }
}

system("onstat -c | egrep '^CLEANERS|^LRUS|^SHMVIRTSIZE|^WSTATS|^LTAPEDEV|^NUMAIOVPS'");
system("onstat -g iov | grep 'kio'");
system("chatr \$INFORMIXDIR/bin/oninit | grep -i shmem_magic");

$aiotop = `onstat -g iov | grep aio | head -1 | awk '{ print \$5 }'`;
$aiobot = `onstat -g iov | grep aio | tail -1 | awk '{ print \$5 }'`;
$aionum = `onstat -g iov | grep aio | wc -l'`;
chop $aiotop;
chop $aiobot;
chop $aionum;
$aiorat = int(($aiobot*100)/$aiotop);
print "AIORAT: $aiorat Top: $aiotop Bot: $aiobot Num: $aionum\n";

#
# If an SAP Informix instance, return SAP version
#

$ifmxdir = $ENV{"INFORMIXDIR"};
$ifmxdirl = length($ifmxdir);
$ifmxdirs = substr($ifmxdir,0,10);

##print "$ifmxdir $ifmxdirl $ifmxdirs\n";
if (($ifmxdirl == 13 && $ifmxdirs eq "/informix/"))
{
  #
  # Get SAP kernel ver
  #

  $sapinst = substr($ifmxdir,10,3);
  ##print "$sapinst\n";

  $sapkern = `/usr/sap/$sapinst/SYS/exe/run/R3check -? | grep version | head -1 | awk '{ print \$7 }'`;
  chop $sapkern;

  $sapkernmode = `/sapmnt/$sapinst/exe/disp+work 2>/dev/null | grep 'compiled for' | awk '{ print \$3 }'`;
  chop $sapkernmode;
  if ($sapkernmode eq "")
  {
    $sapkernmode = "32";
  }
  $sapkern = "$sapkern($sapkernmode)";

  $saprlse = `echo "select * from svers" | dbaccess $sapinst 2>/dev/null | tail -3 | head -1`;
  chop $saprlse;

  print "SAP: $sapkern $saprlse\n";
}

exit 0;
