#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************
#
# Check for correct uid/gid
#

export PATH=$PATH:/opt/dbamon/bin

HOSTNAME=`hostname`
echo "$HOSTNAME" | dbamon_mailer -s "$0 - $HOSTNAME" dbamon@dbamon.com

print "dbamon_install | NOTE: This procedure is being executed"
print "  by uid/gid \c"
id
print " "
print "  Is this the uid/gid that will permanently administer and "
print "  execute DBAmon ???  This script must be executed by the "
print "  same uid/gid that will administer and execute DBAmon."
print "  Enter "y" to continue ===> \c"
read ANS

if [ "$ANS" != "y" ]; then
  print "dbamon_install | Exiting."
  exit 1
fi

if [ "$PWD" != "/opt/dbamon" ]; then
  print "dbamon_install | PWD Must be /opt/dbamon - Exiting."
  exit 1
fi

#
# Check for writeable /opt/dbamon directory
#

if [ ! -w /opt/dbamon ]; then
  print "dbamon_install | Error: Directory /opt/dbamon not writeable."
  print "  chown this directory writeable to the ID:group that will"
  print "  execute and administer DBAmon."
  exit 1
fi

cd /opt/dbamon

#
# Remove tar file
#

print "dbamon_install | Removing tar file"

rm /opt/dbamon/dbamon.tar

#
# Create data dirs
#

print "dbamon_install | Creating work dirs"

mkdir -p /opt/dbamon/dat/appldb
mkdir -p /opt/dbamon/dat/reports/informix_ver
mkdir -p /opt/dbamon/dat/reports/test/informix_ver
mkdir -p /opt/dbamon/dat/config_save
mkdir -p /opt/dbamon/dat/history/dbspaces
mkdir -p /opt/dbamon/tmp
mkdir -p /opt/dbamon/tmp/ontape
mkdir -p /opt/dbamon/tmp/test
mkdir -p /opt/dbamon/log
mkdir -p /opt/dbamon/htm
mkdir -p /opt/dbamon/htm/details
mkdir -p /opt/dbamon/htm/details_test
mkdir -p /opt/dbamon/htm/events_current
mkdir -p /opt/dbamon/htm/events_current_test
mkdir -p /opt/dbamon/htm/graphs/db_growth
mkdir -p /opt/dbamon/htm/graphs/perf
mkdir -p /opt/dbamon/htm/graphs/stats

ln -s /opt/dbamon/img /opt/dbamon/htm/details/img
ln -s /opt/dbamon/img /opt/dbamon/htm/details_test/img
ln -s /opt/dbamon/img /opt/dbamon/htm/events_current/img
ln -s /opt/dbamon/img /opt/dbamon/htm/events_current_test/img

#
# Documentation stuff
#

print "dbamon_install | Software installation complete."
print "  You now need to return to:"
print "  http://dbamon.com/installation/install.shtml"

print " \n Happy Motoring."
exit 0
