#!/usr/local/bin/perl5

# --------------------------------------------------------------
# Changes 
#  bb 29Oct99 - There is a bug in Informix where idle sessions
#   show 65536 or 131072 locks used. For now, I will eliminate
#   sessions which have those values (which are unlikely to occur 
#   naturally).
# --------------------------------------------------------------

$| = 1;
$P = "dbamon_locks.pl";

#
# find number of locks currently held
#

open(IN, "echo '\
set isolation to dirty read;

select
  \"LOCKSHELD\",
  sum(nlocks)
from
  systxptab
;

--
-- A bug in 7.30.UC10* makes bad values in lockheld of syssesprof
--
--select
--  \"LOCKSHELD\",
--  sum(locksheld)
--from
--  syssesprof
--where 
--  sid not in (select sid from syssessions where pid < 0)
--  and locksheld <= (select cf_effective from sysconfig where cf_name = \"LOCKS\")
--  and locksheld != 65536
--  and locksheld != 131072
--;

select
  cf_name,
  cf_effective
from
  sysconfig
where
  cf_name = \"LOCKS\";
select
  \"SESSION\",
  sid,
  locksheld
from
  syssesprof
where
  locksheld > 2
  and sid not in (select sid from syssessions where pid < 0)
  and locksheld <= (select cf_effective from sysconfig where cf_name = \"LOCKS\")
  and locksheld != 65536
  and locksheld != 131072
order by
  3 ;
select 
  \"SHMVSEGCOUNT:\", 
  count(*),
  sum(seg_size)
from 
  syssegments 
where 
  seg_class = 2
' | dbaccess sysmaster 2>/dev/null |") || die "Error running dbaccess";

while(<IN>)
{
  ##print;
  @words = split;
  $verb    = @words[0];
  if ($verb eq "SHMVSEGCOUNT:")
  {
    print;
  }
  if ($verb eq "LOCKSHELD")
  {
    $locksheld = @words[1];
  }
  if ($verb eq "cf_effective")
  {
    $locksmax  = @words[1];
    $lockspct = int($locksheld / $locksmax * 100);
    print "LOCKSPCT: $lockspct $locksheld $locksmax\n";
  }
  if ($verb eq "SESSION")
  {
    print;
  }
}

#
# Sample ckpt time
#

open(IN, "onstat -m | grep 'Checkpoint Completed' |") || die "Error running onstat -m";

while(<IN>)
{
  ##print;
  @words = split;
  $dur  = @words[5];
  $sum += $dur;
  $cnt += 1;
  ##print "dur=$dur\n";
}

##print "sum=$sum\n";
##print "cnt=$cnt\n";
$avg = $sum/$cnt;
printf("CKPTAVG: %4.1f\n",$avg);

#
# Sample maxusers
#

system("onstat -u | grep 'maximum concurrent' | awk '{ print \"MAXUSERS: \" \$5 }'");
system("onstat -u | egrep 'F |D |B |M' | wc -l | awk '{ print \"SYSUSERS: \" \$1 }'");

exit 0;
