#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************

# --------------------------------------------------------------
# Variables
# --------------------------------------------------------------

use Win32::Registry;

$debug = 1;
$| = 1;
#$# = 2;
$P = "dbamon_mssql.pl";

$verb = $ARGV[0];
$arg1 = $ARGV[1];
$arg2 = $ARGV[2];
$arg3 = $ARGV[3];
$arg4 = $ARGV[4];

$system_root = $ENV{"SYSTEMROOT"};
$root_fs = substr($system_root,0,2);
$temp_dir = "$root_fs\\temp";

if (!(-d $temp_dir))
  {
     mkdir ("$temp_dir",0777);
  }

%values="";
$Register = "System\\CurrentControlset\\Services\\tcpip\\Parameters";
$HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry $Register - $!";
$hkey->GetValues(\%values);
foreach $value (keys(%values))
{
  $RegType      = $values{$value}->[1];
  $RegValue     = $values{$value}->[2];
  $RegKey       = $values{$value}->[0];
  $host = $RegValue if $RegKey eq "Hostname";
}
$hkey->Close();

%values="";
$Register = "System\\CurrentControlset\\Services\\tcpip\\Parameters";
$HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry $Register - $!";
$hkey->GetValues(\%values);
foreach $value (keys(%values))
{
  $RegType      = $values{$value}->[1];
  $RegValue     = $values{$value}->[2];
  $RegKey       = $values{$value}->[0];
  $domain = $RegValue if $RegKey eq "Domain";
  $compwork=$domain;
}
$hkey->Close();

# Save Company name

@words = split(/\./,$compwork);
$nexttolast = $#words - 1;
$company = $words[$nexttolast];
print "$P | Company: $company\n";

$driver = "DBAmonMSSQL";

# Get registry entries for Perl and MSSQL
%values="";
$Register = "Software\\Perl";
$HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry $Register - $!";
$hkey->GetValues(\%values);
foreach $value (keys(%values))
{
  $RegType      = $values{$value}->[1];
  $RegValue     = $values{$value}->[2];
  $RegKey       = $values{$value}->[0];
  $PERLPATH = $RegValue if $RegKey eq "";
}
$hkey->Close();
$path_length = length($PERLPATH);
if (substr($PERLPATH,$pathlength - 1,1) eq "\\")
  {
    chop($PERLPATH)
  }

%values="";
$Register = "Software\\Microsoft\\mssqlserver\\setup";
$HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry $Register - $!";
$hkey->GetValues(\%values);
foreach $value (keys(%values))
{
  $RegType      = $values{$value}->[1];
  $RegValue     = $values{$value}->[2];
  $RegKey       = $values{$value}->[0];
  ##print "$RegKey $RegValue \n";
  $SQLPATH = $RegValue if $RegKey eq "SQLPath";
}
$hkey->Close();

print "$P | Starting - host=$host verb=$verb arg1=$arg1 arg2=$arg2 arg3=$arg3 arg4=$arg4\n";
print "$P |            SQLPATH=$SQLPATH PERLPATH=$PERLPATH\n";

#
# Subroutines
#

sub dbError {
   local($errorMsg,@error_fields) = @_;
   print "======== D B   E r r o r   E n c o u n t e r e d =========\n";
   print "Error: DB Error Encountered While: $errorMsg\n";
   print "Error: DB Error String: $DBI::errstr\n";
   print "==========================================================\n";
   $dberror = 1;
   @errors = split ("Database",$DBI::errstr);
   $chk_str = lc(@errors[1]);
   $db      = lc $dbname;
   if ($chk_str =~ " \'$db\' cannot be opened because it is offline")
     {
       $offline = 1;
     }
   exit 1;
}

sub dbErrorOK {
   local($errorMsg,@error_fields) = @_;
   print "======== D B   E r r o r   E n c o u n t e r e d =========\n";
   print "Error: DB Error Encountered While: $errorMsg\n";
   print "Error: DB Error String: $DBI::errstr\n";
   print "==========================================================\n";
   $dberror = 1;
   @errors = split ("Database",$DBI::errstr);
   $chk_str = lc(@errors[1]);
   $db      = lc $dbname;
   if ($chk_str =~ " \'$db\' cannot be opened because it is offline")
     {
       $offline = 1;
     }
}

sub error
{
  $msg = $_[0];
  print "\n";
  print "$P | Fatal Error: $msg\n";
  print "Error: $msg\n";
  print "$P | Exiting\n";
  exit 1;
}


# ----------------------------------------------------------------------
sub checklog
# ----------------------------------------------------------------------
{
  # Vars
  $tsfile = "$temp_dir\\dbamon_mssql_ts.txt";
  $events = 0;

  # For now I will hardcode the min severity that we will report
  $minsev = 17;
  print "$P | minsev=$minsev\n";

  # Read TS file
  open(TS, "$tsfile") || print "$P | Can't open input $tsfile - $!\n";;
  while (<TS>)
  {
    @words = split;
    $tsdate = $words[0];
    $tstime = $words[1];
  }
  print "$P | Input timestamps: $tsdate $tstime\n";
  close(TS);
   
  # use strict;
  use DBI;

  # Attempt to connect to the master database on the server, to verify MSSQL availability.
  print "$P | Connecting to MSSQL\n";
  $dbh = DBI->connect("DBI:ODBC:$driver",'guest','' )
    || &dbError("Connect_To_DB");

  if (!$dberror)
  {
    # Get info for this DB
    print "$P | Invoking xp_readerrorlog\n";
    $sth = $dbh->prepare("use master;exec xp_readerrorlog") 
      || &dbError("Prepare");
    $sth->execute
      || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      @words = split ' ', $Data[0];
      $rdate = $words[0];
      $rtime = $words[1];
      $rpid  = $words[2];
      $verb  = $words[3];

      ##print "f=$flag2nd verb=$verb rdate=$rdate rtime=$rtime tsdate=$tsdate tstime=$tstime $Data[0] \n";

      if ($flag2nd)
      {
        $errmsg = substr($Data[0],32);
        if ($errsev >= $minsev)
        {
          print "Event: $rdate $rtime $errnum $errsev $errsta $errmsg\n";
        }
        $flag2nd = 0;
        next; 
      }
      if ($verb eq 'Error:' && $rdate ge $tsdate && $rtime gt $tstime)
      {
        print "test00000\n";
        ++$events;
        $errnum = $words[4]; 
        chop($errnum);
        $errsev = $words[6];
        chop($errsev);
        $errsta = $words[8];
        chop($errsta);
        $flag2nd = 1; # We want to read the next line
      }
    }  # End of fetch while
    print "$P | Found $events new events\n";

    # Save the last timestamp that we checked
    print "$P | Saving timestamps: $rdate $rtime\n";
    open(TS, "> $tsfile")    
      || die "Error: Can't open output file: $tsfile\n";
    print TS "$rdate $rtime\n";
    close(TS);
  }

}


# ----------------------------------------------------------------------
sub up
# ----------------------------------------------------------------------
{

  $numcpus = $ENV{"NUMBER_OF_PROCESSORS"};

  %values="";
  $Register = "Hardware\\Description\\System\\CentralProcessor\\0";
  $HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry $Register - $!";
  $hkey->GetValues(\%values);
  foreach $value (keys(%values))
  {
    $RegType      = $values{$value}->[1];
    $RegValue     = $values{$value}->[2];
    $RegKey       = $values{$value}->[0];
    $MHz = $RegValue if $RegKey eq "\~MHz";
    $vendor = $RegValue if $RegKey eq "VendorIdentifier";
    $identifier = $RegValue if $RegKey eq "Identifier";
  }
  $hkey->Close();
  @cpu_ident = split (' ',$identifier); 
  $cpumodel = ${cpu_ident[0]} . "/" . ${cpu_ident[2]};
  $cpu = $vendor . " " . " " . $MHz . " MHz ";
 

  %values="";
  $Register = "Software\\Microsoft\\Windows NT\\CurrentVersion";
  $HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry $Register - $!";
  $hkey->GetValues(\%values);
  foreach $value (keys(%values))
  {
    $RegType      = $values{$value}->[1];
    $RegValue     = $values{$value}->[2];
    $RegKey       = $values{$value}->[0];
    $CurrentVersion = $RegValue if $RegKey eq "CurrentVersion";
    $CSDVersion = $RegValue if $RegKey eq "CSDVersion";
  }

 if ($CSDVersion ne "")
  {
    @sp_info = split(' ',$CSDVersion);
    $osver = $CurrentVersion . ",SP" . ${sp_info[2]};
  }
else
  {
    $osver = $CurrentVersion;
  }
print "OSVer: $osver\n";

  # See if the MSSQLServer is running
  open(NET, 'net start|') 
    || print "Error: Running net start";
  while(<NET>)
  {
    ##print;
    @words = split;
    if (lc($words[0]) eq "mssqlserver")
    {
      $servicestat="[Running]";
      last;
    }
  }
  close(NET);

  if ($servicestat eq "")
  {
    $servicestat="[Not Running]";
  } 

  print "MSSQLServiceStatus: $servicestat\n";
  print "NumCPUs: $numcpus\n";
  print "CPU: $cpu\n";
  print "CPUModel: $cpumodel\n";

  # Get memory Info
  open(MEM, 'pstat|') 
    || print "Error: Running pstat";
  while(<MEM>)
  {
    ##print;
    @words = split;
    $ram = int($words[4] / 1024);
    last;
  }
  close(MEM);
  if (defined($ram))
  {
    print "RAM: $ram MB\n";
  }

  # See if the agent is running
  open(NET, 'net start|') 
    || print "Error: Running net start";
  while(<NET>)
  {
    ## print;
    @words = split;
    if (lc($words[0]) eq "sqlserveragent")
    {
      $agentrunning = 1;
      last;
    }
    elsif (lc($words[0]) eq "sqlexecutive")
     {
      $agentrunning = 1;
      last;
     }
  }
  close(NET);

  # use strict;
  use DBI;

  # Attempt to connect to the master database on the server, to verify MSSQL availability.
  print "$P | Connecting to MSSQL\n";
  $dbh = DBI->connect("DBI:ODBC:$driver",'guest','' )
    || &dbError("Connect_To_DB");

  if (!$dberror)
  {
    print "$P | Checking for database master\n";
    $sth = $dbh->do("use master")
      || &dbError("Use_Master");

    # Read from master
    $sql = "use master;
      select name from sysdatabases order by 1; ";
    $sth = $dbh->prepare("$sql") 
      || &dbError("Prepare");
    $sth->execute
      || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      $dbname = $Data[0];
      push(@dblist,$dbname);
      ++$numdbs;
    }

    # Get session userid
    $sql = "select current_user; ";
    $sth = $dbh->prepare("$sql") 
      || &dbError("Prepare");
    $sth->execute
      || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      $user = $Data[0];
    }
    print "Current_User: $user\n";

    # Process DB names
    foreach $dbname (@dblist)
    {
      # Get info for this DB
      $sth = $dbh->prepare("use $dbname;exec sp_spaceused") || &dbError("Prepare");
      $dberror = 0;
      $sth->execute || &dbErrorOK("Connecting to db=$dbname");
      if ($dberror)
      {
        ++$numdbsoffline;
        print "DB:     $dbname CONNECTERROR \n";
        next;
      }
      while (@Data = $sth->fetchrow_array)
      {
	@words = split ' ', $Data[0];
	$verb = $words[0];
        if ($verb eq $dbname)
        {
          $db_spacealloc = $Data[1];
          chop $db_spacealloc ; chop $db_spacealloc ;chop $db_spacealloc ;
          $db_spacefree  = $Data[2];
          chop $db_spacefree ; chop $db_spacefree ;chop $db_spacefree ;
          $db_spaceused  = $db_spacealloc - $db_spacefree;
        }
      }
      $db      = lc $dbname;
      print "DB:     $db $db_spacealloc $db_spaceused\n";
      $tot_spacealloc += $db_spacealloc;
      $tot_spaceused  += $db_spaceused ;
    }

    print "NUMDBs: $numdbs\n";
    print "SpaceAlloc: $tot_spacealloc\n";
    print "SpaceUsed: $tot_spaceused\n";
 
    # Get SQLSrvr version
    $sql = "use master;
      select attribute_value from spt_server_info where attribute_name = 'DBMS_VER' ";
    $sth = $dbh->prepare("$sql") 
      || &dbError("Prepare");
    $sth->execute
      || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      @words = split ' ', $Data[0];
      $ver = $words[5];
      if ($ver eq "6.50.213") { $ver = "${ver}(SP1)";  }
      if ($ver eq "6.50.240") { $ver = "${ver}(SP2)";  }
      if ($ver eq "6.50.258") { $ver = "${ver}(SP3)";  }
      if ($ver eq "6.50.281") { $ver = "${ver}(SP4)";  }
      if ($ver eq "6.50.415") { $ver = "${ver}(SP5)";  } 
      if ($ver eq "6.50.416") { $ver = "${ver}(SP5a)"; }
      if ($ver eq "7.00.699") { $ver = "${ver}(SP1)";  }
      if ($ver eq "7.00.842") { $ver = "${ver}(SP2)";  }
      if ($ver eq "7.00.842") { $ver = "${ver}(SP2)";  }
      if ($ver eq "7.00.961") { $ver = "${ver}(SP3)";  }
      if ($ver eq "8.00.384") { $ver = "${ver}(SP1)";  }
      print "SQLVer: $ver\n";
    }
  }

  # Decide status
  if ($numdbs > 0) 
  {
    $num_up = $numdbs - $numdbsoffline;
    print "DBStatus: UP \($num_up\)";
    if ($offline)
     {
       print "; DOWN \($numdbsoffline\)";
     }
    print "\n";
  }
  else
  {
    print "DBStatus: DOWN\n";
  }
  if ($agentrunning) 
  {
    print "AgentStatus: UP\n";
  }
  else
  {
    print "AgentStatus: DOWN\n";
  }

  # Determine backup type
}

# ----------------------------------------------------------------------
sub bkrun
# ----------------------------------------------------------------------
{
  $db     = $arg1;
  $method = $arg2;
  $cmd    = $arg3;
  print "$P bkrun: Running backup for DB=$db Method=$method\n";
  print "$P bkrun: Command before {DB}, {SQLPATH}, {PERLPATH} and backslash substitution: $cmd\n";
  $cmd =~ s/\{DB\}/$db/g;
  $cmd =~ s/\{SQLPATH\}/$SQLPATH/g;
  $cmd =~ s/\{PERLPATH\}/$PERLPATH/g;
  $cmd =~ s/\//\\/g;
  print "$P bkrun: Command after substitution: $cmd\n";

  @words = split(/ /,$cmd);
  $thispath = $words[0];

  if (! -e "$thispath")
  {
    print "$P | ERROR: NFPath: $thispath Not executable - exiting\n";
    return; 
  }

  if ($method eq "B") { $syscmd = "start/b \"MSSQL $db Backup\" $cmd"; }
  else                { $syscmd = "$cmd"; }
  print "$P bkrun: About to issue: $syscmd\n";
  $rc = system($syscmd);

  print "$P bkrun: Back from issuing: $syscmd - rc=$rc\n";

  $rc /= 256 if $rc != 0;
  if ($rc != 0)
  {
    print "$P | ERROR: Invoked Backup_Command: ended with non-zero rc=$rc\n";
  }
}

# ----------------------------------------------------------------------
sub bkup
# ----------------------------------------------------------------------
{
  # use strict;
  use DBI;

  # Attempt to connect to the master database on the server, to verify MSSQL availability.
  print "$P | Connecting to MSSQL\n";
  $dbh = DBI->connect("DBI:ODBC:$driver",'guest','' )
    || &dbError("Connect_To_DB");

  if (!$dberror)
  {
    print "$P | Checking for database master\n";
    $sth = $dbh->do("use master")
      || &dbError("Use_Master");

    # Read from master
    $sql = "use master;
      select name from sysdatabases order by 1; ";
    $sth = $dbh->prepare("$sql") 
      || &dbError("Prepare");
    $sth->execute
      || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      $dbname = $Data[0];
      push(@dblist,$dbname);
      ++$numdbs;
    }

    # Get SQLSrvr version
    $sql = "use master;
      select attribute_value from spt_server_info where attribute_name = 'DBMS_VER' ";
    $sth = $dbh->prepare("$sql") 
      || &dbError("Prepare");
    $sth->execute
      || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      @words = split ' ', $Data[0];
      $ver = $words[5];
    }

    # Process DB names
    foreach $dbname (@dblist)
    {
      if ($ver =~ "6.5")
        { 
           # Check backup age for this db
           $sql = "
	   use msdb;
       	   select
	      substring(database_name,1,16) as db,
	      max(backup_finish) as maxdate,
	      datediff(hour, max(backup_finish), getdate()) as hours_since
	   from
              sysbackuphistory 
	   where
	      backup_type =1
	      and database_name = '$dbname'
	   group by
	      database_name
           order by database_name, 3 desc";
        }
      else
        {
           # Check backup age for this db
           $sql = "
	   use msdb;
       	   select
	      substring(database_name,1,16) as db,
	      max(backup_finish_date) as maxdate,
	      datediff(hour, max(backup_finish_date), getdate()) as hours_since
	   from
              backupset
	   where
	      type in ('D','I')
	      and database_name = '$dbname'
	   group by
	      database_name 
           order by 1, 3 desc";
        }

      $sth = $dbh->prepare("$sql") || &dbError("Prepare");
      $sth->execute                || &dbError("Execute_Select");
      $bckfound = 0;
      while (@Data = $sth->fetchrow_array)
      {
        $bckfound = 1;
	$db      = lc $Data[0];
	$bckts   = $Data[1];
	$bckage  = $Data[2];
        print "BckAge: $db $bckage $bckts \n";
      }
      if (!$bckfound)
      {
	$db      = lc $dbname;
        print "BckAge: $db -1\n";
      }

      # Create a report of all backups for this DB
      if ($ver =~ "6.5")
        { 
           # Check backup age for this db
           $sql = "
	   use msdb;
       	   select
	      substring(database_name,1,16) as db,
              backup_type,
	      backup_finish,
	      datediff(hour,backup_finish, getdate()) as hours_since
	   from
              sysbackuphistory 
	   where
	      backup_type = 1 
	      and database_name = '$dbname'
              and datediff(day, backup_finish, getdate()) <= 50
	   order by
	      3 desc";
        }
      else
        {
           # Check backup age for this db
           $sql = "
	   use msdb;
       	   select
	      substring(database_name,1,16) as db,
              type,
	      backup_finish_date,
	      datediff(hour, backup_finish_date, getdate()) as hours_since
	   from
              backupset
	   where
	      type in ('D','I')
	      and database_name = '$dbname'
              and datediff(day, backup_finish_date, getdate()) <= 50
	   order by
	      3 desc";
        }

      $sth = $dbh->prepare("$sql") 
	|| &dbError("Prepare");
      $sth->execute
	|| &dbError("Execute_Select");

      $count = 0;
      while (@Data = $sth->fetchrow_array)
      {
        ++$count;
	$db      = lc $Data[0];
	$bcktype = $Data[1];
        if ($bcktype eq "1") { $bcktype = "D" }; 
	$bckts   = $Data[2];
	$bckage  = $Data[3];
        printf "<tr><td>%-16s <td>%-24s <td>%-4s <td>%-6s\n",$db,$bckts,$bcktype,$bckage;
      }
    }
  }
}

# ----------------------------------------------------------------------
# Main
# ----------------------------------------------------------------------

$stime = time;

#
# Check to see if Oracle is up
#
if ($verb eq "up") 
{
  $subrc = &up();
}

#
# Check to see if the listener is up - start it if not
#
if ($verb eq "checklog") 
{
  $subrc = &checklog();
}

#
# Backup age
#
if ($verb eq "bkup") 
{
  $subrc = &bkup();
}

#
# Backup rerun
#
if ($verb eq "bkrun") 
{
  $subrc = &bkrun();
}

#
# Terminate
#

$etime = time;
$elapsed = $etime - $stime;
print "$P | Done - elapsed: $elapsed - subrc: $subrc\n";

exit 0;
