#!/usr/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************
# =========================================================
# dbamon_ora_sum.pl
#
# Changes:
# 
#   bb 12Jun00 - Initial
# =========================================================

$debug = 1;

$| = 1;
$P = "dbamon_ora_eventrpt.pl";
$tmpfl = "/tmp/dbamon_ora_eventrpt_$$.txt";

#######################################################################
# Customize Here:
$dest_server = "curley";
$dest_dir    = "/tmp/sas/";
#######################################################################

chop($ORACLE_SID  = `grep ORACLE_SID:  /opt/dbamon/adm/dbamonrc$modesuf | awk '{ print \$2 }'`);
chop($ORACLE_HOME = `grep ORACLE_HOME: /opt/dbamon/adm/dbamonrc$modesuf | awk '{ print \$2 }'`);
$ENV{'ORACLE_SID'}  = $ORACLE_SID;
$ENV{'ORACLE_HOME'} = $ORACLE_HOME;
$old_path           = $ENV{"PATH"};
$ENV{'PATH'}        = "$ORACLE_HOME/bin:${old_path}";

$ENV{'PATH'} = "/opt/dbamon/bin:$ENV{'PATH'}";
$os = $ENV{"ORACLE_SID"};

$mode = uc $ARGV[0];
$modelc = lc $mode;
if ($mode eq "") { $mode = "prod"; }

$arg1 = $ARGV[1];
$arg2 = $ARGV[2];
$arg3 = $ARGV[3];
$arg4 = $ARGV[4];
$arg5 = $ARGV[5];
$arg6 = $ARGV[6];
$arg7 = $ARGV[7];
$arg8 = $ARGV[8];

if ($mode ne "test" && $mode ne "prod")
{
  print "$P | Usage: $0 {test | prod}\n";
  exit 1;
}

#------------------------------------------------------------------------------
sub trim
#------------------------------------------------------------------------------
{
  my @out = @_;
  for (@out)
  {
    s/^\s+//;
    s/\s+$//;
  }
  return wantarray ? @out : $out[0];
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = @_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  if ($debug) { print "$date ${P} | $msgmsg\n"; }
}

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  $msg = @_[0];
  &msg("=============================================================");
  &msg("Fatal Error: $msg");
  &msg("=============================================================");
  &msg("Exiting rc=1");
  exit 1;
}

#------------------------------------------------------------------------------
sub connectDB
#------------------------------------------------------------------------------
{
  &msg("Connecting to DB");
  use DBI;
  $user = "dbamon";
  $passwd = "dbamon";
  $data_source = "DBI:Oracle";
  $database = $os;

  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
    &error('Failed_on_DB_connect');
  $dbh->{LongReadLen} = 4000;
}

#-----------------------------------------------------------------------------
sub selectData
#-----------------------------------------------------------------------------
{
  &msg("Selecting");

  $statement  = "
    select 
      distinct
      instance,
      text
    from 
      dbamon.events
    where
      ts >= (sysdate - 1)
      and text like 'DBA516%'
    order by 1
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Select_$what');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $inst = $Data[0];
    $text = $Data[1];
    print DATA "$inst $text \n";
  }
  &msg("Selected $selectcount rows");
  print DATA "\nTotal Instance Count: $selectcount \n";
}

#-----------------------------------------------------------------------------
sub sum
#-----------------------------------------------------------------------------
{
  &msg("Selecting");

  $statement  = "
    select
      dbms,
      misc1,
      count(*)
   from
     dbamon.instances
   where
     misc1 is not null
   group by
     dbms,
     misc1; ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Select_$what');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;
    $dbms   = $Data[0];
    $bktype = $Data[1];
    $count  = $Data[2];
    print DATA "$dbms $bktype $count \n";
  }
}

#-----------------------------------------------------------------------------
sub init
#-----------------------------------------------------------------------------
{
  chop($hostname = `hostname`);
  chop($date = `date`);

  msg("Opening output DATA file: $tmpfl");
  system("rm $tmpfl 2>/dev/null");
  open(DATA, ">$tmpfl") || &error("Can't open output $tmpfl - $!");
  print DATA "Oracle/UX Instances Where Backups Are Not Scheduled - Last 24 Hours\n\n";
  print DATA "Oracle Server:Instance           Event Text                                  \n";
  print DATA "-------------------------------- --------------------------------------------\n";
}

#------------------------------------------------------------------------------
#
# Main
#
#------------------------------------------------------------------------------

&msg("Starting mode=$mode arg1=$arg1 arg2=$arg2 arg3=$arg3 arg4=$arg4");

&connectDB;
&init;

&selectData; 

close(DATA);
#system("cat $tmpfl | mailx -m -s 'DBAmon Report: Oracle/UX Instances Not Being Backed Up (Count=$selectcount)' team\@bigdog.cos.agilent.com");
system("cat $tmpfl | mailx -s 'DBAmon Report: Oracle/UX Instances Not Being Backed Up (Count=$selectcount)' bill_border\@agilent.com");
system("rm $tmpfl");

&msg("Done");
exit 0;
