#!/usr/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************
# =========================================================
# dbamon_ora_histupdate.pl
#
# Changes:
# 
#   bb 12Jun00 - Initial
# =========================================================

$debug = 1;

$| = 1;
$P = "dbamon_ora_histupdate.pl";
$ENV{'PATH'} = "/opt/dbamon/bin:$ENV{'PATH'}";
$os = $ENV{"ORACLE_SID"};

$verb     = $ARGV[0];
$mode     = uc $ARGV[1];
$instance = $ARGV[2];
$system   = $ARGV[3];
$dbms     = uc $ARGV[4];
$cat      = $ARGV[5];
$parm     = $ARGV[6];
$value    = $ARGV[7];

$returnrc = 0;

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = @_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  if ($debug) { print "$date ${P} | $msgmsg\n"; }
}

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  $msg = @_[0];
  &msg("=============================================================");
  &msg("Fatal Error: $msg");
  &msg("SQL Error Msg: $DBI::errstr");
  &msg("SQL Error Code: $DBI::err");
  &msg("=============================================================");
  &msg("Exiting rc=1");
  exit 1;
}

#------------------------------------------------------------------------------
sub connectDB
#------------------------------------------------------------------------------
{
  &msg("Connecting to DB");
  use DBI;
  $user = "dbamon";
  $passwd = "dbamon";
  $data_source = "DBI:Oracle";
  $database = $os;

  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
    &error('Failed_on_DB_connect');
}


#-----------------------------------------------------------------------------
sub insertHistory
#-----------------------------------------------------------------------------
{
  $statement  = "
    insert into dbamon.history
      (dbamonmode,instance,system,dbms,category,parm,value) 
    values 
    (\'$mode\',\'$instance\', \'$system\', \'$dbms\', \'$cat\', \'$parm\',$value)
  ";
  ##print "statement=$statement\n";
  $dbh->do($statement);
  $sqlerror = $DBI::errstr;
  $sqlcode = $dbh->err;
  $rows = $dbh->rows;
  ##print "sqlerror=$sqlerror sqlcode=$sqlcode\n";
  if ($sqlcode != 0)
  {
    if ($sqlcode == 1) 
    { 
      &msg("Warning: Duplicate Row - exiting with rc=2"); 
      $returnrc = 2;
    }
    else               
    { 
      &error('Insert_into_history_error'); 
    }
  }
  else
  {
    &msg("$rows Row(s) inserted");
  }
}


#------------------------------------------------------------------------------
#
# Main
#
#------------------------------------------------------------------------------

&msg("Starting verb=$verb mode=$mode arg1=$arg1 arg2=$arg2 arg3=$arg3 arg4=$arg4");

&connectDB;

if ($verb eq "I") 
{ 
  &insertHistory; 
}

&msg("Done");

exit $returnrc;
