#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************

# --------------------------------------------------------------
# Variables
# --------------------------------------------------------------

$debug = 1;
$| = 1;
$# = 2;
$P = "dbamon_oraap.pl";
$msgfile = "/tmp/dbamon_oraap_tmp.txt";
$verb = @ARGV[0];
$arg1 = @ARGV[1];
$arg2 = @ARGV[2];
$arg3 = @ARGV[3];
$arg4 = @ARGV[4];

# Get hostname
$host = `hostname`;
chop $host;

# Save Company name
$compwork = `nslookup $host | grep Name: | awk '{ print \$2 }'`;
chop $compwork;
@words = split(/\./,$compwork);
$nexttolast = $#words - 1;
$company = @words[$nexttolast];
print "$P | Company: $company\n";

$os = $ENV{"ORACLE_SID"};
$oh = $ENV{"ORACLE_HOME"};

print "$P | Starting - verb=$verb arg1=$arg1 arg2=$arg2 arg3=$arg3 arg4=$arg4\n";
if ($debug)
{
  print "$P | Env:\n";
  system("env | grep ORA");
}

#
# Subroutines
#
#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = @_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  print "$date ${P} | $msgmsg\n";
}

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  $msg = @_[0];
  print "\n";
  print "$P | Fatal Error: $msg\n";
  $date = `date`;
  print "$P | Exiting\n";
  exit 1;
}

# ----------------------------------------------------------------------
sub upchecker
# ----------------------------------------------------------------------
{
  ($puser,$pname) = @_;
  &msg("Checking for process $pname owned by user $puser");
  #if (system("ps -u $puser -f | grep $pname > /dev/null") != 0)  
  if (system("ps -u $puser -f | grep $pname | grep -v grep") != 0)  
  {
    $errorprocesses .= "[$pname Process Not Running]";
    &msg("Process not found");
  }
}

# ----------------------------------------------------------------------
sub up
# ----------------------------------------------------------------------
{
  #  arg1: app userid (this script is run by db user)
  $apuser = $arg1;
  chop($dbuser = `whoami`);

  $errorprocesses = "";
  
  &upchecker("$apuser","CPMGR");
  &upchecker("$apuser","MANAGE");
  &upchecker("$apuser","RCVOLTM");
  &upchecker("$apuser","POXCON");
  &upchecker("$apuser","CYQLIB");
  &upchecker("$apuser","PALIBR");
  &upchecker("$apuser","INCTM");
  &upchecker("$dbuser","wdblsnr.ctl");
  &upchecker("$dbuser","wdbstart");
  &upchecker("$dbuser","f60webmx");
  &upchecker("$dbuser","d2ls60");
  &upchecker("$dbuser","d2lc60");

  &msg("ErrorProcesses: $errorprocesses");

  # OS Stuff
  system("uname -a");
  system("model");
  system("echo 'MODE' `getconf SC_KERNEL_BITS 2>&1`");
  system("/tmp/dbamon_cpuinfo");
}

# ----------------------------------------------------------------------
sub bkrun
# ----------------------------------------------------------------------
{
  $cmd = $arg1;
  print "$P bkrun: Issuing at now command to run backup:\n";
  print "$P bkrun: Command before {SID} substitution: $cmd\n";
  $cmd =~ s/\{SID\}/$os/g;
  $cmd = "echo 'time $cmd' | at now";
  print "$P bkrun: About to issue: $cmd\n";
  $rc = system($cmd);
  print "$P bkrun: Back from issuing at now - rc=$rc\n";
}

# ----------------------------------------------------------------------
# Main
# ----------------------------------------------------------------------

$stime = time;

#
# Check to see if Oracle is up
#
if ($verb eq "up") 
{
  $subrc = &up();
}

#
# Terminate
#

$etime = time;
$elapsed = $etime - $stime;
print "$P | Done - elapsed: $elapsed - subrc: $subrc\n";

exit 0;
