#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************

# --------------------------------------------------------------
#
# Modification History:
#
# Date    Author Comment
# ======= ====== ===============================================
# 06Oct03 BB     Added debugging code at the end
# 25Apr04 BB     1.13 Added code to capture the rsh service type
# 1.15 14May04 bb - New NTRESKIT code. Now, try to find it in the default pat
# 1.16 05Aug04 bb - New code for 9i connection
# --------------------------------------------------------------
$version = "1.16";
$verdate = "05Aug04";

use Win32::Registry;

$debug = 1;
$| = 1;
#$# = 2;
$P = "dbamon_orant.pl";
$msgfile = "/tmp/dbamon_ora_tmp.txt";
$db_user = "internal";
$pass = "";

$os   = $ARGV[0];
$verb = $ARGV[1];
$arg1 = $ARGV[2];
$arg2 = $ARGV[3];
$arg3 = $ARGV[4];
$arg4 = $ARGV[5];

$WWW = 1 if $arg1 eq "WWW";

### Get hostname
%values="";
$Register = "System\\CurrentControlset\\Services\\tcpip\\Parameters";
$HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry $Register - $!";
$hkey->GetValues(\%values);
foreach $value (keys(%values))
{
   $RegType      = $values{$value}->[1];
   $RegValue     = $values{$value}->[2];
   $RegKey       = $values{$value}->[0];
   $hostname = $RegValue if $RegKey eq "Hostname";
}
$hkey->Close();
$host = $hostname;
$numcpus = $ENV{"NUMBER_OF_PROCESSORS"};

if ($host eq "wcoslgl3" || $host eq "nbbnas05")
{
  $db_user = "system";
}

# Save Company name
open(NSLOOKUP, 'ipconfig/all|') || die "Error running ipconfig";
while(<NSLOOKUP>)
{
  ##print;
  @words = split;
  $verb1 = $words[0];
  $verb2 = $words[1];
  ##print "verb1=$verb1 verb2=$verb2\n";
  if ($verb1 eq "Host" && $verb2 eq "Name")
  {
    $compwork = $words[$#words]; 
    ##print "compwork=$compwork\n";
  }
}
close(NSLOOKUP);
chop $compwork;
@words = split(/\./,$compwork);
$nexttolast = $#words - 1;
$company = $words[$nexttolast];
##print "$P | Company: $company\n";

$userid = Win32::LoginName();
$driver = "DBAmonOracle$os";

if ($os eq "")
{
  print "$P | Error: No OracleSID supplied\n";
  &msg("END_OF_PROBE");
  exit 1;
}
if ($verb eq "")
{
  print "$P | Error: No verb supplied\n";
  &msg("END_OF_PROBE");
  exit 1;
}

$sid_found = "false";

### Get list of sids that exist
%values="";
$Register = "SYSTEM\\CurrentControlSet\\Services";
$HKEY_LOCAL_MACHINE->Open($Register,$hkey) || die "Cannot open registry $Register -$!";
$hkey->GetKeys(\@key_list);
$hkey->Close();

foreach $RegKey (@key_list)
{
   if ($RegKey =~ "OracleService")
   {
      $sid_cnt+=1;
      $sid_length = length ($RegKey);
      $sid = uc(substr ($RegKey,13,$sid_length));
      if ($sid eq $os)
      {
         $sid_found = "true";
      }
    }
}

if ($sid_ok eq "false")
{
   &error("\"$os\" not present -- OracleService$os not found\n");
}

### Get ORACLE_HOME
%values="";
$Register = "SYSTEM\\CurrentControlSet\\Services\\OracleService$os";
$HKEY_LOCAL_MACHINE->Open($Register,$hkey) || die "Cannot open registry $Register -$!";
$hkey->GetValues(\%values);
$hkey->Close();

foreach $value (keys(%values))
{
   $RegKey   = $values{$value}->[0];
   $RegType  = $values{$value}->[1];
   $RegValue = $values{$value}->[2];
   $RegKey = lc($RegKey);

   if ($RegKey eq "imagepath")
   {
      @words = split (/\\/,$RegValue);
      $start_cmd = @words[-1];
      $_=$RegValue;
      s/$start_cmd//;
      s/bin//;
      $oh=$_;
      chop($oh);
      chop($oh);
      # print "ORACLE_HOME: $oh\n";
   }
}

#---- See if PW is set for this driver 
%values="";
$Register = "Software\\ODBC\\ODBC.INI\\$driver";
$HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| &msg("Cannot open registry $Register - $!");
if ($hkey)
{
  $hkey->GetValues(\%values) || print "Cannot read registry $Register - $!";
  foreach $value (keys(%values))
  {
     $RegType      = $values{$value}->[1];
     $RegValue     = $values{$value}->[2];
     $RegKey       = $values{$value}->[0];
     $syspw = $RegValue if $RegKey eq "Password";
  }
$hkey->Close();
}

#---- Capture oraver
$oraver     = (split(" ",`sqlplus -v`)) [2];
$oraver_fam = (split('\.',$oraver)) [0];
if ($oraver_fam > 8)
{
  $db_user = "";
  $pass    = "/ as sysdba";
}
if ($syspw)
{
  $db_user = "";
  $pass    = "";
}

#---- Get oradrive
$oradrive = substr($oh,0,2); 

#---- See if srvinfo is in the system path
if (system("srvinfo -ns >NUL") == 0)
{
  $srvinfo_path = "srvinfo";
}
else
{
  if ($ENV{'NTRESKIT'})
  {
    $srvinfo_path = "$ENV{'NTRESKIT'}\\srvinfo";
  }
  else
  {
    &msg("Hmmmm... Could not find srvinfo in default path and NTRESKIT not in env");
    ##system("$PERLPATH C:\\dbatools\\socketmail.pl border\@dba.it.agilent.com border\@dba.it.agilent.com \"dbamon_mssql.pl Cannot find srvinfo host=$host [AUTO]\" \"Hi\"");
  }
}

#---- Display banner
&msg("Starting - host=$host os=$os oh=$oh userid=$userid verb=$verb driver=$driver version=$version company=$company");
&msg("Starting - arg1=$arg1 arg2=$arg2 arg3=$arg3 arg4=$arg4 WWW=$WWW oraver=$oraver oraver_fam=$oraver_fam db_user=$db_user pass=$pass oradrive=$oradrive srvinfo_path=$srvinfo_path");

#---- Take these out for now - BB 14May04
#if ($host eq "csenv01") { $ENV{'NTRESKIT'} = "c:\\reskit"; }
#if ($host eq "spgqremw") { $ENV{'NTRESKIT'} = "e:\\reskit"; }
#if ($host eq "wcoslgl3") { $ENV{'NTRESKIT'} = "e:\\reskit"; }
#if ($host eq "engcti1") { $ENV{'NTRESKIT'} = "d:\\ntreskit"; }
#if ($host eq "cslsnt02") { $ENV{'NTRESKIT'} = "d:\\reskit"; }
#if ($host eq "wsccbp02") { $ENV{'NTRESKIT'} = "c:\\bin"; }
#if ($host eq "wsccbp02") { $ENV{'NTRESKIT'} = "c:\\bin"; }
#if ($host eq "wwadap02") { $ENV{'NTRESKIT'} = "c:\\reskit"; }

# Add $oh/bin to path
$path_orig   = $ENV{'Path'};
$path_new    = "${oh}/bin;" . $path_orig;
$ENV{"Path"} = $path_new;

# See if there is a pw file - if there is then use that as the pw
$f = "$oh\\net80\\admin\\.system";
if (-r "$f")
{
  $/="\n";
  chomp($pass = `type $f`);
  print "$P | Access shortcut ON \n";
}


# --------------------------------------------------------------
#
# Subroutines
#
# --------------------------------------------------------------

sub dbError 
{
  local($errorMsg,@error_fields) = @_;
  print "======== D B   E r r o r   E n c o u n t e r e d =========\n";
  print "Error: DB Error Encountered While: $errorMsg\n";
  print "Error: DB Error String: $DBI::errstr\n";
  print "==========================================================\n";
  $dberror = 1;
  &msg("END_OF_PROBE");
  exit 1;
}

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  $msg = $_[0];
  print "\n";
  print "$P | Fatal Error: $msg\n";
  print "Error: $msg\n";
  #$date = `date`;
  print "$P | Exiting\n";
  &msg("END_OF_PROBE");
  exit 1;
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  $date = &get_date("Y/M/D-H:M:S");
  print "$date ${P} $version | $msgmsg\n";
}


#------------------------------------------------------------------------------
sub get_date
#------------------------------------------------------------------------------
{
  # Return date in format supplied as argument. Valid formats are:
  #   Y/M/D-H:M:S
  #   YMD_HMS
  #   YMD

  $format = @_[0];

  @sysdate = localtime;
  for ($i = 0; $i <= 5; $i++)
  {
    if (@sysdate[$i] < 10)
    {
      @sysdate[$i] = 0 . @sysdate[$i];
    }
  }

  if ($format eq "Y/M/D-H:M:S")
  {
    $sysdate = @sysdate[5]+1900 . "/" . ++@sysdate[4] . "/" . @sysdate[3] . "-" . @sysdate[2] . ":" . @sysdate[1] . ":" . @sysdate[0];
  }
  elsif ($format eq "YMD_HMS")
  {
    $sysdate = @sysdate[5]+1900 . ++@sysdate[4] . @sysdate[3] . "_" . @sysdate[2] . @sysdate[1] . @sysdate[0];
  }
  elsif ($format eq "YMD")
  {
    $sysdate = @sysdate[5]+1900 . ++@sysdate[4] . @sysdate[3];
  }
  else
  {
    &error("Invalid format passed to get_date. Must be Y/M/D-H:M:S or YMD_HMS");
  }
  return $sysdate;
}


# ----------------------------------------------------------------------
sub datafiles
# ----------------------------------------------------------------------
{
  # use strict;
  use DBI;

  # Attempt to connect to the master database on the server, to verify Oracle availability.
  print "$P | Connecting to Oracle driver=$driver\n";

  $dbh = DBI->connect("DBI:ODBC:$driver","$db_user","$pass") || &dbError("Connect_To_DB");

  # Read from v$datafile;
  $sql = "select 
      d.name, 
      t.name,
      d.status
    from 
      v\$datafile d,
      v\$tablespace t
    where 
      d.ts# = t.ts# and
      status != 'SYSTEM' and 
      status != 'ONLINE'";
  $sth = $dbh->prepare("$sql") || &dbError("Prepare");
  $sth->execute || &dbError("Execute_Select");
  print "\n";
  while (@Data = $sth->fetchrow_array)
  {
    $dfname = $Data[0];
    $tsname = $Data[1];
    $status = $Data[2];
    print "OfflineDatafile: Tablespace=$tsname DFName=$dfname DFStatus=$status\n";
  }
  print "\n";
}

# ----------------------------------------------------------------------
sub ts      
# ----------------------------------------------------------------------
{
  $t_warn = $arg1;
  $t_crit = $arg2;
  $t_free = $arg3;
  $t_cmd  = $arg4;

  # Run SQL!
  # use strict;
  use DBI;

  # Attempt to connect to the master database on the server, to verify Oracle availability.
  print "$P | Connecting to Oracle driver=$driver\n";

  $dbh = DBI->connect("DBI:ODBC:$driver","$db_user","$pass") || &dbError("Connect_To_DB");

  if (!$dberror)
  {
    $sql = "
     select 
	    a.tablespace_name as tablespace_name,
	    d.contents,
	    a.sum_bytes as bytes_avail,
	    a.max_id,
	    nvl(b.sum_bytes,0) as bytes_used,
	    nvl(c.sum_bytes,0) as bytes_free,
	    round(nvl(b.sum_bytes,0.00) / a.sum_bytes * 100.0, 2) as pct_used,
	    d.status
       from 
	    ( select 
		tablespace_name,
		sum(bytes) sum_bytes,
		count(1) max_id
	      from 
		dba_data_files
	      group by 
		tablespace_name
	    ) a,
	    ( select 
		tablespace_name,
		sum(bytes) sum_bytes
	      from 
		dba_extents
	      group by 
		tablespace_name
	    ) b,
	    ( select 
		tablespace_name,
		sum(bytes) sum_bytes
	      from 
		dba_free_space
	      group by 
		tablespace_name
	    ) c,
	    dba_tablespaces d
      where a.tablespace_name = b.tablespace_name (+)
	and a.tablespace_name = c.tablespace_name (+)
	and a.tablespace_name = d.tablespace_name (+)
      ";

    $sth = $dbh->prepare("$sql") || &dbError("Prepare");
    $sth->execute || &dbError("Execute_Select");
   
    $verb = "Stack: orantTSStack";

    while (@Data = $sth->fetchrow_array)
    {
      $ts   = $Data[0];
      $type = substr($Data[1],0,4);
      $size = $Data[2]/1048576;
      $max  = $Data[3];
      $used = $Data[4]/1048576;
      $free = $Data[5]/1048576;
      $pct  = $Data[6];
      $stat = $Data[7];

      $sth2 = $dbh->prepare("select max(autoextensible) from dba_data_files where tablespace_name = '$ts'") || &dbError("Prepare");
      $sth2->execute || &dbError("Execute_Select");
      while (@Data2 = $sth2->fetchrow_array)
      {
	$autoextend = $Data2[0];
      }

      ##print "ts=$ts autoextend=$autoextend \n";

      $flag = "";
      # MB Needed to get to 5% below warning threshold
      $needed = int($used / (($t_warn-5)/100) - $size);
      if ($needed < 100)
      {
        $needed = 50;
      }
      if ($needed > 2000)
      {
        $needed = 2000;
      }
      
      if ($pct  >= $t_warn && $pct < $t_crit) { $flag = "W" . " " . $needed; }
      if ($pct  >= $t_crit )                  { $flag = "C" . " " . $needed; }
      if ($free >= $t_free)                   { $flag = "";  }
      if ($autoextend eq "YES") { $flag = "A"; } 

      ##print "ts=$ts pct=$pct t_warn=$t_warn t_crit=$t_crit flag=$flag \n";

      #printf("%s %-16s %8d %8d %8d %7.1f %s\n",$verb,$ts,$size,$used,$free,$pct,$flag);
      print "$verb $ts $type $max $size $used $free $pct $flag \n";
    }
    return;
  }
}

# ----------------------------------------------------------------------
sub arclogs
# ----------------------------------------------------------------------
{
  $t_warn = $arg1;
  $t_crit = $arg2;

  # Run SQL!
  # use strict;
  use DBI;

  # Attempt to connect to the master database on the server, to verify Oracle availability.
  print "$P | Connecting to Oracle driver=$driver\n";

  $dbh = DBI->connect("DBI:ODBC:$driver","$db_user","$pass") || &dbError("Connect_To_DB");

  if (!$dberror)
  {
    # Read from v$database
    $sql = "select log_mode from v\$database";
    $sth = $dbh->prepare("$sql") || &dbError("Prepare");
    $sth->execute || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      print "Log_Mode: $Data[0]\n";

      if ($Data[0] eq "NOARCHIVELOG")
      {
        &msg("This DB is in NOARCHIVELOG mode - not checking disk");
        return;
      }
    }

    # Read from v$archive_dest
    $sql = "select destination from v\$archive_dest where length(destination) > 0";
    $sth = $dbh->prepare("$sql") || &dbError("Prepare");
    $sth->execute || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      print "Log_Dest: $Data[0]\n";
      $logdrive = uc substr($Data[0],0,1);
      $logdrivedollar = "$logdrive\$";
      print "Log_Drive: $logdrive\n";
      $logdrivecount++;
    }
    print "Log_Drive_Count: $logdrivecount\n";

    #$logdrivesize = (Win32::Driveinfo::DriveSpace($logdrive)) [5];
    #$logdrivefree = (Win32::Driveinfo::DriveSpace($logdrive)) [6];
    #print "size=$logdrivesize free=$logdrivefree \n";

    # See how full the $logdrive disk is 
    open(SRVINFO, "$srvinfo_path -ns|") || print "Error: Running $srvinfo_path";
    while(<SRVINFO>)
    {
      $srvinfo_ran = 1;
      print;
      @words = split;

      if ($words[0] eq $logdrivedollar) 
      {
        $srvinfo_found = 1;
        $logdrivesize = $words[2];
        $logdrivefree = $words[3];
        $logdriveused = $logdrivesize - $logdrivefree;
        $logdrivepct  = int(($logdriveused / $logdrivesize) * 100);
        print "Log_Drive_Size: $logdrivesize\n";
        print "Log_Drive_Free: $logdrivefree\n";
        print "Log_Drive_Used: $logdriveused\n";
        print "Log_Drive_Pct:  $logdrivepct\n";

        if    ($logdrivepct > $t_crit) { $logflag = "C"; }
        elsif ($logdrivepct > $t_warn) { $logflag = "W"; }
        else { $logflag = " "; }
        print "Log_Flag:  $logflag\n";
      }
    }
  } # end of !$dberror

  if (!$srvinfo_ran)
  {
    print "Log_Flag:  S   ($srvinfo_path (srvinfo) did not run)\n";
    system("set");
  }

  if (!$srvinfo_found)
  {
    print "Log_Flag:  S   ($srvinfo_path (srvinfo) did run, but did not find any information for disk $logdrivedollar - something is wrong)\n";
    print "\nNT Environment:\n";
    system("set");
  }
}

# ----------------------------------------------------------------------
sub up
# ----------------------------------------------------------------------
{
  %values="";
  $Register = "Software\\Microsoft\\Windows NT\\CurrentVersion";
  $HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry $Register - $!";
  $hkey->GetValues(\%values);
  foreach $value (keys(%values))
  {
    $RegType      = $values{$value}->[1];
    $RegValue     = $values{$value}->[2];
    $RegKey       = $values{$value}->[0];
    $CurrentVersion = $RegValue if $RegKey eq "CurrentVersion";
    $CSDVersion = $RegValue if $RegKey eq "CSDVersion";
  }

  if ($CSDVersion ne "")
  {
    @sp_info = split(' ',$CSDVersion);
    $osver = $CurrentVersion . ",SP" . ${sp_info[2]};
  }
  else
  {
    $osver = $CurrentVersion;
  }

  %values="";
  $Register = "Hardware\\Description\\System\\CentralProcessor\\0";
  $HKEY_LOCAL_MACHINE->Open($Register,$hkey)|| die "Cannot open registry $Register - $!";
  $hkey->GetValues(\%values);
  foreach $value (keys(%values))
  {
    $RegType      = $values{$value}->[1];
    $RegValue     = $values{$value}->[2];
    $RegKey       = $values{$value}->[0];
    $MHz = $RegValue if $RegKey eq "\~MHz";
    $vendor = $RegValue if $RegKey eq "VendorIdentifier";
    $identifier = $RegValue if $RegKey eq "Identifier";
  }
  $hkey->Close();
  @cpu_ident = split (' ',$identifier);
  $cpumodel = ${cpu_ident[0]} . "/" . ${cpu_ident[2]};
  $cpu = $vendor . " " . " " . $MHz . " MHz ";

  $cpumodel = $ENV{'PROCESSOR_ARCHITECTURE'} . "," . $ENV{'PROCESSOR_LEVEL'};

  if (!$WWW)
  {
    print "OSVer: $osver\n";
    print "NumCPUs: $ENV{'NUMBER_OF_PROCESSORS'}\n";
    print "CPU: $cpu\n";
    print "CPUModel: $cpumodel\n";
  }

  # Test
  open(SRVINFO, "$srvinfo_path -ns|") || print "Error: Running srvinfo";
  $uptime = "?";
  while(<SRVINFO>)
  {
    ##print;
    @words = split;

    if (/^System Up Time:/)
    {
      chop($uptime = substr($_,16));
    }
  }
  &msg("Ran srvinfo to capture uptime - uptime=$uptime") if !$WWW;

  # Get memory Info
  print "$P Invoking pstat\n" if !$WWW;
  open(MEM, 'pstat 2>NUL |') 
    || print "$P Error $! Running pstat";
  while(<MEM>)
  {
    ##print;
    @words = split;
    $ram = int($words[4] / 1024);
    last;
  }
  close(MEM);
  if (defined($ram) && !$WWW)
  {
    print "RAM: $ram\n";
  }

  &msg("Invoking net start to see which services are running") if !$WWW;

  #---- See if the agent is running
  open(NET, 'net start |') || print "$P Error $! Running net start";

  $rsh_service = "?";

  while(<NET>)
  {
    ##print;
    @words = split;

    if (/TNSListener/)
    {
      $listener_running = 1;
      print "ListenerServiceRunning: Y\n" if !$WWW;
    }

    if (uc $words[0] eq uc "OracleService$os")
    {
      $service_running = 1;
      print "OracleServiceRunning: Y\n" if !$WWW;
    }

    if ($rsh_service eq "?")
    {
      if (/Remote Shell Daemon/)  { $rsh_service="RSD"; }
      if (/Remote Shell Service/) { $rsh_service="RSS"; }
      if (/CYGWIN sshd/)          { $rsh_service="CYGWIN"; }
    }
  }
  close(NET);

  &msg("After net start") if !$WWW;

  print "RSHService: $rsh_service\n" if !$WWW;

  if (!$service_running)
  {
    $dbstatus = "SERVICENOTACTIVE";
    print "DBStatus: $dbstatus\n" if !$WWW;
  }

  # See if the agent is running
  #  Determine the name of the lsnrctl program
  if (-x "$oh\\bin\\lsnrctl80.exe")
  {
    $lsnrpgm = "lsnrctl80"; 
  }
  else
  {
    $lsnrpgm = "lsnrctl"; 
  }
  &msg("Running $lsnrpgm") if !$WWW;

  open(LSNR, "$lsnrpgm status |") 
    || print "Error: Running $lsnrpgm status";
  while(<LSNR>)
  {
    print if !$WWW;
    $listener_output .= $_;
    @words = split;
    if (/command completed successfully/)
    {
      $lsnrctl_running = 1;
      last;
    }
  }
  close(LSNR);

  $lsnr_status = "OK";
  if (!$lsnrctl_running) 
  {
    $lsnr_status = "LSNRCTL-NOT-OK";
  }
  if (!$listener_running) 
  {
    $lsnr_status = "LSNR-SERVICE-NOT-RUNNING";
  }

  print "LSNRStatus: $lsnr_status \n" if !$WWW;

  if ($lsnr_status ne "OK")
  {
    &msg("Since the listener is not running properly, aborting further checks");
    if ($WWW) { exit 1; }
    return 1;
  }

  # Run SQL!
  # use strict;
  use DBI;

  # Attempt to connect to the master database on the server, to verify Oracle availability.

  &msg("Connecting to Oracle driver=$driver");

  $dbh = DBI->connect("DBI:ODBC:$driver","$db_user","$pass") || &dbError("Connect_To_DB");

  if (!$dberror)
  {
    # Read from dual
    &msg("Selecting from dual") if !$WWW;
    $sql = "select dummy from dual";
    $sth = $dbh->prepare("$sql") || &dbError("Prepare");
    $sth->execute || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      $dbdual = $Data[0];
      print "DBDual: $dbdual\n" if !$WWW;
    }

    # Read from v$instance
    &msg("Selecting from v\$instance") if !$WWW;
    $sql = "select version, status, logins from v\$instance";
    $sth = $dbh->prepare("$sql") || &dbError("Prepare");
    $sth->execute || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      $ver = $Data[0];
      $sta = $Data[1];
      $log = $Data[2];

      if (!$WWW)
      {
	print "DBStatus: $sta\n";
	print "DBVersion: $ver\n";
	print "DBLogins: $log\n";
      }
    }

    # Read from v$license
    &msg("Selecting from v\$license") if !$WWW;
    $sql = "select SESSIONS_HIGHWATER from v\$license";
    $sth = $dbh->prepare("$sql") || &dbError("Prepare");
    $sth->execute || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      $hwm = $Data[0];
      print "SESSIONSHWM: $hwm\n" if !$WWW;
    }

    # Get session userid
    &msg("Selecting from dual for user") if !$WWW;
    $sql = "select user from dual";
    $sth = $dbh->prepare("$sql") 
      || &dbError("Prepare");
    $sth->execute
      || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      $user = $Data[0];
    }
    print "Current_User: $user\n" if !$WWW;

    # Get total bytes
    &msg("Selecting from dba_data_files to get size of instance");
    $sql = "select sum(bytes) from dba_data_files";
    $sth = $dbh->prepare("$sql") 
      || &dbError("Prepare");
    $sth->execute
      || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      $tot_spacealloc = int($Data[0] / (1024*1024));
    }

    # Get total free
    &msg("Selecting from dba_free_space to get size of free space");
    $sql = "select sum(bytes) from dba_free_space";
    $sth = $dbh->prepare("$sql") 
      || &dbError("Prepare");
    $sth->execute
      || &dbError("Execute_Select");
    while (@Data = $sth->fetchrow_array)
    {
      $tot_spacefree = int($Data[0] / (1024*1024));
    }
    $tot_spaceused = $tot_spacealloc - $tot_spacefree;

    if (!$WWW)
    {
      print "SpaceFree:  $tot_spacefree\n";
      print "SpaceAlloc: $tot_spacealloc\n";
      print "SpaceUsed:  $tot_spaceused\n";
    }
 
  } # end of !$dberror

  # Decide status
  $dbstatus = "DOWN";

  if ($service_running && $dbdual eq "X" && $sta eq "OPEN")
  {
    $dbstatus = "UP";
  }
  if ($service_running && $log eq "RESTRICTED")
  {
    $dbstatus = "RESTRICTED";
  }
  if ($service_running && $dbdual ne "X")
  {
    $dbstatus = "SQLERROR";
  }

  print "DBStatus: $dbstatus \n" if !$WWW;

  if ($WWW)
  {
    $www_bgcolor = "pink";
    $www_bgcolor = "lime" if $dbstatus eq "UP";

    &msg("WWW Status Summary:");
    print "<table border=1 \n";
    print "<tr bgcolor=slate><th><h5>Item<th><h5>Status\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Hostname<td><h5>$host\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>DB Status<td><h5>$dbstatus\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Listener Status<td><h5>$lsnr_status\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Logins?<td><h5>$log\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Database Space Alloc.<td><h5>$tot_spacealloc mB\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Database Space Used<td><h5>$tot_spaceused mB\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Oracle Version<td><h5>$ver\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>CPU Info<td><h5>$cpu $cpumodel\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>CPU Count<td><h5>$numcpus\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>RAM Size<td><h5>$ram mB\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>OS Version<td><h5>$osver\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Server Up Time<td><h5>$uptime\n";
    print "<tr bgcolor=$www_bgcolor><td><h5>Remote Shell Service<td><h5>$rsh_service\n";
    print "</table>\n";

    &msg("Listener Status: $listener_output");

    &msg("Done");
    &msg("END_OF_PROBE");
    exit 0;
  }
}

# ----------------------------------------------------------------------
sub bkrun
# ----------------------------------------------------------------------
{
  $cmd = $arg1;
  print "$P bkrun: Issuing at now command to run backup:\n";
  print "$P bkrun: Command before {SID} substitution: $cmd\n";
  $cmd =~ s/\{SID\}/$os/g;
  $cmd = "echo 'time $cmd' | at now";
  print "$P bkrun: About to issue: $cmd\n";
  $rc = system($cmd);
  print "$P bkrun: Back from issuing at now - rc=$rc\n";
}

# ----------------------------------------------------------------------
sub bkup
# ----------------------------------------------------------------------
{
  # use strict;
  use DBI;

  print "$P | Connecting to Oracle driver=$driver\n";
  $dbh = DBI->connect("DBI:ODBC:$driver","$db_user","$pass")
    || &dbError("Connect_To_DB");

  $sql = "select table_name from dba_tables where owner='DBAMON' and 
          table_name='BACKUP_AGE'";
  $sth = $dbh->prepare("$sql") || &dbError("Prepare");
  $sth->execute || &dbError("Execute_Select");
  while (@Data = $sth->fetchrow_array)
  {
     $bat_exists = "true";   
  }
 
 
  if ($bat_exists = "true")
  {
     # Read from dbamon.backup_age
     $sql = "select bcklevel, max(tsnum),tstext,elapsed 
       from 
         dbamon.backup_age
       where 
         sid =\'$os\' and bcklevel !=\'ARC\' 
         group by tstext,bcklevel,elapsed
         order by 2,3";
     $sth = $dbh->prepare("$sql") || &dbError("Prepare");
     ##$sth->execute || &dbError("Execute_Select");
     $sth->execute;
     print "=======================================================\n";
     print "Backups Found in dbamon.backup_age:\n\n";

     $lvlage = 99999999;  # Age in hours of most recent LVL? backup
     while (@Data = $sth->fetchrow_array)
     {
       $bcklevel = @Data[0];
       $maxts    = @Data[1];
       $c_date   = @Data[2];
       $e_time   = @Data[3];
       $now = time();
       $agehrs   = ($now - $maxts) / 3600;
       $agehrs   = sprintf("%.0f", $agehrs);
       print "$P BACKUP_AGE: $bcklevel $agehrs - Timestamp=$c_date\n";
       if (substr($bcklevel,0,3) eq "LVL")
       {
          $bktype = "bkRMAN";
          if ($agehrs < $lvlage) { $lvlage = $agehrs; }
       }
       if (substr($bcklevel,0,3) eq "EXP")
       {
          $bktype = "bkEXP";
          if ($agehrs < $lvlage) { $lvlage = $agehrs; }
       }
       if (substr($bcklevel,0,3) eq "TBS")
       {
          $bktype = "bkTBS";
          if ($agehrs < $lvlage) { $lvlage = $agehrs; }
       }
     }
     print "BckAge: $lvlage Type: $bktype CompletionTime: $c_date ElapsedMinutes: $e_time\n"; 
     $flag = 1;
  } 
  else
  {
     # Read from v$datafile;
     $sql = "select 
         s.backup_type, 
         s.incremental_level,
         to_char(s.completion_time,'YYYY/MM/DD-HH24:MI:SS'),
         s.elapsed_seconds / 60,
         (sysdate - s.completion_time) * 24
       from 
         v\$backup_set s
       where 
         s.backup_type in ('D','I')
       order by 5 desc
       ";
     $sth = $dbh->prepare("$sql") || &dbError("Prepare");
     $sth->execute || &dbError("Execute_Select");
     print "=======================================================\n\n";
     print "Backups Found in v\$backup_set:\n\n";
     while (@Data = $sth->fetchrow_array)
     {
       $ty = $Data[0];
       $lv = $Data[1];
       $ct = $Data[2];
       $es = int($Data[3]);
       $ag = int($Data[4]);
       print "BckAge: $ag Type: $ty Level: $lv CompletionTime: $ct ElapsedMinutes: $es\n";
       $flag = 1;
     }
   }
  if (!$flag)
  {
    print "BckAge: -1\n";
  }
  print "=======================================================\n";
}

# ----------------------------------------------------------------------
sub bkhi
# ----------------------------------------------------------------------
{
  &msg("Selecting from DBAMON.BACKUP_AGE");

  # use strict;
  use DBI;

  &msg("Connecting to Oracle driver=$driver");
  $dbh = DBI->connect("DBI:ODBC:$driver","$db_user","$pass") || &dbError("Connect_To_DB");

  # Read from dbamon.backup_age
  $sql = "select 
      bcklevel, 
      tstext, 
      tsnum, 
      dbsize, 
      elapsed 
    from 
      dbamon.backup_age
    where 
      sid =\'$os\'
    order 
      by 2 desc";
  $sth = $dbh->prepare("$sql") || &dbError("Prepare");
  $sth->execute;

  $lvlage = 99999999;  # Age in hours of most recent LVL? backup
  print "<font face='Trebuchet MS'> <table bgcolor=slate> <tr>
    <th><font size=2>Backup<br>Type
    <th><font size=2>Completion<br>Timestamp
    <th><font size=2>DB Size<br>(MB Used)
    <th><font size=2>Backup Duration<br>(Minutes)
    <th><font size=2>Age Of<br>This Backup<br>(Hours) 
  ";

  $rowcount = 0;

  while (@Data = $sth->fetchrow_array)
  {
    $bcklevel = @Data[0];
    $tstext   = @Data[1];
    $tsnum    = @Data[2];
    $dbsize   = @Data[3];
    $elapsed  = @Data[4];

    $now = time();
    $agehrs   = ($now - $tsnum) / 3600;
    $agehrs   = sprintf("%.0f", $agehrs);

    $elapsed_min = $elapsed / 60;
    $elapsed_min = sprintf("%.2f", $elapsed_min);

    $rowcount++;

    print "<tr bgcolor=lightblue>
      <td><font size=2><b>$bcklevel
      <td><font size=2><b>$tstext
      <td align=right><font size=2><b>$dbsize
      <td align=right><font size=2><b>$elapsed_min
      <td align=right><font size=2><b>$agehrs
    \n";
  }
  print "</table>";
  &msg("Total Backups Found: $rowcount\n");
}

# ----------------------------------------------------------------------
#
# Main
#
# ----------------------------------------------------------------------

$stime = time;

#
# Check to see if Oracle is 
#
if ($verb eq "up") 
{
  $subrc = &up();
  $subrc = &ts();
}

#
# Check to see if the listener is up - start it if not
#
if ($verb eq "datafiles") 
{
  $subrc = &datafiles();
}

#
# Backup age
#
if ($verb eq "bkup")
{
  $subrc = &bkup();
}

#
# Archive logs 
#
if ($verb eq "arclogs")
{
  $subrc = &arclogs();
}

#
#---- Backup menu options
#
if ($verb eq "bkhi") { $subrc = &bkhi(); }

#
# Terminate
#

##&msg("Capturing etime");
$etime = time;
$elapsed = $etime - $stime;

&msg("$P DoneOK - elapsed: $elapsed - subrc: $subrc");
&msg("END_OF_PROBE");
exit 0;
