#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************

# --------------------------------------------------------------
# Variables
# --------------------------------------------------------------

$| = 1;
$P = "dbamon_sap.pl";
$tmpfl = "/tmp/dbamon_sap_tmp.txt";
$verb = $ARGV[0];
$arg1 = $ARGV[1];
$arg2 = $ARGV[2];
$arg3 = $ARGV[3];
$arg4 = $ARGV[4];

$host = `hostname`;
chop $host;

$sid = $ENV{"SAPSYSTEMNAME"};

print "$P | Starting - verb=$verb sid=$sid arg1=$arg1 arg2=$arg2 arg3=$arg3 arg4=$arg4 - SAP Env:\n";
system("env | grep SAP");

# --------------------------------------------------------------
# Subroutines
# --------------------------------------------------------------

sub error
{
  $msg = $_[0];
  print "===============================================================================\n";
  print "$P | Fatal ERROR: \n";
  print "$P | $msg \n";
  print "===============================================================================\n";
  exit 1;
}

# ----------------------------------------------------------------------
# Up
# ----------------------------------------------------------------------
sub up
{
  if (! -e "/usr/sap/$sid")
  {
    &error("SAP Instance: $sid Does Not Exist (/usr/sap/$sid Not Found)");
  }
  
  system("uname -a");
  system("model");
  system("echo 'MODE' `getconf SC_KERNEL_BITS`");
  system("/tmp/dbamon_cpuinfo");

  # Measure how full SAPMNT FS is
  $bdfflag = "OK";
  chop($bdf = `bdf /usr/sap/$sid | tail -1`);
  $_ = $bdf;
  @words  = split;
  if ($#words == 5 && index($bdf,"%") > -1)
  {
    $bdfsize = int($words[1]/1000);
    $bdfused = int($words[2]/1000);
    $bdfaval = int($words[3]/1000);
    chop($bdfpct  = $words[4]);
    $bdfname = $words[5];
  }
  elsif ($#words == 4 && index($bdf,"%") > -1)
  {
    $bdfsize = int($words[0]/1000);
    $bdfused = int($words[1]/1000);
    $bdfaval = int($words[2]/1000);
    chop($bdfpct  = $words[3]);
    $bdfname = $words[4];
  }
  else
  {
    $bdfflag = "E";
  }
  $bdfflag = "E" if $bdfsize eq "";
  $bdfflag = "C" if $bdfpct >= 99;
  print "BDFUSRSAPDIR: $bdfsize $bdfused $bdfaval $bdfpct $bdfname $bdfflag \n";

  #
  # Get SAP kernel ver
  #

  $sapkern = `/usr/sap/$sid/SYS/exe/run/R3check -? | grep version | head -1 | awk '{ print \$7 }'`;
  chop $sapkern;

  $sapkernmode = `/sapmnt/$sid/exe/disp+work 2>/dev/null | grep 'compiled for' | awk '{ print \$3 }'`;
  chop $sapkernmode;
  if ($sapkernmode eq "")
  {
    $sapkernmode = "32";
  }
  $sapkern = "$sapkern($sapkernmode)";

  #$saprlse = `echo "select * from svers" | dbaccess $sapinst 2>/dev/null | tail -3 | head -1`;
  #chop $saprlse;

  print "SAPVERSION: $sapkern \n";
  print "SAPKERNMODE: $sapkernmode \n";

  # Count processes
  chop($numstart = `ps -ef | grep /usr/sap/$sid/SYS/exe/run/sapstart | grep -v grep | wc -l`);
  print "SAPNUMSTART: $numstart \n";
  
  # Count dw
  chop($numdw = `ps -ef | grep dw.sap${sid}_ | grep -v grep | wc -l`);
  print "SAPNUMDW: $numdw \n";
  
  # Count dw
  chop($numms = `ps -ef | grep ms.sap${sid}_ | grep -v grep | wc -l`);
  print "SAPNUMMS: $numms \n";
  
  # Count co
  chop($numco = `ps -ef | grep co.sap${sid}_ | grep -v grep | wc -l`);
  print "SAPNUMCO: $numco \n";

  # Get name of start profile for the sapstart task
}

# ----------------------------------------------------------------------
# Main
# ----------------------------------------------------------------------

$stime = time;

if ($verb eq "up") 
{
  $subrc = &up();
}
else
{
  &error("Unknown verb=$verb");
}

#
# Terminate
#
$etime = time;
$elapsed = $etime - $stime;
print "$P | Done - elapsed: $elapsed - subrc: $subrc\n";

exit 0;
