#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************
# =========================================================
# dbamon_ora_sum.pl
#
# Changes:
# 
#   bb 12Jun00 - Initial
# =========================================================

$debug = 1;

$color = "darkblue";
$| = 1;
$P = "dbamon_www_check.pl";
$ENV{'PATH'} = "/opt/dbamon/bin:$ENV{'PATH'}";
$os = $ENV{"ORACLE_SID"};

$tmpfile = "/tmp/${P}_$$.txt";

$mode =  $ARGV[0];
$inst =  $ARGV[1];
$zcli =  $ARGV[2];
$ckin =  $ARGV[3];

$font = "verdana";

$arg3 = $ARGV[4];
$arg4 = $ARGV[5];

$dbamon_userid = "dbamon";

#------------------------------------------------------------------------------
sub trim
#------------------------------------------------------------------------------
{
  my @out = @_;
  for (@out)
  {
    s/^\s+//;
    s/\s+$//;
  }
  return wantarray ? @out : $out[0];
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  if ($debug) { print "$date ${P} | $msgmsg\n"; }
}

#------------------------------------------------------------------------------
sub msgRed
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  if ($debug) { print "$date ${P} | <font color=red><b>$msgmsg</b></font>\n"; }
}

#------------------------------------------------------------------------------
sub bg
#------------------------------------------------------------------------------
{
  if ($lastbg == 1)
  {
    $lastbg = 0;
    return "bgcolor=ffffff"; 
  }
  else
  {
    $lastbg = 1;
    return "bgcolor=lightgrey"; 
  }
}

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  $msg = $_[0];
  &msg("=============================================================");
  &msg("Fatal Error: $msg");
  &msg("=============================================================");
  &msg("Exiting rc=1");
  exit 1;
}

#------------------------------------------------------------------------------
sub connectDB
#------------------------------------------------------------------------------
{
  ##&msg("Connecting to DBAmon Oracle Repository DB to read DBC data");
  use DBI;
  $user = "dbamon";
  $passwd = "dbamon";
  $data_source = "DBI:Oracle";
  $database = $os;

  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
    &error('Failed_on_DB_connect');
  $dbh->{LongReadLen} = 4000;
}

#-----------------------------------------------------------------------------
sub remshDBInformix
#-----------------------------------------------------------------------------
{
  &msg("remsh'ing to Host=$Host Userid=$Userid");

  $lstring = "-l $Userid" if $Userid ne "";

  if ($Inf_Server eq "")
  {
    $_ = $Config;
    @words = split(/\//);
    $Inf_Server = $words[0];
    $ON_Config = $words[1];
    ##print "$Inf_Server $ON_Config \n";
  }

  $cmdpfx = "remsh $Host $lstring '" .
    "export INFORMIXDIR=$Informix_Dir; ".
    "export INFORMIXSERVER=$Inf_Server; ". 
    "export ONCONFIG=$ON_Config; ".
    "export PATH=\$PATH:$Informix_Dir/bin; ";

  #"/tmp/dbamon_inf.pl status '";

  &msg("Env: INFORMIXDIR=$Informix_Dir INFORMIXSERVER=$Inf_Server ONCONFIG=$ON_Config");
  &msg("Issuing: onstat -m");
  system("$cmdpfx onstat -m 2>&1");
}

#-----------------------------------------------------------------------------
sub downloadNT
#-----------------------------------------------------------------------------
{
  if ($DBMS eq "MSSQL")    { $filemask = "mssql" }
  if ($DBMS eq "OracleNT") { $filemask = "orant" }

  &msg("Downloading (rcp) DBAmon software to NT Host=$Host Userid=$Userid");
  $cmd = "remsh $Host 'rcp ${wsnamef}.${dbamon_userid}:/opt/dbamon/bin/download/*${filemask}* temp' 2>&1";
  if (system("$cmd") != 0)
  {
    &error("Cannot download DBAmon software to $Host");
  }
  &msg("Download Successful");
}


#-----------------------------------------------------------------------------
sub download
#-----------------------------------------------------------------------------
{
  &msg("Downloading (rcp) DBAmon software to Host=$Host Userid=$Userid");
  if (system("rcp /opt/dbamon/bin/download/* $Userid\@$Host:/tmp/ 2>&1") != 0)
  {
    &error("Cannot download DBAmon software to $Userid\@$Host");
  }
  ##&msg("Download Successful");
}

#-----------------------------------------------------------------------------
sub downloadSCP
#-----------------------------------------------------------------------------
{
  &msg("Downloading (scp) DBAmon software to Host=$Host Userid=$Userid");
  if (system("scp /opt/dbamon/bin/download/* $Userid\@$Host:/tmp/ 2>&1") != 0)
  {
    &error("Cannot download DBAmon software to $Userid\@$Host");
  }
  ##&msg("Download Successful");
}

#-----------------------------------------------------------------------------
sub remshDBOracleNT
#-----------------------------------------------------------------------------
{
  &msg("remsh'ing to Host=$Host Userid=$Userid ORACLE_HOME=$ORACLE_HOME ORACLE_SID=$ORACLE_SID");

  $lstring = "-l $Userid" if $Userid ne "";

  $cmdpfx = "remsh $Host $lstring '";

  if ($Perl_Path ne "")
  {
    $perlpath = "$Perl_Path";
  }
  else
  {
    $perlpath = "perl";
  }

  &msg("Issuing: $perlpath \\temp\\dbamon_orant.pl $ORACLE_SID up WWW");
  ##print "cmd=$cmdpfx $perlpath \\temp\\dbamon_orant.pl $ORACLE_SID up WWW\n"; 
  system("$cmdpfx$perlpath \\temp\\dbamon_orant.pl $ORACLE_SID up WWW' 2>&1");

  #&msg("Issuing: $perlpath \\temp\\dbamon_orant.pl $ORACLE_SID bkup");
  #system("$cmdpfx$perlpath \\temp\\dbamon_orant.pl $ORACLE_SID bkup' 2>&1");
}

#-----------------------------------------------------------------------------
sub remshOraApps
#-----------------------------------------------------------------------------
{
  &msg("remsh'ing to Host=$Host Userid=$Userid");

  $lstring = "-l $Userid" if $Userid ne "";

  $cmdpfx = "remsh $Host $lstring '" .
    "export ORACLE_HOME=$ORACLE_HOME; ".
    "export ORACLE_SID=$ORACLE_SID; ". 
    "export PATH=\$PATH:$ORACLE_HOME/bin; ";

  $cmdparm = "/tmp/dbamon_oraap.pl up $OraApps_Userid $OraApps_Minproc_Apache $OraApps_COMN_Dir $OraApps_Forms_ORAHOME $OraApps_FS_Check 2>&1";
  &msg("Issuing: $cmdparm");
  system("$cmdpfx $cmdparm ");

}

#-----------------------------------------------------------------------------
sub remshDBOracle
#-----------------------------------------------------------------------------
{
  &msg("remsh'ing to Host=$Host Userid=$Userid");

  $lstring = "-l $Userid" if $Userid ne "";

  $cmdpfx = "remsh $Host $lstring '" .
    "export WWW=Y; ".
    "export ORACLE_HOME=$ORACLE_HOME; ".
    "export ORACLE_SID=$ORACLE_SID; ". 
    "export PATH=\$PATH:$ORACLE_HOME/bin; ";

  &msg("Issuing: /tmp/dbamon_ora.pl up");
  ##system("$cmdpfx /tmp/dbamon_ora.pl up 2>&1 | grep -v Stack:");
  system("$cmdpfx /tmp/dbamon_ora.pl up 2>&1");

  ##&msg("Issuing: /tmp/dbamon_ora.pl alertlog");
  ##system("$cmdpfx /tmp/dbamon_ora.pl alertlog 2>&1");

  ##&msg("Issuing: /tmp/dbamon_ora.pl ts_full");
  ##system("$cmdpfx /tmp/dbamon_ora.pl ts_full 2>&1");
}

#-----------------------------------------------------------------------------
sub sshDBOracle
#-----------------------------------------------------------------------------
{
  &msg("ssh'ing to Host=$Host Userid=$Userid");

  $lstring = "-l $Userid" if $Userid ne "";

  if ($INF_Server eq "")
  {
    $_ = $Config;
    @words = split(/\//);
    $Inf_Server = $words[0];
    $ON_Config = $words[1];
    ##print "$Inf_Server $ON_Config \n";
  }

  #$cmdpfx = "/opt/socks/bin/ssh $lstring $Host '" .
  $cmdpfx = "ssh $lstring $Host '" .
    "export WWW=Y; ".
    "export ORACLE_HOME=$ORACLE_HOME; ".
    "export ORACLE_SID=$ORACLE_SID; ". 
    "export PATH=\$PATH:$ORACLE_HOME/bin; ";

  &msg("Issuing: /tmp/dbamon_ora.pl up");
  system("$cmdpfx /tmp/dbamon_ora.pl up 2>&1");

  ##&msg("Issuing: /tmp/dbamon_ora.pl alertlog");
  ##system("$cmdpfx /tmp/dbamon_ora.pl alertlog 2>&1");
}

#-----------------------------------------------------------------------------
sub remshDBMSSQL
#-----------------------------------------------------------------------------
{
  &msg("remsh'ing to Host=$Host Userid=$Userid");

  $lstring = "-l $Userid" if $Userid ne "";

  $cmdpfx = "remsh $Host $lstring '";
  if ($Perl_Path ne "")
  {
    $perlpath = "$Perl_Path";
  }
  else
  {
    $perlpath = "perl";
  }

  &msg("Issuing: $perlpath \\temp\\dbamon_mssql.pl up WWW");
  system("$cmdpfx $perlpath \\temp\\dbamon_mssql.pl up WWW' 2>&1");

  ##&msg("Issuing: perl \\temp\\dbamon_mssql.pl bkup");
  ##system("$cmdpfx perl \\temp\\dbamon_mssql.pl bkup' > $tmpfile 2>&1");

  ##system("cat $tmpfile | grep -v '<td>'");

  ##print "<font size=2>";
  ##print "<h4>All MSSQL Backups Created During The Last 50 Days:</h4>\n";
  ##print "<table border=1>";
  ##print "<tr bgcolor=slate><th>DB<th>Backup Created<th>Type<th>Age (Hours)\n";
  ##system("cat $tmpfile | grep '<td>'");
  ##print "</table>";

}

#-----------------------------------------------------------------------------
sub remshSAP
#-----------------------------------------------------------------------------
{
  if ($Userid eq "")
  {
    $Userid = lc $SAPSYSTEMNAME . "adm";
  }
  &msg("remsh'ing to Host=$Host Userid=$Userid");
  $lstring = "-l $Userid" if $Userid ne "";

  $cmdpfx = "remsh $Host $lstring '";

  &msg("Issuing: /tmp/dbamon_sap.pl $SAPSYSTEMNAME up");
  system("$cmdpfx /tmp/dbamon_sap.pl $SAPSYSTEMNAME up' 2>&1");
}

#-----------------------------------------------------------------------------
sub pingHost
#-----------------------------------------------------------------------------
{
  ##&msg("ping'ing Host=$Host ");

  $rc = system("/usr/sbin/ping $Host 64 1 | grep 'received, 0% packet loss' > /dev/null 2>&1");
  if ($rc != 0)
  {
    &msg("Cannot ping host=$Host - exiting");
    exit 1;
  }
  ##&msg("ping Successful");
}

#-----------------------------------------------------------------------------
sub getInstance
#-----------------------------------------------------------------------------
{
  ##&msg("Selecting DBC data for mode=$mode inst=$inst");

  # Count tasks
  $statement  = "
    select 
      text
    from 
      dbamon.dbcactive
    where
      dbamonmode = '${mode}'
      and i_hosts = '$inst'
      and text not like '#%'";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  while (@Data = $sth->fetchrow_array)
  {
    ##print "$Data[0] \n";
    $text = $Data[0];
    $_ = $Data[0];
    @words = split;
    chop($parm  = $words[0]);
    $value = $words[1];
    ##print "parm=$parm value=$value \n";
    if ($parm eq "OraApps_FS_Check") 
    {
      $cmd = "\$${parm} .= \"$value \"";
    }
    else
    {
      $cmd = "\$${parm} = \"$value\"";
    }
    ##print "cmd=$cmd \n";
    eval("$cmd"); 
  }

  if ($Host eq "")
  {
    &msg("<b>Error: I could not read the host definition for this instance</b>");
    &msg("<b>       from the DBAmon Oracle repository.</b>");
    &msg("<b>       DBAmon must be initializing.</b>");
    exit 1;
  }

  # Defaults
  $DBMS = "Informix" if $DBMS eq "";

  # Ensure that we have the right instance
  $str = "${Host}${DBMS}${Title1}${ORACLE_SID}";
  chop($ck = `echo "$str" | cksum | awk '{ print \$1 }'`);
 
  &msg("Host=$Host Title1=$Title1 DBMS=$DBMS str=$str ck=$ck");

  if ($ckin ne $ck)   
  {
    system("echo ' ' | mailx -s 'dbamon_www_check.pl CKERR ($zcli) $inst $Title1 $DBMS ck=$ck ckin=$ckin [AUTO]' bill_border\@agilent.com");
    &msg("<font color=red>The information for this instance does not verify correctly with the WWW instance that you selected.</font>");
    &msg("<font color=red>This probably means that an instance was added or removed recently, and the corresponding DBAmon</font> ");
    &msg("<font color=red>has not finished its current interaion. Please retry later.</font>");
    exit 1;
  }
}


#-----------------------------------------------------------------------------
sub init
#-----------------------------------------------------------------------------
{
  if ($mode eq "TEST")
  {
    $rcfile = "/opt/dbamon/adm/dbamonrc_test";
    $html_sys_path = "/opt/dbamon/htm/dbamon_sys_test.html";
  }
  else
  {
    $rcfile = "/opt/dbamon/adm/dbamonrc";
    $html_sys_path = "/opt/dbamon/htm/dbamon_sys.html";
  }
  
  chop($os = `grep ORACLE_SID:  $rcfile | awk '{ print \$2}'`);
  chop($oh = `grep ORACLE_HOME: $rcfile | awk '{ print \$2}'`);

  ##&msg("Setting Oracle Env.");
  $ENV{"ORACLE_SID"} = $os;
  $ENV{"ORACLE_HOME"} = $oh;
  ##system("env | grep ORACLE");

  chop($hostname = `hostname`);
  chop($date = `date`);
  chop($wsname = `hostname`);
  chop($wsnamef = `nslookup $wsname | grep Name: | awk '{ print \$2 }'`);

}

#------------------------------------------------------------------------------
#
# Main
#
#------------------------------------------------------------------------------

&msg("Starting mode=$mode inst=$inst ckin=$ckin arg3=$arg3 arg4=$arg4");

print "<hr>\n";
&msgRed("NOTE: This check that you are running only tests a few components of");
&msgRed("      this database to see if they are running. It is entirely possible");
&msgRed("      that the database could have a serious problem at the same time that");
&msgRed("      this check shows the database to be OK.");
print "<hr>\n";

&init;

&connectDB;

&getInstance;

##system("echo ' ' | mailx -s 'dbamon_www_check.pl ($zcli) $Host $Title1 $DBMS [AUTO]' bill_border\@agilent.com");

if ($Comm_Method ne "ssh") { &pingHost; }

if ($Comm_Method ne "ssh" && 
    $DBMS ne "OracleNT"   &&
    $DBMS ne "MSSQL") { &download; }
if ($DBMS eq "OracleNT"   ||
    $DBMS eq "MSSQL") { &downloadNT; }
if ($Comm_Method eq "ssh" && 
    $DBMS eq "Oracle") { &downloadSCP; }

print "<hr><p STYLE=\"background: black\"><font color=lime>";

if    ($Comm_Method ne "ssh" && $DBMS eq "Informix") { &remshDBInformix } 
elsif ($Comm_Method ne "ssh" && $DBMS eq "Oracle")   { &remshDBOracle } 
elsif ($Comm_Method ne "ssh" && $DBMS eq "OracleNT") { &remshDBOracleNT } 
elsif ($Comm_Method ne "ssh" && $DBMS eq "MSSQL")    { &remshDBMSSQL } 
elsif ($Comm_Method ne "ssh" && $DBMS eq "SAP")      { &remshSAP } 
elsif ($Comm_Method ne "ssh" && $DBMS eq "OracleApps") { &remshOraApps } 
elsif ($Comm_Method eq "ssh" && $DBMS eq "Oracle")   { &sshDBOracle } 
else    { &msg("<b>DBMS: $DBMS Comm_Method: $Comm_Method - Not yet supported by this module</b>"); }

print "<hr></font>";

&msg("Done");
system("rm $tmpfile > /dev/null 2>&1");
exit 0;
