#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************
# =========================================================
#
# Changes:
# 
#   bb 12Jun00 - Initial
# =========================================================

$| = 1;
$debug = 0;

$color = "darkblue";

$P = "dbamon_www_magnify.pl";
$auditfile = "/opt/dbamon/dat/audit/dbamon_www_magnify.txt";

$ENV{'PATH'} = "/opt/dbamon/bin:$ENV{'PATH'}";
$os = $ENV{"ORACLE_SID"};
chop($dbamon_userid = `whoami`);

$tmpfile = "/tmp/${P}_$$.txt";

$verb = $ARGV[0];
$mode = $ARGV[1];
$inst = $ARGV[2];
$ckin = $ARGV[3];
$brow = $ARGV[4];
$zcli = $ARGV[5];
$act  = $ARGV[6];
$title_in = $ARGV[7];


$font = "verdana";

if ($ckin eq ".")
{
  $modein    = $ARGV[1];
  $dbcfilein = $ARGV[2];
}

#------------------------------------------------------------------------------
sub trim
#------------------------------------------------------------------------------
{
  my @out = @_;
  for (@out)
  {
    s/^\s+//;
    s/\s+$//;
  }
  return wantarray ? @out : $out[0];
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  print "$date ${P} | $msgmsg\n"; 
}

#------------------------------------------------------------------------------
sub bg
#------------------------------------------------------------------------------
{
  if ($lastbg == 1)
  {
    $lastbg = 0;
    return "bgcolor=ffffff"; 
  }
  else
  {
    $lastbg = 1;
    return "bgcolor=lightgrey"; 
  }
}

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  $msg = $_[0];
  &msg("=============================================================");
  &msg("Fatal Error: $msg");
  &msg("=============================================================");
  &msg("statement=$statement");
  &msg("Exiting rc=1");
  exit 1;
}

#------------------------------------------------------------------------------
sub connectDB
#------------------------------------------------------------------------------
{
  &msg("Connecting to DBAmon Oracle Repository DB to read DBC data") if $debug;
  use DBI;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $os;

  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
    &error('Failed_on_DB_connect');
  $dbh->{LongReadLen} = 4000;
}



#------------------------------------------------------------------------------
sub makePulldown
#------------------------------------------------------------------------------
{
  ($this_dbms) = @_;

  $pd_debug = 0;

  $dbms_coded = "oracledbux" if $DBMS eq "Oracle";
  $dbms_coded = "oracledbnt" if $DBMS eq "OracleNT";
  $dbms_coded = "mssql"      if $DBMS eq "MSSQL";
  $dbms_coded = "sap"        if $DBMS eq "SAP";
  $dbms_coded = "oracleapps" if $DBMS eq "OracleApps";
  $dbms_coded = "informixux" if $DBMS eq "Informix";

  print "dbms_coded=$dbms_coded \n" if $pd_debug;

  $pd_options_d = "<form name=pulldown_magd>
    <select STYLE='background: cyan;font-size: 7pt'
    name=menuchoice 
    onChange='location.href=document.pulldown_magd.menuchoice.options[document.pulldown_magd.menuchoice.selectedIndex].value
    '>\n";
  $pd_options_d .= "<option selected>\n";
  $pd_options_d .= "<option STYLE='background: black; color: white'>Display Commands\n";

  $pd_options_a = "<form name=pulldown_maga>
    <select STYLE='background: cyan;font-size: 7pt'
    name=menuchoice 
    onChange='location.href=document.pulldown_maga.menuchoice.options[document.pulldown_maga.menuchoice.selectedIndex].value
    '>\n";
  $pd_options_a .= "<option selected>\n";
  $pd_options_a .= "<option STYLE='background: black; color: white'>Display Commands\n";
  
  open(BDF, "/opt/dbamon/adm/pulldown.txt") || &logit("Cannot open pulldown.txt config file - $!");
  while(<BDF>)
  {
    @words = split('\|',$_);
    $pd_dbms    = $words[1];

    next if $pd_dbms ne $dbms_coded;

    $pd_section = $words[3];
    $pd_option  = $words[5];
    $pd_desc    = $words[7];
    print "pd_dbms=$pd_dbms pd_section=$pd_section pd_option=$pd_option pd_desc=$pd_desc\n" if $pd_debug;

    if ($pd_section eq "D")
    {
      $pd_options_d .= "<option value='/cgi-bin/dbamon_magnify_run.pl?$pd_option,$mode,$inst,$ckin,$title_in,$dbms_coded,$pd_section'>[$pd_option] $pd_desc\n";
    }
    if ($pd_section eq "A")
    {
      $pd_options_a .= "<option value='/cgi-bin/dbamon_magnify_run.pl?$pd_option,$mode,$inst,$ckin,$title_in,$dbms_coded,$pd_section'>[$pd_option] $pd_desc\n";
    }
  }

  $pd_options_d .= "</select></form>\n";
  $pd_options_a .= "</select></form>\n";

  return;
}
#--------------------------------------------------------------------------------


#-----------------------------------------------------------------------------
sub download
#-----------------------------------------------------------------------------
{
  &msg("Downloading DBAmon software to Host=$Host Userid=$Userid");
  if (system("rcp /opt/dbamon/bin/download/*orastat* $Userid\@$Host:/tmp/ 2>&1") != 0)
  {
    &error("Cannot RCP download DBAmon software to $Userid\@$Host");
  }
  if (system("rcp /opt/dbamon/bin/download/dbamon_ora.pl $Userid\@$Host:/tmp/ 2>&1") != 0)
  {
    &error("Cannot RCP download DBAmon software to $Userid\@$Host");
  }
  &msg("Download Successful") if $debug;

  # Register this download so that we don't have to do it again right away
  system("mkdir /opt/dbamon/tmp/download_registry 2>/dev/null");
  system("touch /opt/dbamon/tmp/download_registry/$Host");
}

#-----------------------------------------------------------------------------
sub downloadSSH
#-----------------------------------------------------------------------------
{
  # Get the timestamp of the most recent registry download entry
  $z1 = ( stat "/opt/dbamon/tmp/download_registry/$Host" ) [9];
  $z2 = int((time - $z1) / 60);
  &msg("It has been $z2 minutes since the last download for this host - /opt/dbamon/tmp/download_registry/$Host");
  if ($z2 < 60)
  {
    &msg("Since it has been < 60 minutes since the last download for this host, skipping download");
    return;
  }

  &msg("Downloading (SSH) DBAmon software to Host=$Host Userid=$Userid");
  if (system("scp /opt/dbamon/bin/download/*orastat* $Userid\@$Host:/tmp/ 2>&1") != 0)
  {
    &error("Cannot SCP download DBAmon software to $Userid\@$Host");
  }
  &msg("Download Successful") if $debug;

  # Register this download so that we don't have to do it again right away
  system("mkdir /opt/dbamon/tmp/download_registry 2>/dev/null");
  system("touch /opt/dbamon/tmp/download_registry/$Host");
}

#-----------------------------------------------------------------------------
sub downloadNT
#-----------------------------------------------------------------------------
{
  # Get the timestamp of the most recent registry download entry
  $z1 = ( stat "/opt/dbamon/tmp/download_registry/$Host" ) [9];
  $z2 = int((time - $z1) / 60);
  &msg("It has been $z2 minutes since the last download for this host - /opt/dbamon/tmp/download_registry/$Host");
  if ($z2 < 60)
  {
    &msg("Since it has been < 60 minutes since the last download for this host, skipping download");
    return;
  }

  &msg("Downloading (NT) DBAmon software to Host=$Host");
  if (system("remsh $Host 'rcp ${fqhost}.${dbamon_userid}:/opt/dbamon/bin/download/*orantstat* temp' 2>&1") != 0)
  {
    &error("Cannot download DBAmon software to $Userid\@$Host");
  }
  if (system("remsh $Host 'rcp ${fqhost}.${dbamon_userid}:/opt/dbamon/bin/download/*dbamon_mssql* temp' 2>&1") != 0)
  {
    &error("Cannot download DBAmon software to $Userid\@$Host");
  }

  # Register this download so that we don't have to do it again right away
  system("mkdir /opt/dbamon/tmp/download_registry 2>/dev/null");
  system("touch /opt/dbamon/tmp/download_registry/$Host");
}


#-----------------------------------------------------------------------------
sub downloadNTSSH
#-----------------------------------------------------------------------------
{
  if ($DBMS eq "MSSQL")    { $filemask = "mssql" }
  if ($DBMS eq "OracleNT") { $filemask = "orant" }

  &msg("downloadNTSCP: Downloading (scp) DBAmon software to NT Host=$Host Userid=$Userid");
  $cmd = "scp /opt/dbamon/bin/download/*${filemask}* '$Userid\@$Host:\\\\temp' 2>&1";
  &msg("cmd=$cmd");
  if (system("$cmd") != 0)
  {
    &error("Cannot download DBAmon software to $Host");
  }
  &msg("Download Ended RC=0");
}



#-----------------------------------------------------------------------------
sub remshDBOracleNT
#-----------------------------------------------------------------------------
{
  &msg("remsh'ing to Host=$Host Userid=$Userid ORACLE_HOME=$ORACLE_HOME ORACLE_SID=$ORACLE_SID") if $debug;
  &msg("Invoking command on Host=$Host");

  $lstring = "-l $Userid" if $Userid ne "";

  $cmdpfx = "remsh $Host $lstring '";

  if ($Perl_Path ne "")
  {
    $perlpath = "$Perl_Path";
  }
  else
  {
    $perlpath = "perl";
  }

  $s_time = time;
  $cmd = "${cmdpfx}${perlpath} \\temp\\dbamon_orantstat.pl $ORACLE_SID $verb 2>&1";
  &msg("Invoking: $cmd") if $debug;
  &msg("Invoking: $cmd");
  system("$cmd");
  $e_time = time;
  print "\n</font></b></p>\n";
}

#-----------------------------------------------------------------------------
sub remshDBOracle
#-----------------------------------------------------------------------------
{

  $lstring = "-l $Userid" if $Userid ne "";

  $cmdpfx = "remsh $Host $lstring '" .
    "export DBAMON=Y; ".
    "export ORACLE_HOME=$ORACLE_HOME; ".
    "export ORACLE_SID=$ORACLE_SID; ". 
    "export PATH=\$PATH:$ORACLE_HOME/bin; ";

  &msg("remsh'ing to Host=$Host Userid=$Userid Command=/tmp/dbamon_orastat.pl $verb");
  
  $s_time = time;
  system("$cmdpfx /tmp/dbamon_orastat.pl $verb 2>&1");
  $e_time = time;
}

#-----------------------------------------------------------------------------
sub sshDBOracle
#-----------------------------------------------------------------------------
{
  $lstring = "-l $Userid" if $Userid ne "";

  if ($INF_Server eq "")
  {
    $_ = $Config;
    @words = split(/\//);
    $Inf_Server = $words[0];
    $ON_Config = $words[1];
    ##print "$Inf_Server $ON_Config \n";
  }

  #$cmdpfx = "/opt/socks/bin/ssh $lstring $Host '" .
  $cmdpfx = "ssh $lstring $Host '" .
    "export DBAMON=Y; ".
    "export ORACLE_HOME=$ORACLE_HOME; ".
    "export ORACLE_SID=$ORACLE_SID; ". 
    "export PATH=\$PATH:$ORACLE_HOME/bin; ";

  &msg("ssh'ing to Host=$Host Userid=$Userid Command=/tmp/dbamon_orastat.pl $verb") if $debug;
  
  $s_time = time;
  system("$cmdpfx /tmp/dbamon_orastat.pl $verb 2>&1");
  $e_time = time;
  print "</table></font></b>\n";
}

#-----------------------------------------------------------------------------
sub pingHost
#-----------------------------------------------------------------------------
{
  &msg("ping'ing Host=$Host") if $debug;

  $rc = system("/usr/sbin/ping $Host 64 1 | grep 'received, 0% packet loss' > /dev/null 2>&1");
  if ($rc != 0)
  {
    &msg("Cannot ping host=$Host - exiting");
    exit 1;
  }
  &msg("ping Successful") if $debug;
}

#-----------------------------------------------------------------------------
sub getInstance
#-----------------------------------------------------------------------------
{
  if ($ckin eq ".")
  {
    #&msg("Selecting DBC key for modein=$modein dbcfilein=$dbcfilein");
    # Count tasks
    $statement  = "
      select
        i_hosts,
        dbamonmode
      from
        dbamon.dbcactive
      where
        text like '%DBCFileName=$dbcfilein%'
        and dbamonmode like '$modein%'
        ";
    ##print "$statement\n";
    $sth = $dbh->prepare($statement) ||
            &error('Failed_on_DB_prepare_in_chgEnt');
    $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
    while (@Data = $sth->fetchrow_array)
    {
      $inst = $Data[0];
      $mode = $Data[1];
    }
    &msg("Derived inst=$inst mode=$mode");
  }

  ##&msg("Selecting DBC data for mode=$mode inst=$inst");

  # Count tasks
  $statement  = "
    select 
      text
    from 
      dbamon.dbcactive
    where
      dbamonmode = '${mode}'
      and i_hosts = '$inst'
      and text not like '#%'";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  while (@Data = $sth->fetchrow_array)
  {
    ##print "$Data[0] \n";
    $text = $Data[0];
    $_ = $Data[0];
    @words = split;
    chop($parm  = $words[0]);
    $value = $words[1];
    ##print "parm=$parm value=$value \n";
    if ($parm eq "OraApps_FS_Check") 
    {
      $cmd = "\$${parm} .= \"$value \"";
    }
    else
    {
      $cmd = "\$${parm} = \"$value\"";
    }
    ##print "cmd=$cmd \n";
    eval("$cmd"); 
  }

  if ($Host eq "")
  {
    &msg("<b>Error: I could not read the host definition for this instance</b>");
    &msg("<b>       from the DBAmon Oracle repository.</b>");
    &msg("<b>       DBAmon must be initializing.</b>");
    exit 1;
  }

  # Defaults
  $DBMS = "Informix" if $DBMS eq "";

  # Ensure that we have the right instance
  $str = "${Host}${DBMS}${Title1}${ORACLE_SID}";
  chop($ck = `echo "$str" | cksum | awk '{ print \$1 }'`);
 
  &msg("Host=$Host Title1=$Title1 DBMS=$DBMS Comm_Method=$Comm_Method str=$str ck=$ck");

  if ($ckin ne $ck && $ckin ne ".")   
  {
    system("echo ' ' | mailx -m -s '$P CKERR ($zcli) $inst $Title1 $DBMS ck=$ck ckin=$ckin [AUTO]' bill_border\@agilent.com");
    &msg("<font color=red>The information for this instance does not verify correctly with the WWW instance that you selected.</font>");
    &msg("<font color=red>This probably means that an instance was added or removed recently, and the corresponding DBAmon</font> ");
    &msg("<font color=red>has not finished its current interaion. Please retry later.</font>");
    exit 1;
  }
}


#-----------------------------------------------------------------------------
sub init
#-----------------------------------------------------------------------------
{
  if ($mode eq "TEST")
  {
    $rcfile = "/opt/dbamon/adm/dbamonrc_test";
    $html_sys_path = "/opt/dbamon/htm/dbamon_sys_test.html";
  }
  else
  {
    $rcfile = "/opt/dbamon/adm/dbamonrc";
    $html_sys_path = "/opt/dbamon/htm/dbamon_sys.html";
  }
  
  chop($os = `grep ORACLE_SID:  $rcfile | awk '{ print \$2}'`);
  chop($oh = `grep ORACLE_HOME: $rcfile | awk '{ print \$2}'`);

  ##&msg("Setting Oracle Env.");
  $ENV{"ORACLE_SID"} = $os;
  $ENV{"ORACLE_HOME"} = $oh;
  ##system("env | grep ORACLE");

  chop($hostname = `hostname`);
  chop($fqhost = `nslookup $hostname | grep Name: | awk '{ print \$2 }'`);
  chop($date = `date`);

}

#------------------------------------------------------------------------------
sub autoCmdMSSQLbkhi
#------------------------------------------------------------------------------
{
  if ($Comm_Method eq "ssh")
  {
    $cmd = "ssh -l $Userid $Host '$perlpath /temp/dbamon_mssql.pl bkhi $verbarg1'";
  }
  else
  {
    $cmd = "remsh $Host '$perlpath \\temp\\dbamon_mssql.pl bkhi $verbarg1'";
  }

  &msg("remsh-ing to $Host - cmd=$cmd");
  system("$cmd 2>&1");

  #$z = `cat $tmpfile`;
  #$z =~ s/</{/g;
  #$z =~ s/>/}/g;
  #print "$z";
}

#------------------------------------------------------------------------------
sub autoCmdMSSQLbkrb
#------------------------------------------------------------------------------
{

  if ($verbarg1 eq "ALLV")
  {
    $bkpcmd = "{PERLPATH} C:\\dbatools\\mssql_backup_all.pl V $verbarg2 ";
  }
  elsif ($verbarg1 eq "ALLD")
  {
    $bkpcmd = "{PERLPATH} C:\\dbatools\\mssql_backup_all.pl D $verbarg2 $backup_diskloc";
  }
  elsif ($backup_method eq "D")
  {
    $bkpcmd = "{PERLPATH} C:\\dbatools\\mssql_disk_backup.pl {DB} $verbarg2 $backup_diskloc";
  }
  elsif ($backup_method eq "O")
  {
    $bkpcmd = "{PERLPATH} C:\\dbatools\\mssql_OBII_backup.pl {DB} $verbarg2 ";
  }
  else
  {
    $bkpcmd = "{PERLPATH} C:\\dbatools\\mssql_veritas_backup.pl {DB} $verbarg2 ";
  }

  &msg("backup_method=$backup_method bkpcmd=$bkpcmd");

  if ($Comm_Method eq "ssh")
  {
    $cmd = "ssh -l $Userid $Host '$perlpath /temp/dbamon_mssql.pl bkrun $verbarg1 B \"$bkpcmd\"'";
  }
  else
  {
    $cmd = "remsh $Host '$perlpath \\temp\\dbamon_mssql.pl bkrun $verbarg1 B \"$bkpcmd\"'";
  }

  &msg("remsh-ing to $Host - cmd=$cmd");
  system("$cmd 2>&1");

  #$z = `cat $tmpfile`;
  #$z =~ s/</{/g;
  #$z =~ s/>/}/g;
  #print "$z";
}

#------------------------------------------------------------------------------
sub autoCmdOraclebkrb
#------------------------------------------------------------------------------
{
  $bkpcmd = "/usr/local/dba/tools/ora_backup {SID} $verbarg2 >> /opt/oracle/adm/cronlog/ora_backup_{SID}_${verbarg2}.log ";

  $lstring = "-l $Userid" if $Userid ne "";

  if ($Comm_Method eq "ssh")
  {

  }
  else
  {
    $cmdpfx = "remsh $Host $lstring '" .
      "export DBAMON=Y; ".
      "export ORACLE_HOME=$ORACLE_HOME; ".
      "export ORACLE_SID=$ORACLE_SID; ". 
      "export PATH=\$PATH:$ORACLE_HOME/bin; ";
  }

  $cmd = "$cmdpfx /tmp/dbamon_ora.pl bkrb $verbarg2";
  &msg("remsh-ing to $Host - cmd=$cmd");
  system("$cmd 2>&1");

  #$z = `cat $tmpfile`;
  #$z =~ s/</{/g;
  #$z =~ s/>/}/g;
  #print "$z";

  &autoCmdOraclebkps;
}

#------------------------------------------------------------------------------
sub autoCmdMSSQLbkbl
#------------------------------------------------------------------------------
{
  if ($Comm_Method eq "ssh")
  {
    $cmd = "ssh -l $Userid $Host '$perlpath /temp/dbamon_mssql.pl bkbl $verbarg1 $verbarg2'";
  }
  else
  {
    $cmd = "remsh $Host '$perlpath \\temp\\dbamon_mssql.pl bkbl $verbarg1 $verbarg2'";
  }

  &msg("remsh-ing to $Host - cmd=$cmd");

  system("$cmd 2>&1");

  #$z = `cat $tmpfile`;
  #$z =~ s/</{/g;
  #$z =~ s/>/}/g;
  #print "$z";
  &msg("Click <b>RELOAD</b> to refresh.");
}

#------------------------------------------------------------------------------
sub autoCmdOraclebkbl
#------------------------------------------------------------------------------
{
  $lstring = "-l $Userid" if $Userid ne "";

  $cmdpfx = "remsh $Host $lstring '" .
    "export DBAMON=Y; ".
    "export ORACLE_HOME=$ORACLE_HOME; ".
    "export ORACLE_SID=$ORACLE_SID; ". 
    "export PATH=\$PATH:$ORACLE_HOME/bin; ";

  &msg("remsh'ing to Host=$Host Userid=$Userid Command=/tmp/dbamon_orastat.pl $verb") if $debug;

  $cmd = "$cmdpfx /tmp/dbamon_ora.pl bkbl $verbarg1 $verbarg2 $verbarg3";
  &msg("remsh-ing to $Host - cmd=$cmd");

  system("$cmd 2>&1");

  #$z = `cat $tmpfile`;
  #$z =~ s/</{/g;
  #$z =~ s/>/}/g;
  #print "$z";
  &msg("Click <b>RELOAD</b> to refresh.");
}

#------------------------------------------------------------------------------
sub autoCmdOraclebkhi
#------------------------------------------------------------------------------
{
  $lstring = "-l $Userid" if $Userid ne "";

  $cmdpfx = "remsh $Host $lstring '" .
    "export DBAMON=Y; ".
    "export ORACLE_HOME=$ORACLE_HOME; ".
    "export ORACLE_SID=$ORACLE_SID; ". 
    "export PATH=\$PATH:$ORACLE_HOME/bin; ";

  &msg("remsh'ing to Host=$Host Userid=$Userid Command=/tmp/dbamon_orastat.pl $verb") if $debug;

  $cmd = "$cmdpfx /tmp/dbamon_ora.pl bkhi $verbarg1 $verbarg2 $verbarg3";
  &msg("remsh-ing to $Host - cmd=$cmd");

  system("$cmd 2>&1");

  #$z = `cat $tmpfile`;
  #$z =~ s/</{/g;
  #$z =~ s/>/}/g;
  #print "$z";
  &msg("Click <b>RELOAD</b> to refresh.");
}

#------------------------------------------------------------------------------
sub autoCmdOraclebkps
#------------------------------------------------------------------------------
{
  $lstring = "-l $Userid" if $Userid ne "";

  $cmdpfx = "remsh $Host $lstring '" .
    "export DBAMON=Y; ".
    "export ORACLE_HOME=$ORACLE_HOME; ".
    "export ORACLE_SID=$ORACLE_SID; ". 
    "export PATH=\$PATH:$ORACLE_HOME/bin; ";

  &msg("remsh'ing to Host=$Host Userid=$Userid Command=/tmp/dbamon_orastat.pl $verb") if $debug;

  $cmd = "$cmdpfx /tmp/dbamon_ora.pl bkps $verbarg1 $verbarg2 $verbarg3";
  &msg("remsh-ing to $Host - cmd=$cmd");

  system("$cmd 2>&1");

  #$z = `cat $tmpfile`;
  #$z =~ s/</{/g;
  #$z =~ s/>/}/g;
  #print "$z";
  &msg("Click <b>RELOAD</b> to refresh.");
}

#------------------------------------------------------------------------------
sub autoCmdMSSQLbk
#------------------------------------------------------------------------------
{
  &msg("Selecting mssql_backup data");
  $statement  = "
    select
      db,
      bkts,
      bkage
    from
      dbamon.mssql_backup
    where
      server = '$title_in'
      ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
	  &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  print "</pre></font></p><font face=$font><h5>MSSQL Backup Menu For Server: $Host (Backup Method: $backup_method_long)</h5>
  <table border=1>
  <tr bgcolor=slate>
    <th ><h6>Database
    <th ><h6>Last LVLx Backup<br>Timestamp
    <th ><h6>Hours<br>Since<br>Last<br>Backup
    <th><h6>View<br>mssql_backup<br>Log File 
    <th><h6>Launch<br>New<br>Backup
    <th><h6>View DB <br>Backup<br>History
  ";
   

  while (@Data = $sth->fetchrow_array)
  {
    $db    = $Data[0];
    $bkts  = $Data[1];
    $bkage = $Data[2];
    ##&msg("Found db=$db bkts=$bkts bkage=$bkage");

    $bkage = "" if $bkage == -1;
    print "
    <tr bgcolor=lightblue>
      <td><font size=2><b>$db</b>
      <td><font size=2>$bkts
      <td align=right><font size=2>$bkage
      <td><font size=2>View Log:
          <font size=2><a href='/cgi-bin/dbamon_magnify_run.pl?bkbl-$db-LVL0,$modein,$dbcfilein,.,$title_in,mssql,M'>LVL0</a> |
          <font size=2><a href='/cgi-bin/dbamon_magnify_run.pl?bkbl-$db-LVL1,$modein,$dbcfilein,.,$title_in,mssql,M'>LVL1</a> |
          <font size=2><a href='/cgi-bin/dbamon_magnify_run.pl?bkbl-$db-ARC ,$modein,$dbcfilein,.,$title_in,mssql,M'>ARC</a>
      <td><font size=2>Launch Backup:
          <font size=2><a href='/cgi-bin/dbamon_magnify_run.pl?bkrb-$db-LVL0,$modein,$dbcfilein,.,$title_in,mssql,M'>LVL0</a> |
          <font size=2><a href='/cgi-bin/dbamon_magnify_run.pl?bkrb-$db-LVL1,$modein,$dbcfilein,.,$title_in,mssql,M'>LVL1</a> |
          <font size=2><a href='/cgi-bin/dbamon_magnify_run.pl?bkrb-$db-ARC ,$modein,$dbcfilein,.,$title_in,mssql,M'>ARC</a>
      <td><font size=2><a href='/cgi-bin/dbamon_magnify_run.pl?bkhi-$db,$modein,$dbcfilein,.,$title_in,mssql,M'>View History</a> 
    ";
  }

  print "
  <tr bgcolor=lightblue><td colspan=99><hr>
  <tr bgcolor=lightblue>
    <td><font size=2><b>*All Databases*</b>
    <td><font size=2>(N/A)
    <td align=right><font size=2>(N/A)
    <td><font size=2>View Log:
	<font size=2><a href='/cgi-bin/dbamon_magnify_run.pl?bkbl-ALL,$modein,$dbcfilein,.,$title_in,mssql,M'>All Launcher</a>
    <td><font size=2>Launch Backup:
	<font size=2><a href='/cgi-bin/dbamon_magnify_run.pl?bkrb-ALL${backup_method}-LVL0,$modein,$dbcfilein,.,$title_in,mssql,M'>LVL0</a> |
	<font size=2><a href='/cgi-bin/dbamon_magnify_run.pl?bkrb-ALL${backup_method}-LVL1,$modein,$dbcfilein,.,$title_in,mssql,M'>LVL1</a> |
	<font size=2><a href='/cgi-bin/dbamon_magnify_run.pl?bkrb-ALL${backup_method}-ARC ,$modein,$dbcfilein,.,$title_in,mssql,M'>ARC</a>
    <td><font size=2>(N/A)
  ";

  print "</table><pre>\n";
}

#------------------------------------------------------------------------------
sub autoCmdOraclebkSub1
#------------------------------------------------------------------------------
{
  my $bktype = $_[0];
  print "
  <tr bgcolor=lightblue>
    <td><font size=2><b>$bktype</b>
    <td><font size=2>
	<font size=2><a href='/cgi-bin/dbamon_magnify_run.pl?bkbl-$db-$bktype-view,$modein,$dbcfilein,.,$title_in,oracle,M'>View Log</a> |
	<font size=2><a href='/cgi-bin/dbamon_magnify_run.pl?bkbl-$db-$bktype-tail,$modein,$dbcfilein,.,$title_in,oracle,M'>Tail -50 Log</a> |
	<font size=2><a href='/cgi-bin/dbamon_magnify_run.pl?bkrb-$db-$bktype,$modein,$dbcfilein,.,$title_in,oracle,M'>Launch Backup</a>
  ";
}

#------------------------------------------------------------------------------
sub autoCmdOraclebk
#------------------------------------------------------------------------------
{
  print "</pre></font></p><font face=$font><h5>Oracle Backup Menu For Oracle Instance: $title_in</h5>
  <table border=1>
  <tr bgcolor=slate>
    <th><h5>Backup<br>Type
    <th><h5>Available Transactions
  ";
   
  $bkage = "" if $bkage == -1;

  print "
  <tr bgcolor=lightblue>
    <td><font size=2><b>(All)</b>
    <td><font size=2>
	<font size=2><a href='/cgi-bin/dbamon_magnify_run.pl?bkps-$db-$bktype,$modein,$dbcfilein,.,$title_in,oracle,M'>View Running Backups / List Logs</a> |
        <font size=2><a href='/cgi-bin/dbamon_magnify_run.pl?bkhi-$db,$modein,$dbcfilein,.,$title_in,oracle,M'><br>View Backup History</a> 
  ";

  &autoCmdOraclebkSub1("ARC");
  &autoCmdOraclebkSub1("ARCEMERGENCY");
  &autoCmdOraclebkSub1("ARCFSCHECK");
  &autoCmdOraclebkSub1("ARCKEEP8");
  &autoCmdOraclebkSub1("ARCKEEP24");
  &autoCmdOraclebkSub1("LVL0");
  &autoCmdOraclebkSub1("LVL1");

  print "
  <tr bgcolor=lightblue>
    <td><font size=2><b>OFFLINE</b>
    <td><font size=2>
	<font size=2><a href='/cgi-bin/dbamon_magnify_run.pl?bkbl-$db-OFFLINE-view,$modein,$dbcfilein,.,$title_in,oracle,M'>View Log</a> |
	<font size=2><a href='/cgi-bin/dbamon_magnify_run.pl?bkbl-$db-OFFLINE-tail,$modein,$dbcfilein,.,$title_in,oracle,M'>Tail -50 Log</a> 
  ";

  print "
  <tr bgcolor=lightblue>
    <td><font size=2><b>DBAmon</b>
    <td><font size=2>
	<font size=2><a href='/cgi-bin/dbamon_magnify_run.pl?bkbl-$db-DBAmon-view,$modein,$dbcfilein,.,$title_in,oracle,M'>View Log</a> |
	<font size=2><a href='/cgi-bin/dbamon_magnify_run.pl?bkbl-$db-DBAmon-tail,$modein,$dbcfilein,.,$title_in,oracle,M'>Tail -50 Log</a> 
  ";


  print "</table><pre>\n";
}


#------------------------------------------------------------------------------
#
# Main
#
#------------------------------------------------------------------------------

&msg("Starting mode=$mode inst=$inst ckin=$ckin brow=$brow act=$act title_in=$title_in");

&init;

&connectDB;

&getInstance;

##system("echo ' ' | mailx -m -s '$P ($zcli) $Host $Title1 $DBMS $verb [AUTO]' bill_border\@agilent.com");

if ($Perl_Path ne "")
{
  $perlpath = "$Perl_Path";
}
else
{
  $perlpath = "perl";
}

if ($DBMS ne "Oracle" && $DBMS ne "OracleNT" && $DBMS ne "MSSQL") 
{
  &msg("<b><font color=red>DBAmon 'Magnify' only works for Oracle/UX and Oracle/NT</font></b>");
  exit 1;
}

#if ($Comm_Method ne "ssh") { &pingHost; }



##print "verb=$verb\n";
if ($verb =~ /-/)
{
  if ($DBMS eq "OracleNT" || $DBMS eq "MSSQL")
  {
    if ($Comm_Method eq "ssh")     { &downloadNTSSH; } 
    else                           { &downloadNT; }
  }
  else
  {
    if ($Comm_Method eq "ssh")     { &downloadSSH; } 
    else                           { &download; }
  }
}

if ($brow eq "IE")
{
  print "<hr><p STYLE=\"background: black\"><font color=cyan face='andale mono'>";
}
else
{
  print "<hr><font color=darkblue><b>";
}


if ($act eq "M")
{
  # Try to determine the backup method (D, V or O)
  chop($backup_method_line = `grep '^$Host' /usr/local/dba/tools/mssql_backup_sched.cfg | head -1`);
  $backup_method  = (split(" ",$backup_method_line)) [6];

  @words= split(" ",$backup_method_line);
  $backup_diskloc = $words[7] if $#words > 6;

  if    ($backup_method eq "D") { $backup_method_long = "(D)isk - DiskPath=$backup_diskloc"; }
  elsif ($backup_method eq "V") { $backup_method_long = "(V)eritas"; }
  else                          { $backup_method_long = "No mssql_backup_sched Entry Found - Assuming (V)eritas"; $backup_method = "V"; }

  if ($verb =~ /-/)
  {
    @words = split('\-',$verb);
    $verb     = $words[0];
    $verbarg1 = $words[1];
    $verbarg2 = $words[2];
    $verbarg3 = $words[3];
    &msg("verb=$verb verbarg1=$verbarg1 verbarg2=$verbarg2 verbarg3=$verbarg3"); 
  }
  $zsub = "&autoCmd$DBMS$verb()";
  &msg("AutoCmd: Invoking $verb for $DBMS - $zsub"); 
  ##system("echo ' ' | mailx -m -s '$P $zsub ($zcli) $Host $Title1 $DBMS $verb [AUTO]' bill_border\@agilent.com");

  # Audit line
  $audit = "$date $P $zsub $DBMS $Host $Title1 $verbarg1 $verbarg2 $verbarg3";
  system("echo '$audit' >> $auditfile");

  eval($zsub);
  exit;
}


if ($Comm_Method ne "ssh" && $DBMS eq "Oracle")     { &remshDBOracle } 
if ($Comm_Method eq "ssh" && $DBMS eq "Oracle")     { &sshDBOracle } 

if ($Comm_Method ne "ssh" && $DBMS eq "OracleNT")   { &remshDBOracleNT } 
#if ($Comm_Method eq "ssh" && $DBMS eq "OracleNT")  { &sshDBOracleNT } 

print "</pre></font></b></p><font face=$font color=black>\n";
print "<hr>";
$elapsed = $e_time - $s_time;

#if    ($act eq "D") { $goback = "-1"; }
#elsif ($act eq "A") { $goback = "-2"; }
#print "<script language='JavaScript'>
#  function back() { history.go($goback); }
#</script>";
#print "<pre><a href='javascript:back()'>Click Here</a> to return to the previous page.<pre>";

#
# Make Pulldown
#

&makePulldown;
print "<font size=2><b>Reinvoke Menu:</b></font><p>
<table border=0>
<tr bgcolor=slate><th><h5>Display<br>Commands
  <th><h5>Alter<br>Commands
<tr align=center>
  <td>$pd_options_d 
  <td>$pd_options_a </table><hr>\n";

#print "<script language='JavaScript'> 
#  confirm('Click OK to return to previous WWW page.');
#  history.go($goback); 
#  </script>\n"; 

if    ($act eq "D") { $goback = "-1"; }
elsif ($act eq "A") { $goback = "-2"; }
print "<script language='JavaScript'> function back() { history.go($goback); } </script> 
  <br><b><font size=2><a href='javascript:back()'>Click Here</a> to return to the previous page.</b>
  <pre></font>";

system("rm $tmpfile > /dev/null 2>&1");
exit 0;
