# -----------------------------------------------------------------------------
sub oraArclog
{
  ($thishost) = @_;
  #
  # Check Oracle to see if arclogs are configured ok and dir not full
  #

  if ($t_arclog_w[$thishost] eq "N")
  {
    &logit("(Not Selected (T_Arclog_Full: is N)",$thishost);
    return 1;
  }

  if ($up[$thishost] ne "Y")
  {
    logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  if ($t_arclog_w[$thishost] eq "") { $t_arclog_w[$thishost] = "80" }
  if ($t_arclog_c[$thishost] eq "") { $t_arclog_c[$thishost] = "90" }
  
  &remsh("/tmp/dbamon_ora.pl arclogs $t_arclog_w[$thishost] $t_arclog_c[$thishost] \"$t_arclog_cmd[$thishost]\"",$tmpfl3,$thishost);
  ##system("cat $tmpfl3");

  #See if auto-inhibit occured
  if ($up[$thishost] eq "I")
  {
    logit("(Auto-Inhibited)",$thishost);
    return;
  }

  $arcdir = "";
  $arcfs = "";
  $arcdirfull = "";
  $arcdesterror = "";
  $arcdestwarning = "";
  $arclogmode = 0;
  $arcdestheader = 0;

  &logDetails($thishost,"</table>");
  &logDetails($thishost,"<h3>Oracle Archive Log Status</h3>");
  &logDetails($thishost,"<table border=1>");

  open(TMPFL3, "$tmpfl3") || &error_msg("Can't open input $tmpfl3 - $!");
  while(<TMPFL3>)
  {
    &parse;
    $z = substr($F0,0,3);
    if ($z eq "<tr")
    {
      if ($arcdestheader != 1)
      {
	logDetails($thishost,"</table>");
	logDetails($thishost,"<h3>Oracle Archive Log Destination Data (8i and Higher Only)</h3>");
	logDetails($thishost,"<table border=1>");
        $arcdestheader = 1;
      }
      &logDetails($thishost,$F0);
    }
    if ($F2 eq "arcflag:")    {  $arclogflag[$thishost] = $F3; }
    if ($F2 eq "arcdir:")     {  $arcdir = $F3; }
    if ($F2 eq "arcfs:")      {  $arcfs = $F3; }
    if ($F2 eq "arcdirfull:") {  $arcdirfull = $F3; }
    if ($F2 eq "arcdirraw:")  {  $arcdirraw = $F3; }
    if ($F2 eq "arcdesterror:") 
    {
      $arcdesterror = $F3;
      $arcdestlist = $F4;
    }
    if ($F2 eq "arcdestwarning:") 
    {
      $arcdestwarning = $F3;
      $arcdestlist_w = $F4;
    }
    if ($F2 eq "arclogmode:" && $F3 eq "Archive")
    {
      $arclog[$thishost] = "ArcLog";
      $arclogmode = 1;
    }
    # arccmdrun is the last display for each destination
    if ($F2 eq "arccmdrun:") 
    {  
      $arccmdrun = $F3;

      if ($arccmdrun eq "Y")
      {
	$rerun = "(Backup Was Invoked)";
	##system("echo '' | mailx -s 'DBAmon oraArclog() ARC Backup Invoked - $titleraw[$thishost] $arcdirfull $arcdir [AUTO]' bill_border\@agilent.com");
      }
      else
      {
	$rerun = "";
      }

      if ($arclogflag[$thishost] eq "E")
      {
	&event("W",$thishost,"Oracle Archive Log Dir is NULL: Something went wrong with svrmgrl","ArcLgErr","DBA645W",$tmpfl3);
      }
      if ($arclogflag[$thishost] eq "W")
      {
	&event("W",$thishost,"Oracle Archive Log Dir: $arcdir FS $arcfs is ${arcdirfull}% Full - Warning (Threshold: ${t_arclog_w[$thishost]}%) $rerun","ArcLgFUll","DBA641W",$tmpfl3);
      }
      if ($arclogflag[$thishost] eq "C")
      {
	&event("C",$thishost,"Oracle Archive Log Dir: $arcdir FS $arcfs is ${arcdirfull}% Full - Critical (Threshold: ${t_arclog_c[$thishost]}%) $rerun","ArcLgFull","DBA642C",$tmpfl3);
      }
      if ($arclogflag[$thishost] eq "N")
      {
	&event("C",$thishost,"Oracle Archive Logging is ON; But Auto Archiving is OFF","ArcLgOff","DBA643C",$tmpfl3);
      }
      if ($arcdesterror eq "Y")
      {
	&event("W",$thishost,"Oracle Archive Log Destination: $arcdestlist in ERROR Status - Auto restart of destination was not successful","ArcLgDest","DBA646",$tmpfl3);
      }
      if ($arcdestwarning eq "Y")
      {
	&event("W",$thishost,"Oracle Archive Log Destination: $arcdestlist_w was automatically restarted","ArcLgDestFixed","DBA647C",$tmpfl3);
      }
      if ($arclogflag[$thishost] eq "")
      {
	$msg = sprintf("OK - Arclog Dir %s FS $arcfs is %s%% Full",$arcdir,$arcdirfull);
	&logit($msg,$thishost);
      }
      &logDetails($thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>");
      &logDetails($thishost,"<tr><td><b>Archive Log Mode:</b><td>$arclog[$thishost]");
      &logDetails($thishost,"<tr><td><b>Archive Dest:</b><td>$arcdirraw<td>(From init.ora)");
      &logDetails($thishost,"<tr><td><b>Archive Directory:</b><td>$arcdir<td>");
      &logDetails($thishost,"<tr><td><b>Archive Filesystem:</b><td>$arcfs<td>");
      &logDetails($thishost,"<tr><td><b>Archive Filesystem Full Warning Threshold:</b><td>$t_arclog_w[$thishost]<td>");
      &logDetails($thishost,"<tr><td><b>Archive Filesystem Full Critical Threshold:</b><td>$t_arclog_c[$thishost]<td>");
      &logDetails($thishost,"<tr><td><b>Archive Directory Percent Full:</b><td>$arcdirfull<td>");
      &logDetails($thishost,"<tr><td><b>Archive Backup Command:</b><td>$t_arclog_cmd[$thishost]<td>");
      &logDetails($thishost,"<tr><td><b>Archive Backup Invoked?:</b><td>$arccmdrun<td>");
    }
  }
  close(TMPFL3);

  if ($arclogmode)
  {
  }
  else
  {
    $arclog[$thishost] = "NoArcLog";
    &logit("Archive Log Mode is OFF",$thishost);
  }

  &logDetails($thishost,"</table><hr>");
}
# -----------------------------------------------------------------------------
1;
