#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************
# =========================================================
# dbamon_ora_sum.pl
#
# Changes:
# 
#   bb 12Jun00 - Initial
# =========================================================

$debug = 1;

$color = "darkblue";
$| = 1;
$P = "dbamon_www_email.pl";
$ENV{'PATH'} = "/opt/dbamon/bin:$ENV{'PATH'}";
$os = $ENV{"ORACLE_SID"};

$tmpfile = "/tmp/${P}_$$.txt";

$this_hostname = $ARGV[0];
$this_domain   = $ARGV[1];
$zcli =  $ARGV[2];
$ckin =  $ARGV[3];

$font = "verdana";

$arg3 = $ARGV[4];
$arg4 = $ARGV[5];

$dbamon_userid = "dbamon";

#------------------------------------------------------------------------------
sub trim
#------------------------------------------------------------------------------
{
  my @out = @_;
  for (@out)
  {
    s/^\s+//;
    s/\s+$//;
  }
  return wantarray ? @out : $out[0];
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  if ($debug) { print "$date ${P} | $msgmsg\n"; }
}

#------------------------------------------------------------------------------
sub bg
#------------------------------------------------------------------------------
{
  if ($lastbg == 1)
  {
    $lastbg = 0;
    return "bgcolor=ffffff"; 
  }
  else
  {
    $lastbg = 1;
    return "bgcolor=lightgrey"; 
  }
}

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  $msg = $_[0];
  &msg("=============================================================");
  &msg("Fatal Error: $msg");
  &msg("=============================================================");
  &msg("Exiting rc=1");
  exit 1;
}

#------------------------------------------------------------------------------
sub connectDB
#------------------------------------------------------------------------------
{
  &msg("Connecting to DBAmon Oracle Repository DB to read DBC data");
  use DBI;
  $user   = "dbatools";
  $passwd = "br0nc0s";
  $data_source = "DBI:Oracle";
  $database = $os;

  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
    &error('Failed_on_DB_connect');
  $dbh->{LongReadLen} = 4000;
}

#------------------------------------------------------------------------------
sub connectDBSTAR
#------------------------------------------------------------------------------
{
  ##&msg("Connecting to STAR Oracle DB");
  use DBI;
  $user = "stargazer";
  $passwd = "iondrive";
  $data_source = "DBI:Oracle";
  $database = "STAR";

  $dbhStars = DBI->connect("$data_source:$database", $user, $passwd) ||
    &error('Failed_on_DB_connect');
}


#-----------------------------------------------------------------------------
sub pingHost
#-----------------------------------------------------------------------------
{
  ##&msg("ping'ing Host=$Host ");

  $rc = system("/usr/sbin/ping $Host 64 1 | grep 'received, 0% packet loss' > /dev/null 2>&1");
  if ($rc != 0)
  {
    &msg("Cannot ping host=$Host - exiting");
    exit 1;
  }
  ##&msg("ping Successful");
}

#-----------------------------------------------------------------------------
sub doIt
#-----------------------------------------------------------------------------
{
  &msg("Selecting EMail Address information from STARS for Host/Domain $this_hostname/$this_domain");

  # Count tasks
  $sql  = "
insert into 
    dbatools.automail_body
      (
       ambo_key,
       ambo_seq,
       ambo_text
      )
    values
      (
       '86575',
       '93',
       '</pre><hr>'
      )
  ";

  &msg("sql=$sql"); 

  $sth = $dbh->prepare($sql) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

}


#-----------------------------------------------------------------------------
sub getInstance
#-----------------------------------------------------------------------------
{
  ##&msg("Selecting DBC data for mode=$mode inst=$inst");

  # Count tasks
  $statement  = "
    select 
      text
    from 
      dbamon.dbcactive
    where
      dbamonmode = '${mode}'
      and i_hosts = '$inst'
      and text not like '#%'";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  while (@Data = $sth->fetchrow_array)
  {
    ##print "$Data[0] \n";
    $text = $Data[0];
    $_ = $Data[0];
    @words = split;
    chop($parm  = $words[0]);
    $value = $words[1];
    ##print "parm=$parm value=$value \n";
    if ($parm eq "OraApps_FS_Check") 
    {
      $cmd = "\$${parm} .= \"$value \"";
    }
    else
    {
      $cmd = "\$${parm} = \"$value\"";
    }
    ##print "cmd=$cmd \n";
    eval("$cmd"); 
  }

  if ($Host eq "")
  {
    &msg("<b>Error: I could not read the host definition for this instance</b>");
    &msg("<b>       from the DBAmon Oracle repository.</b>");
    &msg("<b>       DBAmon must be initializing.</b>");
    exit 1;
  }

  # Defaults
  $DBMS = "Informix" if $DBMS eq "";

  # Ensure that we have the right instance
  $str = "${Host}${DBMS}${Title1}${ORACLE_SID}";
  chop($ck = `echo "$str" | cksum | awk '{ print \$1 }'`);
 
  &msg("Host=$Host Title1=$Title1 DBMS=$DBMS str=$str ck=$ck");

  if ($ckin ne $ck)   
  {
    system("echo ' ' | mailx -m -s 'dbamon_www_check.pl CKERR ($zcli) $inst $Title1 $DBMS ck=$ck ckin=$ckin [AUTO]' bill_border\@agilent.com");
    &msg("<font color=red>The information for this instance does not verify correctly with the WWW instance that you selected.</font>");
    &msg("<font color=red>This probably means that an instance was added or removed recently, and the corresponding DBAmon</font> ");
    &msg("<font color=red>has not finished its current interaion. Please retry later.</font>");
    exit 1;
  }

  # Get the domain for this host
  chop($fqhostname = `nslookup $Host | grep Name: | awk '{ print \$2 }'`);
  ##print "fqhostname=$fqhostname\n";

  @words = split(/\./,$fqhostname);
  $this_host = $words[0];

  $z = index($fqhostname,'.');
  $this_domain = substr($fqhostname,$z+1);
  ##print "z=$z this_domain=$this_domain\n";
}


#-----------------------------------------------------------------------------
sub init
#-----------------------------------------------------------------------------
{
  if ($mode eq "TEST")
  {
    $rcfile = "/opt/dbamon/adm/dbamonrc_test";
    $html_sys_path = "/opt/dbamon/htm/dbamon_sys_test.html";
  }
  else
  {
    $rcfile = "/opt/dbamon/adm/dbamonrc";
    $html_sys_path = "/opt/dbamon/htm/dbamon_sys.html";
  }
  
  chop($os = `grep ORACLE_SID:  $rcfile | awk '{ print \$2}'`);
  chop($oh = `grep ORACLE_HOME: $rcfile | awk '{ print \$2}'`);

  ##&msg("Setting Oracle Env.");
  $ENV{"ORACLE_SID"} = $os;
  $ENV{"ORACLE_HOME"} = $oh;
  ##system("env | grep ORACLE");

  chop($hostname = `hostname`);
  chop($date = `date`);
  chop($wsname = `hostname`);
  chop($wsnamef = `nslookup $wsname | grep Name: | awk '{ print \$2 }'`);

}
#------------------------------------------------------------------------------
#
# Main
#
#------------------------------------------------------------------------------

&msg("Starting"); 

&init;
&connectDB;
&doIt;

exit;
