#!/usr/local/bin/perl
#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************
# =========================================================
# dbamon_ora_sumread.pl
#
# Changes:
# 
#   bb 12Jun00 - Initial
# =========================================================

$debug = 1;
$| = 1;
$log = "/opt/dbamon/log/dbamon_ora_sumread.log";

$P = "dbamon_ora_sumread.pl";
$ENV{'PATH'} = "/opt/dbamon/bin:$ENV{'PATH'}";
$os = $ENV{"ORACLE_SID"};

$mode = uc $ARGV[0];
$modelc = lc $ARGV[0];

#$rowcolor = "b0e0e6";
$rowcolor = "dcdcdc";

$font = "verdana";
$table_width = "720";

$arg1 = $ARGV[1];
$arg2 = $ARGV[2];
$arg3 = $ARGV[3];
$arg4 = $ARGV[4];
#$arg5 = $ARGV[5];
#$arg6 = $ARGV[6];
#$arg7 = $ARGV[7];
#$arg8 = $ARGV[8];

if ($mode ne "TEST" && $mode ne "PROD")
{
  print "$P | Usage: $0 {TEST | PROD}\n";
  exit 1;
}

#------------------------------------------------------------------------------
sub healthcolors
#------------------------------------------------------------------------------
{
  if    ($health >= 90) { $healthcolor = "#00ff00"; }
  elsif ($health >= 80) { $healthcolor = "#99cc00"; }
  elsif ($health >= 70) { $healthcolor = "#ffff00"; }
  elsif ($health >= 60) { $healthcolor = "#ff9900"; }
  else                  { $healthcolor = "#ff0000"; }
}

#------------------------------------------------------------------------------
sub trim
#------------------------------------------------------------------------------
{
  my @out = $_;
  for (@out)
  {
    s/^\s+//;
    s/\s+$//;
  }
  return wantarray ? @out : $out[0];
}

#------------------------------------------------------------------------------
sub msg
#------------------------------------------------------------------------------
{
  $msgmsg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  if ($debug) { print "$date ${P} | $msgmsg\n"; }
  system("echo '$date ${P} | $msgmsg' >> $log");
}

#------------------------------------------------------------------------------
sub bg
#------------------------------------------------------------------------------
{
  if ($lastbg == 1)
  {
    $lastbg = 0;
    return "bgcolor=ffffff"; 
  }
  else
  {
    $lastbg = 1;
    return "bgcolor=$rowcolor"; 
  }
}

#------------------------------------------------------------------------------
sub bg2
#------------------------------------------------------------------------------
{
  if ($lastbg2 == 1)
  {
    $lastbg2 = 0;
    return "bgcolor=ffffff"; 
  }
  else
  {
    $lastbg2 = 1;
    return "bgcolor=$rowcolor"; 
  }
}

#------------------------------------------------------------------------------
sub error
#------------------------------------------------------------------------------
{
  $msg = $_[0];
  &msg("=============================================================");
  &msg("Fatal Error: $msg");
  &msg("=============================================================");
  &msg("Exiting rc=1");
  exit 1;
}

#------------------------------------------------------------------------------
sub connectDB
#------------------------------------------------------------------------------
{
  &msg("Connecting to DB");
  use DBI;
  $user = "dbamon";
  chop($passwd = `grep 'ORACLE_Password:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
  $data_source = "DBI:Oracle";
  $database = $os;

  $dbh = DBI->connect("$data_source:$database", $user, $passwd) ||
    &error('Failed_on_DB_connect');
  $dbh->{LongReadLen} = 1000000;

  $dbh->do("alter session set sql_trace=true");
}

#-----------------------------------------------------------------------------
sub makeTitle
#-----------------------------------------------------------------------------
{
  &msg("Creating title section");

  print HTML "<title>DBAmon Instance Summary - Mode: $mode</title>\n" ;
  print HTML "<meta http-equiv=Refresh content=1800><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
  print HTML "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTML "<table width=$table_width><tr><td><img src='img/dbamonlogo.jpg' width=$table_width>\n" ;
  print HTML "<tr bgcolor=wheat><td><font face=$font size=5><center>Instance Summary</center>\n";
  print HTML "</table>\n" ;


  print HTML "<table width=$table_width>\n" ;
  print HTML "<tr bgcolor=white align=center>\n" ;
  print HTML "<td><a HREF='#ALPHA'>           <h6>A-Z Server Listing (This Page)</a>\n" ;
  print HTML "<td><a HREF='index.html'>       <h6>DBAmon Console</a>\n" ;
  print HTML "<td><a HREF='graphs/'>          <h6>Historical Graphs</a>\n" ;
  print HTML "<td><a HREF='http://dbamon.com'><h6>DBAmon Home Page</a>\n" ;
  print HTML "<td><a HREF='http://dbamon.com/errors'><h6>DBAmon Error Reference</a>\n" ;
  print HTML "</table>\n" ;

  print HTML "<font face=$font size=-2><i>Page generated by DBAmon 
<a HREF='http://dbamon.com/misc/change_history.shtml'><b>$verrel</b></a> mode=$mode
on Master=$hostname at $date - DBAmon started $startdate</i></font>\n" ;
  print HTML "<hr>\n" ;
}

#-----------------------------------------------------------------------------
sub hourGraph
#-----------------------------------------------------------------------------
{
  print HTML "
  <script language='JavaScript'>
  var is_major = parseInt(navigator.appVersion);
  var agt      = navigator.userAgent;
  if (agt.indexOf('IE') == -1)
  {
    document.writeln(\"<h2><font color=red>DBAmon WWW Pages Only Look Correct If You Are Using IE</font></h3>  \" );
  }
  </script>
";

  # Count tasks

  $statement  = "
    select
      to_char(ts, 'YYYY/MM/DD-HH24'),
      sev,
      count(*)
    from
      dbamon.event_history
    where
      ts >= sysdate - 1
      and dbamonmode like 'prod%'
    group by
      to_char(ts, 'YYYY/MM/DD-HH24'),
      sev
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  $ts_x = -1;

  while (@Data = $sth->fetchrow_array)
  {
    $ts  = $Data[0];
    $sev = $Data[1];
    $cnt = $Data[2];
    ## &msg("ts=$ts sev=$sev cnt=$cnt");

    $ts_x ++;
    push(@ts_list,$ts);
    push(@cn_list,$cnt);

    $total_cnt += $cnt;

    $max_cnt = $cnt if $cnt > $max_cnt;

    $this_dt = (split("-",$ts)) [0];
    $lo_date = $this_dt if $lo_date eq "";
    $hi_date = $this_dt;
  }

  print HTML "<table width=$table_width> \n" ;
  print HTML "<tr bgcolor=slate><th colspan=99><h5>Recent Ticket (Non-Duplicate 'prod' Critical Event) Count - Last 24 Hours\n";
  print HTML "<tr bgcolor=slate><th><h6>By Hour<br>(Date: ${lo_date}-${hi_date})\n" ;

  foreach $ts (@ts_list) 
  { 
    $this_ti = (split("-",$ts)) [1];
    print HTML "<th bgcolor=slate><h6>$this_ti\n"; 
  }
  
  print HTML "<tr><th bgcolor=slate><h6>Event Count\n";

  if    ($max_cnt > 200) { $z_factor = 0.25; }
  elsif ($max_cnt > 100) { $z_factor = 0.5; }
  elsif ($max_cnt > 20)  { $z_factor = 1; }
  else                   { $z_factor = 3; }
  
  #foreach $cn (@cn_list) 
  for ($i = 0; $i <= $ts_x; $i++)
  { 
    $this_cn = $cn_list[$i];
    $z = $this_cn * $z_factor;

    if    ($this_cn >= 20) { $color="red"; }
    elsif ($this_cn >= 10) { $color="yellow"; }
    else                   { $color="green"; }

    $dt = $ts_list[$i];

    print HTML "<td align=center valign=bottom><a href='/cgi-bin/dbamon_event_detail.pl?H,$dt'><img src='img/$color.gif' width=15 height=$z></a>\n"; 
  }

  print HTML "<tr bgcolor=slate><th><h6>(Last 24 Hours: $total_cnt)\n";

  foreach $cn (@cn_list) 
  { 
    print HTML "<td align=center><h6>$cn\n"; 
  }

  print HTML "</table><hr> \n" ;
}

#-----------------------------------------------------------------------------
sub dayGraph
#-----------------------------------------------------------------------------
{
  # Count tasks

  $ daygraph_days = 15;

  $statement  = "
    select
      to_char(ts, 'YYYY/MM/DD'),
      sev,
      count(*)
    from
      dbamon.event_history
    where
      ts >= sysdate - $daygraph_days
      and dbamonmode like 'prod%'
    group by
      to_char(ts, 'YYYY/MM/DD'),
      sev
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  undef @ts_list;
  undef @cn_list;

  $ts_x = -1;

  $max_cnt = 0;

  while (@Data = $sth->fetchrow_array)
  {
    $ts  = $Data[0];
    $sev = $Data[1];
    $cnt = $Data[2];
    ## &msg("ts=$ts sev=$sev cnt=$cnt");

    $ts_x ++;
    push(@ts_list,$ts);
    push(@cn_list,$cnt);

    $total_cnt += $cnt;

    $max_cnt = $cnt if $cnt > $max_cnt;

    $this_dt = (split("-",$ts)) [0];
    $lo_date = $this_dt if $lo_date eq "";
    $hi_date = $this_dt;
  }

  print HTML "<table width=$table_width> \n" ;
  print HTML "<tr bgcolor=slate><th colspan=99><h5>Recent Ticket (Non-Duplicate 'prod' Critical Event) Count - Last $daygraph_days Days\n";
  print HTML "<tr bgcolor=slate><th><h6>By Date\n" ;

  foreach $ts (@ts_list) 
  { 
    #$this_ti = (split("/",$ts)) [1];
    $this_ti = substr($ts,5);
    print HTML "<th bgcolor=slate><h6>$this_ti\n"; 
  }
  
  print HTML "<tr><th bgcolor=slate><h6>Event Count\n";

  if    ($max_cnt > 1500) { $z_factor = 0.05; }
  elsif ($max_cnt > 1000) { $z_factor = 0.10; }
  elsif ($max_cnt > 250)  { $z_factor = 0.15; }
  else                    { $z_factor = 0.25; }

  print "max_cnt=$max_cnt z_factor=$z_factor\n";
  
  #foreach $cn (@cn_list) 
  for ($i = 0; $i <= $ts_x; $i++)
  { 
    $this_cn = $cn_list[$i];
    $z = int($this_cn * $z_factor);

    if    ($this_cn >= 20*24) { $color="red"; }
    elsif ($this_cn >= 10*24) { $color="yellow"; }
    else                      { $color="green"; }

    $dt = $ts_list[$i];

    print HTML "<td align=center valign=bottom><a href='/cgi-bin/dbamon_event_detail.pl?D,$dt'><img src='img/$color.gif' width=15 height=$z></a>\n"; 
  }

  print HTML "<tr bgcolor=slate><th><h6>(Last 10 Days: $total_cnt)\n";

  foreach $cn (@cn_list) 
  { 
    print HTML "<td align=center><h6>$cn\n"; 
  }

  print HTML "</table><hr> \n" ;
}

#-----------------------------------------------------------------------------
sub makeScoreboard
#-----------------------------------------------------------------------------
{
  &msg("Creating scoreboard section");

  # Count tasks
  $statement  = "
    select 
      count(distinct dbamonmode),
      avg(iter_dur)
    from 
      dbamon.task
    where
      dbamonmode like '%${modelc}%'
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  while (@Data = $sth->fetchrow_array)
  {
    $task_count = $Data[0];
    $task_avgtm = int($Data[1] / 60);
  }

  # Count tasks
  $statement  = "
    select 
      count(distinct system)
    from 
      dbamon.summary_detail
    where
      dbamonmode like '%${modelc}%'
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  &msg("  (After select 2)");

  while (@Data = $sth->fetchrow_array)
  {
    $server_count = $Data[0];
  }
  ##print "server_count=$server_count \n";

  # Get total space allocated

  $statement  = "
    select 
      sum(spacealloc) 
    from 
      dbamon.summary_detail
    where
      dbamonmode like '%${modelc}%'
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  &msg("  (After select 3)");

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $total_space = $Data[0];
  }

  $statement  = "
    select 
      count(*)
    from 
      dbamon.summary_detail
    where
      dbamonmode like '%${modelc}%'
      and dbms != '(ServerAlias)'
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  &msg("  (After select 4)");

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $health_tot = $Data[0];
  }

  $statement  = "
    select 
      count(*)
    from 
      dbamon.summary_detail
    where
      dbamonmode like '%${modelc}%'
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');

  &msg("  (After select 5)");

  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $detail_tot = $Data[0];
  }

  ## $statement  = "select sum(count) from dbamon.summary_tot where text = 'No Events' and dbamonmode like '%${modelc}%'";
  ## ##print "$statement\n";
  ## $sth = $dbh->prepare($statement) ||
  ##         &error('Failed_on_DB_prepare_in_chgEnt');
  ## $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  ## $selectcount = 0;
  ## while (@Data = $sth->fetchrow_array)
  ## {
  ##   $health_good = $Data[0];
  ## }
  ## if ($health_tot > 0) { $health = int(($health_good / $health_tot) * 100); }

  $statement  = "select avg(health) from dbamon.summary_detail where dbamonmode like '${modelc}%' and health != -1";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute                    || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $health = int($Data[0]);
    ##print "health=$health\n";
  }

  &healthcolors;


  print HTML "<table width=$table_width>\n";
  print HTML "<tr bgcolor=darkblue><td><font face=$font size=3 color=wheat><b><center>Instance Scoreboard</center></font></b>\n";
  print HTML "</table>\n";

  print HTML "<table width=$table_width>\n";
  print HTML "<tr><th bgcolor=slate colspan=4><h5>All Instance <a href='http://dbamon.com/misc/health.shtml'>Health Index</a> (0-100):<td bgcolor=$healthcolor><font face=$font size=6><center>$health</center></font>\n";

  # 
  # Marquee
  # 

  $statement  = "select 
    title, 
    sev,
    count(*) 
  from 
    dbamon.event_history 
  where 
    ts >= sysdate - 1 
    and dbamonmode like 'prod%'
  group by 
    title,
    sev 
  order by 
    3 desc";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $worst_instances = "";
  while (@Data = $sth->fetchrow_array)
  {
    $instance = $Data[0];
    $sev      = $Data[1];
    $count    = $Data[2];
    last if ++$selectcount > 10;

    $worst_instances .= "$instance ($sev=$count) ... ";
  }

  $marquee_msg  = "DBAmon is Monitoring $health_tot Instance(s) - On $server_count Server(s) - $total_space gB Total DB Space ... ";
  $marquee_msg .= "$task_count DBAmon Task(s) ... ";

  print HTML "<tr><td bgcolor=slate align=center><h6>Stats:\n";
  print HTML "<td colspan=3><marquee bgcolor=wheat scrolldelay=10 scrollamount=3><h6><font color=darkblue>$marquee_msg</font></marquee>\n";
  print HTML "<td bgcolor=slate>\n";

  $marquee_msg = "$worst_instances ";
  print HTML "<tr><td bgcolor=slate align=center><h6>Worst Instances:\n";
  print HTML "<td colspan=3><marquee bgcolor=wheat scrolldelay=10 scrollamount=3><h6><font color=darkblue>$marquee_msg</font></marquee>\n";
  print HTML "<td bgcolor=slate align=center><h6>(Last 24 Hours 'prod')\n";

  print HTML "<tr><td colspan=5><hr>\n";


  
  # Graph of critical events during the last 24 hours
  &hourGraph;
  &dayGraph;

  #print HTML "</table>\n";
  #print HTML "<table width=50% rules=groups frame=hsides>\n";

  print HTML "<tr bgcolor=slate><th colspan=4><h5>Event Severity<th><h5>Event Count\n";

  $statement  = "select text, color, sum(count) from dbamon.summary_tot where dbamonmode like '${modelc}%' and text like '%Event%' group by text, color order by 3 desc";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $section_tot = 0;
  $lastbg = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $text   = $Data[0];
    $color  = $Data[1];
    $count  = $Data[2];

    $sev = "";
    $order = "";
    if    ($text =~ /^Critical/) { $sev = "C"; $order = 1; }
    elsif ($text =~ /^Warning/)  { $sev = "W"; $order = 2; }
    elsif ($text =~ /^Info/)     { $sev = "I"; $order = 3; }
    elsif ($text =~ /^User/)     { $sev = "U"; $order = 4; }
    else                         { next; }

    if ($sev ne "")
    {
      $event_type = "<a href='sev_${modelc}.html#${sev}'>$text</a>";
    }
    else
    {
      $event_type = $text;
    }

    # Make is more readable
    $color = "lime" if $color =~ /green/;

    if ($color =~ /black/ || $color =~ /green/ || $color =~ /blue/ || $color =~ /gray/)
    {
      #print HTML "<tr $bg><td bgcolor=$color colspan=2><h5><font face=$font color=white>$event_type</font><td align=right><h5>$count \n";
      $order_hash{$order} = "<td bgcolor=$color colspan=4><h5><font face=$font color=white>$event_type</font><td align=right><h5>$count";
    }
    else
    {
      #print HTML "<tr $bg><td bgcolor=$color colspan=2><h5>$event_type<td align=right><h5>$count \n";
      $order_hash{$order} = "<td bgcolor=$color colspan=4><h5>$event_type<td align=right><h5>$count";
    }
    $selectcount++;
    $section_tot += $count if $text !~ /No Events/;
  }

  @order_keys = sort keys %order_hash;
  foreach $key (@order_keys)
  {
    ##print "key=$key\n";
    $bg = &bg;
    print HTML "<tr $bg>$order_hash{$key} \n";
  }

  &msg("Selected $selectcount summary_tot Event rows");
  print HTML "<tr><th colspan=4 bgcolor=slate align=left><h5>Total Events:<th align=right><h5>$section_tot\n";

  print HTML "<tr><td colspan=5><hr>\n";


  #
  # Non-Event Exceptions
  #

  print HTML "<tr bgcolor=slate>
    <td colspan=4><h5><center>Non-Event Exceptions</center> 
    <td><h5><center>Instance Count</center> 
    \n";

  $statement  = "select text, color, sum(count) from dbamon.summary_tot where dbamonmode like '${modelc}%' and text not like '%Event%' group by text, color order by 3 desc";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $text   = $Data[0];
    $color  = $Data[1];
    $color= "blue" if $color eq "slate   ";
    ##print "color=>$color< \n";
    $count  = $Data[2];
    $bg = &bg;
    if ($color =~ /black/ || $color =~ /green/ || $color =~ /blue/ || $color =~ /gray/)
    {
      print HTML "<tr $bg><td bgcolor=$color colspan=4><h5><font face=$font color=silver>$text</font><td align=right><h5>$count \n";
    }
    else
    {
      print HTML "<tr $bg><td bgcolor=$color colspan=4><h5>$text<td align=right><h5>$count \n";
    }
    $selectcount++;
  }
  &msg("Selected $selectcount summary_tot NO Event rows");
  print HTML "<tr><td colspan=5><hr>\n";
  print HTML "<tr bgcolor=slate><th><h5>DBMS/Appl.<th><h5>Instance Count<th><h5>% Of All Instances<th><h5>Low Version<th><h5>High Version\n";

  $statement  = "select dbms, min(v_low), max(v_high), sum(count) from dbamon.summary_dbms where dbamonmode like '${modelc}%' group by dbms order by 4 desc";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $lastbg = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $selectcount++;

    $dbms   = $Data[0];
    $v_low  = $Data[1];
    $v_high = $Data[2];
    $count  = $Data[3];

    &msg("dbms=$dbms count=$count");

    push(@dbmslist,$dbms);
    $tot_count += $count;

    if ($detail_tot != 0) { $pct = int(($count/$detail_tot) * 100); }

    if ($dbms eq "Informix-UX     ") { $color = "darkblue" ; }
    if ($dbms eq "OracleDB-UX     ") { $color = "red"      ; }
    if ($dbms eq "OracleApps      ") { $color = "darkred"  ; }
    if ($dbms eq "SAP             ") { $color = "violet"   ; }
    if ($dbms eq "OracleDB-NT     ") { $color = "ff0090"   ; }
    if ($dbms eq "MSSQL           ") { $color = "green"    ; }

    $bg = &bg;
    $_ = $dbms;
    s/ //g;
    $dbmslc = lc $_;
    $url = "dbamon_sys_dbms_${dbmslc}_${modelc}.html";

    print HTML "<tr $bg><td><h5><a href='$url'><font face=$font color=$color>$dbms</a></font><td align=right><h5>$count<td align=right><h5>${pct}%<td nowrap><h5>$v_low <td nowrap><h5>$v_high \n";
  }
  print HTML "<tr><td bgcolor=slate><h5>Total ($selectcount Value(s)):<td align=right><h5>$tot_count\n" ;
  $g_tot_dbms = $tot_count;
  &msg("DBMS Scoreboard - tot_count=$tot_count g_tot_dbms=$g_tot_dbms health_tot=$health_tot");

  if ($health_tot != $g_tot_dbms)
  {
    &msg("The number of detail rows ($health_tot) does not match the DBMS total ($g_tot_dbms)");
    &msg("from the summary_tasks table. Therefore, an update must be in process");
    &msg("now. Killing myself");
    ##system("echo x | mailx -m -s '$P - health_tot=$health_tot g_tot_dbms=$g_tot_dbms' bill_border\@agilent.com");
    #exit 2;
  }

  &scoreboardID1 if $id1_breakout eq "Y";
  &scoreboardID2 if $id2_breakout eq "Y";
  &scoreboardID3 if $id3_breakout eq "Y";
  &scoreboardLOC if $loc_breakout eq "Y";

  print HTML "</table><hr>\n" ;
}

#-----------------------------------------------------------------------------
sub scoreboardLOC
#-----------------------------------------------------------------------------
{
  print HTML "<tr><td colspan=5><hr>\n";
  print HTML "<tr bgcolor=slate><th colspan=2><h5>Server Network Location<th><h5>Instance Count<th><h5>% Of All Instances<th><h5>Average <a href='http://dbamon.com/misc/health.shtml'>Health</a>\n";

  $statement  = "select nvl(serverloc,'[Null]'), count(*) 
    from dbamon.summary_detail 
    where dbamonmode like '${modelc}%' and dbms != '(ServerAlias)'
    group by serverloc order by 1";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute                    || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $tot_count = 0;
  $lastbg = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $loc   = $Data[0];
    $count = $Data[1];

    $selectcount++;

    # Get health for this location, excluding -1 rows
    $statement  = "select avg(health) from dbamon.summary_detail where dbamonmode like '${modelc}%' and nvl(serverloc,'[Null]') = '$loc' and health != -1";
    ##print "$statement\n";
    $sth2 = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
    $sth2->execute                    || &error('Failed_on_DB_execute_in_chgEnt');
    while (@Data = $sth2->fetchrow_array)
    {
      $health = int($Data[0]);
    }
    ##print "loc=$loc count=$count health=$health\n";

    &healthcolors;

    push(@loclist,$loc);
    $tot_count += $count;

    if ($detail_tot != 0) { $pct = sprintf("%4.1f",($count/$detail_tot) * 100); }

    $bg = &bg;
    $_ = $loc;
    s/ //g;
    s/\./_/g;
    $loclc = lc $_;
    $url = "dbamon_sys_loc_${loclc}_${modelc}.html";

    print HTML "<tr $bg><td colspan=2><h5><a href='$url'><font face=$font>$loc</a></font><td align=right><h5>$count<td align=right><h5>${pct}%<td align=right bgcolor=$healthcolor><h5>${health} \n";
  }
  print HTML "<tr><td bgcolor=slate colspan=2><h5>Total ($selectcount Value(s)):<td align=right><h5>$tot_count\n" ;
}

#-----------------------------------------------------------------------------
sub scoreboardID1
#-----------------------------------------------------------------------------
{
  print HTML "<tr><td colspan=5><hr>\n";
  print HTML "<tr bgcolor=slate><th colspan=2><h5>ID1 Value<th><h5>Instance Count<th><h5>% Of All Instances<th><h5>Average <a href='http://dbamon.com/misc/health.shtml'>Health</a>\n";

  $statement  = "select nvl(id1,'[Null]'), count(*), avg(health) 
    from dbamon.summary_detail 
    where dbamonmode like '${modelc}%' and dbms != '(ServerAlias)'
    group by id1 order by 1";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $tot_count = 0;
  $lastbg = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $id1   = $Data[0];
    $count = $Data[1];
 
    $selectcount++;

    # Get health for this location, excluding -1 rows
    $statement  = "select avg(health) from dbamon.summary_detail where dbamonmode like '${modelc}%' and nvl(id1,'[Null]') = '$id1' and health != -1";
    ##print "$statement\n";
    $sth2 = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
    $sth2->execute                    || &error('Failed_on_DB_execute_in_chgEnt');
    while (@Data = $sth2->fetchrow_array)
    {
      $health = int($Data[0]);
    }
    ##print "id1=$id1 count=$count health=$health\n";

    &healthcolors;

    push(@id1list,$id1);
    $tot_count += $count;

    if ($detail_tot != 0) { $pct = sprintf("%4.1f",($count/$detail_tot) * 100); }

    $bg = &bg;
    $_ = $id1;
    s/ //g;
    $id1lc = lc $_;
    $url = "dbamon_sys_id1_${id1lc}_${modelc}.html";

    print HTML "<tr $bg><td colspan=2><h5><a href='$url'><font face=$font>$id1</a></font><td align=right><h5>$count<td align=right><h5>${pct}%<td align=right bgcolor=$healthcolor><h5>${health} \n";
  }
  print HTML "<tr><td bgcolor=slate colspan=2><h5>Total ($selectcount Value(s)):<td align=right><h5>$tot_count\n" ;
}

#-----------------------------------------------------------------------------
sub scoreboardID2
#-----------------------------------------------------------------------------
{
  print HTML "<tr><td colspan=5><hr>\n";
  print HTML "<tr bgcolor=slate><th colspan=2><h5>ID2 Value<th><h5>Instance Count<th><h5>% Of All Instances<th><h5>Average <a href='http://dbamon.com/misc/health.shtml'>Health</a>\n";

  $statement  = "select nvl(id2,'[Null]'), count(*), avg(health) 
    from dbamon.summary_detail 
    where dbamonmode like '${modelc}%' and dbms != '(ServerAlias)'
    group by id2 order by 1";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $tot_count = 0;
  $lastbg = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $id2   = $Data[0];
    $count = $Data[1];

    $selectcount++;

    # Get health for this location, excluding -1 rows
    $statement  = "select avg(health) from dbamon.summary_detail where dbamonmode like '${modelc}%' and nvl(id2,'[Null]') = '$id2' and health != -1";
    ##print "$statement\n";
    $sth2 = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
    $sth2->execute                    || &error('Failed_on_DB_execute_in_chgEnt');
    while (@Data = $sth2->fetchrow_array)
    {
      $health = int($Data[0]);
    }
    ##print "id2=$id2 count=$count health=$health\n";

    &healthcolors;

    push(@id2list,$id2);
    $tot_count += $count;

    if ($detail_tot != 0) { $pct = sprintf("%4.1f",($count/$detail_tot) * 100); }

    $bg = &bg;
    $_ = $id2;
    s/ //g;
    $id2lc = lc $_;
    $url = "dbamon_sys_id2_${id2lc}_${modelc}.html";

    print HTML "<tr $bg><td colspan=2><h5><a href='$url'><font face=$font>$id2</a></font><td align=right><h5>$count<td align=right><h5>${pct}%<td align=right bgcolor=$healthcolor><h5>${health} \n";
  }
  print HTML "<tr><td bgcolor=slate colspan=2><h5>Total ($selectcount Value(s)):<td align=right><h5>$tot_count\n" ;
}

#-----------------------------------------------------------------------------
sub scoreboardID3
#-----------------------------------------------------------------------------
{
  print HTML "<tr><td colspan=5><hr>\n";
  print HTML "<tr bgcolor=slate><th colspan=2><h5>ID3 Value<th><h5>Instance Count<th><h5>% Of All Instances<th><h5>Average <a href='http://dbamon.com/misc/health.shtml'>Health</a>\n";

  $statement  = "select nvl(id3,'[Null]'), count(*), avg(health) 
    from dbamon.summary_detail 
    where dbamonmode like '${modelc}%' and dbms != '(ServerAlias)'
    group by id3 order by 1";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $tot_count = 0;
  $lastbg = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $id3   = $Data[0];
    $count = $Data[1];

    $selectcount++;

    # Get health for this location, excluding -1 rows
    $statement  = "select avg(health) from dbamon.summary_detail where dbamonmode like '${modelc}%' and nvl(id3,'[Null]') = '$id3' and health != -1";
    ##print "$statement\n";
    $sth2 = $dbh->prepare($statement) || &error('Failed_on_DB_prepare_in_chgEnt');
    $sth2->execute                    || &error('Failed_on_DB_execute_in_chgEnt');
    while (@Data = $sth2->fetchrow_array)
    {
      $health = int($Data[0]);
    }
    ##print "id3=$id3 count=$count health=$health\n";

    &healthcolors;

    push(@id3list,$id3);
    $tot_count += $count;

    if ($detail_tot != 0) { $pct = sprintf("%4.1f",($count/$detail_tot) * 100); }

    $bg = &bg;
    $_ = $id3;
    s/ //g;
    $id3lc = lc $_;
    $url = "dbamon_sys_id3_${id3lc}_${modelc}.html";

    print HTML "<tr $bg><td colspan=2><h5><a href='$url'><font face=$font>$id3</a></font><td align=right><h5>$count<td align=right><h5>${pct}%<td align=right bgcolor=$healthcolor><h5>${health} \n";
  }
  print HTML "<tr><td bgcolor=slate colspan=2><h5>Total ($selectcount Value(s)):<td align=right><h5>$tot_count\n" ;
}

#-----------------------------------------------------------------------------
sub makeDetailDBMS
#-----------------------------------------------------------------------------
{
  $thisdbms = $_[0];
  $_ = $thisdbms;
  s/ //g;
  $thisdbmslc = lc $_;
  $thisdbms = $_;
  ##&msg("Creating detail section for dbms=$thisdbms");
  $htmlfile = "/opt/dbamon/htm/dbamon_sys_dbms_${thisdbmslc}_${modelc}.html";
  open(HTMLDBMS, ">$htmlfile") || &error("Can't open output $htmlfile - $!");

  print HTMLDBMS "<title>DBAmon Instance Summary - DBMS/Appl.: $thisdbms - Mode: $mode</title>\n" ;
  print HTMLDBMS "<meta http-equiv=Refresh content=1800><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
  print HTMLDBMS "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTMLDBMS "<table><tr><td><img src='img/dbamonlogo.jpg'>\n" ;
  print HTMLDBMS "<tr bgcolor=wheat><td><font face=$font size=5><center>Instance Summary For DBMS/Appl.: $thisdbms</center>\n";
  print HTMLDBMS "</table>\n" ;
  print HTMLDBMS "<font face=$font size=-2><i>This page was generated by DBAmon <b>$verrel</b> mode=$mode running on $hostname on $date - This execution of DBAmon was started on $startdate</i></font>\n" ;
  #print HTMLDBMS "<hr><ul><font face=$font size=-1>\n";
  #print HTMLDBMS "<li> <a HREF='http://dbamon.com'><b>DBAmon Home Page</a> </b>\n" ;
  #print HTMLDBMS "</ul></font>\n" ;
  print HTMLDBMS "<hr>\n" ;

  print HTMLDBMS "<p><font face=$font size=3><b>Instance Detail - $thisdbms Instances:</font></b>\n" ;
  print HTMLDBMS "<table rules=groups frame=hsides>\n" ;

  print HTMLDBMS "<tr bgcolor=slate>\n" ;
  print HTMLDBMS "<th colspan=5><h5>Server/<br>Instance Title1/Title2/Title3<br>ID1<sub>1</sub> ID2<sub>2</sub> ID3<sub>3</sub> ID4<sub>4</sub> <br>Uptime % Last 30 Days\n" ;

  print HTMLDBMS "<th><h5>DBMS/<br>Appl.\n" ;
  print HTMLDBMS "<th><h5><a href='http://dbamon.com/ref/actions.shtml'>Actions</a>\n" ;
  print HTMLDBMS "<th><h5>Events\n" ;
  print HTMLDBMS "<th><h5>Status<br>/CONFIG<br>Flags\n" ;
  #print HTMLDBMS "<th><h5>DBMS/<br>Appl.<br>Version\n" ;

  print HTMLDBMS "<th><h5>Bkup Method:<br> Hours Since<br>Last Bkup/ <br>Threshold<br>(R)erun Cmd\n" ;
  print HTMLDBMS "<th><h5>CPU<br>Model-CPUs<br>(MB Mem)\n" ;
  print HTMLDBMS "<th><h5>O/S<br>Level<br>(Mode)\n" ;
  print HTMLDBMS "<th><h5>Alloc/<br>Used<br>gB\n" ;
  print HTMLDBMS "<th><h5>Mon.<br>Secs.<br>(% Tot.)\n" ;
  print HTMLDBMS "<th><h5>Misc.\n" ;
  print HTMLDBMS "<th><h5>Task/Entry<br>Age<br>Mins.\n" ;

  print HTMLDBMS "</tr>\n" ;

  $statement  = "
    select 
      system, 
      title, 
      dbms, 
      ts, 
      sysdate-ts,
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
      and dbms = '$thisdbms'
    order by 2
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];
    $age    = int($Data[4] * (60*24));    #Convert to minutes
    #$task   = trim($Data[5]);
    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;
    $html =~ s/<select/\n  <select/g;

    #print "task=$task age=$age\n";
    #foreach (@Data) { print "rec=$_\n"; }

    $bg = &bg;

    print HTMLDBMS "<tr $bg height=21> $html <td nowrap><h6>$task/$age\n";
    $selectcount++;
  }
  &msg("Selected $selectcount summary_detail rows for dbms=$thisdbms");

  print HTMLDBMS "</table><hr>\n" ;
  if ($selectcount == 0)
  {
    print HTMLDBMS "<h5>No Instances Of This DBMS/Appl. Are Being Monitored</h5><hr>\n" ;
  }
  else
  {
    print HTMLDBMS "<h5>$selectcount Instance(s) Of This DBMS/Appl. Are Being Monitored</h5><hr>\n" ;
  }
  close(HTMLDBMS);
}

#-----------------------------------------------------------------------------
sub makeDetailID1
#-----------------------------------------------------------------------------
{
  $thisid1 = $_[0];
  $_ = $thisid1;
  s/ //g;
  $thisid1lc = lc $_;
  $thisid1 = $_;
  &msg("Creating detail section for id1=$thisid1");
  $htmlfile = "/opt/dbamon/htm/dbamon_sys_id1_${thisid1lc}_${modelc}.html";
  open(HTMLID1, ">$htmlfile") || &error("Can't open output $htmlfile - $!");

  print HTMLID1 "<title>DBAmon Instance Summary - ID1: $thisid1 - Mode: $mode</title>\n" ;
  print HTMLID1 "<meta http-equiv=Refresh content=1800><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
  print HTMLID1 "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTMLID1 "<table><tr><td><img src='img/dbamonlogo.jpg'>\n" ;
  print HTMLID1 "<tr bgcolor=wheat><td><font face=$font size=5><center>Instance Summary For ID1=$thisid1</center>\n";
  print HTMLID1 "</table>\n" ;
  print HTMLID1 "<font face=$font size=-2><i>This page was generated by DBAmon <b>$verrel</b> mode=$mode running on $hostname on $date - This execution of DBAmon was started on $startdate</i></font>\n" ;
  #print HTMLID1 "<hr><ul><font face=$font size=-1>\n";
  #print HTMLID1 "<li> <a HREF='http://dbamon.com'><b>DBAmon Home Page</a> </b>\n" ;
  #print HTMLID1 "</ul></font>\n" ;
  print HTMLID1 "<hr>\n" ;

  print HTMLID1 "<p><font face=$font size=3><b>Instance Detail - ID1=$thisid1 Instances:</font></b>\n" ;
  print HTMLID1 "<table rules=groups frame=hsides>\n" ;

  print HTMLID1 "<tr bgcolor=slate>\n" ;
  print HTMLID1 "<th colspan=5><h5>Server/<br>Instance Title1/Title2/Title3<br>ID1<sub>1</sub> ID2<sub>2</sub> ID3<sub>3</sub> ID4<sub>4</sub> <br>Uptime % Last 30 Days\n" ;
  print HTMLID1 "<th><h5>DBMS/<br>Appl.\n" ;
  print HTMLID1 "<th><h5><a href='http://dbamon.com/ref/actions.shtml'>Actions</a>\n" ;
  print HTMLID1 "<th><h5>Events\n" ;
  print HTMLID1 "<th><h5>Status<br>/CONFIG<br>Flags\n" ;
  #print HTMLID1 "<th><h5>DBMS/<br>Appl.<br>Version\n" ;

  print HTMLID1 "<th><h5>Bkup Method:<br> Hours Since<br>Last Bkup/ <br>Threshold<br>(R)erun Cmd\n" ;
  print HTMLID1 "<th><h5>CPU<br>Model-CPUs<br>(MB Mem)\n" ;
  print HTMLID1 "<th><h5>O/S<br>Level<br>(Mode)\n" ;
  print HTMLID1 "<th><h5>Alloc/<br>Used<br>gB\n" ;
  print HTMLID1 "<th><h5>Mon.<br>Secs.<br>(% Tot.)\n" ;
  print HTMLID1 "<th><h5>Misc.\n" ;
  print HTMLID1 "<th><h5>Task/Entry<br>Age<br>Mins.\n" ;

  print HTMLID1 "</tr>\n" ;

  if ($thisid1 eq "[Null]") { $sqlid1 = "is NULL"; }
  else                      { $sqlid1 = "= '$thisid1'"; }

  $statement  = "
    select 
      system, 
      title, 
      dbms, 
      ts, 
      sysdate-ts,
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
      and id1 $sqlid1
    order by 2
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];
    $age    = int($Data[4] * (60*24));    #Convert to minutes
    #$task   = trim($Data[5]);
    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;

    $bg = &bg;
    print HTMLID1 "<tr $bg height=21> $html <td nowrap><h6>$task/$age\n";
    $selectcount++;
  }
  &msg("Selected $selectcount summary_detail rows for ID1=$thisid1");

  ##print HTMLID1 "</form>\n" ;
  print HTMLID1 "</table><hr>\n" ;
  if ($selectcount == 0)
  {
    print HTMLID1 "<h5>No Instances Of This ID1 Value Are Being Monitored</h5><hr>\n" ;
  }
  else
  {
    print HTMLID1 "<h5>$selectcount Instance(s) Of This ID1 Value Are Being Monitored</h5><hr>\n" ;
  }
  close(HTMLID1);
}

#-----------------------------------------------------------------------------
sub makeDetailID2
#-----------------------------------------------------------------------------
{
  $thisid2 = $_[0];
  $_ = $thisid2;
  s/ //g;
  $thisid2lc = lc $_;
  $thisid2 = $_;
  &msg("Creating detail section for id2=$thisid2");
  $htmlfile = "/opt/dbamon/htm/dbamon_sys_id2_${thisid2lc}_${modelc}.html";
  open(HTMLID2, ">$htmlfile") || &error("Can't open output $htmlfile - $!");

  print HTMLID2 "<title>DBAmon Instance Summary - ID2: $thisid2 - Mode: $mode</title>\n" ;
  print HTMLID2 "<meta http-equiv=Refresh content=1800><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
  print HTMLID2 "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTMLID2 "<table><tr><td><img src='img/dbamonlogo.jpg'>\n" ;
  print HTMLID2 "<tr bgcolor=wheat><td><font face=$font size=5><center>Instance Summary For ID2=$thisid2</center>\n";
  print HTMLID2 "</table>\n" ;
  print HTMLID2 "<font face=$font size=-2><i>This page was generated by DBAmon <b>$verrel</b> mode=$mode running on $hostname on $date - This execution of DBAmon was started on $startdate</i></font>\n" ;
  #print HTMLID2 "<hr><ul><font face=$font size=-1>\n";
  #print HTMLID2 "<li> <a HREF='http://dbamon.com'><b>DBAmon Home Page</a> </b>\n" ;
  #print HTMLID2 "</ul></font>\n" ;
  print HTMLID2 "<hr>\n" ;

  print HTMLID2 "<p><font face=$font size=3><b>Instance Detail - ID2=$thisid2 Instances:</font></b>\n" ;
  print HTMLID2 "<table rules=groups frame=hsides>\n" ;

  print HTMLID2 "<tr bgcolor=slate>\n" ;
  print HTMLID2 "<th colspan=5><h5>Server/<br>Instance Title1/Title2/Title3<br>ID1<sub>1</sub> ID2<sub>2</sub> ID3<sub>3</sub> ID4<sub>4</sub> <br>Uptime % Last 30 Days\n" ;
  print HTMLID2 "<th><h5>DBMS/<br>Appl.\n" ;
  print HTMLID2 "<th><h5><a href='http://dbamon.com/ref/actions.shtml'>Actions</a>\n" ;
  print HTMLID2 "<th><h5>Events\n" ;
  print HTMLID2 "<th><h5>Status<br>/CONFIG<br>Flags\n" ;
  #print HTMLID2 "<th><h5>DBMS/<br>Appl.<br>Version\n" ;

  print HTMLID2 "<th><h5>Bkup Method:<br> Hours Since<br>Last Bkup/ <br>Threshold<br>(R)erun Cmd\n" ;
  print HTMLID2 "<th><h5>CPU<br>Model-CPUs<br>(MB Mem)\n" ;
  print HTMLID2 "<th><h5>O/S<br>Level<br>(Mode)\n" ;
  print HTMLID2 "<th><h5>Alloc/<br>Used<br>gB\n" ;
  print HTMLID2 "<th><h5>Mon.<br>Secs.<br>(% Tot.)\n" ;
  print HTMLID2 "<th><h5>Misc.\n" ;
  print HTMLID2 "<th><h5>Task/Entry<br>Age<br>Mins.\n" ;

  print HTMLID2 "</tr>\n" ;

  if ($thisid2 eq "[Null]") { $sqlid2 = "is NULL"; }
  else                      { $sqlid2 = "= '$thisid2'"; }

  $statement  = "
    select 
      system, 
      title, 
      dbms, 
      ts, 
      sysdate-ts,
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
      and id2 $sqlid2
    order by 2
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];
    $age    = int($Data[4] * (60*24));    #Convert to minutes
    #$task   = trim($Data[5]);
    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;

    $bg = &bg;
    print HTMLID2 "<tr $bg height=21> $html <td nowrap><h6>$task/$age\n";
    $selectcount++;
  }
  &msg("Selected $selectcount summary_detail rows for ID2=$thisid2");

  ##print HTMLID2 "</form>\n" ;
  print HTMLID2 "</table><hr>\n" ;
  if ($selectcount == 0)
  {
    print HTMLID2 "<h5>No Instances Of This ID2 Value Are Being Monitored</h5><hr>\n" ;
  }
  else
  {
    print HTMLID2 "<h5>$selectcount Instance(s) Of This ID2 Value Are Being Monitored</h5><hr>\n" ;
  }
  close(HTMLID2);
}





#-----------------------------------------------------------------------------
sub makeDetailID3
#-----------------------------------------------------------------------------
{
  $thisid3 = $_[0];
  $_ = $thisid3;
  s/ //g;
  $thisid3lc = lc $_;
  $thisid3 = $_;
  &msg("Creating detail section for id3=$thisid3");
  $htmlfile = "/opt/dbamon/htm/dbamon_sys_id3_${thisid3lc}_${modelc}.html";
  open(HTMLID3, ">$htmlfile") || &error("Can't open output $htmlfile - $!");

  print HTMLID3 "<title>DBAmon Instance Summary - ID3: $thisid3 - Mode: $mode</title>\n" ;
  print HTMLID3 "<meta http-equiv=Refresh content=1800><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
  print HTMLID3 "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTMLID3 "<table><tr><td><img src='img/dbamonlogo.jpg'>\n" ;
  print HTMLID3 "<tr bgcolor=wheat><td><font face=$font size=5><center>Instance Summary For ID3=$thisid3</center>\n";
  print HTMLID3 "</table>\n" ;
  print HTMLID3 "<font face=$font size=-2><i>This page was generated by DBAmon <b>$verrel</b> mode=$mode running on $hostname on $date - This execution of DBAmon was started on $startdate</i></font>\n" ;
  #print HTMLID3 "<hr><ul><font face=$font size=-1>\n";
  #print HTMLID3 "<li> <a HREF='http://dbamon.com'><b>DBAmon Home Page</a> </b>\n" ;
  #print HTMLID3 "</ul></font>\n" ;
  print HTMLID3 "<hr>\n" ;

  print HTMLID3 "<p><font face=$font size=3><b>Instance Detail - ID3=$thisid3 Instances:</font></b>\n" ;
  print HTMLID3 "<table rules=groups frame=hsides>\n" ;

  print HTMLID3 "<tr bgcolor=slate>\n" ;
  print HTMLID3 "<th colspan=5><h5>Server/<br>Instance Title1/Title2/Title3<br>ID1<sub>1</sub> ID3<sub>2</sub> ID3<sub>3</sub> ID4<sub>4</sub> <br>Uptime % Last 30 Days\n" ;
  print HTMLID3 "<th><h5>DBMS/<br>Appl.\n" ;
  print HTMLID3 "<th><h5><a href='http://dbamon.com/ref/actions.shtml'>Actions</a>\n" ;
  print HTMLID3 "<th><h5>Events\n" ;
  print HTMLID3 "<th><h5>Status<br>/CONFIG<br>Flags\n" ;
  #print HTMLID3 "<th><h5>DBMS/<br>Appl.<br>Version\n" ;

  print HTMLID3 "<th><h5>Bkup Method:<br> Hours Since<br>Last Bkup/ <br>Threshold<br>(R)erun Cmd\n" ;
  print HTMLID3 "<th><h5>CPU<br>Model-CPUs<br>(MB Mem)\n" ;
  print HTMLID3 "<th><h5>O/S<br>Level<br>(Mode)\n" ;
  print HTMLID3 "<th><h5>Alloc/<br>Used<br>gB\n" ;
  print HTMLID3 "<th><h5>Mon.<br>Secs.<br>(% Tot.)\n" ;
  print HTMLID3 "<th><h5>Misc.\n" ;
  print HTMLID3 "<th><h5>Task/Entry<br>Age<br>Mins.\n" ;

  print HTMLID3 "</tr>\n" ;

  if ($thisid3 eq "[Null]") { $sqlid3 = "is NULL"; }
  else                      { $sqlid3 = "= '$thisid3'"; }

  $statement  = "
    select 
      system, 
      title, 
      dbms, 
      ts, 
      sysdate-ts,
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
      and id3 $sqlid3
    order by 2
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];
    $age    = int($Data[4] * (60*24));    #Convert to minutes
    #$task   = trim($Data[5]);
    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;

    $bg = &bg;
    print HTMLID3 "<tr $bg height=21> $html <td nowrap><h6>$task/$age\n";
    $selectcount++;
  }
  &msg("Selected $selectcount summary_detail rows for ID3=$thisid3");

  ##print HTMLID3 "</form>\n" ;
  print HTMLID3 "</table><hr>\n" ;
  if ($selectcount == 0)
  {
    print HTMLID3 "<h5>No Instances Of This ID3 Value Are Being Monitored</h5><hr>\n" ;
  }
  else
  {
    print HTMLID3 "<h5>$selectcount Instance(s) Of This ID3 Value Are Being Monitored</h5><hr>\n" ;
  }
  close(HTMLID3);
}






#-----------------------------------------------------------------------------
sub makeDetailLOC
#-----------------------------------------------------------------------------
{
  $thisloc = $_[0];
  $_ = $thisloc;
  s/ //g;
  $thisloc_sql = $_;
  s/\./_/g;
  $thisloclc = lc $_;
  $thisloc = $_;
  &msg("Creating detail section for loc=$thisloc");
  $htmlfile = "/opt/dbamon/htm/dbamon_sys_loc_${thisloclc}_${modelc}.html";
  open(HTMLLOC, ">$htmlfile") || &error("Can't open output $htmlfile - $!");

  print HTMLLOC "<title>DBAmon Instance Summary - LOC: $thisloc - Mode: $mode</title>\n" ;
  print HTMLLOC "<meta http-equiv=Refresh content=1800><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
  print HTMLLOC "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTMLLOC "<table><tr><td><img src='img/dbamonlogo.jpg'>\n" ;
  print HTMLLOC "<tr bgcolor=wheat><td><font face=$font size=5><center>Instance Summary For Server Network Location:<br>$thisloc_sql</center>\n";
  print HTMLLOC "</table>\n" ;
  print HTMLLOC "<font face=$font size=-2><i>This page was generated by DBAmon <b>$verrel</b> mode=$mode running on $hostname on $date - This execution of DBAmon was started on $startdate</i></font>\n" ;
  #print HTMLLOC "<hr><ul><font face=$font size=-1>\n";
  #print HTMLLOC "<li> <a HREF='http://dbamon.com'><b>DBAmon Home Page</a> </b>\n" ;
  #print HTMLLOC "</ul></font>\n" ;
  print HTMLLOC "<hr>\n" ;

  print HTMLLOC "<p><font face=$font size=3><b>Instance Detail - Server Network Location=$thisloc_sql Instances:</font></b>\n" ;
  print HTMLLOC "<table rules=groups frame=hsides>\n" ;

  print HTMLLOC "<tr bgcolor=slate>\n" ;
  print HTMLLOC "<th colspan=5><h5>Server/<br>Instance Title1/Title2/Title3<br>ID1<sub>1</sub> ID2<sub>2</sub> ID3<sub>3</sub> ID4<sub>4</sub> <br>Uptime % Last 30 Days\n" ;
  print HTMLLOC "<th><h5>DBMS/<br>Appl.\n" ;
  print HTMLLOC "<th><h5><a href='http://dbamon.com/ref/actions.shtml'>Actions</a>\n" ;
  print HTMLLOC "<th><h5>Events\n" ;
  print HTMLLOC "<th><h5>Status<br>/CONFIG<br>Flags\n" ;
  #print HTMLLOC "<th><h5>DBMS/<br>Appl.<br>Version\n" ;

  print HTMLLOC "<th><h5>Bkup Method:<br> Hours Since<br>Last Bkup/ <br>Threshold<br>(R)erun Cmd\n" ;
  print HTMLLOC "<th><h5>CPU<br>Model-CPUs<br>(MB Mem)\n" ;
  print HTMLLOC "<th><h5>O/S<br>Level<br>(Mode)\n" ;
  print HTMLLOC "<th><h5>Alloc/<br>Used<br>gB\n" ;
  print HTMLLOC "<th><h5>Mon.<br>Secs.<br>(% Tot.)\n" ;
  print HTMLLOC "<th><h5>Misc.\n" ;
  print HTMLLOC "<th><h5>Task/Entry<br>Age<br>Mins.\n" ;

  print HTMLLOC "</tr>\n" ;

  if ($thisloc eq "[Null]") { $sqlloc = "is NULL"; }
  else                      { $sqlloc = "= '$thisloc_sql'"; }

  $statement  = "
    select 
      system, 
      title, 
      dbms, 
      ts, 
      sysdate-ts,
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
      and serverloc $sqlloc
    order by 2
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];
    $age    = int($Data[4] * (60*24));    #Convert to minutes
    #$task   = trim($Data[5]);
    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;

    $bg = &bg;
    print HTMLLOC "<tr $bg height=21> $html <td nowrap><h6>$task/$age\n";
    $selectcount++;
  }
  &msg("Selected $selectcount summary_detail rows for Server Network Location=$thisloc_sql");

  ##print HTMLLOC "</form>\n" ;
  print HTMLLOC "</table><hr>\n" ;
  if ($selectcount == 0)
  {
    print HTMLLOC "<h5>No Instances Of This Server Network Location Value Are Being Monitored</h5><hr>\n" ;
  }
  else
  {
    print HTMLLOC "<h5>$selectcount Instance(s) Of This LOC Value Are Being Monitored</h5><hr>\n" ;
  }
  close(HTMLLOC);
}

#-----------------------------------------------------------------------------
sub instanceDetail
#-----------------------------------------------------------------------------
{
  &msg("instanceDetail() - Creating detail section");
  
  open(HTMLDET, ">/opt/dbamon/htm/$detpath") || &error("Can't open output $detpath - $!");

  print HTMLDET "<a name='ALPHA'>\n";
  print HTMLDET "<table width=$table_width>\n";
  print HTMLDET "<tr bgcolor=darkblue><td><font face=$font size=3 color=wheat><b><center>Instance Detail<br>($detail_tot Instance(s) on $server_count Server(s) - $total_space gB Total Size - DBAmon Tasks: $task_count - Avg. Iteration Time: $task_avgtm Min.)</center></font></b>\n";
  print HTMLDET "</table>\n";

  #print HTMLDET "<font face=$font size=3><b>Instance Detail ($detail_tot Instance(s) on $server_count Server(s) - $total_space gB Total Size - DBAmon Tasks: $task_count - Avg. Iteration Time: $task_avgtm Min.):</font></b>\n" ;

  print HTMLDET "<table rules=groups frame=hsides>\n" ;

  print HTMLDET "<tr bgcolor=slate>\n" ;
  print HTMLDET "<th colspan=5><h5>Server/<br>Instance Title1/Title2/Title3<br>ID1<sub>1</sub> ID2<sub>2</sub> ID3<sub>3</sub> ID4<sub>4</sub> <br>Uptime % Last 30 Days\n" ;
  print HTMLDET "<th><h5>DBMS/<br>Appl.\n" ;
  print HTMLDET "<th><h5><a href='http://dbamon.com/ref/actions.shtml'>Actions</a>\n" ;
  print HTMLDET "<th><h5>Events\n" ;
  print HTMLDET "<th><h5>Status<br>/CONFIG<br>Flags\n" ;
  #print HTMLDET "<th><h5>DBMS/<br>Appl.<br>Version\n" ;

  print HTMLDET "<th><h5>Bkup Method:<br> Hours Since<br>Last Bkup/ <br>Threshold<br>(R)erun Cmd\n" ;
  print HTMLDET "<th><h5>CPU<br>Model-CPUs<br>(MB Mem)\n" ;
  print HTMLDET "<th><h5>O/S<br>Level<br>(Mode)\n" ;
  print HTMLDET "<th><h5>Alloc/<br>Used<br>gB\n" ;
  print HTMLDET "<th><h5>Mon.<br>Secs.<br>(% Tot.)\n" ;
  print HTMLDET "<th><h5>Misc.\n" ;
  print HTMLDET "<th><h5>Task/Entry<br>Age<br>Mins.\n" ;

  print HTMLDET "</tr>\n" ;

  $statement  = "
    select 
      system, 
      title, 
      dbms, 
      ts, 
      sysdate-ts,
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
    order by 2
  ";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $lastbg = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];
    $age    = int($Data[4] * (60*24));    #Convert to minutes
    #$task   = trim($Data[5]);
    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;

    ##print "FOUND title=$title selectcount=$selectcount \n";

    $bg = &bg;
    print HTMLDET "<tr $bg height=21> $html <td nowrap><h6>$task/$age\n";
    $selectcount++;
    push(@instance_list,$title);
  }
  ##print HTMLDET "</form>\n" ;
  print HTMLDET "</table><hr>\n" ;
  close(HTMLDET);
  &msg("Selected $selectcount summary_detail rows");
}

#-----------------------------------------------------------------------------
sub uptime
#-----------------------------------------------------------------------------
{
  $t = $_[0];
  $statement  = "
    select
      avg(tot_pct)
    from 
      dbamon.uptime_summary
    where 
      instance = '$t'
      and ts >= sysdate - 30";
  ##print "statement=$statement\n";
  $sth2 = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth2->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $color = "lime"; 

  while (@Data = $sth2->fetchrow_array)
  {
    $u = $Data[0];
  }

  $u = int($u);
  $u = sprintf("%5.1f",$u);

  if ($u ne "")
  {
    if    ($u >= 99) { $c = "green"; } 
    elsif ($u >= 95) { $c = "yellow"; } 
    else             { $c = "red"; } 
    $s = "<font color=$c><h5>$u%</font>";
  }
  else 
  {
    $s = "";
  }
  print "t=$t u=$u s=$s \n";
  return $s;
}

#-----------------------------------------------------------------------------
sub makeSev
#-----------------------------------------------------------------------------
{
  $htmlfile = "/opt/dbamon/htm/sev_${modelc}.html";
  open(HTMLSEV, ">$htmlfile") || &error("Can't open output $htmlfile - $!");

  print HTMLSEV "<title>DBAmon Event Detail - Mode: $mode</title>\n" ;
  print HTMLSEV "<meta http-equiv=Refresh content=1800><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
  print HTMLSEV "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTMLSEV "<table><tr><td><img src='img/dbamonlogo.jpg'>\n" ;
  print HTMLSEV "<tr bgcolor=wheat><td><font face=$font size=5><center>Event Detail</center>\n";
  print HTMLSEV "</table>\n" ;
  print HTMLSEV "<font face=$font size=-2><i>This page was generated by DBAmon <b>$verrel</b> mode=$mode running on $hostname on $date - This execution of DBAmon was started on $startdate</i></font><hr>\n" ;

  @sev_list = ("C","W","I","U");
  %sev_colors = ("C" , "red",
                 "W" , "yellow",
                 "I" , "cyan",
                 "U" , "lime");
  %sev_text   = ("C" , "Critical",
                 "W" , "Warning",
                 "I" , "Info",
                 "U" , "User");

  foreach $sev (@sev_list)
  {
    ##print "sev=$sev\n";
    print HTMLSEV "<a name='$sev'</a>\n";
    print HTMLSEV "<h4>Severity <font color=$sev_colors{$sev}>$sev</font> $sev_text{$sev} Events</h4>\n";
    print HTMLSEV "<table border=0><tr bgcolor=slate><th><h5>MsgID<th><h5>Event Timestamp<th><h5>Ticket<th><h5>DBMS<th><h5>Event Text\n";
    $statement  = "
      select
        system,
        title,
        dbms,
        text,
        msgid,
        details_url,
        to_char(ts,\'YYYY/MM/DD-HH24:MI:SS\'),
        ticket
      from 
	dbamon.event_detail
      where 
        dbamonmode like '${modelc}%' and
	sev = '$sev'
      order by 
        msgid,
        system,
        to_char(ts,\'YYYY/MM/DD-HH24:MI:SS\') desc";
    ##print "statement=$statement\n";
    $sth2 = $dbh->prepare($statement) ||
	    &error('Failed_on_DB_prepare_in_chgEnt');
    $sth2->execute || &error('Failed_on_DB_execute_in_chgEnt');

    $last_msgid = "";
    $counter = 0;
    $lastbg2 = 0;

    while (@Data = $sth2->fetchrow_array)
    {
      #$system   = $Data[0];
      $instance = $Data[1];
      $dbms     = $Data[2];
      $text     = $Data[3];
      $msgid    = $Data[4];
      $url      = $Data[5];
      $detts    = $Data[6];
      $ticket   = $Data[7];

      next if $msgid eq "DBA301";

      ##print "text=$text\n";

      if ($dbms eq "Informix-UX") { $dbms_color = "darkblue" ; }
      if ($dbms eq "OracleDB-UX") { $dbms_color = "red"      ; }
      if ($dbms eq "OracleApps") { $dbms_color = "darkred"  ; }
      if ($dbms eq "SAP") { $dbms_color = "violet"   ; }
      if ($dbms eq "OracleDB-NT") { $dbms_color = "ff0090"   ; }
      if ($dbms eq "MSSQL") { $dbms_color = "green"    ; }

      if ($msgid ne $last_msgid && $last_msgid ne "")
      {
        print HTMLSEV "<tr><td><hr size=1>\n";
        $lastbg2 = 0;
      }

      if ($ticket eq "" || $ticket eq "?")
      {
        $ticket = "N/A";
      }

      # temp - until i fix the ticket problem
      $ticket = "";

      $bg2 = &bg2;
      print HTMLSEV "<tr $bg2><td bgcolor=$sev_colors{$sev}><h5><a HREF='http://dbamon.com/errors.shtml#$msgid'>$msgid</a><td nowrap><h5>$detts<td><h5>$ticket<td nowrap><h5><font color=$dbms_color>$dbms</font><td><a href='$url'><h5>$text</a>\n";
      $counter++;

      $last_msgid = $msgid;
    }
    print HTMLSEV "</table>";
    print HTMLSEV "<h6>$counter $sev_text{$sev} Event(s)<hr></h6>";
  }
  close(HTMLSEV);
}

#-----------------------------------------------------------------------------
sub newAlpha
#-----------------------------------------------------------------------------
{
  mkdir("/opt/dbamon/htm/alpha_$modelc",755);
  system("ln -s /opt/dbamon/htm/img /opt/dbamon/htm/alpha_$modelc/img > /dev/null 2>&1");
  system("ln -s /opt/dbamon/htm/events_current /opt/dbamon/htm/alpha_$modelc/events_current > /dev/null 2>&1");
  system("ln -s /opt/dbamon/htm/details /opt/dbamon/htm/alpha_$modelc/details > /dev/null 2>&1");
  system("ln -s /opt/dbamon/htm/reports /opt/dbamon/htm/alpha_$modelc/reports > /dev/null 2>&1");
  system("ln -s /opt/dbamon/htm/graphs /opt/dbamon/htm/alpha_$modelc/graphs > /dev/null 2>&1");
  open(HTMLALPHA, ">/opt/dbamon/htm/alpha_$modelc/$alpha.html") || &error("Can't open output /opt/dbamon/htm/alpha_$modelc/$alpha.html - $!");
  print HTMLALPHA "<title>DBAmon Instance Summary - ALPHA: $thisid1 - Mode: $mode</title>\n" ;
  print HTMLALPHA "<meta http-equiv=Refresh content=1800><link REL='SHORTCUT ICON' href='/dbamon/img/favicon.ico'>\n" ;
  print HTMLALPHA "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTMLALPHA "<table><tr><td><img src='img/dbamonlogo.jpg'>\n" ;
  print HTMLALPHA "<tr bgcolor=wheat><td><font face=$font size=5><center>Instance Summary For '$alpha' Servers</center>\n";
  print HTMLALPHA "</table>\n" ;
  print HTMLALPHA "<font face=$font size=-2><i>This page was generated by DBAmon <b>$verrel</b> mode=$mode running on $hostname on $date - This execution of DBAmon was started on $startdate</i></font>\n" ;
  #print HTMLALPHA "<hr><ul><font face=$font size=-1>\n";
  #print HTMLALPHA "<li> <a HREF='http://dbamon.com'><b>DBAmon Home Page</a> </b>\n" ;
  #print HTMLALPHA "</ul></font>\n" ;
  print HTMLALPHA "<hr>\n" ;

  print HTMLALPHA "<p><font face=$font size=3><b>Instance Detail - '$alpha' Server Instance(s):</font></b>\n" ;

  print HTMLALPHA "<table rules=groups frame=hsides>\n" ;

  print HTMLALPHA "<tr bgcolor=slate>\n" ;
  print HTMLALPHA "<th colspan=5><h5>Server/<br>Instance Title1/Title2/Title3<br>ID1<sub>1</sub> ID2<sub>2</sub> ID3<sub>3</sub> ID4<sub>4</sub> <br>Uptime % Last 30 Days\n" ;
  print HTMLALPHA "<th><h5>DBMS/<br>Appl.\n" ;
  print HTMLALPHA "<th><h5><a href='http://dbamon.com/ref/actions.shtml'>Actions</a>\n" ;
  print HTMLALPHA "<th><h5>Events\n" ;
  print HTMLALPHA "<th><h5>Status<br>/CONFIG<br>Flags\n" ;
  #print HTMLALPHA "<th><h5>DBMS/<br>Appl.<br>Version\n" ;

  print HTMLALPHA "<th><h5>Bkup Method:<br> Hours Since<br>Last Bkup/ <br>Threshold<br>(R)erun Cmd\n" ;
  print HTMLALPHA "<th><h5>CPU<br>Model-CPUs<br>(MB Mem)\n" ;
  print HTMLALPHA "<th><h5>O/S<br>Level<br>(Mode)\n" ;
  print HTMLALPHA "<th><h5>Alloc/<br>Used<br>gB\n" ;
  print HTMLALPHA "<th><h5>Mon.<br>Secs.<br>(% Tot.)\n" ;
  print HTMLALPHA "<th><h5>Misc.\n" ;
  print HTMLALPHA "<th><h5>Task/Entry<br>Age<br>Mins.\n" ;
  print HTMLALPHA "</tr>\n" ;
}

#-----------------------------------------------------------------------------
sub instanceDetailAlpha
#-----------------------------------------------------------------------------
{
  &msg("instanceDetailAlpha() - Creating detail section");
  
  $statement  = "select 
      system,
      title, 
      dbms, 
      ts, 
      sysdate-ts,
      dbamonmode,
      htmlstring 
    from 
      dbamon.summary_detail 
    where 
      dbamonmode like '${modelc}%' 
    order by 2";
  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $lastbg2 = 0;

  &msg("  (After select 1)");

  while (@Data = $sth->fetchrow_array)
  {
    $sytem  = $Data[0];
    $title  = $Data[1];
    $dbms   = $Data[2];
    $ts     = $Data[3];
    $age    = int($Data[4] * (60*24));    #Convert to minutes
    #$task   = trim($Data[5]);
    $task   = $Data[5];
    $html   = $Data[6];
    $html =~ s/<td/\n  <td/g;
    $html =~ s/<option/\n  <option/g;
    $alpha  = uc substr($sytem,0,1);

    $dbms = "ServerNetAlias" if $dbms =~ /ServerAlias/;

    if ($alpha ne $last_alpha)
    {
      print HTMLALPHA "</table><p><font size=2><b>$alpha_i_count Total Instance(s)/Alias(es)</font><hr>\n" ;
      close(HTMLALPHA);
      if ($alpha_flag == 1)
      {
        $alpha_urls .= " <td align=right><h5>$alpha_i_count";
        chop($alpha_dbms_list);  # Remove trailing comma
        #$alpha_dbms_list =~ s/ //g;
        #$alpha_dbms_list =~ s/fontcolor/font color/g;
        $alpha_urls .= " <td><h5>$alpha_dbms_list\n";
        $alpha_dbms_list = "";
      }
      $alpha_flag = 1;
      $bg2 = &bg2;
      $alpha_urls .= "\n <tr $bg2><td align=center><a href='alpha_$modelc/$alpha.html'><h5>$alpha</a>";
      &newAlpha;
      $lastbg = 0;
      $alpha_i_count = 0;
    }
    $alpha_i_count++;
    if ($alpha_dbms_list !~ /$dbms/)
    {
      if ($dbms eq "Informix-UX     ") { $color = "darkblue" ; }
      if ($dbms eq "OracleDB-UX     ") { $color = "red"      ; }
      if ($dbms eq "OracleApps      ") { $color = "darkred"  ; }
      if ($dbms eq "SAP             ") { $color = "violet"   ; }
      if ($dbms eq "OracleDB-NT     ") { $color = "ff0090"   ; }
      if ($dbms eq "MSSQL           ") { $color = "green"    ; }
      if ($dbms eq "ServerNetAlias")   { $color = "brown"    ; }

      $alpha_dbms_list .= "<font color=$color>$dbms</font>,";
    }
    
    $last_alpha = $alpha;

    $bg = &bg;
    print HTMLALPHA "<tr $bg height=21> $html <td nowrap><h6>$task/$age\n";
    $selectcount++;
  }
  $alpha_urls .= " <td align=right><h5>$alpha_i_count";
  print HTMLALPHA "</table><hr>\n" ;
  close(HTMLALPHA);
  chop($alpha_dbms_list);  # Remove trailing comma
  #$alpha_dbms_list =~ s/ //g;
  #$alpha_dbms_list =~ s/fontcolor/font color/g;
  $alpha_urls .= " <td><h5>$alpha_dbms_list\n";

  &msg("Selected $selectcount summary_detail rows - num_instances=$num_instances");
}



#-----------------------------------------------------------------------------
sub makeDetail
#-----------------------------------------------------------------------------
{
  &msg("Creating detail section");

  &instanceDetail;   # Create detailed portion - file is $detpath
  print HTML "<!--#include virtual='$detpath'-->\n";

  # Now count the number of rows in the tasks table for iteration 0. 
  # If the number of detail rows != the sum from the summary_dbms table,
  # then an update must be happening now!

  $statement  = "
    select 
      sum(num_instances)
    from 
      dbamon.task 
    where 
      dbamonmode like '${modelc}%' 
      and iter_num = 0 
    ";

  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  while (@Data = $sth->fetchrow_array)
  {
    $num_instances = $Data[0];
  }
  &msg("There are $num_instances instances from the task=0 dbamon.task table");

  #if ($num_instances != $selectcount)
  if ($num_instances > $selectcount)
  {
    &msg("The number of detail rows ($selectcount) does not match the count total ($num_instances)");
    &msg("from the summary_tasks table. Therefore, an update must be in process");
    &msg("now. Killing myself");
    exit 2;
  }
}

#-----------------------------------------------------------------------------
sub makeDetailShort
#-----------------------------------------------------------------------------
{
  $shortpath      = "/opt/dbamon/htm/tmp/instances${modelc}_$$.html.new";
  $shortpath_perm = "/opt/dbamon/htm/instances$modelc.html";

  &msg("cp'ing HTML");
  close(HTML);
  system("cp $html_sys_path_new $shortpath");
  ##system("ll $html_sys_path_new $shortpath");

  msg("Reopening output HTML file: $html_sys_path_new");
  open(HTML, ">>$html_sys_path_new") || &error("Can't open input $html_sys_path_new - $!");

  &msg("Creating Short detail section");

  open(HTMLSHORT, ">>$shortpath") || &error("Can't open output $shortpath - $!");

  &instanceDetailAlpha;

  print HTMLSHORT "<a name='ALPHA'>\n";
  print HTMLSHORT "<table width=$table_width>\n";
  print HTMLSHORT "<tr bgcolor=darkblue><td><font face=$font size=3 color=wheat><b><center>Instance Detail - By First Letter Of Server Name</center></font></b>\n";
  print HTMLSHORT "</table>\n";

  print HTMLSHORT "<table border=0 width=$table_width><tr bgcolor=slate><td><h5>First Letter Of<br>Server Name<td><h5>Instance<br>Count<td><h5>DBMS(s)\n";
  print HTMLSHORT "$alpha_urls </table>\n";
  print HTMLSHORT "<font face=$font size=2><b><p>($server_count Total Server(s) - $health_tot Total Instance(s)/Alias(es) - $total_space gB Total DB Space)<hr>\n";

  &makeTasksShort;

  close(HTMLSHORT);
}

#-----------------------------------------------------------------------------
sub makeFoot
#-----------------------------------------------------------------------------
{
  &msg("Creating foot section");

  open(HTMLTASK, ">$task_detail_file") || &error("Can't open output $task_detail_file - $!");

  print HTMLTASK "<title>DBAmon Monitor Task Detail - Mode: $mode</title>\n" ;
  print HTMLTASK "<body bgcolor=white link=darkblue vlink=darkblue><font face=$font>\n" ;
  print HTMLTASK "<table><tr><td><img src='img/dbamonlogo.jpg'>\n" ;
  print HTMLTASK "<tr bgcolor=wheat><td><font face=$font size=5><center>Monitor Task Detail - Mode: $mode</center>\n";
  print HTMLTASK "</table>\n" ;
  print HTMLTASK "<font face=$font size=-2><i>This page was generated by DBAmon <b>$verrel</b> mode=$mode running on $hostname on $date - This execution of DBAmon was started on $startdate</i></font>\n" ;
  print HTMLTASK "<hr>\n" ;

  print HTMLTASK "<p><font face=$font size=3><b>Monitor Task Detail:</font></b>\n" ;
  print HTMLTASK "<table rules=groups frame=hsides>\n" ;

  print HTMLTASK "<tr bgcolor=slate>\n" ;
  print HTMLTASK "<th><h5>Monitor Process\n" ;
  print HTMLTASK "<th><h5>Iteration<br>Number\n" ;
  print HTMLTASK "<th><h5>Iteration<br>Duration<br>(Mins.)\n" ;
  print HTMLTASK "<th><h5>Iteration<br>Completion<br>Time\n" ;
  print HTMLTASK "<th><h5>PID\n" ;
  print HTMLTASK "<th><h5>DB Server<br>Names Monitored\n" ;
  print HTMLTASK "<th><h5>Task Start Time\n" ;
  print HTMLTASK "<th><h5>Number of <br>Instances<br> Monitored\n" ;
  print HTMLTASK "</tr>\n" ;

  $statement  = "
    select 
      dbamonmode, 
      pid,
      starttime_num,
      starttime_char,
      alpha,
      iter_num,
      iter_dur,
      num_instances,
      to_char(ts,\'YYYY/MM/DD-HH24:MI:SS\') 
    from 
      dbamon.task 
    where 
      dbamonmode like '${modelc}%' 
    order by 
      1, 6";

  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $i_mode= $Data[0];
    $pid   = $Data[1];
    #$st_n  = $Data[2];
    $st_c  = $Data[3];
    $alpha = $Data[4];
    $i_num = $Data[5];
    $i_dur = int($Data[6] / 60);
    $num   = $Data[7];
    $ctime = $Data[8];
 
    if ($i_mode ne $last_mode && $last_mode ne "")
    {
      print HTMLTASK "<tr><td colspan=8><hr>\n";
    }

    $bg = &bg;
    if ($i_mode ne $last_mode)
    {
      print HTMLTASK "<tr $bg>
       <td><h5>$i_mode 
       <td align=right><h5>$i_num 
       <td align=right><h5>$i_dur 
       <td><h5>$ctime 
       <td><h5>$pid 
       <td><h5>$alpha 
       <td><h5>$st_c 
       <td align=right><h5>$num 
      \n";
    }
    else
    {
      print HTMLTASK "<tr $bg>
       <td><h5>$i_mode 
       <td align=right><h5>$i_num 
       <td align=right><h5>$i_dur 
       <td><h5>$ctime 
       <td><td><td><td align=right><h5>$num
      \n";

    }
    $selectcount++;
    $last_mode = $i_mode;
  }

  print HTMLTASK "</table><hr>\n" ;
  close(HTMLTASK);
}

#-----------------------------------------------------------------------------
sub makeTasksShort
#-----------------------------------------------------------------------------
{
  &msg("Creating tasks section");

  print HTMLSHORT "<table width=$table_width>\n";
  print HTMLSHORT "<tr bgcolor=darkblue><td><font face=$font size=3 color=wheat><b><center>Monitor Task Summary</center></font></b>\n";
  print HTMLSHORT "</table>\n";
  
  print HTMLSHORT "<table rules=groups frame=hsides width=$table_width>\n" ;

  print HTMLSHORT "<tr bgcolor=slate>\n" ;
  print HTMLSHORT "<th><h5>Monitor Process\n" ;
  print HTMLSHORT "<th><h5>Instances<br>Being<br>Monitored\n" ;
  print HTMLSHORT "<th><h5>Last Iteration <br># Completed\n" ;
  print HTMLSHORT "<th><h5>Avg. Iteration <br>Duration<br>(Mins.)\n" ;
  print HTMLSHORT "<th><h5>Min. Iteration <br>Duration<br>(Mins.)\n" ;
  print HTMLSHORT "<th><h5>Max. Iteration <br>Duration<br>(Mins.)\n" ;
  print HTMLSHORT "<th><h5>Avg. Number of <br>Instances<br>Monitored\n" ;
  print HTMLSHORT "<th><h5>Avg. Duration<br>Per Instance<br>(Mins.)\n" ;
  print HTMLSHORT "</tr>\n" ;

  $statement  = "
    select 
      dbamonmode, 
      alpha,
      max(iter_num),
      avg(iter_dur),
      min(iter_dur),
      max(iter_dur),
      avg(num_instances)
    from 
      dbamon.task 
    where 
      dbamonmode like '${modelc}%' 
      and iter_num > 0
    group by
      dbamonmode,
      alpha
    ";

  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $lastbg = 0;

  $total_num = 0;
  $total_min = 99999;
  $total_max = 0;
  $total_cnt = 0;
  $total_avg = 0;
  $total_avgdur = 0;

  while (@Data = $sth->fetchrow_array)
  {
    $i_mode= $Data[0];
    $i_alph= $Data[1];
    $i_num = $Data[2];
    $i_dur = int($Data[3] / 60);
    $i_min = int($Data[4] / 60);
    $i_max = int($Data[5] / 60);
    $num   = sprintf("%7.1f",$Data[6]);
    $avgper= sprintf("%7.2f",$i_dur/$num);

    $bg = &bg;
    print HTMLSHORT "<tr $bg><td><h5>$i_mode <td><h5>$i_alph<td align=right><h5>$i_num <td align=right><h5>$i_dur <td align=right><h5>$i_min<td align=right><h5>$i_max <td align=right><h5>$num <td align=right><h5>$avgper \n";
    $selectcount++;
    $num_instances += $num;
    
    $total_num += $i_num;
    $total_cnt += $num;
    $total_avg += $avgper;
    $total_min = $i_min if $i_min < $total_min;
    $total_max = $i_max if $i_max > $total_max;
    $total_avgdur += $i_dur;
  }

  $total_avg = $total_avg / $selectcount if $selectcount > 0;
  $total_avgdur = int($total_avgdur / $selectcount) if $selectcount > 0;

  $total_cnt = sprintf("%7.1f",$total_cnt);
  $total_avg = sprintf("%7.2f",$total_avg);

  print HTMLSHORT "<tr>\n" ;
  print HTMLSHORT "<th align=left bgcolor=slate><h5>Total:\n" ;
  print HTMLSHORT "<th bgcolor=white><h5>\n" ;
  print HTMLSHORT "<th align=right bgcolor=white><h5>$total_num\n" ;
  print HTMLSHORT "<th align=right bgcolor=white><h5>$total_avgdur\n" ;
  print HTMLSHORT "<th align=right bgcolor=white><h5>$total_min\n" ;
  print HTMLSHORT "<th align=right bgcolor=white><h5>$total_max\n" ;
  print HTMLSHORT "<th align=right bgcolor=white><h5>$total_cnt\n" ;
  print HTMLSHORT "<th align=right bgcolor=white><h5>$total_avg\n" ;

  $statement  = "
    select 
      dbamonmode, 
      max(iter_num),
      avg(iter_dur)
    from 
      dbamon.task 
    where 
      dbamonmode like '${modelc}%' 
    group by
      dbamonmode
  ";

  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $color = "lime"; 

  $endmsg2  = "No tasks have reported - DBAmon is starting";
  $taskflag1 = 1;

  while (@Data = $sth->fetchrow_array)
  {
    $taskflag1 = 0;
    $endmsg2  = "Since all tasks have completed >=1 iteration, this page is complete";

    $i_mode   = $Data[0];
    $i_num    = $Data[1];
    $avg_iter = $Data[2];

    if ($i_num < 1) 
    {
      $endmsg1 .= "Task=$i_mode has not yet completed 1st iteration<br>";
      $endmsg2  = "This page is not yet complete";
      $color = "red";
      $taskflag2 = 1;
    }
  }

  # Experiment - if page is not complete, then die
  if ($taskflag1 || $taskflag2)  
  {
    &msg("Page not complete - Exiting - taskflag1=$taskflag1 taskflag2=$taskflag");
    exit 0;
  }

  print HTMLSHORT "<tr><td colspan=8 bgcolor=$color align=center><h5>$endmsg1 $endmsg2 \n";
  ##print HTMLSHORT "</form>\n" ;
  print HTMLSHORT "</table>\n" ;
  print HTMLSHORT "<ul><li><h5><a href='$task_detail_url'>Monitor Task Details</a></ul>\n" ;
  print HTMLSHORT "<hr>\n" ;
}

#-----------------------------------------------------------------------------
sub makeTasks
#-----------------------------------------------------------------------------
{
  &msg("Creating tasks section");

  print HTML "<table width=$table_width>\n";
  print HTML "<tr bgcolor=darkblue><td><font face=$font size=3 color=wheat><b><center>Monitor Task Summary</center></font></b>\n";
  print HTML "</table>\n";
  
  print HTML "<table rules=groups frame=hsides width=$table_width>\n" ;

  print HTML "<tr bgcolor=slate>\n" ;
  print HTML "<th><h5>Monitor Process\n" ;
  print HTML "<th><h5>Instances<br>Being<br>Monitored\n" ;
  print HTML "<th><h5>Last Iteration <br># Completed\n" ;
  print HTML "<th><h5>Avg. Iteration <br>Duration<br>(Mins.)\n" ;
  print HTML "<th><h5>Min. Iteration <br>Duration<br>(Mins.)\n" ;
  print HTML "<th><h5>Max. Iteration <br>Duration<br>(Mins.)\n" ;
  print HTML "<th><h5>Avg. Number of <br>Instances<br>Monitored\n" ;
  print HTML "<th><h5>Avg. Duration<br>Per Instance<br>(Mins.)\n" ;
  print HTML "</tr>\n" ;

  $statement  = "
    select 
      dbamonmode, 
      alpha,
      max(iter_num),
      avg(iter_dur),
      min(iter_dur),
      max(iter_dur),
      avg(num_instances)
    from 
      dbamon.task 
    where 
      dbamonmode like '${modelc}%' 
      and iter_num > 0
    group by
      dbamonmode,
      alpha
    ";

  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $i_mode= $Data[0];
    $i_alph= $Data[1];
    $i_num = $Data[2];
    $i_dur = int($Data[3] / 60);
    $i_min = int($Data[4] / 60);
    $i_max = int($Data[5] / 60);
    $num   = sprintf("%7.1f",$Data[6]);
    $avgper= sprintf("%7.2f",$i_dur/$num);

    $bg = &bg;
    print HTML "<tr $bg><td><h5>$i_mode <td><h5>$i_alph<td align=right><h5>$i_num <td align=right><h5>$i_dur <td align=right><h5>$i_min<td align=right><h5>$i_max <td align=right><h5>$num <td align=right><h5>$avgper \n";
    $selectcount++;
    $num_instances += $num;
  }

  $statement  = "
    select 
      dbamonmode, 
      max(iter_num),
      avg(iter_dur)
    from 
      dbamon.task 
    where 
      dbamonmode like '${modelc}%' 
    group by
      dbamonmode
  ";

  ##print "$statement\n";
  $sth = $dbh->prepare($statement) ||
          &error('Failed_on_DB_prepare_in_chgEnt');
  $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
  $selectcount = 0;
  $color = "lime"; 

  $endmsg2  = "No tasks have reported - DBAmon is starting";
  $taskflag1 = 1;

  while (@Data = $sth->fetchrow_array)
  {
    $taskflag1 = 0;
    $endmsg2  = "Since all tasks have completed >=1 iteration, this page is complete";

    $i_mode   = $Data[0];
    $i_num    = $Data[1];
    $avg_iter = $Data[2];

    if ($i_num < 1) 
    {
      $endmsg1 .= "Task=$i_mode has not yet completed 1st iteration<br>";
      $endmsg2  = "This page is not yet complete";
      $color = "red";
      $taskflag2 = 1;
    }
  }

  # Experiment - if page is not complete, then die
  if ($taskflag1 || $taskflag2)  
  {
    &msg("Page not complete - Exiting - taskflag1=$taskflag1 taskflag2=$taskflag");
    exit 1;
  }

  print HTML "<tr><td colspan=8 bgcolor=$color><h5>$endmsg1 $endmsg2 \n";
  ##print HTML "</form>\n" ;
  print HTML "</table>\n" ;
  print HTML "<ul><li><h5><a href='$task_detail_url'>Monitor Task Details</a></ul>\n" ;
  print HTML "<hr>\n" ;
}

#-----------------------------------------------------------------------------
sub reportMenu
#-----------------------------------------------------------------------------
{
  &msg("Creating report menu");

  # make sure dir exists
  if (! -x "/opt/dbamon/htm/reports/")
  {
    system("mkdir /opt/dbamon/htm/reports/");
  }

  $rpt_dbtime = 0;

  foreach (@instance_list)
  {
    s/ //g;
    $inst = $_;
    ##&msg("Found instance=$inst");

    $zsrvr = (split(":",$inst)) [0];
    $zinst = (split(":",$inst)) [1];

    $b4 = time;

    $statement = "select dbms, dbmsver from dbamon.instances 
                  where system like '$zsrvr%' 
                    and instance = '$zinst' 
                    and dbamonmode like '%${modelc}%'";
    $sth = $dbh->prepare($statement) ||
	    &error('Select_$what');
    $sth->execute || &error('Failed_on_DB_execute_in_chgEnt');
    $selectcount = 0;
    $dbms = "?";
    $dver = "?";
    while (@Data = $sth->fetchrow_array)
    {
      $selectcount++;
      ($dbms = $Data[0]) =~ s/ //g;
      ($dver = $Data[1]) =~ s/ //g;
    }

    $rpt_dbtime += (time - $b4);

    $ver1 = substr($dver,0,1);

    if    ($dbms eq "Oracle" && $ver1 ge "8") { $incfile = "inc1"; }
    elsif ($dbms eq "Oracle" && $ver1 lt "8") { $incfile = "inc2"; }
    else                                      { $incfile = "inc3"; }

    ##&msg("dbms=$dbms dver=$dver ver1=$ver1 incfile=$incfile zsrvr=$zsrvr zinst=$zinst");

    # build menu 
    $html_template = `cat /opt/dbamon/lib/dbamon_ora_sumread.$incfile.html`;
    $html_template =~ s/INSTANCE/$inst/g;
    $html_template =~ s/MODE/$modelc/g;
    $html_template =~ s/SERVER/$zsrvr/g;
    $html_template =~ s/DBNAME/$zinst/g;

    $file = "/opt/dbamon/htm/reports/$inst.html";
    open(RPTINST, ">/opt/dbamon/htm/reports/$inst.html") || &error("Can't open output $file - $!");
    print RPTINST "$html_template";
    close(RPTINST); 
    $menucount++;
  }
  &msg("Created $menucount report menus - rpt_dbtime=$rpt_dbtime");
}

#-----------------------------------------------------------------------------
sub init
#-----------------------------------------------------------------------------
{
  if ($mode eq "TEST")
  {
    $rcfile = "/opt/dbamon/adm/dbamonrc_test";
    $html_sys_path = "/opt/dbamon/htm/dbamon_sys_test.html";
    # remove any old new files from preior failed iterations
  }
  else
  {
    $rcfile = "/opt/dbamon/adm/dbamonrc";
    $html_sys_path = "/opt/dbamon/htm/dbamon_sys.html";
    # remove any old new files from preior failed iterations
  }
  msg("rm'ing old .new files - Usage error message is OK");
  system("find /opt/dbamon/htm/tmp/*.new -mtime +1 | xargs rm");

  # Read ID1_Breakout: parm
  chop($id1_breakout = `grep 'ID1_Breakout:' $rcfile | grep -v '^#' | awk '{ print \$2 }'`);
  msg("id1_breakout=$id1_breakout  ");

  # Read ID2_Breakout: parm
  chop($id2_breakout = `grep 'ID2_Breakout:' $rcfile | grep -v '^#' | awk '{ print \$2 }'`);
  msg("id2_breakout=$id2_breakout  ");

  # Read ID3_Breakout: parm
  chop($id3_breakout = `grep 'ID3_Breakout:' $rcfile | grep -v '^#' | awk '{ print \$2 }'`);
  msg("id3_breakout=$id3_breakout  ");

  # Read Loc_Breakout: parm
  chop($loc_breakout = `grep 'Loc_Breakout:' $rcfile | grep -v '^#' | awk '{ print \$2 }'`);
  msg("loc_breakout=$loc_breakout  ");
  
  chop($verrel        = `cat /opt/dbamon/bin/verrel`);
  chop($startdate     = `cat /opt/dbamon/adm/startdate_${modelc}.txt`);

  ##msg("html_sys_path=$html_sys_path  ");

  chop($hostname = `hostname`);
  chop($date = `date`);

  #$html_sys_path_new = "${html_sys_path}.$$.new";
  $html_sys_path_new = "/opt/dbamon/htm/tmp/syspath_${modelc}_$$.html.new";
  msg("Opening output HTML file: $html_sys_path_new");
  system("mkdir /opt/dbamon/htm/tmp > /dev/null 2>&1");
  open(HTML, ">$html_sys_path_new") || &error("Can't open input $html_sys_path_new - $!");

  $task_detail_file = "/opt/dbamon/htm/task_detail_${modelc}.html";
  $task_detail_url  = "task_detail_${modelc}.html";

  if ($modelc eq "test") { $detpath = "instance_detail_test.html"; }
  else                   { $detpath = "instance_detail.html"; }
}

#------------------------------------------------------------------------------
#
# Main
#
#------------------------------------------------------------------------------

&msg("Starting mode=$mode arg1=$arg1 arg2=$arg2 arg3=$arg3 arg4=$arg4");

if ($mode eq "PROD")
{
  system("         ps -ef | grep $P | grep -v grep");
  chop($numproc = `ps -ef | grep $P | grep -v grep | wc -l`);
  &msg("Number of ${P}'s for mode=$mode running: $numproc");
  if ($numproc > 2)
  {
    &msg("There is another instance of $P running - numproc=$numproc - killing myself");
    exit 2; 
  }
}

&connectDB;
&init;

&makeTitle; 
&makeScoreboard; 

&makeDetailShort; 
&makeDetail; 

&makeTasks; 
&makeFoot; 

&makeSev;

foreach $dbms (@dbmslist)
{
  ##print "dbms=$dbms \n";
  &makeDetailDBMS($dbms); 
}

if ($id1_breakout eq "Y")
{
  foreach $id1 (@id1list)
  {
    ##print "id1=$id1 \n";
    &makeDetailID1($id1); 
  }
}

if ($id2_breakout eq "Y")
{
  foreach $id2 (@id2list)
  {
    ##print "id2=$id2 \n";
    &makeDetailID2($id2); 
  }
}

if ($id3_breakout eq "Y")
{
  foreach $id3 (@id3list)
  {
    ##print "id3=$id3 \n";
    &makeDetailID3($id3); 
  }
}

if ($loc_breakout eq "Y")
{
  foreach $loc (@loclist)
  {
    ##print "loc=$loc \n";
    &makeDetailLOC($loc); 
  }
}

&msg("Closing HTML filehandle");
close(HTML);

&msg("Renaming $html_sys_path_new to $html_sys_path");
$rc = system("mv $html_sys_path_new $html_sys_path"); 
if ($rc != 0) 
{
  &error("Error renaming $html_sys_path_new to $html_sys_path");
}

&msg("Renaming $shortpath to $shortpath_perm");
$rc = system("mv $shortpath $shortpath_perm"); 
if ($rc != 0) 
{
  &error("Error renaming $shortpath to $shortpath_perm");
}

# Just in case
system("rm $html_sys_path_new > /dev/null 2>&1"); 

&msg("Invoking dbamon_uptime_summarize");
system("dbamon_uptime_summarize > /opt/dbamon/log/dbamon_uptime_summarize.log 2>&1");

&msg("Invoking dbamon_ora_util eventCleanup");
system("echo 'dbamon_ora_util prod eventCleanup >> /opt/dbamon/log/dbamon_eventCleanup.log 2>&1' | at now");

&msg("Done");
chop($date = `date +%Y/%m/%d-%H:%M:%S`);
system("echo '$date' > /opt/dbamon/htm/asof_$modelc.txt");
chop($size = `ls -l /opt/dbamon/htm/$detpath | awk '{ print \$5 }'`);
system("echo '$size' > /opt/dbamon/htm/sizeof_$modelc.txt");

# Create report menus
&reportMenu;

$num_instances /= 2;
system("echo '$date - $mode - $num_instances' >> $log");

exit 0;
