# -----------------------------------------------------------------------
# MAIN Logic
# -----------------------------------------------------------------------
{
  #
  # ARGs
  #
  # arg=$mod dbamon_tasknum=$i dbamon_alpha=$array[$i] cmdloc=/opt/dbamon/bin
  $arg            = $ARGV[0];
  $dbamon_tasknum = $ARGV[1];
  $dbamon_alpha   = $ARGV[2];
  $cmdloc         = $ARGV[3];

  #
  # debug flags
  #

  $debug      = 0;
  $debug_html = 0;
  $debug_read = 0;
  $debug_opc  = 0;
  $debug_crit = 0;
  
  $dashes = "-" x 70;

  #
  # Version and Release
  #

  chop($verrel = `cat /opt/dbamon/bin/verrel`);
  
  $dbamon_home = "http://dbamon.com";

  #
  # set other variables
  #

  chop($strdate = `date`);

  $rc_save = 0;

  $pid = $$;

  # Write my pid and mode to a file
  $time_processes = time;
  chop($ts_processes = `date +%Y/%m/%d-%H:%M:%S`);
  $modeout = $arg . $dbamon_tasknum;
  system("echo '$pid $modeout $time_processes $ts_processes $dbamon_alpha ' >> /opt/dbamon/adm/processes_${arg}.txt");

  $optdir="/opt/dbamon";

  if ($arg eq "test") 
  {
    $tmpdir="/opt/dbamon/tmp/test_${dbamon_tasknum}";
    system("rm -fr $tmpdir 2>/dev/null");
    system("mkdir  $tmpdir 2>/dev/null");
    $rptdir="/opt/dbamon/dat/reports/test";
  }
  else
  {
    $tmpdir="/opt/dbamon/tmp/prod_${dbamon_tasknum}";
    system("rm -fr $tmpdir 2>/dev/null");
    system("mkdir  $tmpdir 2>/dev/null");
    $rptdir="/opt/dbamon/dat/reports";
  }

  $pgmdir="/opt/dbamon/bin";
  $admdir="/opt/dbamon/adm";
  $hstdir="/opt/dbamon/dat/history";
  $inhibdir="/opt/dbamon/dat/inhibit";

  $remshlog="$tmpdir/remsherr_$dbamon_tasknum";
  $pinglog ="$tmpdir/pingerr_$dbamon_tasknum";
  $parmall ="$tmpdir/dbamonrc_$dbamon_tasknum";

  # Cleanup old temp files
  system("rm $tmpdir/dbamon_tmp*${dbamon_tasknum} > /dev/null 2>&1");

  $tmpfl1="$tmpdir/dbamon_tmp1_${dbamon_tasknum}";
  $tmpfl2="$tmpdir/dbamon_tmp2_${dbamon_tasknum}";
  $tmpfl3="$tmpdir/dbamon_tmp3_${dbamon_tasknum}";
  $tmpfl4="$tmpdir/dbamon_tmp4_${dbamon_tasknum}";
  $tmpfl5="$tmpdir/dbamon_tmp5_${dbamon_tasknum}";
  $tmpfl6="$tmpdir/dbamon_tmp6_${dbamon_tasknum}";
  $tmpfl7="$tmpdir/dbamon_tmp7_${dbamon_tasknum}";
  $tmpfl8="$tmpdir/dbamon_tmp8_${dbamon_tasknum}";
  $tmpflt="$tmpdir/dbamon_tmpt_${dbamon_tasknum}";
  $sqlfil="$tmpdir/dbamon_sqlf_${dbamon_tasknum}";

  $tmplcl="/opt/dbamon/tmp/dbamon_arc_sql_${dbamon_tasknum}";  # dbamon_arch_onarch output
  $tmprmt="/tmp/dbamon_arc.sql";    # on monitored system

  $logfile="dummy";
  $wheretolog="S";

  $f_s = "<font size=2>";
  $f_e = "</font>";

  chop($wsname = `hostname`);
  chop($wsnamef = `nslookup $wsname | grep 'Name:' | awk '{ print \$2 }'`);

  chop($dbamon_userid = `id -u -n`);

  $table_bgcolor = "antiquewhite";

  @z = split(/\./,$wsnamef);
  $company = $z[$#z -1];

  ##print "arg=$arg wsname=$wsname wsnamef=$wsnamef company=$company #=$#z \n";

  if ($arg eq "test")
  {
    $mode="test";
    $parmfl="$optdir/adm/dbamonrc_test";
    $insertdb="database dbamon_test;" ;
    if ($ENV{'DBAMON_WWW'} == 1)
    {
      $parmdir="$optdir/adm/instances_test_www";
    }
    else
    {
      $parmdir="$optdir/adm/instances_test";
    }
  }
  else
  {
    $mode="prod";
    $parmfl="$optdir/adm/dbamonrc";
    $insertdb="database dbamon;" ;
    $parmdir="$optdir/adm/instances";
  }

  &logit("Mode=$mode pid=$pid dbamon_tasknum=$dbamon_tasknum");

  #---- Verify that all DBAmon directories exist
  &verifyDirs();

  # Read dbamonrc and DBC files
  &readConfig();

  chop($use_oracle  = `grep 'Use_Oracle:' $parmfl | grep -v '^#' | awk '{ print \$2 }'`);
  if ($use_oracle eq "Y")
  {
    $insertdb = "-- connect?";
    &logit("Connecting to Oracle Repository DB - ORACLE_SID=$ENV{'ORACLE_SID'}");
    &connectDB;
  }

  #---- Verify that all DBAmon tables exist
  &verifyTables();

  $msg = sprintf("SYSTEM values - sleep_time=%s iterations=%s dbamon_admin=%s html_events_dir=%s",$sleep_time,$iterations,$dbamon_admin,$html_events_dir);
  &logit($msg);

  system("rm $tmpdir/dbamon_savemsg_next > /dev/null 2>&1");
  system("rm $tmpdir/dbamon_savemsg_this > /dev/null 2>&1");

  $outmode = $mode;
  if ($outmode ne "") 
  {
    $outmode = "prod"
  }

  $msg = sprintf("Version %s Starting",$verrel);
  &logit($msg);
  &log_msg($msg);
  $msg = sprintf("pgmdir=%s arg=%s tmpdir=%s insertdb=%s company=%s pid=%s",$pgmdir,$arg,$tmpdir,$insertdb,$company,$pid);
  &logit($msg);
  &log_msg($msg);
  $msg = sprintf("dbamon_userid=%s dbamon_tasknum=%s dbamon_alpha=%s",$dbamon_userid,$dbamon_tasknum,$dbamon_alpha);
  &logit($msg);
  &log_msg($msg);

  $save_flag = 0;

  #
  # Check DBAmon version against latest on dbamon_home
  #
  &check_sw();

  for ($iter_count = 1; $iter_count <= $iterations; $iter_count++)
  {
    $time_start = time;

    $msg = sprintf("Start of Iteration #%s",$iter_count); 
    &logit($msg);

    #
    # Start of iteration housekeeping
    #
    &begin_stuff();

    # Read DBC files
   
    if ($ENV{'DBAMON_READDBCDB'} ne "")
    {
      &readDBCDB();
    }
    else  
    {
      &readDBCFile();
    }

    if ($iter_count == 1)
    {
      # Check license key
      # Check our license key
      &logit("Checking license key");
      if (system("/opt/dbamon/bin/keychk $high_host $dbamon_admin $verrel $dbmslist $mode") != 0)
      {
	$msg = "ERROR - Your license key in /opt/dbamon/adm/key.txt is not valid or expired - see preceeding message";
	&error_msg($msg);
	exit 1;
      }
    }

    #
    # Download Software
    #
    &run_monitor("DownloadSW");

    if (index($dbmslist,"OracleNT") > -1)
    {
      &run_monitor("orantUp");
      &run_monitor("orantPerf");
      &run_monitor("orantTSFull");
      &run_monitor("orantArclog");
      &run_monitor("orantDatafiles");
      &run_monitor("orantBkup");
    }
    else
    {
      $msg = "(No OracleNT Instances to Monitor)";
      &logit($msg);
    }

    if (index($dbmslist,"MSSQL") > -1)
    {
      &run_monitor("sqlUp");
      &run_monitor("sqlTLog");
      &run_monitor("sqlBkup");
      &run_monitor("sqlAlerts");
    }
    else
    {
      $msg = "(No MSSQL Instances to Monitor)";
      &logit($msg)
    }

    if (index($dbmslist,"SAP") > -1)
    {
      &run_monitor("sapUp");
    }
    else
    {
      $msg = "(No SAP Instances to Monitor)";
      &logit($msg);
    }

    if (index($dbmslist,"OracleApps") > -1)
    {
      &run_monitor("oraapUp");
    }
    else
    {
      $msg = "(No OracleApps Instances to Monitor)";
      &logit($msg);
    }

    if (index($dbmslist,"OracleDB") > -1)
    {
      &run_monitor("oraUp");
      &run_monitor("oraSaveCfg");
      &run_monitor("oraSec");
      &run_monitor("oraInSync");
      &run_monitor("oraSGA");
      &run_monitor("oraLsnr");
      &run_monitor("oraAuditSes");
      &run_monitor("oraDatafiles");
      &run_monitor("oraArclog");
      &run_monitor("oraBkup");
      &run_monitor("oraBkupArc");
      &run_monitor("oraTSFull");
      &run_monitor("oraAlerts");
      &run_monitor("oraExtents");
      &run_monitor("oraPerf");
    }
    else
    {
      $msg = "(No OracleDB Instances to Monitor)";
      &logit($msg);
    }

    if (index($dbmslist,"Informix") > -1)
    {
      &run_monitor("infUp");         # Informix up
      &run_monitor("infLongTX");     # Long tx
      &run_monitor("infChkDup");     # Dup onconfig parms
      &run_monitor("infSWVer");      # Ifmx vers
      &run_monitor("infChunksDown"); # Chunks down 
      &run_monitor("infSaveCfg");    # Save onconfig
      &run_monitor("infLocks");      # Locks exceeded
      &run_monitor("infNFile");      # NFILEs
      &run_monitor("infCkpt");       # Checkpoint dur
      &run_monitor("infShmem");      # Shmem segs
      &run_monitor("infExtents");    # TBL extents
      &run_monitor("infDBS");        # DBSpaces
      &run_monitor("infCleaners");   # Cleaners
      &run_monitor("infLlogs");      # Logical logs
      &run_monitor("infArc");        # Backup age
      &run_monitor("infHDR");        # HDR
      &run_monitor("infMLog");       # Message log
      &run_monitor("infPerf");       # Perf stuff
    }
    else
    {
      $msg = "(No Informix Instances to Monitor)";
      &logit($msg);
    }

    #
    # Print Summary
    #
    $this_function = "";
    &summarize();

    #
    # End of iteration housekeeping
    #
    &end_stuff();

    #
    # Calc iteration duration
    #
    $time_end = time;
    $dur = $time_end - $time_start;

    # Write to task table
    if ($use_oracle eq "Y")
    {
      &logit("Inserting into dbamon.task");

      if ($dbamon_alpha eq "") { $z = "*"; }
      else                     { $z = $dbamon_alpha; }

      $statement  = "
	insert into dbamon.task
	(dbamonmode,pid,starttime_num,starttime_char,alpha,iter_num,iter_dur,num_instances)
	values
	(\'$modeout\',\'$pid\', \'$time_processes\', \'$ts_processes\', \'$z\', \'$iter_count\',\'$dur\',\'$high_host\')
      ";
      ##print "statement=$statement\n";
      runSQL($statement);
     
      # Recreate the summary WWW page for this mode
      &logit("Updating repository with Event Data for this iteration");
      &eventDB;

      # Recreate the summary WWW page for this mode
      &logit("Invoking dbamon_ora_sumread.pl");
      $cmd = "$pgmdir/dbamon_ora_sumread.pl $mode > $tmpfl8 2>&1";
      $stime_sumread = time;
      $rc = system($cmd);
      if ($rc != 0) { $rc = $rc / 256; }
      &logit("dbamon_ora_sumread.pl ended with rc=2 (Normal)") if $rc == 2;
      if ($rc != 0 && $rc != 2)
      {
	$msg = sprintf("dbamon_ora_sumread.pl Error - rc=%s",$rc);
	&logit($msg);
	&error_msg($msg,'',$tmpfl8);
      }
      $etime_sumread = time - $stime_sumread;
      &logit("dbamon_ora_sumread.pl Ended with rc=$rc - Elapsed time: $etime_sumread"); 
      system("cp $tmpfl8 /tmp/dbamon_ora_sumread.log"); 
    }

    #
    # Sleep
    #

    &logit("------------------------------------------------------------------");

    $msg = sprintf("End of Iteration %s of %s",$iter_count,$iterations);
    &logit($msg);

    $msg = sprintf("Iteration Duration: %s Seconds",$dur);
    &logit($msg);

    if ($iter_count < $iterations && $iter_min_secs ne "" && $dur < $iter_min_secs)
    {
      &logit("This interation ran for less than dbamonrc Iter_Min_Secs: value of $iter_min_secs");
      $st = $iter_min_secs - $dur;
      &logit("Sleeping for $st seconds before starting the next iteration");
      sleep($st);
    }

    if ($sleep_time > 0)
    {
      &logit("Sleeping for dbamonrc Sleeptime: value of $sleep_time seconds");
      &logit("------------------------------------------------------------------");

      if (system("sleep $sleep_time") != 0)
      {
	$msg = sprintf("Cancelled");
	&logit($msg);
	&log_msg($msg);
	system("rm $optdir/tmp/dbamon_savemsg_next > /dev/null 2>&1");
	system("rm $optdir/tmp/dbamon_savemsg_this > /dev/null 2>&1");
	exit;
      }
    }
  }
  &logit("------------------------------------------------------------------");
  &logit("All DBAmon Iterations Completed - Exiting");
}
1;
