sub DownloadSWNT
#
{
  ($thishost) = @_;
  #
  # If we are using ssh, use scp instead of rcp 
  #

  $hn = $hostname[$thishost];
  ##print "NT download_host[hn]=" download_host[hn]
  if ($download_host{$hn} == 1 && $download_every[$thishost] ne "Y")
  {
    $download_flag[$thishost] = 1;
    $up[$thishost] = "";
    $hn = $hostname[$thishost];
    $msg = sprintf("Download already done for host: %s",$hn);
    &logit($msg,$thishost);
    return;
  }

  #
  # Remove any old /tmp/dbamon* files
  #
  $must_connect = 1;
  &remsh("erase \\temp\\dbamon*.pl",$tmpfl2,$thishost);
  if ($up[$thishost] eq "N")     # Remsh error
  {
    logit("(Connect Error) - turning off download flag",$thishost);
    $up[$thishost] = "D";
    $download_flag[$thishost] = 0;
    return;
  }

  #
  # Until an rcp bug is fixed we have to remsh to server and then rcp the
  # S/W back to \temp
  #
  # Download pgms from /opt/dbamon/bin/download to temp
  #

  if ($dbms[$thishost] eq "MSSQL")    { $filemask = "mssql" }
  if ($dbms[$thishost] eq "OracleNT") { $filemask = "orant" }

  system("rm $tmpfl2 2>&1");
  system("touch $tmpfl2");

  if ($ntrcpbug[$thishost] eq "Y")
  {
    $cmd = "remsh $hostname[$thishost] 'rcp ${wsnamef}.${dbamon_userid}:/opt/dbamon/bin/download/*$filemask* $filemask' 2>&1 | grep -v ^\$ > $tmpfl2";
    $rc = system($cmd);
    print "rc=$rc cmd=$cmd \n";
    $cmd = "remsh $hostname[$thishost] 'move $filemask \\temp\\dbamon_${filemask}.pl' 2>&1 | grep -v ^\$ >> $tmpfl2 2>&1";
    $rc = system($cmd);
    print "rc=$rc cmd=$cmd\n";
  }
  else
  {
    $cmd = "remsh $hostname[$thishost] 'rcp ${wsnamef}.${dbamon_userid}:/opt/dbamon/bin/download/*${filemask}* temp' 2>&1 | grep -v ^\$ > $tmpfl2 2>&1";
    $rc = system($cmd);
    ##print "rc=$rc cmd=$cmd \n";
  }

  system("cat $tmpfl2");

  if (system("test -s $tmpfl2") == 0 && system("grep '1 file(s) moved' $tmpfl2 > /dev/null 2>&1") != 0)
  {
    #
    # Check for pw expired error
    #
    if (system("grep -i expired $tmpfl2") == 0)
    {
      &event("C",$thishost,"rcp Error - Userid=$userid[$thishost] password expired","DnldPasswd","DBA502C",$tmpfl2);
      $up[$thishost] = "D";
      return;
    }
    elsif (system("grep -i disabled $tmpfl2") == 0)
    {
      &event("C",$thishost,"rcp Error - Userid=$userid[$thishost] account disabled","DnldAcct","DBA502C",$tmpfl2);
      $up[$thishost] = "D";
      return;
    }
    elsif (system("grep -i incorrect $tmpfl2") == 0)
    {
      &event("C",$thishost,"rcp Error - Userid=$userid[$thishost] login incorrect","DnldIncorr","DBA502C",$tmpfl2);
      $up[$thishost] = "D";
      return;
    }
    else
    {
      &event("C",$thishost,"Undiagnosed rcp Error - Userid=$userid[$thishost]","Dnldrcp","DBA502C",$tmpfl2);
      $up[$thishost] = "D";
      return;
    }
  }

  # 
  # Completion Message
  #

  &logit("OK",$thishost);
  $download_flag[$thishost] = 1;
  $up[$thishost] = "";
  $hn = $hostname[$thishost];
  $download_host{$hn} = 1;
  
  &function_cleanup();

  #
  # Ensure that /usr/local/bin/perl on the db server points to perl5
  #
  
  ##print "$perlpath[$thishost] -v\n";
  &remsh("$perlpath[$thishost] -v",$tmpfl2,$thishost);
  ##system("cat $tmpfl2");
  if (system("egrep 'This is perl, version 5|This is perl, v5|perl5' $tmpfl2 > /dev/null") != 0)
  {
    if (system("grep 'name specified is not recognized' $tmpfl2 > /dev/null") == 0)
    { 
      system("echo 'Command Not Found - Check Perl_Path: DBC Parameter' > $tmpfl3");
    }
    else
    {
      system("echo 'Undiagnosable Error:' > $tmpfl3");
      system("cat -v $tmpfl2 >> $tmpfl3");
    }
    &event("C",$thishost,"$perlpath[$thishost] Does Not Invoke Perl Version 5","PerlVer","DBA503C",$tmpfl3);
    $up[$thishost] = "D";
    return;
  }
}     
1;
