sub check_inhib
#
# Check to see if checking of any kind is to be inhibited now for this instance
#
{
  ($h) = @_;

  chop($nowdate = `date +%Y/%m/%d`);
  chop($nowhour = `date +%H`);
  chop($nowday  = `date +%a`);

  #
  # Check for .dbc inhibit by hours of the day specified
  #

  if ($mon_hours[$h] ne "")
  {
    ##print mon_hours[$h] nowhour
    if (index($mon_hours[$h],$nowhour) == -1)
    {
      $msg = sprintf("*** DBAmon checking inhibited Hour=%s Monitor_Hours=%s ***",$nowhour,$mon_hours[$h]);
      $msgid = "DBA301W";
      &logit($msg,$h);
    
      &info_msg($msg,$h);
      $m_info[$h]++;

      return "Y";
    }
  }

  if ($mon_days[$h] ne "")
  {
    ##print mon_days[$h] nowday
    if (index($mon_days[$h],$nowday) == -1)
    {
      $msg = sprintf("*** DBAmon checking inhibited Day=%s Monitor_Days=%s ***",$nowday,$mon_days[$h]);
      $msgid = "DBA301W";
      &logit($msg,$h);
    
      &info_msg($msg,$h);
      $m_info[$h]++;

      return "Y";
    }
  }

  if ($mon_excl[$h] ne "")
  {
    $dayhour = $nowday . "-" . $nowhour;
    ##print mon_excl[$h] " " dayhour
    if (index($mon_excl[$h],$dayhour) > -1)
    {
      $msg = sprintf("*** DBAmon checking inhibited DayHour=%s Monitor_Excl=%s ***",$dayhour,$mon_excl[$h]);
      $msgid = "DBA301W";
      &logit($msg,$h);
    
      &info_msg($msg,$h);
      $m_info[$h]++;

      return "Y";
    }
  }

  #
  # Check for all dbamon monitoring inhibited
  #

  if (system("grep 'Date=$nowdate Hour=$nowhour' $inhibdir/ALL > /dev/null 2>&1") == 0)
  {
    $msg = sprintf("*** ALL - DBAmon checking inhibited Date=%s Hour=%s ***",$nowdate,$nowhour);
    $msgid = "DBA301W";
    &logit($msg,$h);
  
    &info_msg($msg,$h);
    $m_info[$h]++;

    return "Y";
  }

  #
  # Check inhibit file
  #

  ##print "$title[$h] $inhibdir/$inhibfile[$h] \n";

  if (system("ll $inhibdir/$inhibfile[$h] > /dev/null 2>&1") == 0)
  {
    ##print "grep 'Date=$nowdate Hour=$nowhour' $inhibdir/$inhibfile[$h] > /dev/null 2>&1 \n";
    if (system("grep 'Date=$nowdate Hour=$nowhour' $inhibdir/$inhibfile[$h] > /dev/null 2>&1") == 0)
    {
      $msg = sprintf("*** This Instance - DBAmon checking inhibited Date=%s Hour=%s ***",$nowdate,$nowhour);
      $msgid = "DBA301W";
      &logit($msg,$h);
  
      &info_msg($msg,$h);
      $m_info[$h]++;

      return "Y";
    }
  }
  return "N";
}

#-------------------------------------------------------------------------------
1;
