sub crit_msg
# Send mail for critical messages 
{
  ($m, $h, $f) = @_;

  $debug_crit = 0;

  $msgsave = $msgid;
  $msgmod = "DBAmon|$title[$h]| $m";

  &log_msg($m,$h);

  if ($f ne "") 
  {
    &log_file($f,$h);
  }

  if ($short ne "")
  {
    $z = "<font color=red>$short</font>";
    if (index($msgs[$h],$z) == -1) { $msgs[$h] .= "$z "; }
    $short = "";
  }
  
  if ($arg eq "ztest")
  {
    &logit("Test Mode - NOT Mailing message",$h);
    return 0;
  }

  $savemsg = sprintf("host=%s userlist=%s msg=%s", $title[$h], $userlist[$h_userlist[$h]], $msg);
  system("echo '$savemsg' >> $tmpdir/dbamon_savemsg_next");   # Hmmmm
  ###print savemsg >> tmpdir"/dbamon_savemsg_next"

  if (system("grep '$savemsg' $tmpdir/dbamon_savemsg_this") == 0)
  {
    $duplicate_flag = 1;
  }
  else
  {
    $duplicate_flag = 0;
  }

  if ($pager_flag[$h] && $duplicate_flag == 0)
  {
    $page_sent = "Y";
  }
  else                                    
  {
    $page_sent = "";
  }

  $page_sent = "";

  if ($duplicate_flag)
  {
    &logit("NOT Performing Notification for Consecutive Duplicate Critical Message",$h);
    return;
  }

  # 
  # Send message to pager gateway
  #
  # This section uses the HOSTS section Pager_Email
  # and Pager_Subject values. 
  #

  if ($pager_flag[$h])
  {
    #
    # Optionally invoke userexit 
    #
    if (-x "/opt/dbamon/bin/userexit/pager")
    {
      &logit("Invoking userexit: pager");
      system("export D_HOST=$title[$h];export D_MSG='$m';export D_FILE=$f;/opt/dbamon/bin/userexit/pager");
    }

    $mx = sprintf("Sending pager notification Subject=%s EMail=%s",$pager_subject[$h],$pager_email[$h]);
    &logit($mx,$h);

    # Customization for HP/Agilent
    if (($company eq "hp" || $company eq "agilent") && $pager_subject[$h] eq "DUMMY")
    {
      &logit("Invoking page_dbagap for hp/agilent",$h);
      $cmd = "echo '(DBAmon) $titleraw[$h] $msg' | /usr/local/sap/tools/page_dbagap";
      $rc = system($cmd);
      if ($debug_crit)
      {
        printf("page_dbagap rc=%s cmd=%s\n",$rc,$cmd);
      }
    }
    else
    {
      $mx = sprintf("Sending EMail to %s",$pager_email[$h])
      &logit($mx,$h);

      if ($pager_subject[$h] eq "") 
      {
        $pager_subject[$h] = "DBAmon Notification";
      }

      $cmd = "echo '(DBAmon) $titleraw[$h]-$msg ' | dbamon_mailer -m -s '$pager_subject[$h]' $pager_email[$h]";
      ##print "cmd=$cmd";
      $rc = system($cmd);
    }
  }

  # 
  # tmpfl5 will contain the header and text of message
  #

  system("rm $tmpfl5 2>/dev/null");

  chop($date = `date`);

  open(TMPFL5,  ">$tmpfl5") || &error_msg("Can't open output $tmpfl5 - $!");

  print TMPFL5 "--- DBAmon Critical Message Notification ---\n";
  print TMPFL5 "    Instance: $title[$h]\n";
  print TMPFL5 "        Date: $date\n\n";
  print TMPFL5 "$msg \n";

  if ($msgsave ne "") 
  {
    print TMPFL5 "    For more information on this error, see:\n"; 
    print TMPFL5 "    $dbamon_home/errors.shtml#$msgsave\n\n";
  }

  if ($f ne "") 
  {
    print TMPFL5 `cat $f`;
  }

  close(TMPFL5);

  # 
  # If this host uses OpC, send opcmsg
  #

  if ($opc_appl[$h] ne "" && $opc eq "Y")
  {
    $msg_fix = $msg;
    $msg_fix =~ s/!//g; 

    &logit("Sending OpC Message",$h);

    $cmd = "remsh $opc_gw[$h] '/opt/OV/bin/OpC/opcmsg severity=critical application=\"$opc_appl[$h]\" object=$opc_obj[$h] msg_text=\"$msg_fix $opc_trailer\" msg_grp=$opc_mg[$h]'";

    if ($debug_opc || $debug_crit) 
    {
      printf("About to execute: %s\n",$cmd);
    }
    $rc = system($cmd);
    if ($rc != 0) 
    {
      printf("Command rc=%s\n",$rc);
    }
  }

  # 
  # Parse list of userid into indiviual elements
  #

  ###user_elm[0] = split(userlist[$h_userlist[$h]],user_elm)
  $list_id = $h_userlist[$h];      # This is the Notify_List value for the isntance
  $_ = $userlist[$list_id];        # The notify list entry
  @user_elm = split;

  if ($debug_crit)
  {
    print "list_id=$list_id \n";
    print "entries=$_ \n";
    print "number of user_elm's=$#user_elm\n";
  }

  for ($i_mail=0; $i_mail<= $#user_elm; $i_mail++)
  {
    if ($debug_crit)
    {
      printf("Processing i_mail=%s user_elm[$i_mail]=%s\n",$i_mail,$user_elm[$i_mail])
    }

    if (substr($user_elm[$i_mail],0,1) eq "@")
    {
      $host = substr($user_elm[$i_mail],1);
      $msgtemp = sprintf("Sending postnote to host=%s",$host);
      &logit($msgtemp,$h);

      $rc = system("cat $tmpfl5 | $post_dir/clpostXm $host");
      if ($rc != 0) 
      {
        $msgtemp = sprintf("Postnote rc=%s",$rc);
        &logit($msgtemp,$h);
      }
      next;
    }

    $msgtemp = sprintf("Mailing critical message to user=%s",$user_elm[$i_mail]);
    &logit($msgtemp,$h);

    $cmd = "cat $tmpfl5 |dbamon_mailer -m -s '$msgmod' $user_elm[$i_mail]";
    ##print "cmd=$cmd \n";

    if ($debug_crit)
    {
      printf("About to execute cmd=%s\n",$cmd);
    }
    $rc = system($cmd);
    if ($debug_crit) 
    { 
      printf("Mail rc=%s\n",$rc);
    }
  }

  #
  # Optionally create BLT ticket 
  #

  if ($make_tickets eq "Y")
  {
    $msgtemp = sprintf("Invoking dbamon_make_ticket.pl to create helpdesk ticket hostfix=%s msgmod=%s",$hostfix[$h],$msgmod);
    &logit($msgtemp,$h);
    $ENV{"INSTANCE"}=$title[$h];
    $ENV{"ERRFILE"} =$tmpfl5;
    $ENV{"ERRMSG"}  =$msgmod;
    $ENV{"DBMS"}    =$dbms[$h];
    $ENV{"HOST"}    =$hostfix[$h];
    $rc = system("/opt/dbamon/bin/dbamon_make_ticket.pl");
  }
}
#--------------------------------------------------------------------------------
1;
