sub event
#--------------------------------------------------------------------------------
# Generic event creator
# Usage:
#   &event( 
#           "D",           (Severity: C, W, I, U)
#           1,             (Host #)
#           "Event Text",  (Text)
#           "Shorttxt",    (Short Text)
#           "DBA001I",     (MsgID)
#           "/tmp/zzz"     (Optional - File to append to msg)
#         )
#--------------------------------------------------------------------------------
{
  ($e_sev, $e_h, $e_msg, $e_short, $e_msgid, $e_file) = @_;

  # Remove all quotes and shorten if neccessary
  $_ = $e_msg;
  s/'//g;
  s/"//g;
  s/\n/ /g;
  $e_msg = $_;
  $e_msg = substr($e_msg,0,490) if length($e_msg) > 490;

  if ($e_sev eq "C")
  {
    $e_str = "!!!";
    $e_color = "red";
    $e_text = "Critical";
    $m_critical[$e_h]++;
  }
  elsif ($e_sev eq "W")
  {
    $e_str = "***";
    $e_color = "yellow";
    $e_text = "Warning";
    $m_warning[$e_h]++;
  }
  elsif ($e_sev eq "I")
  {
    $e_str = "...";
    $e_color = "cyan";
    $e_text = "Info";
    $m_info[$e_h]++;
  }
  elsif ($e_sev eq "U")
  {
    $e_str = "---";
    $e_color = "lime";
    $e_text = "User";
    $m_user[$e_h]++;
  }
  else
  {
    &error_msg("Invalid severity: $e_sev passed to /opt/dbamon/lib/event.pl - e_h=$e_h");
  }
  
  $z = "";
  $z = "${routine}() " if $routine ne "";
  $e_msg = "$e_str ${z}$e_msg $e_str";

  $e_msgid = "${e_msgid}${e_sev}" if length($e_msgid) < 7;
  $e_msgid_short = substr($e_msgid,0,6);
  $e_msgsave = $e_msgid;

  $e_msgmod = "DBAmon | $titleraw[$e_h] | $e_msg";

  # Check for event overrides
  if ($use_oracle eq "Y")
  {
    &eventOCheck($e_msgid_short);
    ##print "Back from eventOCheck - $e_msgid_short - ov_ticket=$ov_ticket ov_pager=$ov_pager ov_email=$ov_email \n";
    if (length("$ov_ticket$ov_pager$ov_email") > 0)
    {
      &logit("Event_Override: ov_ticket=$ov_ticket ov_pager=$ov_pager ov_email=$ov_email",$e_h);
    }
  }

  if ($pager_flag[$e_h] && $duplicate_flag == 0)
  {
    $page_sent = "Y";
  }
  else                                    
  {
    $page_sent = "";
  }

  &eventLog($e_msg,$e_h);

  if ($e_file ne "") 
  {
    &log_file($e_file,$e_h);
    $e_long = `cat $e_file`;
  }

  # Write event text to Day log
  &logit("$e_text Event: $e_msg",$e_h);
  if ($e_file ne "") 
  {
    $z1 = `cat $e_file`;
    $z2 = "Event Details: \n-----(Event Details Start)-----\n$z1\n------(Event Details End)------"; 
    &logit($z2,$e_h);
  }

  # Add to the list of short messages for this instance
  if ($e_short ne "")
  {
    $z = "<font color=$e_color>$e_short</font>";
    if (index($msgs[$e_h],$z) == -1) { $msgs[$e_h] .= "$z "; }
  }
  
  # Save this message for the next iteration - prevent consecutive dup messages

  chomp($z_msg      = $e_msg);
  chomp($z_host     = $titleraw[$e_h]);
  chomp($z_userlist = $userlist[$h_userlist[$e_h]]);
  $savemsg = "host=$z_host userlist=$z_userlist msg=$z_msg";
  system("echo '$savemsg' >> $tmpdir/dbamon_savemsg_next");   # Hmmmm

  # See if this message was logged during the last iteration
  ##print "grep '$savemsg' $tmpdir/dbamon_savemsg_this >/dev/null\n";
  ##$rc = system("grep -x '$savemsg' $tmpdir/dbamon_savemsg_this 2>&1"); 
  ##print "grep rc=$rc \n";
  ##system("cat $tmpdir/dbamon_savemsg_this");

  if (system("grep '$savemsg' $tmpdir/dbamon_savemsg_this >/dev/null") == 0)
  {
    $duplicate_flag = 1;
    print "Debug Info:\n";
    print "grep '$savemsg' $tmpdir/dbamon_savemsg_this 2>&1\n";
    system("grep '$savemsg' $tmpdir/dbamon_savemsg_this 2>&1");
  }
  else
  {
    $duplicate_flag = 0;
  }

  if ($duplicate_flag)
  {
    &logit("NOT Performing Notification for Consecutive Duplicate Message",$e_h);
    return;
  }

  # Send page
  if ($pager_flag[$e_h] && $g_pager eq "Y" && $e_sev eq "C" && $ov_pager ne "N")
  {
    #
    # Optionally invoke userexit 
    #
    if (-x "/opt/dbamon/bin/userexit/pager")
    {
      &logit("Invoking userexit: pager");
      system("export D_HOST=$title[$e_h];export D_MSG='$e_msg';export D_FILE=$e_file;/opt/dbamon/bin/userexit/pager");
    }

    $mx = sprintf("Sending pager notification Subject=%s EMail=%s",$pager_subject[$e_h],$pager_email[$e_h]);
    &logit($mx,$e_h);

    # Customization for HP/Agilent
    if (($company eq "hp" || $company eq "agilent") && $pager_subject[$e_h] eq "DUMMY")
    {
      &logit("Invoking page_dbagap for hp/agilent",$e_h);
      $cmd = "echo '(DBAmon) $titleraw[$e_h] $e_msg' | /usr/local/sap/tools/page_dbagap";
      $rc = system($cmd);
      if ($debug_crit)
      {
        printf("page_dbagap rc=%s cmd=%s\n",$rc,$cmd);
      }
    }
    else
    {
      $mx = sprintf("Sending EMail to %s",$pager_email[$e_h])
      &logit($mx,$e_h);

      if ($pager_subject[$e_h] eq "") 
      {
        $pager_subject[$e_h] = "DBAmon Notification";
      }

      $cmd = "echo '(DBAmon) $titleraw[$e_h]-$e_msg ' | dbamon_mailer -m -s '$pager_subject[$e_h]' $pager_email[$e_h]";
      ##print "cmd=$cmd";
      $rc = system($cmd);
    }
  }

  # 
  # tmpfl5 will contain the header and text of message
  #

  system("rm $tmpfl5 2>/dev/null");
  $date = &getdate();
  open(TMPFL5,  ">$tmpfl5") || &error_msg("event(#1) - Can't open output $tmpfl5 - $!");
 
  $mailformat = "html";   # html or text

  if ($mailformat eq "text")
  {
    print TMPFL5 "--------------- DBAmon Event Notification ---------------\n";
    print TMPFL5 "  Instance: $title[$e_h]\n";
    print TMPFL5 "      DBMS: $dbms[$e_h]\n";
    print TMPFL5 " Timestamp: $date\n";
    print TMPFL5 "  Severity: $e_text\n";
    print TMPFL5 "     Event: <font color=$e_color><b>$e_msg</b></font>\n";
    print TMPFL5 "---------------------------------------------------------\n";
    if ($e_msgsave ne "") 
    {
      print TMPFL5 "\nFor more info on this event, see: <a href='$dbamon_home/errors.shtml#$e_msgid_short'<b>DBAmon Event Reference: $e_msgsave</b></a>\n";
    }
    if ($e_file ne "") 
    {
      print TMPFL5 "<hr>";
      print TMPFL5 "<b>Diagnostic Data ($e_file):</b><br>\n";
      print TMPFL5 `cat $e_file`;
      print TMPFL5 "<hr>";
    }
    $htmlsuf = " ";
  }
  else
  {
    print TMPFL5 "</pre> <font face=verdana size=2>
<table border=0 width=90%>
<tr bgcolor=darkblue><td><center><font color=white size=6>DBAmon</font></center>
<tr bgcolor=wheat><td><center><b>Event Notification</b></center>
</table>
<ul>
  <li><b>Instance: </b> $title[$e_h]
  <li><b>DBMS: </b> $dbms[$e_h]
  <li><b>Timestamp: </b> $date
  <li><b>Severity: </b> <font color=$e_color>$e_text</font>
  <li><b>Event: <font color=$e_color>$e_msg</b></font> \n
  <li><b>DBAmon Mode: </b> $modeout \n";
    if ($e_msgsave ne "") 
    {
      print TMPFL5 "<li><b>Event URL: <a href='$dbamon_home/errors.shtml#$e_msgid_short'>DBAmon Event Reference: $e_msgsave</b></a>\n";
    }
    print TMPFL5 "</ul><hr>";
    if ($e_file ne "") 
    {
      print TMPFL5 "<b>Diagnostic Data ($e_file):</b><pre>";
      print TMPFL5 `cat $e_file`;
      print TMPFL5 "</pre><hr>";
    }
    $htmlsuf = " -h";
  }

  close(TMPFL5);
  # TEST
  #system("cp $tmpfl5 /tmp/z");

  # 
  # If this host uses OpC, send opcmsg
  #

  if ($opc_appl[$e_h] ne "" && $opc eq "Y")
  {
    $msg_fix = $e_msg;
    $msg_fix =~ s/!//g; 

    &logit("Sending OpC Message",$e_h);

    $cmd = "remsh $opc_gw[$e_h] '/opt/OV/bin/OpC/opcmsg severity=$e_text application=\"$opc_appl[$e_h]\" object=$opc_obj[$e_h] msg_text=\"$msg_fix $opc_trailer\" msg_grp=$opc_mg[$e_h]'";

    if ($debug_opc || $debug_crit) 
    {
      printf("About to execute: %s\n",$cmd);
    }
    $rc = system($cmd);
    if ($rc != 0) 
    {
      printf("Command rc=%s\n",$rc);
    }
  }

  #
  # Send notification
  #
  if ($e_sev eq "C" || $e_sev eq "U" || $ov_email eq "Y")
  {
    ##print "hu=($h_userlist[$e_h])\n";
    if ($h_userlist[$e_h] ne "")
    {
      # 
      # Parse list of userid into indiviual elements
      #
      ###user_elm[0] = split(userlist[$h_userlist[$e_h]],user_elm)
      $list_id = $h_userlist[$e_h];      # This is the Notify_List value for the isntance
      $_ = $userlist[$list_id];        # The notify list entry
      @user_elm = split;

      if ($debug_crit)
      {
	print "list_id=$list_id \n";
	print "entries=$_ \n";
	print "number of user_elm's=$#user_elm\n";
      }

      for ($i_mail=0; $i_mail<= $#user_elm; $i_mail++)
      {
	if ($debug_crit)
	{
	  printf("Processing i_mail=%s user_elm[$i_mail]=%s\n",$i_mail,$user_elm[$i_mail])
	}

	if (substr($user_elm[$i_mail],0,1) eq "@")
	{
	  $host = substr($user_elm[$i_mail],1);
	  $msgtemp = sprintf("Sending postnote to host=%s",$host);
	  &logit($msgtemp,$e_h);

	  $rc = system("cat $tmpfl5 | $post_dir/clpostXm $host");
	  if ($rc != 0) 
	  {
	    $msgtemp = sprintf("Postnote rc=%s",$rc);
	    &logit($msgtemp,$e_h);
	  }
	  next;
	}

	$msgtemp = sprintf("Mailing critical message to user=%s",$user_elm[$i_mail]);
	&logit($msgtemp,$e_h);

	$cmd = "cat $tmpfl5 |dbamon_mailer $htmlsuf -m -s '$e_msgmod' $user_elm[$i_mail]";
	##print "cmd=$cmd \n";

	if ($debug_crit)
	{
	  printf("About to execute cmd=%s\n",$cmd);
	}
	$rc = system($cmd);
	if ($debug_crit) 
	{ 
	  printf("Mail rc=%s\n",$rc);
	}
      }
    }
    else
    {
      &logit("Notify not sent - Notify_List: is null",$e_h);
    }
  }
  
  #
  # Optionally create BLT ticket 
  #
  if ($e_sev eq "C" && $make_tickets eq "Y" && -x "/opt/dbamon/bin/userexit/ticket" && $ov_ticket ne "N")
  {
    &logit("Invoking userexit /opt/dbamon/bin/userexit/ticket to create ticket",$e_h);
    $ENV{"INSTANCE"}=$title[$e_h];
    $ENV{"ERRFILE"} =$tmpfl5;
    $ENV{"ERRMSG"}  =$e_msgmod;
    $ENV{"DBMS"}    =$dbms[$e_h];
    $ENV{"HOST"}    =$hostfix[$e_h];
    $ENV{"ID1"}     =$id1[$e_h];
    $ENV{"ID2"}     =$id2[$e_h];
    $ENV{"ID3"}     =$id3[$e_h];
    $ENV{"SEV"}     =$e_sev;
    $ENV{"MSGID"}   =$e_msgid;
    $ENV{"LONG"}    =$e_long;
    $ENV{"SHORT"}   =$e_short;
    $ENV{"MODE"}    =$modeout;
    $rc = system("/opt/dbamon/bin/userexit/ticket");
  }
}
#--------------------------------------------------------------------------------
1;
