# -----------------------------------------------------------------------------
sub infLocks
{
  ($thishost) = @_;
  if ($up[$thishost] ne "Y")
  {
    &logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  #if (substr(sw_version[$thishost],1,1) < "7")
  #{
  #  msg = sprintf("Locks Used checking only works on Informix version >= 7")
  #  logit(msg,$thishost)
  #  return 0 
  #}

  ##print os_version[$thishost]
  ##print substr(os_version[$thishost],1,1) 

  if (substr($os_version[$thishost],0,1) eq "0")
  {
    $msg = sprintf("Locks Used checking only works on HP-UX version >= 10");
    &logit($msg,$thishost);
    return 0;
  }

  #
  # Run onstat -l
  #

  &remsh("onstat -;export PATH=\$PATH:$infdir[$thishost]/bin;/tmp/dbamon_inf.pl locks",$tmpfl2,$thishost);
  ##system("cat $tmpfl2");

  $locksflag = 0;
  $shmvseg[$thishost] = -1;
  $backup_method[$thishost] = "T";

  open(TMPFL2, "$tmpfl2"  ) || &error_msg("Can't open input $tmpfl2 - $!");
  while(<TMPFL2>)
  {
    &parse;

    if ($F1 eq "CKPTAVG:")
    {
      $ckptavg[$thishost] = $F2;
    }

    if ($F1 eq "MAXUSERS:")
    {
      $allusers[$thishost] = $F2;
    }

    if ($F1 eq "SYSUSERS:")
    {
      $sysusers[$thishost] = $F2;
    }

    if ($F1 eq "ARCTYPE")
    {
      if ($F2 gt "0")
      {
        $backup_method[$thishost] = "A";
        $backup_method_long[$thishost] = "OnArch";
      }
      else
      {
        $backup_method[$thishost] = "T";
        $backup_method_long[$thishost] = "OnTape";
      }
    }

    if ($F1 eq "SHMVSEGCOUNT:")
    {
      $shmvseg[$thishost] = $F2;
      $shmvsiz[$thishost] = $F3;
    }

    if ($F1 eq "NFILE:")
    {
      $nf_cur[$thishost] = $F2;
      $nf_max[$thishost] = $F3;
      $nf_pct[$thishost] = $F4;
    }

    if ($F1 eq "LOCKSPCT:")
    {
      $locksflag = 1;

      $lockspct  = $F2;
      $locksused = $F3;
      $locksmax  = $F4;

      ##print "lockspct=$lockspct \n";

      if ($lockspct > 100)
      {
	$msg = sprintf("... Informix BUG Encountered (lockspct > 100) - Used Locks=%s  Max Locks=%s (%s percent) ...",$locksused,$locksmax,$lockspct);
	$msgid = "DBA299I";
	&logit($msg,$thishost);
	$m_info[$thishost]++;
        $short = "LockBUG";
	&info_msg($msg,$thishost,$tmpfl2);
      }

      if ($lockspct > 80 && $lockspct < 101)
      {
	$msg = sprintf("!!! Used Locks=%s  Max Locks=%s (%s percent) !!!",$locksused,$locksmax,$lockspct);
	$msgid = "DBA300C";
	&logit($msg,$thishost);
	$m_critical[$thishost]++;
        $short = "Lock";
	&crit_msg($msg,$thishost,$tmpfl2);
      }
      else
      {
	$msg = sprintf("OK (%s/%s) %s percent",$locksused,$locksmax,$lockspct);
	&logit($msg,$thishost);
      }
    }

  }
  close(TMPFL2);

  $maxusers[$thishost] = $allusers[$thishost] - $sysusers[$thishost];
  
  if ($locksflag == 0 && substr($sw_version[$thishost],0,1) ge "7")
  {
    $msg = sprintf("infLocks() - %s - tmpfl2 error",$title[$thishost]);
    &logit($msg,$thishost);
    &error_msg($msg,$thishost,$tmpfl2);
  }
}
# -----------------------------------------------------------------------------
1;
