sub oraBkup
# -----------------------------------------------------------------------------
{
  ($thishost) = @_;

  if ($up[$thishost] ne "Y")
  {
    &logit("(Down/Inhibited)",$thishost);
    return 1; 
  }
    
  if ($backup_age[$thishost] eq "")
  {
    logit("Backup Aging not requested for this instance",$thishost);
    return 0;
  }

  #
  # bb 11Oct99 - Check to see if there is a backup age inhibit 
  # entry.
  #
  if ($use_repository eq "Y")
  {
    $rc = system("/opt/dbamon/bin/dbamon_ba_check.pl $titleraw[$thishost]");
    if ($rc > 0)
    {
      $file = "/opt/dbamon/tmp/ba_check.tmp";
      open(BA,  "$file") || &error_msg("Can't open input $file - $!");
      while (<BA>)
      {
        &parse;
        $sts     = $F1;
        $ets     = $F2;
        $ts      = $F3;
        $reason  = $F4;
      }
      close(BA);
      system("rm /opt/dbamon/tmp/ba_check.tmp");
    
      $bainhibit[$thishost] = 1;
      $bckhours_c[$thishost] = "black";
      $bckhours[$thishost]   = "(I)";
      $msg = sprintf("Backup Aging inhibited for this instance - Start: %s End: %s Created: %s Reason: %s",$sts,$ets,$ts,$reason);
      &logit($msg,$thishost);
      return 0;
    }
  }
  else
  {
    logit("Backup Aging Inhibit not possible because Use_Oracle != Y",$thishost);
  }

  if ($backup_method_long[$thishost] ne "bkRMAN")
  {
    system("rm $tmpfl6 > /dev/null 2>&1");
    $msg  = "Since Backup_Age: is on for this DB, you should be\n";
    $msg .= "running RMAN (ora_backup) backups. Establish RMAN\n";
    $msg .= "backups and run a LVL0 backup to satisfy this check.\n";
    $msg .= "\nDiagnostic Data:\n";
    $msg .= $oraBkupStack[$thishost];
    system("echo '$msg' > $tmpfl6");

    $bckhours_c[$thishost] = "yellow";

    &event("W",$thishost,"Backup Method for this DB is $backup_method_long[$thishost] - Backup_Age: checking requires that Backup Method be bkRMAN","BkpMethod","DBA513W",$tmpfl6);
    return 0;
  }

  #running  = "?"
  $this_age = $mr_age_lvl[$thishost];
  $bckhours[$thishost] = $this_age;

  if ($bckhours[$thishost] eq "99999999") 
  {
    $bckhours[$thishost] = "(Never)";
  }
  $bckhours_c[$thishost] = "lime";

  #
  # Check age vs. threashold - backup NOT running
  #

  # Just in case we exceed, set these vars and make report
  $rounded1 = int($this_age / 10);
  $rounded1 = $rounded1 * 10;
  $rounded2 = $rounded1 + 9;

  system("rm $tmpfl6 > /dev/null 2>&1");
  $msg  = "RMAN Backup Details:\n";
  $msg .= "Hours since last LVL0/LVL1 backup: $this_age\n";
  $msg .= "Threshold for this instance: $backup_age[$thishost]\n";
  $msg .= "Backup Rerun Command for this instance: $backup_command[$thishost]\n";
  $msg .= "Most recent ARC backup age (hours): $mr_age_arc[$thishost]\n";
  $msg .= "Most recent LVL0 backup age (hours): $mr_age_lvl0[$thishost]\n";
  $msg .= "Most recent LVL1 backup age (hours): $mr_age_lvl1[$thishost]\n";
  system("echo '$msg' > $tmpfl6");

  # Check against threshold
  ##print "this_age=$this_age t=$backup_age[$thishost] \n";

  if ($this_age > $backup_age[$thishost])
  {
    if ($backup_running[$thishost] eq "Y")
    {
      $running_str = "(Backup IS Running Now)";
      $bckhours_c[$thishost] = "yellow";
      &event("W",$thishost,"$rounded1-$rounded2 Hours since last good ora_backup backup - threshold: $backup_age[$thishost] $running_str","BkpAge","DBA51wW",$tmpfl6);
    }
    else
    {
      #
      # 3.23D 08Jul00 BB
      #   we did not issue the restart on the last iteration
      #   (in which case it should be running now), then issue
      #   the restart command.
      #
      if ($backup_command[$thishost] ne "" && $backup_rerun_iter[$thishost] != ($iter_count - 1) )
      {
        # Issue rerun
        $cmd = "/tmp/dbamon_ora.pl bkrun \"$backup_command[$thishost]\"";
        ##print "backup rerun cmd=$cmd \n";
	remsh($cmd,$tmpfl3,$thishost);
        ##print "tmpf3: \n";
	##system("cat $tmpfl3");
        $backup_rerun_iter[$thishost] = $iter_count;

        # warning event
	$running_str = "(Backup Was Rerun)";
	$bckhours_c[$thishost] = "yellow";

        &event("W",$thishost,"$rounded1-$rounded2 Hours since last good ora_backup backup - threshold: $backup_age[$thishost] $running_str","BkpAge","DBA514W",$tmpfl6);
      }
      else
      {
	$running_str = "(Backup IS NOT Running Now)";
	$bckhours_c[$thishost] = "hotpink";

        &event("C",$thishost,"$rounded1-$rounded2 Hours since last good ora_backup backup - threshold: $backup_age[$thishost] $running_str","BkpAge","DBA511C",$tmpfl6);
      }
    }
  }
  else    # Age not exceeded
  {
    $msg = sprintf("OK - Age=%s Threshold=%s",$this_age,$backup_age[$thishost]);
    &logit($msg,$thishost);
  }
}
# -----------------------------------------------------------------------------
1;
