# -----------------------------------------------------------------------------
sub orantUp
{
  ($thishost) = @_;
  #
  # Get Instance online data
  #

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  if ($up[$thishost] eq "D")
  {
    logit("(No software download)",$thishost);
    return;
  }

  # Start with a clean slate
  $up[$thishost] = "";

  $must_connect = 1;
  &remsh("$perlpath[$thishost] \\temp\\dbamon_orant.pl $orasid[$thishost] $orahome[$thishost] up $t_diskwarn[$thishost] $t_diskcrit[$thishost] $t_freespace[$thishost] '$ts_command[$thishost]'",$tmpfl3,$thishost);
  if ($up[$thishost] eq "N")     # Remsh error
  {
    logit("(Connect Error)",$thishost);
    return;
  }

  ##system("cat $tmpfl3");

  $dbstatus = "";
  $total_size = "";
  $total_used = "";
  $pgmflag = 0;

  $total_size = 0;
  $total_free = 0;
  $total_used = 0;
  $total_df   = 0;

  $orantTSStack[$thishost] = "";

  open(TMPFL3,"$tmpfl3") || &error_msg("Can't open input $tmpfl3 - $!");
  while (<TMPFL3>)
  {
    &parse;
    if ($F1 eq "DBVersion:")    { $sw_version[$thishost] = $F2 }
    if ($F1 eq "OSVer:")        { $os_version[$thishost] = $F2 }
    if ($F1 eq "DBStatus:")     { $dbstatus = $F2 }
    if ($F1 eq "NumCPUs:")      { $hw_processors[$thishost] = $F2 }
    if ($F1 eq "CPUModel:")     { $hw_model[$thishost] = $F2 }
    if ($F1 eq "RAM:")          { $hw_memory[$thishost] = $F2 }
    if ($F1 eq "SpaceAlloc:")   { $total_size = $F2 }
    if ($F1 eq "SpaceUsed:")    { $total_used = $F2 }
    if ($F1 eq "LSNRStatus:")   { $lsnr_status = $F2 }
    if ($F2 eq "DoneOK")        { $pgmflag = 1 }
    if ($F1 eq "SESSIONSHWM:")  { $sessionshwm[$thishost] = $F2 }
    if ($F1 eq "BUFHITRATIO:")  { $bufhitratio[$thishost] = $F2 }
    if ($F1 eq "LIBHITRATIO:")  { $libhitratio[$thishost] = $F2 }
    if ($F1 eq "DICTHITRATIO:") { $dicthitratio[$thishost] = $F2 }

    if ($F1 eq "Stack:" && $F2 eq "orantTSStack")
    {
      $orantTSStack[$thishost] .= $F0;
    } 
  }
  close(TMPFL3);

  if ($sw_version[$thishost] lt $ver_oraclent_low  || $ver_oraclent_low eq "" ) { $ver_oraclent_low  = $sw_version[$thishost] }
  if ($sw_version[$thishost] gt $ver_oraclent_high || $ver_oraclent_high eq "") { $ver_oraclent_high = $sw_version[$thishost] }

  $system_size[$thishost] = $total_size / 1000;
  $system_used[$thishost] = $total_used / 1000;
  $grand_total_size += ($total_size / 1000);

  $reason = "";  # Fill in later

  #if (! $pgmflag) 
  #{
  #  &event("C",$thishost,"Connect Logic Error - Probe dbamon_orant.pl Did Not Finish","Logic","DBA905C",$tmpfl3);
  #  $download_flag[$thishost] = 0;
  #  return;
  #}

  # Check status
  if ($dbstatus ne "UP")
  {
    $up[$thishost] = "N";
    $download_flag[$thishost] = 0;

    if ($t_mustbeup[$thishost] eq "Y")
    {
      &event("C",$thishost,"Oracle/NT Not Active - Status=$dbstatus","Down","DBA901C",$tmpfl3);
    }
    else
    {
      &event("I",$thishost,"Oracle/NT Not Active - Status=$dbstatus","Down","DBA902I",$tmpfl3);
    }
  }
  else
  {
    $up[$thishost] = "Y";
    $msg = sprintf("OK");
    &logit($msg,$thishost);
  }

  # Check listener
  if ($lsnr_status ne "OK")
  {
    $up[$thishost] = "N";
    &event("C",$thishost,"Oracle/NT Listener Not Active - Status=$lsnr_status","LsnrDown","DBA903C",$tmpfl3);
  }

  &histCreate("orantUp()",$thishost,"STA","sessionshwm",$sessionshwm[$thishost]);
  &histCreate("orantUp()",$thishost,"PER","bufhitratio",$bufhitratio[$thishost]);
  &histCreate("orantUp()",$thishost,"PER","libhitratio",$libhitratio[$thishost]);
  &histCreate("orantUp()",$thishost,"PER","dicthitratio",$dicthitratio[$thishost]);

  &logDetails($thishost,"<h3>Oracle Instance Data</h3>");
  &logDetails($thishost,"<table border=1>");
  &logDetails($thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>");

  &logDetails($thishost,"<tr><td><b>Oracle Version:<td align=right> $sw_version[$thishost]");
  &logDetails($thishost,"<tr><td><b>ORACLE_SID:<td align=right> $orasid[$thishost]");
  &logDetails($thishost,"<tr><td><b>ORACLE_HOME:<td align=right> $orahome[$thishost]");
  #logDetails($thishost,"<tr><td><b>Concurrent Sessions HWM:<td align=right> $sessionshwm[$thishost]");
  #logDetails($thishost,"<tr><td><b>Buffer Cache Hit Ratio:<td align=right> $bufhitratio[$thishost]");
  #logDetails($thishost,"<tr><td><b>Library Cache Hit Ratio:<td align=right> $libhitratio[$thishost]");
  #logDetails($thishost,"<tr><td><b>Dictionary Cache Hit Ratio:<td align=right> $dicthitratio[$thishost]");
  #logDetails($thishost,"<tr><td><b>ORACLE_HOME Disk % Full:<td align=right> $homefull[$thishost]");
  &logDetails($thishost,"<tr><td><b>Oracle Up?<td align=right> $up[$thishost] <td>(Y or N)");
  #logDetails($thishost,"<tr><td><b>Oracle OPS Mode?:<td align=right> $ops[$thishost] <td>");
  #logDetails($thishost,"<tr><td><b>Oracle OPS Instance Number:<td align=right> $inst_num[$thishost] <td>");
  #logDetails($thishost,"<tr><td><b>Oracle Standby Mode?:<td align=right> $standby[$thishost] <td>(CURRENT or STANDBY)");
  &logDetails($thishost,"</table><hr>");

  &logDetails($thishost,"<h3>Server Data</h3>");
  &logDetails($thishost,"<table border=1>");
  &logDetails($thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>");
  &logDetails($thishost,"<tr><td><b>OS Type:<td align=right> $os[$thishost] ");
  &logDetails($thishost,"<tr><td><b>OS Version:<td align=right> $os_version[$thishost]");
  &logDetails($thishost,"<tr><td><b>Server Type:<td align=right> $hw_model[$thishost]");
  &logDetails($thishost,"<tr><td><b>Server Memory (MB):<td align=right> $hw_memory[$thishost]");
  &logDetails($thishost,"<tr><td><b>Server Processor Count:<td align=right> $hw_processors[$thishost]");
  &logDetails($thishost,"</table><hr>");
}

# -----------------------------------------------------------------------------
1;
