sub readConfig
#
# This function will read the parm file
#
{
  $msg = sprintf("Reading parm file $parmfl");
  &logit($msg);

  $longest = 0;

  $i_hosts = 0;
  $i_users = 0;

  $debug_read = 0;

  #
  # Compile /opt/dbamon/adm/instances/*.dbc and dbamonrc into 1 file
  #
  system("rm $tmpdir/instances 2>/dev/null");
  system("rm $tmpdir/dbamonrc 2>/dev/null");

  open(PARMALL,  ">$parmall") || &error_msg("Can't open output $parmall - $!");
  open(DBAMONRC, "$parmfl"  ) || &error_msg("Can't open input $parmfl - $!");
  while (<DBAMONRC>)
  {
    &parse;
    
    # Try to extract Admin_EMail because we will need that for parsing
    # and it may be at the end of the file
    if ($F1 eq "Admin_EMail:") { $dbamon_admin = $F2; }

    if ($F1 eq "Include:")
    {
      system("cat $F2 > $tmpdir/instances");
      $file = "$tmpdir/instances";

      # only copy the DBC files for my alpha assignment
      open(INSTANCES, "$file"  ) || &error_msg("Can't open input $file - $!");
      while (<INSTANCES>)
      {
        &parse;
        if ($dbamon_alpha eq "")
        {
	  print PARMALL "$F0";
        }
        else
        {
          # Get the first letter of the hostname found in each Host: entry
	  if ($F1 eq "Host:")
	  {
	    $z = uc substr($F2,0,1);
	    ##print "z=$z dbamon_alpha=$dbamon_alpha F2=$F2 \n";

	    if (index($dbamon_alpha,$z) > -1) 
            { 
              $alpha_flag = 1;
	      $msg = sprintf("dbamon_alpha=%s Including Host: %s",$dbamon_alpha,$F2);
	      logit($msg);
            }
            else 
            {
              $alpha_flag = 0;
            }
            
          }
          if ($alpha_flag) { print PARMALL "$F0"; }
        }
      } # end of while getline
      close(INSTANCES);
    }
    else # for if include
    {
      print PARMALL "$F0"; 
    }
  }
  close(DBAMONRC);
  close(PARMALL);

  #
  # Process combined parm file
  #

  open(PARMALL,  "$parmall") || &error_msg("Can't open input $parmall - $!");
  while (<PARMALL>)
  {
    &parse;

    ##print "parmall NF=$NF F1=$F1 F2=$F2 \n";
    
    if ($NF == 0)
    {
      next;
    }

    if (substr($F1,0,1) ne "#" && $F1 ne "Section")
    {

      if ($section eq "HOSTS") 
      { 
	if ($F1 eq "Host:")
        {
          $i_hosts++;
          $hostname[$i_hosts] = $F2;
	  if ($debug_read) { printf("Found Host %s\n",$hostname[$i_hosts]); }
        }

        # Insert repository row
        if ($F0 ne "")
        {
	  $sqltext = "insert into dbamon.dbcactive (dbamonmode,i_hosts,text)\n";
	  chop($_ = $F0);
          #s/\\/\//g;
          s/&/[Ampersand]/g;
          $sqltext .= "  values ('$modeout','$i_hosts','$_')\n";
          runSQL($sqltext);
        }

        #
        # Parse data
        #

	if ($F1 eq "Comm_Method:")      { $comm_method[$i_hosts]  = $F2; }
	elsif ($F1 eq "Title1:")           
        { 
          $title1[$i_hosts]  = $F2; 
	  $z = length($title1[$i_hosts]);
	  if ($z > 16)
	  {
	    $msg = "Title1: value: $title1[$i_hosts] length exceeds maximum of 16 - truncated";
	    error_msg($msg,$i_hosts);
	    $title1[$i_hosts] = substr($title1[$i_hosts],0,16);
	  }
        }
	elsif ($F1 eq "Title2:")           { $title2[$i_hosts]  = $F2; }
	elsif ($F1 eq "Title3:")           { $title3[$i_hosts]  = $F2; }
	elsif ($F1 eq "Host_URL:")         { $host_url[$i_hosts]  = $F2; }
	elsif ($F1 eq "Title1_URL:")       { $title1url[$i_hosts]  = $F2; }
	elsif ($F1 eq "Title2_URL:")       { $title2url[$i_hosts]  = $F2; }
	elsif ($F1 eq "Userid:")           { $userid[$i_hosts]   = $F2; }
	elsif ($F1 eq "UseridApps:")       { $useridap[$i_hosts]   = $F2; }
	elsif ($F1 eq "DBMS:")             { $dbms[$i_hosts] = $F2; }
	elsif ($F1 eq "SWPackage:")        { $dbms[$i_hosts] = $F2; }
	elsif ($F1 eq "Monitor:")          { $runmon[$i_hosts] = $F2; }
	elsif ($F1 eq "Monitor_Hours:")    { $mon_hours[$i_hosts] = $F2; }
	elsif ($F1 eq "Monitor_Days:")     { $mon_days[$i_hosts] = $F2; }
	elsif ($F1 eq "Monitor_Exclude:")  { $mon_excl[$i_hosts] = $F2; }
	elsif ($F1 eq "Download_Every:")   { $download_every[$i_hosts] = $F2; }
	elsif ($F1 eq "Perl_Path:")        { $perlpath[$i_hosts] = $F2; }
	elsif ($F1 eq "ID1:")              { $id1[$i_hosts] = $F2; }
	elsif ($F1 eq "ID2:")              { $id2[$i_hosts] = $F2; }
	elsif ($F1 eq "ID3:")              { $id3[$i_hosts] = $F2; }
	elsif ($F1 eq "NT_RCP_Bug:")       { $ntrcpbug[$i_hosts] = $F2; }
	elsif ($F1 eq "ORACLE_HOME:")      { $orahome[$i_hosts] = $F2; }
	elsif ($F1 eq "ORACLE_SID:")       
        {
          $orasid[$i_hosts] = $F2;
          # This is for the inhib file name
          $server[$i_hosts] = $F2 ;
        }
	elsif ($F1 eq "SAPSYSTEMNAME:")       
        {
          $sapsid[$i_hosts] = $F2;
          # This is for the inhib file name
          $server[$i_hosts] = $F2 ;
        }
        elsif ($F1 eq "Config:")
        {
          @words = split(/\//,$F2);
	  $server[$i_hosts]   = $words[0];
	  $config[$i_hosts]   = $words[1];
        }
	elsif ($F1 eq "Inf_Server:"   || $F1 eq "INFORMIXSERVER:") { $server[$i_hosts] = $F2 }
	elsif ($F1 eq "ON_Config:"    || $F1 eq "ONCONFIG:")    { $config[$i_hosts] = $F2 }
	elsif ($F1 eq "SQL_Hosts:"    || $F1 eq "INFORMIXSQLHOSTS:")    { $sqlhosts[$i_hosts] = $F2 }
	elsif ($F1 eq "Informix_Dir:" || $F1 eq "INFORMIXDIR:") { $infdir[$i_hosts]   = $F2 }
	elsif ($F1 eq "Informix_Version:") { $infver[$i_hosts]   = $F2 }
	elsif ($F1 eq "Local_Or_Remote:")  { $lclrmt[$i_hosts]   = $F2 }
        elsif ($F1 eq "T_Disk_Full:" || $F1 eq "T_TS_Full:" || $F1 eq "T_DBSpace_Full:")
        {
          @words = split(/\//,$F2);
	  $t_diskwarn[$i_hosts] = $words[0];
	  $t_diskcrit[$i_hosts] = $words[1];
          ##print "tdw=$t_diskwarn[$i_hosts] tdc=$t_diskcrit[$i_hosts] F2=$F2 \n";
        }
	elsif ($F1 eq "T_TS_Command:") 
        {
          $z = index($F0,$F2);
          $ts_command[$i_hosts]    = substr($F0,$z);
          chop($ts_command[$i_hosts]);
          ##print "tsc=$ts_command[$i_hosts] \n";
        }
        elsif ($F1 eq "T_Arclog_Full:")
        {
          @words = split(/\//,$F2);
	  $t_arclog_w[$i_hosts] = $words[0];
	  $t_arclog_c[$i_hosts] = $words[1];
          $t_arclog_fix[$i_hosts] = $F3;
        }
	elsif ($F1 eq "T_DBSpace_Free:" || $F1 eq "T_TS_Free:") { $t_freespace[$i_hosts] = $F2 }
	elsif ($F1 eq "T_Read_Hit:")    { $t_readhit[$i_hosts] = $F2 }
	elsif ($F1 eq "T_Write_Hit:")   { $t_writehit[$i_hosts] = $F2 }
	elsif ($F1 eq "T_Long_Tx:")     { $t_longtx[$i_hosts] = $F2 }
	elsif ($F1 eq "T_Extents:")
        {     
          $t_extents[$i_hosts] = $F2;
          $t_extents_fix[$i_hosts] = $F3;
        }
	elsif ($F1 eq "OpC_Application:")  { $opc_appl[$i_hosts] = "$F2 $F3 $F4"; }
	elsif ($F1 eq "OpC_Object:")       { $opc_obj[$i_hosts] = $F2;  }
	elsif ($F1 eq "OpC_Msg_Group:")    { $opc_mg[$i_hosts] = $F2; }
	elsif ($F1 eq "OpC_Gateway:")      { $opc_gw[$i_hosts] = $F2; }
	elsif ($F1 eq "Must_Be_Up:")       { $t_mustbeup[$i_hosts] = $F2 }
	elsif ($F1 eq "Mem_Window:")       { $memwin[$i_hosts] = $F2 }
	elsif ($F1 eq "Backup_Age:")       { $backup_age[$i_hosts] = $F2; }
	elsif ($F1 eq "Backup_Check_DBs:") { $backup_dbs[$i_hosts] =  "," . lc $F2 . ","; }
	elsif ($F1 eq "Backup_Command:") 
        {
          $z = index($F0,$F2); 
          chop($backup_command[$i_hosts]    = substr($F0,$z));
          $backup_rerun_iter[$i_hosts] = 9999999 ;
          ##print "z=$z bc=$backup_command[$i_hosts] \n";
        }
	elsif ($F1 eq "L0_Age:")         { $l0_age[$i_hosts] = $F2 }
	elsif ($F1 eq "Max_Extents:")    { $max_extents[$i_hosts] = $F2 }
	elsif ($F1 eq "Pager_Subject:")  { $pager_subject[$i_hosts] = $F2; }
	elsif ($F1 eq "Pager_EMail:")    { $pager_email[$i_hosts] = "$F2 $F3 $F4"; }

 	elsif ($F1 eq "Notify_List:")  
        {
          $h_userlist[$i_hosts] = $F2;

          $_ = $title1[$i_hosts];
          s/\//_/g;  # change slashes to underscores
          $infname[$i_hosts]  = $_;
	 
	  if (length("hostname[$i_hosts]:$infname[$i_hosts]") > $longest)
	  {  
	    $longest = length("hostname[$i_hosts]:$infname[$i_hosts]");
	  }

	  $m_critical[$i_hosts] = 0;
	  $m_warning[$i_hosts]  = 0;
	  $m_info[$i_hosts]  = 0;

	  $t_critical[$i_hosts] = 0;
	  $t_warning[$i_hosts]  = 0;
	  $t_info[$i_hosts]  = 0;

	  $up[$i_hosts]       = " ";

          if ($dbms[$i_hosts] eq "SAP" && $userid[$i_hosts] eq "")
          {
            $userid[$i_hosts] = lc $sapsid[$i_hosts] . "adm";
          }

          if ($userid[$i_hosts] ne "")
          {
	    $tuserid = " -l $userid[$i_hosts] ";
          }
          else
          {
	    $tuserid = " ";
          }

          # Host DBC Defaults 

          if ($runmon[$i_hosts] eq "")      { $runmon[$i_hosts] = "Y"  }
	  if ($infver[$i_hosts] eq "")      { $infver[$i_hosts] = "7"  }
	  if ($lclrmt[$i_hosts] eq "")      { $lclrmt[$i_hosts] = "R"  }
          if ($t_freespace[$i_hosts] eq "") { $t_freespace[$i_hosts] = 999999999 }
          if ($dbms[$i_hosts] eq "")        { $dbms[$i_hosts] = "Informix" }
          if ($t_mustbeup[$i_hosts] eq "")  { $t_mustbeup[$i_hosts] = "Y" }
          if ($l0_age[$i_hosts] eq "")      { $l0_age[$i_hosts] = 30 }
          if ($perlpath[$i_hosts] eq "")    { $perlpath[$i_hosts] = "perl"  }

          # Evaluate DBMS

          $what[$i_hosts] = "DB";

          if ($dbms[$i_hosts] eq "Informix") 
          {
            $num_informix++;
            if ($os[$i_hosts] eq "") { $os[$i_hosts] = "UX"; }
          }
          elsif ($dbms[$i_hosts] eq "Oracle")   
          {
            $num_oracle++;
            if ($os[$i_hosts] eq "") { $os[$i_hosts] = "UX"; }
          }
          elsif ($dbms[$i_hosts] eq "OracleApps")   
          {
            $what[$i_hosts] = "AP";
            $num_oracleapps++;
            if ($os[$i_hosts] eq "") { $os[$i_hosts] = "UX"; }
          }
          elsif ($dbms[$i_hosts] eq "SAP")   
          {
            $what[$i_hosts] = "AP";
            $num_sap++;
            if ($os[$i_hosts] eq "") { $os[$i_hosts] = "UX"; }
          }
          elsif ($dbms[$i_hosts] eq "MSSQL")  
          {
            $num_mssql++;
            if ($os[$i_hosts] eq "") { $os[$i_hosts] = "NT"; }
          }
          elsif ($dbms[$i_hosts] eq "OracleNT")  
          {
            $num_oraclent++;
            if ($os[$i_hosts] eq "") { $os[$i_hosts] = "NT"; }
          }
          else 
          {
            $num_unknown++;
            if ($os[$i_hosts] eq "") { $os[$i_hosts] = "??"; }
	    $msg = "DBMS: Value: $dbms[$i_hosts] Invalid for Host: $hostname[$i_hosts]";
	    &error_msg($msg,$i_hosts);
          }

	  if ($debug_read) { printf("Processing Host/Instance %s/%s\n",$hostname[$i_hosts],$infname[$i_hosts]) }

          # Prevent errors

	  if ($comm_method[$i_hosts] eq "ssh" && $dbms[$i_hosts] ne "Oracle")
	  {
	    $msg = "Comm_Method: ssh is only valid with DBMS: Oracle";
	    &error_msg($msg,$i_hosts);
	    $comm_method[$i_hosts] = "";
	  }

          # Create remsh commands

          # Default remsh cmd
          $remshcmd[$i_hosts] = "remsh";

	  if ($infver[$i_hosts] eq "5" && $lclrmt[$i_hosts] eq "L")
	  {
	    $cmdpfx[$i_hosts]="export INFORMIXDIR=$infdir[$i_hosts];export TBCONFIG=$server[$i_hosts];$infdir[$i_hosts]/bin/";
	    $cmdsfx[$i_hosts]="";
	  }

	  if ($infver[$i_hosts] eq "5" && $lclrmt[$i_hosts] eq "R")
	  {
	    $cmdpfx[$i_hosts]="remsh $hostname[$i_hosts] $tuserid 'export INFORMIXDIR=$infdir[$i_hosts];export TBCONFIG=$server[$i_hosts];$infdir[$i_hosts]/bin/";
	    $cmdsfx[$i_hosts]="'";
	  }

	  if ($infver[$i_hosts] eq "6" && $lclrmt[$i_hosts] eq "R" && $sqlhosts[$i_hosts] eq "")
	  {
	    $cmdpfx[$i_hosts]="remsh $hostname[$i_hosts] $tuserid 'export INFORMIXDIR=$infdir[$i_hosts];export INFORMIXSERVER=$server[$i_hosts];export ONCONFIG=$config[$i_hosts];$infdir[$i_hosts]/bin/";
	    $cmdsfx[$i_hosts]="'";
	  }

	  if ($infver[$i_hosts] eq "6" && $lclrmt[$i_hosts] eq "R" && $sqlhosts[$i_hosts] ne "")
	  {
	    $cmdpfx[$i_hosts]="remsh $hostname[$i_hosts] $tuserid 'export INFORMIXDIR=$infdir[$i_hosts];export INFORMIXSERVER=$server[$i_hosts];export ONCONFIG=$config[$i_hosts];export INFORMIXSQLHOSTS=$sqlhosts[$i_hosts];$infdir[$i_hosts]/bin/";
	    $cmdsfx[$i_hosts]="'";
	  }

	  if ($infver[$i_hosts] eq "7" && $lclrmt[$i_hosts] eq "R" && $sqlhosts[$i_hosts] eq "")
	  {
	    $cmdpfx[$i_hosts]="remsh $hostname[$i_hosts] $tuserid 'export INFORMIXDIR=$infdir[$i_hosts];export INFORMIXSERVER=$server[$i_hosts];export ONCONFIG=$config[$i_hosts];$infdir[$i_hosts]/bin/";
	    $cmdsfx[$i_hosts]="'";
	  }

	  if ($infver[$i_hosts] eq "7" && $lclrmt[$i_hosts] eq "R" && $sqlhosts[$i_hosts] ne "")
	  {
	    $cmdpfx[$i_hosts]="remsh $hostname[$i_hosts] $tuserid 'export INFORMIXDIR=$infdir[$i_hosts] ;export INFORMIXSERVER=$server[$i_hosts] ;export ONCONFIG=$config[$i_hosts] ;export INFORMIXSQLHOSTS=$sqlhosts[$i_hosts] ;$infdir[$i_hosts]/bin/";
	    $cmdsfx[$i_hosts]="'";
	  }

	  if ($dbms[$i_hosts] eq "SAP")
	  {
            if ($comm_method[$i_hosts] eq "ssh")
            {
	      $cmdpfx[$i_hosts]=
		"ssh $hostname[$i_hosts] $tuserid '"     .
		"export PATH=\$PATH:/usr/sap/$sapsid[$i_hosts]/SYS/exe/run/;" . 
		"export SAPSYSTEMNAME=$sapsid[$i_hosts];" ;
	      $cmdsfx[$i_hosts]="'";
              $remshcmd[$i_hosts] = "ssh";
            }
            else
            {
	      $cmdpfx[$i_hosts]=
                "remsh $hostname[$i_hosts] $tuserid '"    .
		"export PATH=\$PATH:/usr/sap/$sapsid[$i_hosts]/SYS/exe/run/;" . 
		"export SAPSYSTEMNAME=$sapsid[$i_hosts];" ;
	      $cmdsfx[$i_hosts]="'";
              $remshcmd[$i_hosts] = "remsh";
            }
	  }

	  if ($dbms[$i_hosts] eq "Oracle")
	  {
            if ($comm_method[$i_hosts] eq "ssh")
            {
                $cmdpfx[$i_hosts]=
                  "ssh $hostname[$i_hosts] $tuserid '"     .
                  "export ORACLE_HOME=$orahome[$i_hosts];" . 
                  "export ORACLE_SID=$orasid[$i_hosts];"   .
                  "export PATH=\$PATH:$orahome[$i_hosts]/bin;" ;
	      $cmdsfx[$i_hosts]="'";
              $remshcmd[$i_hosts] = "ssh";
            }
            else
            {
	      $cmdpfx[$i_hosts]=
                "remsh $hostname[$i_hosts] $tuserid '"    .
                "export ORACLE_HOME=$orahome[$i_hosts];"  .
                "export ORACLE_SID=$orasid[$i_hosts];"    .
                "export PATH=\$PATH:$orahome[$i_hosts]/bin;";
	      $cmdsfx[$i_hosts]="'";
              $remshcmd[$i_hosts] = "remsh";
            }
	  }

	  if ($dbms[$i_hosts] eq "OracleApps")
	  {
            if ($comm_method[$i_hosts] eq "ssh")
            {
	      $cmdpfx[$i_hosts]="ssh $hostname[$i_hosts] $tuserid \
		'export ORACLE_HOME=$orahome[$i_hosts] \
		;export ORACLE_SID=$orasid[$i_hosts] \
		;export PATH=$PATH:$orahome[$i_hosts]/bin;" ;
	      $cmdsfx[$i_hosts]="'";
              $remshcmd[$i_hosts] = "ssh";
            }
            else
            {
	      $cmdpfx[$i_hosts]="remsh $hostname[$i_hosts] $tuserid '";
	      $cmdsfx[$i_hosts]="'";
              $remshcmd[$i_hosts] = "remsh";
            }
	  }

	  if ($dbms[$i_hosts] eq "MSSQL")
	  {
            $cmdpfx[$i_hosts]="remsh $hostname[$i_hosts] $tuserid '" ;
            $cmdsfx[$i_hosts]="'";
            $remshcmd[$i_hosts] = "remsh";
	  }

	  if ($dbms[$i_hosts] eq "OracleNT")
	  {
            $cmdpfx[$i_hosts]="remsh $hostname[$i_hosts] $tuserid '" ;
            $cmdsfx[$i_hosts]="'";
            $remshcmd[$i_hosts] = "remsh";
	  }

          ##print "parm remshcmd=" remshcmd[$i_hosts]
	  ##print infver[$i_hosts]  lclrmt[$i_hosts]  sqlhosts[$i_hosts]  memwin[$i_hosts] 

	  if ($infver[$i_hosts] eq "7" && $lclrmt[$i_hosts] eq "R" && $sqlhosts[$i_hosts] eq "" && $memwin[$i_hosts] ne "")
	  {
	    $cmdpfx[$i_hosts]="remsh $hostname[$i_hosts] $tuserid \
              'export INFORMIXDIR=$infdir[$i_hosts] \
              ;export INFORMIXSERVER=$server[$i_hosts] \
              ;export ONCONFIG=$config[$i_hosts] \
              ;setmemwindow -i $memwin[$i_hosts] -p \$\$ \
              ;$infdir[$i_hosts]/bin/";
	    $cmdsfx[$i_hosts]="'";
	  }

	  if ($infver[$i_hosts] eq "7" && $lclrmt[$i_hosts] eq "R" && $sqlhosts[$i_hosts] ne "" && $memwin[$i_hosts] ne "")
	  {
	    $cmdpfx[$i_hosts]="remsh $hostname[$i_hosts] $tuserid \
              'export INFORMIXDIR=$infdir[$i_hosts] \
              ;export INFORMIXSERVER=$server[$i_hosts] \
              ;export ONCONFIG=$config[$i_hosts] \
              ;export INFORMIXSQLHOSTS=$sqlhosts[$i_hosts] \
              ;setmemwindow -i $memwin[$i_hosts] -p \$\$ \
              ;$infdir[$i_hosts]/bin/";
	    $cmdsfx[$i_hosts]="'";
	  }
        }   # End of Notify_List if
        else
        {
          if ($F1 ne "Host:")
          {
          $msg = "Error - Unknown DBC parameter: $F1 specified for Host: $hostname[$i_hosts]";
          error_msg($msg);
          logit($msg);
          }
        }

      }   # End of HOSTS section

      if ($section eq "USERS") 
      {
        $i_users++;
        $thislist = $F1;
	$templist = $F0;
	$userlist[$thislist] = substr($templist,6) ;
        ##printf("Processing Userlist/User %s/%s\n",$thislist,$userlist[$thislist])
      }   # End of USERS section

      if ($section eq "SYSTEM") 
      {
	if ($F1 eq "Sleeptime:")           { $sleep_time = $F2 }
        elsif ($F1 eq "Iterations:")       { $iterations = $F2 }
        elsif ($F1 eq "Count_Tables:")     { $count_tables = $F2 }
        elsif ($F1 eq "Admin_EMail:")      { $dbamon_admin = $F2 }
        elsif ($F1 eq "Report_EMail:")     { $report_email = "$F2 $F3 $F4 $F5 $F6 $F7 $F8 $9"; }
        elsif ($F1 eq "Log_Path:")         { $log_path = $F2 }
        elsif ($F1 eq "Save_Dir:")         { $save_dir = $F2 }
        elsif ($F1 eq "PN_Dir:")           { $post_dir = $F2 }
        elsif ($F1 eq "Use_MySQL:")        { $use_mysql = $F2 }
        elsif ($F1 eq "Use_Oracle:")       { $use_oracle = $F2 }
        elsif ($F1 eq "Remsh_Sev:")        { $remsh_sev = $F2 }
        elsif ($F1 eq "Remsh_Retries:")    { $remsh_retries = $F2 }
        elsif ($F1 eq "HTML_Rpt_Path:")    { $report_path = $F2 }
        elsif ($F1 eq "HTML_Log_Path:")    { $html_path = $F2 }
        elsif ($F1 eq "HTML_Sys_Path:")    { $html_sys_path = $F2 }
        elsif ($F1 eq "HTML_Events_Dir:")  { $html_events_dir = $F2 }
        elsif ($F1 eq "HTTP_Events_Dir:")  { $http_events_dir = $F2 }
        elsif ($F1 eq "HTTP_Details_Dir:") { $http_details_dir = $F2 }
        elsif ($F1 eq "HTTP_Log_Path:")    { $http_path = $F2 }
        elsif ($F1 eq "HTTP_Rpt_Path:")    { $http_rpt_path = $F2 }
        elsif ($F1 eq "Images_Dir:")       { $images_path = $F2 }
        elsif ($F1 eq "OpC_Messages:")     { $opc = $F2 }
        elsif ($F1 eq "OpC_Trailer:")      { $opc_trailer = substr($F0,18) }
        elsif ($F1 eq "Ver_Colors:")       { $ver_colors = $F2 }
        elsif ($F1 eq "Make_Tickets:")     { $make_tickets = $F2 }
        elsif ($F1 eq "ORACLE_SID:")       { $oracle_sid = $F2 }
        elsif ($F1 eq "ORACLE_HOME:")      { $oracle_home = $F2 }
        elsif ($F1 eq "Num_Tasks:")        { $num_tasks = $F2 }
        elsif ($F1 eq "Task_Cfg_File:")    { $task_cfg_file = $F2 }
        elsif ($F1 eq "Iter_Min_Secs:")    { $iter_min_secs = $F2 }
        elsif ($F1 eq "Paging:")           { $g_pager = $F2 }
        elsif ($F1 eq "WWW_Check:")        { $www_check = $F2 }
        else
        {
	  $msg = sprintf("Error - SYSTEM section parameter %s unknown - exiting - rec=%s\n",$F1,$F0);
	  &error_msg($msg);
          exit 1;
        }

        # Defaults
	if ($iterations eq "*")   { $iterations = 999999 }
	if ($count_tables eq "")  { $count_tables = "Y" }
	if ($make_tickets eq "")  { $make_tickets = "N" }
	if ($remsh_retries eq "") { $remsh_retries = 1 }
	if ($post_dir eq "")      { $post_dir = "/usr/local/bin/X11" }
	if ($ver_colors eq "")    { $ver_colors = "N" }
	if ($save_dir eq "")      { $save_dir = "/opt/dbamon/dat/config_save" }
	if ($sleep_time eq "")    { $sleep_time = 30 }
	if ($opc eq "")           { $opc = "N" }
	if ($g_pager eq "")       { $g_pager = "Y" }

      }   # End of SYSTEM section

    } # End of comment check

    if ($F1 eq "Section")
    {
      $section = $F2;
      if ($debug_read) { printf("Now Processing %s Section ...\n",$section); }
    }

  } # End of getline do

  close(PARMALL);

  $omsg = "";
  if ($http_details_dir ne "") { $omsg .= "Warning - dbamonrc SYSTEM section parm HTTP_Detail_Dir: is obsolete - ignored\n" }
  if ($http_rpt_path    ne "") { $omsg .= "Warning - dbamonrc SYSTEM section parm HTTP_Rpt_Path: is obsolete - ignored\n" }
  if ($report_path      ne "") { $omsg .= "Warning - dbamonrc SYSTEM section parm HTML_Rpt_Path: is obsolete - ignored\n" }
  if ($http_events_dir  ne "") { $omsg .= "Warning - dbamonrc SYSTEM section parm HTTP_Events_Dir: is obsolete - ignored\n" }
  if ($http_path        ne "") { $omsg .= "Warning - dbamonrc SYSTEM section parm HTTP_Log_Path: is obsolete - ignored\n" }
  if ($http_rpt_path    ne "") { $omsg .= "Warning - dbamonrc SYSTEM section parm HTTP_Rpt_Path: is obsolete - ignored\n" }
  if ($html_sys_path    ne "") { $omsg .= "Warning - dbamonrc SYSTEM section parm HTML_Sys_Path: is obsolete - ignored\n" }
  if ($html_events_dir  ne "") { $omsg .= "Warning - dbamonrc SYSTEM section parm HTML_Events_Dir: is obsolete - ignored\n" }
  if ($html_path        ne "") { $omsg .= "Warning - dbamonrc SYSTEM section parm HTML_Log_Path: is obsolete - ignored\n" }
  if ($images_path      ne "") { $omsg .= "Warning - dbamonrc SYSTEM section parm Images_Dir: is obsolete - ignored\n" }
  if ($use_mysql        ne "") { $omsg .= "Warning - dbamonrc SYSTEM section parm Use_MySQL: is obsolete - ignored\n" }
  if ($omsg  ne "") 
  {
    $msg = "Obsolete DBAmon dbamonrc SYSTEM Parameters Found\n $omsg";
    &error_msg($msg);
  }

  # Assign values to html_ vars
  if ($arg eq "test") 
  {
    $html_sys_path   = "/opt/dbamon/htm/dbamon_sys_test.html";
    $html_events_dir = "/opt/dbamon/htm/events_current_test";
    $html_path       = "/opt/dbamon/htm/dbamon_log_test.html";
  }
  else
  {
    $html_sys_path   = "/opt/dbamon/htm/dbamon_sys.html";
    $html_events_dir = "/opt/dbamon/htm/events_current";
    $html_path       = "/opt/dbamon/htm/dbamon_log.html";
  } 
  # 2.03 modification - I will now write to .new path for HTML
  #   documents and will move _path to _path_perm at the end of each iteration
  $html_path_perm   = html_path;
  $html_path        = "${html_path}.new";
  
  $high_host = $i_hosts;
  $high_users = $i_users;

  # Re-process hosts entries to pad for title with longest length

  $spaces = "                                                    ";
  $i = 1;

  while ($i <= $high_host) 
  {
    ##split(hostname[$i],hostfixwk,".")
    @words = split(/\./,$hostname[$i]);
    $hostname_first = $words[0];

    # BB Test to accomodate multiple processes writing to the same log
    $longest = 32;

    $infname[$i] .= "_AppSrvr" if $what[$i] eq "AP";

    $title[$i] = substr("${hostname_first}:${infname[$i]}$spaces",0,$longest);

    # titleraw was added to have a way to grep for the host-instance
    # name in the dbspace history file to avoid duplicate entries
    # when the length of title shortens (bb 11Dec98)

    $hostfix[$i]   = $hostname_first;
    $titleraw[$i]  = "${hostname_first}:$infname[$i]";
    $inhibfile[$i] = "${hostname_first}_$server[$i]";
    $titlehist[$i] = "${hostname_first}_" . uc $infname[$i];
    chop($fqhostname[$i] = `nslookup $hostname[$i] | grep Name: | awk '{ print \$2 }'`);
    
    if ($pager_subject[$i] ne "" || $pager_email[$i] ne "") 
    { 
      $pager_flag[$i] = 1; 
    }
    else                                                
    { 
      $pager_flag[$i] = 0;
    }

    # bb 17May00 3.23.A Backup-only monitoring implies MBUN
    ##print "runmon=" runmon[$i]
    if ($runmon[$i] eq "B") 
    {
      $t_mustbeup[$i] = "N";
      $msg = sprintf("Since Monitor: is B then Must_Be_Up: Set to N - %s",$title[$i]);
      logit($msg);
    }

    $save_file[$i] = "$save_dir/config.$hostname[$i]_$infname[$i]";

    $html_events[$i] = "$html_events_dir/${hostname_first}:$infname[$i].html.new";
    ##print "html_events="html_events[$i]

    $html_events_perm[$i] = "$html_events_dir/${hostname_first}:$infname[$i].html";
    $html_events_flag[$i] = 0;

    if ($arg eq "test") { $z = "/opt/dbamon/htm/details_test/" }
    else                { $z = "/opt/dbamon/htm/details/" }

    $html_details[$i]      = "${z}${hostname_first}:$infname[$i].html.new";
    $html_details_perm[$i] = "${z}${hostname_first}:$infname[$i].html";
    $html_details_flag[$i] = 0;
    system("mkdir $z 2>/dev/null");

    if ($dbms[$i] eq "SAP") 
    {
      $dbmsout[$i] = "SAP";
      $dbms_color[$i] = "violet";
    }
    if ($dbms[$i] eq "Informix") 
    {
      $dbmsout[$i] = "Informix-UX";
      $dbms_color[$i] = "darkblue";
    }
    if ($dbms[$i] eq "Oracle")     
    {
      $dbmsout[$i] = "OracleDB-UX";
      $dbms_color[$i] = "red";
      &error_msg("Configuration Error: ORACLE_SID Cannot Be Null - Host: $hostname[$i]",$i) 
        if $orasid[$i] eq "";
      &error_msg("Configuration Error: ORACLE_HOME Cannot Be Null - Host: $hostname[$i]",$i) 
        if $orahome[$i] eq "";
    }
    if ($dbms[$i] eq "OracleApps") 
    {
      $dbmsout[$i] = "OracleApps";
      $dbms_color[$i] = "darkred";
    }
    if ($dbms[$i] eq "OracleNT")   
    {
      $dbmsout[$i] = "OracleDB-NT";
      $dbms_color[$i] = "ff0090";
    }
    if ($dbms[$i] eq "MSSQL")      
    {
      $dbmsout[$i] = "MSSQL";
      $dbms_color[$i] = "green";
    }

    $i++;
  }

  # For info events with no host
  $html_events[0] = "/dev/null";
  $html_details[0] = "/dev/null";

  # Validate SYSTEM values
  if ($iterations eq "")    { &error_parm_null("SYSTEM","iterations") }
  if ($dbamon_admin eq "")  { &error_parm_null("SYSTEM","dbamon_admin") }
  if ($log_path eq "")      { &error_parm_null("SYSTEM","log_path") }

  if ($use_oracle ne "" && $use_oracle ne "N" && $use_oracle ne "Y") 
  {
    &error_parm("SYSTEM Section parameter Use_Oracle: must be null, Y or N");
  }
  if ($use_oracle eq "Y" && ($oracle_sid eq "" || $oracle_home eq ""))
  {
    &error_parm("SYSTEM Section: If Use_Oracle:=Y, then ORACLE_SID and ORACLE_HOME must be specified");
  }
  if ($use_oracle ne "Y" && $www_check eq "Y")
  {
    &error_parm("SYSTEM Section: If WWW_Check: is Y, then Use_Oracle: must also be Y");
  }

  if ($use_oracle eq "Y" || $use_mysql eq "Y") 
  {
    if ($use_oracle eq "Y") { $z = "Oracle" }
    else                    { $z = "MySql" }
    $msg = sprintf("%s Data Repository will be used",$z);
    logit($msg);
    $use_repository = "Y";
  }
  else
  {
    $msg = sprintf("Data Repository will not be used");
    logit($msg);
  }

  # Wrapup

  $msg = sprintf("Read %s host definitions - longest title=%s",$high_host,$longest);
  logit($msg);

  $msg = sprintf("Read %s userlist definitions",$high_users);
  logit($msg);

  return;

}

# -----------------------------------------------------------------------------
1;
