sub readDBC
# This function will read the DBC file
{

  $longest = 0;

  $i_hosts = 0;
  $i_users = 0;

  undef $num_informix;
  undef $num_oracle;
  undef $num_oracleapps;
  undef $num_oraclent;
  undef $num_sap;
  undef $num_mssql;
  undef $num_unknown;

  $debug_read = 0;

  &logit("Reading DBC file directory from $parmdir");

  opendir(DBC_DIR, "$parmdir") || &error_msg("Cannot opendir $parmdir - $!");
  @dbc_files = sort readdir DBC_DIR;
  closedir(DBC_DIR);

  &logit("Done reading DBC file directory from $parmdir");

  DBCFILE: foreach $dbc_file (@dbc_files)
  {
    if ($dbc_file =~ /.dbc$/)
    {
      $dbc_count++;
      ##print "Found DBC file=$dbc_file ... opening \n";





      open(DBC,"$parmdir/$dbc_file");

      #See if this DBC file has Host: specified twice
      ##print "checking $parmdir/$dbc_file for dups\n";
      chop($dupcheck = `cat $parmdir/$dbc_file | grep -v '^#' | grep ^Host: | wc -l`);
      ##print "dupcheck=$dupcheck\n";
      if ($dupcheck > 1)
      {
        &logit("**************************************************************************************");
        &logit("Host: Specified > once in DBC File: $dbcfilename[$i] - DBC File discarded");
        &logit("**************************************************************************************");
        next DBCFILE;
      }

      while (<DBC>)
      {
	&parse;
	next if ($NF == 0);

        if ($F1 eq "Host:")
        {
          ##print "hi ih=$i_hosts \n";

          # z will contain the first letter of the host name. This can 
          # be overridden by first character of DBC
          # file name if Use_DBC_Firstchar: = Y.
          if ($use_dbc_firstchar eq "Y")
          {
            $z = uc substr($dbc_file,0,1);
          }
          else  # We will use first character of hostname
          {
            $z = uc substr($F2,0,1);
          }
          ##print "z=$z dbamon_alpha=$dbamon_alpha F2=$F2 dbc_file=$dbc_file\n";

	  if ((index($dbamon_alpha,$z) > -1 || $dbamon_alpha eq "") && $F3 ne "Inactive") 
	  { 
	    $alpha_flag = 1;
	    ##$msg = sprintf("dbamon_alpha=%s Including Host: %s",$dbamon_alpha,$F2);
	    ##logit($msg);

	    # Increment counter
	    $i_hosts++;

            $dbcfilename[$i_hosts] = "${parmdir}/${dbc_file}";
            chop($this_checksum = `cksum $dbcfilename[$i_hosts] | cut -f 1 -d ' '`);
            if ($this_checksum ne $last_checksum[$i_hosts])
            {     
	      undef $download_flag[$i_hosts];
              ##print "turned off download flag for $dbcfilename[$i_hosts] \n";
            }
            $last_checksum[$i_hosts] = $this_checksum;
          
            # del any old dbcactive data for this instance number
            if ($use_oracle eq "Y")
            {
              runSQL("delete from dbamon.dbcactive where dbamonmode = '$modeout' and i_hosts = '$i_hosts'");
	      $sqltext = "insert into dbamon.dbcactive (dbamonmode,i_hosts,text)\n";
	      $sqltext .= "  values ('$modeout','$i_hosts','#--DBCFileName=$dbc_file--#')\n";
	      runSQL($sqltext);
            }

	    undef $backup_age[$i_hosts];
	    undef $backup_age_parm[$i_hosts];
	    undef $backup_age_arc[$i_hosts];
	    undef $backup_age_parm_arc[$i_hosts];
	    undef $backup_dbs[$i_hosts];
	    undef $backup_command[$i_hosts];
	    undef $comm_method[$i_hosts];
	    undef $config[$i_hosts];
	    undef $dbms[$i_hosts];
	    undef $download_every[$i_hosts];
	    undef $h_userlist[$i_hosts];
	    undef $host_url[$i_hosts];
	    undef $hostname[$i_hosts];
	    undef $id1[$i_hosts];
	    undef $id2[$i_hosts];
	    undef $id3[$i_hosts];
	    undef $infdir[$i_hosts];
	    undef $infname[$i_hosts];
	    undef $infver[$i_hosts];
	    undef $l0_age[$i_hosts];
	    undef $lclrmt[$i_hosts];
	    undef $max_extents[$i_hosts];
	    undef $memwin[$i_hosts];
	    undef $mon_days[$i_hosts];
	    undef $mon_excl[$i_hosts];
	    undef $mon_hours[$i_hosts];
	    undef $ntrcpbug[$i_hosts];
	    undef $opc_appl[$i_hosts];
	    undef $opc_gw[$i_hosts];
	    undef $opc_mg[$i_hosts];
	    undef $opc_obj[$i_hosts];
	    undef $orahome[$i_hosts];
	    undef $orasid[$i_hosts];
	    undef $pager_email[$i_hosts];
	    undef $pager_subject[$i_hosts];
	    undef $perlpath[$i_hosts];
	    undef $runmon[$i_hosts];
	    undef $sapsid[$i_hosts];
	    undef $server[$i_hosts];
	    undef $sqlhosts[$i_hosts];
	    undef $t_arclog_c[$i_hosts];
	    undef $t_arclog_cmd[$i_hosts];
	    undef $t_arclog_w[$i_hosts];
	    undef $t_diskcrit[$i_hosts];
	    undef $t_diskwarn[$i_hosts];
	    undef $t_extents[$i_hosts];
	    undef $t_extents_fix[$i_hosts];
	    undef $t_freespace[$i_hosts];
	    undef $t_longtx[$i_hosts];
	    undef $t_mustbeup[$i_hosts];
	    undef $t_readhit[$i_hosts];
	    undef $t_writehit[$i_hosts];
	    undef $title1_dup[$i_hosts];
	    undef $title1[$i_hosts];
	    undef $title1url[$i_hosts];
	    undef $title2[$i_hosts];
	    undef $title2url[$i_hosts];
	    undef $title3[$i_hosts];
	    undef $ts_command[$i_hosts];
	    undef $userid[$i_hosts];
	    undef $useridap[$i_hosts];
	    undef $comn[$i_hosts];
	    undef $minproc_apache[$i_hosts];
	    undef $oraapfs[$i_hosts];
	    undef $parm_errors[$i_hosts];
	    undef $rootpath[$i_hosts];
	    undef $rootoffs[$i_hosts];
	    undef $os[$i_hosts];
	    undef $sw_version[$i_hosts];
	    undef $os_version[$i_hosts];
	    undef $hw_model[$i_hosts];
	    undef $sn[$i_hosts];
	    undef $is_prihost[$i_hosts];
	    undef $is_prisid[$i_hosts];
	    undef $is_threshold[$i_hosts];
	    undef $mssql_agentmon[$i_hosts];

	    $dbcfile[$i_hosts] = $dbc_file;

	    $hostname[$i_hosts] = lc $F2;
	    if ($debug_read) { printf("Found Host %s\n",$hostname[$i_hosts]); }
	  }
	  else 
	  {
            ##print "skipping host=$F2 \n";
	    $alpha_flag = 0;
            close(DBC);
            next DBCFILE;
	  }
        }

        # Insert repository row
        if ($F0 ne "" && $use_oracle eq "Y")
        {
	  $sqltext = "insert into dbamon.dbcactive (dbamonmode,i_hosts,text)\n";
	  chop($_ = $F0);
          #s/\\/\//g;
          s/&/[Ampersand]/g;
          s/\'/[SingleQuote]/g;
          $sqltext .= "  values ('$modeout','$i_hosts','$_')\n";
          runSQL($sqltext);
        }

        #
        # Parse data
        #
	if ($F1 eq "Comm_Method:")      { $comm_method[$i_hosts]  = $F2; }
	elsif ($F1 eq "Title1:")           
        { 
          # At this point the title1 var should be null; if it isn't, then there must be dup title1 entries
          ##print "t1b4=$title1[$i_hosts] \n";
          if ($title1[$i_hosts] ne "") 
          { 
            $title1_dup[$i_hosts] = 1; 
            ##print "t1di=$title1_dup[$i_hosts] \n";
          }
     
          $title1[$i_hosts]  = $F2; 
	  $z = length($title1[$i_hosts]);
	  if ($z > 16)
	  {
	    $msg = "Title1: value: $title1[$i_hosts] length exceeds maximum of 16 - truncated";
	    error_msg($msg,$i_hosts);
	    $title1[$i_hosts] = substr($title1[$i_hosts],0,16);
	  }
        }
	elsif ($F1 eq "Title2:")           { $title2[$i_hosts]  = $F2; }
	elsif ($F1 eq "Title3:")           { $title3[$i_hosts]  = $F2; }
	elsif ($F1 eq "Host_URL:")         { $host_url[$i_hosts]  = $F2; }
	elsif ($F1 eq "Title1_URL:")       { $title1url[$i_hosts]  = $F2; }
	elsif ($F1 eq "Title2_URL:")       { $title2url[$i_hosts]  = $F2; }
	elsif ($F1 eq "Userid:")           { $userid[$i_hosts]   = $F2; }

	elsif ($F1 eq "DBMS:")             
        { 
          #See if this has already been specified
          if ($dbms[$i_hosts] ne "") 
          {
            $parm_errors[$i_hosts] .= "Error - DBMS was specified TWICE in this DBC file\n"; 
            next DBCFILE;
          }
          $dbms[$i_hosts] = $F2; 
        }

	elsif ($F1 eq "SWPackage:")        { $dbms[$i_hosts] = $F2; }
	elsif ($F1 eq "Monitor:")          { $runmon[$i_hosts] = $F2; }
	elsif ($F1 eq "Monitor_Hours:")    { $mon_hours[$i_hosts] = $F2; }
	elsif ($F1 eq "Monitor_Days:")     { $mon_days[$i_hosts] = $F2; }
	elsif ($F1 eq "Monitor_Exclude:")  { $mon_excl[$i_hosts] = $F2; }
	elsif ($F1 eq "Download_Every:")   { $download_every[$i_hosts] = $F2; }
	elsif ($F1 eq "Perl_Path:")        { $perlpath[$i_hosts] = $F2; }
	elsif ($F1 eq "ID1:")              { $id1[$i_hosts] = $F2; }
	elsif ($F1 eq "ID2:")              { $id2[$i_hosts] = $F2; }
	elsif ($F1 eq "ID3:")              { $id3[$i_hosts] = $F2; }
	elsif ($F1 eq "NT_RCP_Bug:")       { $ntrcpbug[$i_hosts] = $F2; }
	elsif ($F1 eq "UseridApps:")              { $useridap[$i_hosts]   = $F2; }
	elsif ($F1 eq "OraApps_Userid:")          { $useridap[$i_hosts]   = $F2; }
	elsif ($F1 eq "OraApps_COMN_Dir:")        { $comn[$i_hosts] = $F2; }
	elsif ($F1 eq "OraApps_Minproc_Apache:")  { $minproc_apache[$i_hosts] = $F2; }
	elsif ($F1 eq "OraApps_Forms_ORAHOME:")   { $forms_orahome[$i_hosts] = $F2; }
	elsif ($F1 eq "OraApps_FS_Check:")        { $oraapfs[$i_hosts] .= "$F2 "; }
	elsif ($F1 eq "ORACLE_HOME:")      { $orahome[$i_hosts] = $F2; }
	elsif ($F1 eq "ORACLE_SID:")       
        {
          $orasid[$i_hosts] = $F2;
          # This is for the inhib file name
          $server[$i_hosts] = $F2 ;
        }
	elsif ($F1 eq "SAPSYSTEMNAME:")       
        {
          $sapsid[$i_hosts] = $F2;
          # This is for the inhib file name
          $server[$i_hosts] = $F2 ;
        }
        elsif ($F1 eq "Config:")
        {
          @words = split(/\//,$F2);
	  $server[$i_hosts]   = $words[0];
	  $config[$i_hosts]   = $words[1];
        }
	elsif ($F1 eq "Inf_Server:"   || $F1 eq "INFORMIXSERVER:") { $server[$i_hosts] = $F2 }
	elsif ($F1 eq "ON_Config:"    || $F1 eq "ONCONFIG:")    { $config[$i_hosts] = $F2 }
	elsif ($F1 eq "SQL_Hosts:"    || $F1 eq "INFORMIXSQLHOSTS:")    { $sqlhosts[$i_hosts] = $F2 }
	elsif ($F1 eq "Informix_Dir:" || $F1 eq "INFORMIXDIR:") { $infdir[$i_hosts]   = $F2 }
	elsif ($F1 eq "Informix_Version:") { $infver[$i_hosts]   = $F2 }
        # Made obsolete 21May01
	#elsif ($F1 eq "Local_Or_Remote:")  { $lclrmt[$i_hosts]   = $F2 }
        elsif ($F1 eq "T_Disk_Full:" || $F1 eq "T_TS_Full:" || $F1 eq "T_DBSpace_Full:")
        {
          @words = split(/\//,$F2);
	  $t_diskwarn[$i_hosts] = $words[0];
	  $t_diskcrit[$i_hosts] = $words[1];
          ##print "tdw=$t_diskwarn[$i_hosts] tdc=$t_diskcrit[$i_hosts] F2=$F2 \n";
        }
	elsif ($F1 eq "T_TS_Command:") 
        {
          $z = index($F0,$F2);
          $ts_command[$i_hosts]    = substr($F0,$z);
          chop($ts_command[$i_hosts]);
          ##print "tsc=$ts_command[$i_hosts] \n";
        }
        elsif ($F1 eq "T_Arclog_Full:")
        {
          @words = split(/\//,$F2);
	  $t_arclog_w[$i_hosts] = $words[0];
	  $t_arclog_c[$i_hosts] = $words[1];
        }
        elsif ($F1 eq "T_Log_Full:")   # Informix
        {
          @words = split(/\//,$F2);
	  $t_logfull_w[$i_hosts] = $words[0];
	  $t_logfull_c[$i_hosts] = $words[1];
        }
	elsif ($F1 eq "T_Arclog_Command:") 
        {
          $z = index($F0,$F2);
          $t_arclog_cmd[$i_hosts]    = substr($F0,$z);
          chop($t_arclog_cmd[$i_hosts]);
          ##print "arc_cmd=$t_arclog_cmd[$i_hosts] \n";
        }
	elsif ($F1 eq "T_DBSpace_Free:" || $F1 eq "T_TS_Free:") { $t_freespace[$i_hosts] = $F2 }

	elsif ($F1 eq "T_Read_Hit:")      { $t_readhit[$i_hosts] = $F2 }
	elsif ($F1 eq "T_Read_Hit_Sev:")  { $t_readhit_sev[$i_hosts] = $F2 }

	elsif ($F1 eq "T_Write_Hit:")   { $t_writehit[$i_hosts] = $F2 }
	elsif ($F1 eq "T_Long_Tx:")     { $t_longtx[$i_hosts] = $F2 }
	elsif ($F1 eq "T_Extents:")
        {     
          $t_extents[$i_hosts] = $F2;
          $t_extents_fix[$i_hosts] = $F3;
        }
	elsif ($F1 eq "OpC_Application:")  { $opc_appl[$i_hosts] = "$F2 $F3 $F4"; }
	elsif ($F1 eq "OpC_Object:")       { $opc_obj[$i_hosts] = $F2;  }
	elsif ($F1 eq "OpC_Msg_Group:")    { $opc_mg[$i_hosts] = $F2; }
	elsif ($F1 eq "OpC_Gateway:")      { $opc_gw[$i_hosts] = $F2; }
	elsif ($F1 eq "Must_Be_Up:")       { $t_mustbeup[$i_hosts] = $F2 }
	elsif ($F1 eq "Mem_Window:")       { $memwin[$i_hosts] = $F2 }
	elsif ($F1 eq "Backup_Check_DBs:") { $backup_dbs[$i_hosts] =  "," . lc $F2 . ","; }
	elsif ($F1 eq "In_Sync_Pri_Host:") { $is_prihost[$i_hosts] = $F2; }
	elsif ($F1 eq "In_Sync_Pri_SID:")  { $is_prisid[$i_hosts] = $F2; }
	elsif ($F1 eq "In_Sync_Age:")      { $is_threshold[$i_hosts] = $F2; }
	elsif ($F1 eq "In_Sync_NL_Sev:")   { $is_nolog_sev[$i_hosts] = $F2; }
	elsif ($F1 eq "Listener_Check:")   { $listener_check[$i_hosts] = $F2; }
	elsif ($F1 eq "Backup_Age:")       
        { 
          $backup_age[$i_hosts] = $F2; 
          $backup_age_parm[$i_hosts] = $F3; 
        }
	elsif ($F1 eq "Backup_Age_Arc:")       
        { 
          $backup_age_arc[$i_hosts] = $F2; 
          $backup_age_parm_arc[$i_hosts] = $F3; 
        }
	elsif ($F1 eq "Backup_Command:") 
        {
          $z = index($F0,$F2); 
          chop($backup_command[$i_hosts]    = substr($F0,$z));
          $backup_rerun_iter[$i_hosts] = 9999999 ;
          ##print "z=$z bc=$backup_command[$i_hosts] \n";
        }
	elsif ($F1 eq "L0_Age:")         { $l0_age[$i_hosts] = $F2 }
	elsif ($F1 eq "Max_Extents:")    { $max_extents[$i_hosts] = $F2 }
	elsif ($F1 eq "Pager_Subject:")  { $pager_subject[$i_hosts] = $F2; }
	elsif ($F1 eq "Pager_EMail:")    { $pager_email[$i_hosts] = "$F2 $F3 $F4"; }

	elsif ($F1 eq "MSSQL_Agent_Mon:") { $mssql_agentmon[$i_hosts] = $F2; }

 	elsif ($F1 eq "Notify_List:")  
        {
          $h_userlist[$i_hosts] = $F2;
        }
        else
        {
          if ($F1 ne "Host:")
          {
            $zfile = "$parmdir/$dbc_file";
	    $msg = "Error - Unknown DBC parameter: $F1 specified in DBC file: $zfile";
	    #error_msg($msg);
	    #logit($msg);
            $parm_errors[$i_hosts] .= "$msg\n";
          }
        }
      }      
      close(DBC);

      ##if ($company eq "agilent")
      ##{
      ##  chop($datechk = `date +%C%y/%m/%d-%H:%M:%S`);
      ##  if ($datechk ge "2001/05/19-12:00:00" &&  $datechk le "2001/05/20-12:00:00")
      ##  {
      ##    $t_mustbeup[$i_hosts] = "N";
      ##    logit("Must_Be_Up: Forced to N for host: $hostname[$i_hosts]:$title1[$i_hosts] ");
      ##  }
      ##}

      # Process various parm for this instance
      $_ = $title1[$i_hosts];
      s/\//_/g;  # change slashes to underscores
      $infname[$i_hosts]  = $_;
     
      if (length("hostname[$i_hosts]:$infname[$i_hosts]") > $longest)
      {  
	$longest = length("hostname[$i_hosts]:$infname[$i_hosts]");
      }

      $m_critical[$i_hosts] = 0;
      $m_warning[$i_hosts]  = 0;
      $m_info[$i_hosts]  = 0;

      $t_critical[$i_hosts] = 0;
      $t_warning[$i_hosts]  = 0;
      $t_info[$i_hosts]  = 0;

      $up[$i_hosts]       = " ";

      if ($dbms[$i_hosts] eq "SAP" && $userid[$i_hosts] eq "")
      {
	$userid[$i_hosts] = lc $sapsid[$i_hosts] . "adm";
      }

      if ($userid[$i_hosts] ne "")
      {
	$tuserid = " -l $userid[$i_hosts] ";
      }
      else
      {
	$tuserid = " ";
      }

      # Validation
      ##print "$hostname[$i_hosts] $title1[$i_hosts] \n";
      if ($hostname[$i_hosts] eq "") { $parm_errors[$i_hosts] .= "Error - Null Host: DBC Parameter\n"; }
      if ($title1[$i_hosts] eq "")   { $parm_errors[$i_hosts] .= "Error - Null Title1: DBC Parameter\n"; }
      if ($title1_dup[$i_hosts])     { $parm_errors[$i_hosts] .= "Error - Duplicate Title1: Parameter Found\n"; }
      if ($t_extents_fix[$i_hosts] ne "" && $t_extents_fix[$i_hosts] ne "NOFIX")  
      { 
        $parm_errors[$i_hosts] .= "Error - 2nd parm of T_Extents: must be null or NOFIX\n"; 
      }
      if ($backup_age_parm[$i_hosts] ne "" && $backup_age_parm[$i_hosts] ne "ARC")  
      { 
        $parm_errors[$i_hosts] .= "Error - 2nd parm of Backup_Age: must be null or ARC\n"; 
      }
      if (($is_prihost[$i_hosts] ne "" ||
           $is_prisid[$i_hosts] ne "" ||
           $is_threshold[$i_hosts] ne "")
         &&
          ($is_prihost[$i_hosts] eq "" ||
           $is_prisid[$i_hosts] eq "" ||
           $is_threshold[$i_hosts] eq ""))
      { 
        $parm_errors[$i_hosts] .= "If any of the three In_Sync* parms are specified, they all must be specifed\n"; 
      }
      if ($is_nolog_sev[$i_hosts] ne "" &&
          $is_nolog_sev[$i_hosts] ne "C" &&
          $is_nolog_sev[$i_hosts] ne "W")
      { 
        $parm_errors[$i_hosts] .= "In_Sync_NL_Sev must be specifed as Null, C or W\n"; 
      }

      ##print "$hostname[$i_hosts] $title1[$i_hosts] $parm_errors[$i_hosts]\n";
      # Host DBC Defaults 
      if ($runmon[$i_hosts] eq "")      { $runmon[$i_hosts] = "Y"  }
      if ($infver[$i_hosts] eq "")      { $infver[$i_hosts] = "7"  }
      if ($lclrmt[$i_hosts] eq "")      { $lclrmt[$i_hosts] = "R"  }
      if ($t_freespace[$i_hosts] eq "") { $t_freespace[$i_hosts] = 999999999 }
      if ($dbms[$i_hosts] eq "")        { $dbms[$i_hosts] = "Informix" }
      if ($t_mustbeup[$i_hosts] eq "")  { $t_mustbeup[$i_hosts] = "Y" }
      if ($l0_age[$i_hosts] eq "")      { $l0_age[$i_hosts] = 30 }
      if ($perlpath[$i_hosts] eq "")    { $perlpath[$i_hosts] = "perl"  }
      if ($is_nolog_sev[$i_hosts] eq "") { $is_nolog_sev[$i_hosts] = "C"  }

      # Evaluate DBMS

      $what[$i_hosts] = "DB";

      if ($dbms[$i_hosts] eq "Informix") 
      {
	$num_informix++;
	if ($os[$i_hosts] eq "") { $os[$i_hosts] = "UX"; }
      }
      elsif ($dbms[$i_hosts] eq "Oracle")   
      {
	$num_oracle++;
        ##print "num_oracle incremented to $num_oracle - host=$hostname[$i_hosts] \n";
	if ($os[$i_hosts] eq "") { $os[$i_hosts] = "UX"; }
      }
      elsif ($dbms[$i_hosts] eq "OracleApps")   
      {
	$what[$i_hosts] = "AP";
	$num_oracleapps++;
	if ($os[$i_hosts] eq "") { $os[$i_hosts] = "UX"; }
      }
      elsif ($dbms[$i_hosts] eq "SAP")   
      {
	$what[$i_hosts] = "AP";
	$num_sap++;
	if ($os[$i_hosts] eq "") { $os[$i_hosts] = "UX"; }
      }
      elsif ($dbms[$i_hosts] eq "MSSQL")  
      {
	$num_mssql++;
	if ($os[$i_hosts] eq "") { $os[$i_hosts] = "NT"; }
      }
      elsif ($dbms[$i_hosts] eq "OracleNT")  
      {
	$num_oraclent++;
	if ($os[$i_hosts] eq "") { $os[$i_hosts] = "NT"; }
      }
      else 
      {
	$num_unknown++;
	if ($os[$i_hosts] eq "") { $os[$i_hosts] = "??"; }
	$msg = "DBMS: Value: $dbms[$i_hosts] Invalid for Host: $hostname[$i_hosts]";
	&error_msg($msg,$i_hosts);
      }

      if ($debug_read) { printf("Processing Host/Instance %s/%s\n",$hostname[$i_hosts],$infname[$i_hosts]) }

      # Prevent errors
      ##print "ih=$i_hosts host=$hostname[$i_hosts] cm=$comm_method[$i_hosts] u=$userid[$i_hosts] dbms=$dbms[$i_hosts] \n";

      if ($comm_method[$i_hosts] eq "ssh" && $dbms[$i_hosts] ne "Oracle")
      {
	$msg = "Comm_Method: ssh is only valid with DBMS: Oracle";
	&error_msg($msg,$i_hosts);
	$comm_method[$i_hosts] = "";
      }

      # Create remsh commands

      # Default remsh cmd
      $remshcmd[$i_hosts] = "remsh";

      if ($infver[$i_hosts] eq "5" && $lclrmt[$i_hosts] eq "L")
      {
	$cmdpfx[$i_hosts]="export INFORMIXDIR=$infdir[$i_hosts];export TBCONFIG=$server[$i_hosts];$infdir[$i_hosts]/bin/";
	$cmdsfx[$i_hosts]="";
      }

      if ($infver[$i_hosts] eq "5" && $lclrmt[$i_hosts] eq "R")
      {
	$cmdpfx[$i_hosts]="remsh $hostname[$i_hosts] $tuserid 'export INFORMIXDIR=$infdir[$i_hosts];export TBCONFIG=$server[$i_hosts];$infdir[$i_hosts]/bin/";
	$cmdsfx[$i_hosts]="'";
      }

      if ($infver[$i_hosts] eq "6" && $lclrmt[$i_hosts] eq "R" && $sqlhosts[$i_hosts] eq "")
      {
	$cmdpfx[$i_hosts]="remsh $hostname[$i_hosts] $tuserid 'export INFORMIXDIR=$infdir[$i_hosts];export INFORMIXSERVER=$server[$i_hosts];export ONCONFIG=$config[$i_hosts];$infdir[$i_hosts]/bin/";
	$cmdsfx[$i_hosts]="'";
      }

      if ($infver[$i_hosts] eq "6" && $lclrmt[$i_hosts] eq "R" && $sqlhosts[$i_hosts] ne "")
      {
	$cmdpfx[$i_hosts]="remsh $hostname[$i_hosts] $tuserid 'export INFORMIXDIR=$infdir[$i_hosts];export INFORMIXSERVER=$server[$i_hosts];export ONCONFIG=$config[$i_hosts];export INFORMIXSQLHOSTS=$sqlhosts[$i_hosts];$infdir[$i_hosts]/bin/";
	$cmdsfx[$i_hosts]="'";
      }

      if ($infver[$i_hosts] eq "7" && $lclrmt[$i_hosts] eq "R" && $sqlhosts[$i_hosts] eq "")
      {
	$cmdpfx[$i_hosts]="remsh $hostname[$i_hosts] $tuserid 'export INFORMIXDIR=$infdir[$i_hosts];export INFORMIXSERVER=$server[$i_hosts];export ONCONFIG=$config[$i_hosts];$infdir[$i_hosts]/bin/";
	$cmdsfx[$i_hosts]="'";
      }

      if ($infver[$i_hosts] eq "7" && $lclrmt[$i_hosts] eq "R" && $sqlhosts[$i_hosts] ne "")
      {
	$cmdpfx[$i_hosts]="remsh $hostname[$i_hosts] $tuserid 'export INFORMIXDIR=$infdir[$i_hosts] ;export INFORMIXSERVER=$server[$i_hosts] ;export ONCONFIG=$config[$i_hosts] ;export INFORMIXSQLHOSTS=$sqlhosts[$i_hosts] ;$infdir[$i_hosts]/bin/";
	$cmdsfx[$i_hosts]="'";
      }

      if ($dbms[$i_hosts] eq "SAP")
      {
	if ($comm_method[$i_hosts] eq "ssh")
	{
	  $cmdpfx[$i_hosts]=
	    "ssh $hostname[$i_hosts] $tuserid '"     .
	    "export PATH=\$PATH:/usr/sap/$sapsid[$i_hosts]/SYS/exe/run/;" . 
	    "export SAPSYSTEMNAME=$sapsid[$i_hosts];" ;
	  $cmdsfx[$i_hosts]="'";
	  $remshcmd[$i_hosts] = "ssh";
	}
	else
	{
	  $cmdpfx[$i_hosts]=
	    "remsh $hostname[$i_hosts] $tuserid '"    .
	    "export PATH=\$PATH:/usr/sap/$sapsid[$i_hosts]/SYS/exe/run/;" . 
	    "export SAPSYSTEMNAME=$sapsid[$i_hosts];" ;
	  $cmdsfx[$i_hosts]="'";
	  $remshcmd[$i_hosts] = "remsh";
	}
      }

      if ($dbms[$i_hosts] =~ /^Oracle/)
      {
	if ($orahome[$i_hosts] eq "*" && $save_orahome[$i_hosts] eq "")
	{
	  $download_flag[$i_hosts] = 0;
        }
	if ($orahome[$i_hosts] eq "*" && $save_orahome[$i_hosts] ne "")
	{
	  $orahome[$i_hosts] = $save_orahome[$i_hosts];
	  &logit("Re-Promoting ORACLE_HOME from * to $orahome[$i_hosts]",$i_hosts);
          if ($use_oracle eq "Y")
          {
	    # Update dbcactive table
	    runSQL("delete from dbamon.dbcactive where dbamonmode = '$modeout' and i_hosts = '$i_hosts' and text like 'ORACLE_HOME:%'");
	    $sqltext = "insert into dbcactive (dbamonmode,i_hosts,text)
			values ('$modeout','$i_hosts','ORACLE_HOME: $orahome[$i_hosts]')";
	    runSQL($sqltext);
          }
	}
	if ($comm_method[$i_hosts] eq "ssh")
	{
	    $cmdpfx[$i_hosts]=
	      "ssh -v $hostname[$i_hosts] $tuserid '"     .
	      "export ORACLE_HOME=$orahome[$i_hosts];" . 
	      "export ORACLE_SID=$orasid[$i_hosts];"   .
	      "export PAGER_EMAIL=$pager_email[$i_hosts];"   .
	      "export PATH=\$PATH:$orahome[$i_hosts]/bin;" ;
	  $cmdsfx[$i_hosts]="'";
	  $remshcmd[$i_hosts] = "ssh";
	}
	else
	{
	  $cmdpfx[$i_hosts]=
	    "remsh $hostname[$i_hosts] $tuserid '"    .
	    "export ORACLE_HOME=$orahome[$i_hosts];"  .
	    "export ORACLE_SID=$orasid[$i_hosts];"    .
	    "export PAGER_EMAIL=$pager_email[$i_hosts];"    .
	    "export PATH=\$PATH:$orahome[$i_hosts]/bin;";
	  $cmdsfx[$i_hosts]="'";
	  $remshcmd[$i_hosts] = "remsh";
	}
      }

      if ($dbms[$i_hosts] eq "OracleApps")
      {
	if ($comm_method[$i_hosts] eq "ssh")
	{
	  $cmdpfx[$i_hosts]="ssh $hostname[$i_hosts] $tuserid " . 
	    "'export ORACLE_HOME=$orahome[$i_hosts] " .
	    ";export ORACLE_SID=$orasid[$i_hosts] " .
	    ";export PATH=\$PATH:$orahome[$i_hosts]/bin;" ;
	  $cmdsfx[$i_hosts]="'";
	  $remshcmd[$i_hosts] = "ssh";
	}
	else
	{
	  $cmdpfx[$i_hosts]="remsh $hostname[$i_hosts] $tuserid " .
	    "'export ORACLE_HOME=$orahome[$i_hosts] " .
	    ";export ORACLE_SID=$orasid[$i_hosts] " .
	    ";export PATH=\$PATH:$orahome[$i_hosts]/bin;" ;
	  $cmdsfx[$i_hosts]="'";
	  $remshcmd[$i_hosts] = "remsh";
	}
      }

      ##print "cmdpfx=$cmdpfx[$i_hosts]\n";

      if ($dbms[$i_hosts] eq "MSSQL")
      {
	$cmdpfx[$i_hosts]="remsh $hostname[$i_hosts] $tuserid '" ;
	$cmdsfx[$i_hosts]="'";
	$remshcmd[$i_hosts] = "remsh";
      }

      if ($dbms[$i_hosts] eq "OracleNT")
      {
	$cmdpfx[$i_hosts]="remsh $hostname[$i_hosts] $tuserid '" ;
	$cmdsfx[$i_hosts]="'";
	$remshcmd[$i_hosts] = "remsh";
      }

      ##print "parm remshcmd=" remshcmd[$i_hosts]

      if ($infver[$i_hosts] eq "7" && $lclrmt[$i_hosts] eq "R" && $sqlhosts[$i_hosts] eq "" && $memwin[$i_hosts] ne "")
      {
	$cmdpfx[$i_hosts]="remsh $hostname[$i_hosts] $tuserid \
	  'export INFORMIXDIR=$infdir[$i_hosts] \
	  ;export INFORMIXSERVER=$server[$i_hosts] \
	  ;export ONCONFIG=$config[$i_hosts] \
	  ;setmemwindow -i $memwin[$i_hosts] -p \$\$ \
	  ;$infdir[$i_hosts]/bin/";
	$cmdsfx[$i_hosts]="'";
      }

      if ($infver[$i_hosts] eq "7" && $lclrmt[$i_hosts] eq "R" && $sqlhosts[$i_hosts] ne "" && $memwin[$i_hosts] ne "")
      {
	$cmdpfx[$i_hosts]="remsh $hostname[$i_hosts] $tuserid \
	  'export INFORMIXDIR=$infdir[$i_hosts] \
	  ;export INFORMIXSERVER=$server[$i_hosts] \
	  ;export ONCONFIG=$config[$i_hosts] \
	  ;export INFORMIXSQLHOSTS=$sqlhosts[$i_hosts] \
	  ;setmemwindow -i $memwin[$i_hosts] -p \$\$ \
	  ;$infdir[$i_hosts]/bin/";
	$cmdsfx[$i_hosts]="'";
      }

    } # end of if dbcfile = ...

  } # end of DBCFILE foreach

  # Save number of highest host
  $high_host = $i_hosts;
  ##print "hh=$high_host ih=$i_hosts \n";

  if ($high_host == 0 || $high_host eq "")
  {
    &logit("0 Instances to monitor - Server Name Prefix for this task=$dbamon_alpha - Sleeping forever");
    sleep;
    exit 1;
  }

  # Re-process hosts entries to pad for title with longest length
  $spaces = "                                                    ";
  $i = 1;

  while ($i <= $high_host) 
  {
    &logit("Including Instance: i=$i host=$hostname[$i] cm=$comm_method[$i] u=$userid[$i] dbms=$dbms[$i]");
    &logit("                    dbcfile=$dbcfilename[$i]");
    @words = split(/\./,$hostname[$i]);
    $hostname_first = $words[0];

    # BB Test to accomodate multiple processes writing to the same log
    $longest = 32;

    $infname[$i] .= "_AppSrvr" if $what[$i] eq "AP";

    $title[$i] = substr("${hostname_first}:${infname[$i]}$spaces",0,$longest);

    # titleraw was added to have a way to grep for the host-instance
    # name in the dbspace history file to avoid duplicate entries
    # when the length of title shortens (bb 11Dec98)

    $hostfix[$i]   = $hostname_first;
    $titleraw[$i]  = "${hostname_first}:$infname[$i]";
    $inhibfile[$i] = "${hostname_first}_$server[$i]";
    $titlehist[$i] = "${hostname_first}_" . uc $infname[$i];
    chop($fqhostname[$i] = `nslookup $hostname[$i] | grep Name: | awk '{ print \$2 }'`);

    # Get the network location for this host
    $z = index($fqhostname[$i], '.');
    $serverloc[$i] = substr($fqhostname[$i],$z+1);
    ##print "fqhostname=$fqhostname[$i] serverloc=$serverloc[$i] z=$z\n";
    
    if ($pager_subject[$i] ne "" || $pager_email[$i] ne "") 
    { 
      $pager_flag[$i] = 1; 
    }
    else                                                
    { 
      $pager_flag[$i] = 0;
    }

    # bb 17May00 3.23.A Backup-only monitoring implies MBUN
    ##print "runmon=" runmon[$i]
    if ($runmon[$i] eq "B") 
    {
      $t_mustbeup[$i] = "N";
      $t_diskwarn[$i] = 999;
      $t_diskcrit[$i] = 999;
      $msg = sprintf("Since Monitor: is B then Must_Be_Up: Set to N and Full Thresholds set to 999 - %s",$title[$i]);
      logit($msg);
    }

    $save_file[$i] = "$save_dir/config.$hostname[$i]_$infname[$i]";

    $html_events[$i] = "$html_events_dir/${hostname_first}:$infname[$i].html.new";

    $html_events_perm[$i] = "$html_events_dir/${hostname_first}:$infname[$i].html";
    $html_events_flag[$i] = 0;

    if ($arg eq "test") { $z = "/opt/dbamon/htm/details_test/" }
    else                { $z = "/opt/dbamon/htm/details/" }

    $html_details[$i]      = "${z}${hostname_first}:$infname[$i].html.new";
    $html_details_perm[$i] = "${z}${hostname_first}:$infname[$i].html";
    $html_details_flag[$i] = 0;
    system("mkdir $z 2>/dev/null");

    if ($dbms[$i] eq "SAP") 
    {
      $dbmsout[$i] = "SAP";
      $dbms_color[$i] = "violet";
    }
    if ($dbms[$i] eq "Informix") 
    {
      $dbmsout[$i] = "Informix-UX";
      $dbms_color[$i] = "darkblue";
    }
    if ($dbms[$i] eq "Oracle")     
    {
      $dbmsout[$i] = "OracleDB-UX";
      $dbms_color[$i] = "red";
      &error_msg("Configuration Error: ORACLE_SID Cannot Be Null - Host: $hostname[$i]",$i) 
        if $orasid[$i] eq "";
      &error_msg("Configuration Error: ORACLE_HOME Cannot Be Null - Host: $hostname[$i]",$i) 
        if $orahome[$i] eq "";
    }
    if ($dbms[$i] eq "OracleApps") 
    {
      $dbmsout[$i] = "OracleApps";
      $dbms_color[$i] = "darkred";
    }
    if ($dbms[$i] eq "OracleNT")   
    {
      $dbmsout[$i] = "OracleDB-NT";
      $dbms_color[$i] = "ff0090";
    }
    if ($dbms[$i] eq "MSSQL")      
    {
      $dbmsout[$i] = "MSSQL";
      $dbms_color[$i] = "green";
    }

    # Start - Debug a problem
    ##print "readDBC() - m_critical=$m_critical[$i] title=$title[$i]\n";
    # End   - Debug a problem


    # If there were any parm errors, create an event now
    if ($parm_errors[$i] ne "")
    {
      open(TMPFL6, ">$tmpfl6") || &error_msg("Can't open output $tmpfl6 - $!");
      print TMPFL6 $parm_errors[$i];
      close(TMPFL6);
      &event("C",$i,"Error(s) Found in DBC File: $dbcfilename[$i]","DBCErr","DBA020",$tmpfl6);
      &logit("Error(s) Found in DBC File: $dbcfilename[$i]");
    }

    $i++;
  }

  # Wrapup
  ##$msg = sprintf("Read %s Host: definitions - longest title=%s",$high_host,$longest);
  &logit("$high_host Instance(s) Will Be Monitored By This Task");

  $dbmslist = "";
  ##print "num_informix=$num_informix \n";
  if ($num_oracleapps   > 0) { $dbmslist .= "OracleApps,"; }
  if ($num_oracle       > 0) { $dbmslist .= "OracleDB,"; }
  if ($num_informix     > 0) { $dbmslist .= "Informix,"; }
  if ($num_mssql        > 0) { $dbmslist .= "MSSQL,"; }
  if ($num_oraclent     > 0) { $dbmslist .= "OracleNT,"; }
  if ($num_sap          > 0) { $dbmslist .= "SAP,"; }
  &logit("DBMS(s)/Appl(s) That Will Be Monitored: $dbmslist");

  # Write to task table
  if ($use_oracle eq "Y")
  {
    if ($dbamon_alpha eq "") { $z = "*" }
    else                     { $z = $dbamon_alpha }

    $statement  = "delete from dbamon.task where dbamonmode = '$modeout' and iter_num = '0'";
    runSQL($statement);
 
    $statement  = "
      insert into dbamon.task
      (dbamonmode,pid,starttime_num,starttime_char,alpha,iter_num,iter_dur,num_instances)
      values
      (\'$modeout\',\'$pid\', \'$time_processes\', \'$ts_processes\', \'$z\', \'0\',\'0\',\'$high_host\') ";
    runSQL($statement);
   
    # Nullify html_sys_path
    $html_sys_path = "/dev/null";
  }
  # Start - Debug a problem
  ##print "readDBC() - num_oracle=$num_oracle\n";
  # End   - Debug a problem

  # Read distlist data from repository
  &readDist;
}

# -----------------------------------------------------------------------------
1;
