# -----------------------------------------------------------------------------
sub sapUp
{
  ($thishost) = @_;

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  if ($up[$thishost] eq "D")
  {
    logit("(No software download)",$thishost);
    return;
  }

  # Start with a clean slate
  $up[$thishost] = "";

  $cmd = "/tmp/dbamon_sap.pl $sapsid[$thishost] up";
  ##print "cmd=$cmd \n";

  $must_connect = 1;

  ##print "up before=$up[$thishost]\n"; 
  &remsh($cmd,$tmpfl3,$thishost);
  ##print "up after=$up[$thishost]\n"; 

  ##system("cat $tmpfl3");

  if ($up[$thishost] eq "N")     # Remsh error
  {
    &logit("(Connect Error)",$thishost);
    return;
  }

  if ($t_mustbeup[$thishost] eq "Y") { $downsev = "C"; }
  else                               { $downsev = "I"; }

  $ngflag = "";

  open(TMPFL3, "$tmpfl3"  ) || &error_msg("Can't open input $tmpfl3 - $!");
  while(<TMPFL3>)
  {
    &parse;
    if ($F1 eq "Hostname:")      { $applhost = $F2; }

    if ($F1 eq "Physical_RAM_MB:")  { $hw_memory[$thishost] = $F2 }
    if ($F1 eq "Num_Processors:")   { $hw_processors[$thishost] = $F2 }
    if ($F1 eq "SAPVERSION:")       { $sw_version[$thishost] = $F2 }
    if ($F1 eq "SAPNUMSTART:")   { $numstart = $F2 }
    if ($F1 eq "SAPNUMDW:")      { $numdw = $F2 }
    if ($F1 eq "SAPNUMMS:")      { $numms = $F2 }
    if ($F1 eq "SAPNUMCO:")      { $numco = $F2 }
    if ($F1 eq "SAPNUMSE:")      { $numse = $F2 }
    if ($F1 eq "PF:")            { $pf = $F2 }
    if ($F1 eq "DBMS:")          { $db = $F2 }
    if ($F1 eq "wp_no_dia:")     { $wp_no_dia = $F2 }
    if ($F1 eq "wp_no_btc:")     { $wp_no_btc = $F2 }
    if ($F1 eq "wp_no_enq:")     { $wp_no_enq = $F2 }
    if ($F1 eq "wp_no_spo:")     { $wp_no_spo = $F2 }
    if ($F1 eq "wp_no_vb:")      { $wp_no_vb  = $F2 }
    if ($F1 eq "wp_no_vb2:")     { $wp_no_vb2 = $F2 }
    if ($F1 eq "wp_total:")      { $wp_total  = $F2 }
    if ($F1 eq "wp_shouldberunning:")      { $wp_shouldbe  = $F2 }

    if ($F1 eq "MODE" && $F2 ne "getconf")
    {
      $os_mode[$thishost] = $F2
    }

    if (substr($F1,0,4) eq "9000")
    {
      @words = split(/\//,$F0);
      $model = $words[2];
      $hw_model[$thishost] = $model;
    }
    if ($F1 eq "HP-UX")
    {
      $os_version[$thishost] = substr($F3,2);
    }
    if ($F5 eq "ErrorProcesses:") 
    {
      $errorprocesses = $F6 . $F7 . $F8 . $F9 . $F10 . $F11 . $F12 . $F13 . $F14 . $F15;
    }
    if ($F4 eq "PROCESSSTART")
    {
      $ngflag = 1;
      &event("$downsev",$thishost,"$applhost - SAP Down - sapstart Process Not Running - Number Found: $F5 - Should Be: $F6","SAPDown","DBA101$downsev",$tmpfl3);
    }
    if ($F4 eq "PROCESSERROR")
    {
      $ngflag = 1;
      &event("$downsev",$thishost,"$applhost - Missing $F3 process(es) - Number Found: $F5 - Should Be: $F6","MissProc","DBA101$downsev",$tmpfl3);
    }
    if ($F2 eq "DBCHECKNG")
    {
      $ngflag = 1;
      &event("$downsev",$thishost,"$applhost - SAP (R3check) Cannot Connect to DB","DBConn","DBA102$downsev",$tmpfl3);
    }
    if ($F1 eq "BDFUSRSAPDIR:")
    {
      $bdfsize = $F2;
      $bdfused = $F3;
      $bdfaval = $F4;
      $bdfpct  = $F5;
      $bdfname = $F6;
      $bdfflag = $F7;
      if ($bdfflag ne "OK")
      {
	if ($bdfflag eq "C")
	{
	  &event("C",$thishost,"$applhost - /usr/sap/SID Filesystem is $bdfpct full ($bdfaval MB Free)","SAPDirFull","DBA165C",$tmpfl3);
	}
	else
	{
	  &event("C",$thishost,"$applhost - Error running bdf /usr/sap/SID","SAPDirErr","DBA166C",$tmpfl3);
	}
      }
    }
  }
  close(TMPFL3);

  if ($sw_version[$thishost] lt $ver_sap_low  || $ver_sap_low eq "" ) { $ver_sap_low  = $sw_version[$thishost] }
  if ($sw_version[$thishost] gt $ver_sap_high || $ver_sap_high eq "") { $ver_sap_high = $sw_version[$thishost] }


  &logDetails($thishost,"<h3>Server Data</h3>");
  &logDetails($thishost,"<table border=1>");
  &logDetails($thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>");
  &logDetails($thishost,"<tr><td><b>OS Type:<td align=right>$os[$thishost]");
  &logDetails($thishost,"<tr><td><b>OS Version:<td align=right>$os_version[$thishost]");
  &logDetails($thishost,"<tr><td><b>OS Mode:<td align=right>$os_mode[$thishost]<td>(32, 64 or Blank)");
  &logDetails($thishost,"<tr><td><b>Server Type:<td align=right>$hw_model[$thishost]");
  &logDetails($thishost,"<tr><td><b>Server Memory (MB):<td align=right>$hw_memory[$thishost]");
  &logDetails($thishost,"<tr><td><b>Server Processor Count:<td align=right>$hw_processors[$thishost]");
  &logDetails($thishost,"</table><hr>");

  &logDetails($thishost,"<h3>Server Data</h3>");
  &logDetails($thishost,"<table border=1>");
  &logDetails($thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>");
  &logDetails($thishost,"<tr><td><b>SAP Version:<td align=right>$sw_version[$thishost]");
  &logDetails($thishost,"<tr><td><b>DBMS:<td align=right>$db");
  &logDetails($thishost,"<tr><td><b>/usr/sap/SID FS Name:<td align=right>$bdfname<td>");
  &logDetails($thishost,"<tr><td><b>/usr/sap/SID FS Size(MB):<td align=right>$bdfsize<td>");
  &logDetails($thishost,"<tr><td><b>/usr/sap/SID FS Used(MB):<td align=right>$bdfused<td>");
  &logDetails($thishost,"<tr><td><b>/usr/sap/SID FS Available(MB):<td align=right>$bdfaval<td>");
  &logDetails($thishost,"<tr><td><b>/usr/sap/SID FS Percent Full:<td align=right>$bdfpct<td>");
  &logDetails($thishost,"<tr><td><b>/usr/sap/SID FS Status Flag:<td align=right>$bdfflag<td>");
  &logDetails($thishost,"<tr><td><b>SAP Profile: <td align=right>$pf<td>");
  &logDetails($thishost,"<tr><td><b>SAP Profile Parameter: wp_no_dia <td align=right>$wp_no_dia<td>");
  &logDetails($thishost,"<tr><td><b>SAP Profile Parameter: wp_no_btc <td align=right>$wp_no_btc<td>");
  &logDetails($thishost,"<tr><td><b>SAP Profile Parameter: wp_no_enq <td align=right>$wp_no_enq<td>");
  &logDetails($thishost,"<tr><td><b>SAP Profile Parameter: wp_no_spo <td align=right>$wp_no_spo<td>");
  &logDetails($thishost,"<tr><td><b>SAP Profile Parameter: wp_no_vb  <td align=right>$wp_no_vb<td>");
  &logDetails($thishost,"<tr><td><b>SAP Profile Parameter: wp_no_vb2 <td align=right>$wp_no_vb2<td>");
  &logDetails($thishost,"<tr><td><b>Total wp_no_* Count: <td align=right>$wp_total<td>");
  &logDetails($thishost,"<tr><td><b>sapstart Process Count:<td align=right>$numstart");
  &logDetails($thishost,"<tr><td><b>Number of wp Processes That Should Be Running: <td align=right>$wp_shouldbe<td>");
  &logDetails($thishost,"<tr><td><b>dw Process Count:<td align=right>$numdw");
  &logDetails($thishost,"<tr><td><b>ms Process Count:<td align=right>$numms");
  &logDetails($thishost,"<tr><td><b>co Process Count:<td align=right>$numco");
  &logDetails($thishost,"</table><hr>");
  
  &history_dummy($thishost);
  &histCreate("sapUp()",$thishost,"INS",".",0,0);

  $backup_method_long[$thishost] = "N/A";

  if (! $ngflag)
  {
    $up[$thishost] = "Y";
    &logit("OK - numdw=$numdw numms=$numms numco=$numco wp_total=$wp_total numstart=$numstart pf=$pf",$thishost);
  }
}
# -----------------------------------------------------------------------------
1;
