#--------------------------------------------------------------------------------
sub warn_msg
#
# Send warning msg
#
{
  ($m, $h, $f) = @_;

  #
  # Log message and file
  #

  &log_msg($m,$h);
  if ($f ne "") 
  {
    &log_file($f,$h);
  }

  #
  # Optionally invoke userexit 
  #
  if (-x "/opt/dbamon/bin/userexit/warn_msg") 
  {
    logit("Invoking userexit: warn_msg");
    system("export D_HOST=$title[$h];export D_MSG='$m';export D_FILE=$f;/opt/dbamon/bin/userexit/warn_msg");
  }

  if ($short ne "")
  {
    $z = "<font color=yellow>$short</font>";
    if (index($msgs[$h],$z) == -1) { $msgs[$h] .= "$z "; }
    $short = "";
  }

  
  if ($arg eq "test")
  {
    logit("Test Mode - NOT sending OpC message",$h);
    return 0;
  }

  #
  # Send opc message warn_msg
  #

  if ($opc_appl[$h] ne "" && $opc eq "Y")
  {
    $_ = $m;
    s/\*//g;
    s/!//g;
    $mm = $_;

    &logit("Sending OpC Message",$h);

    if (substr($os_version[$h],0,1) eq "1")
    {
      $cmd = "remsh $opc_gw[$h] '/opt/OV/bin/OpC/opcmsg severity=warning application=\"$opc_appl[$h]\" object=$opc_obj[$h] msg_text=\"$mm $opc_trailer\" $msg_grp=$opc_mg[$h] '";
    }
    else
    {
      $cmd = "remsh $opc_gw[$h] '/usr/OV/bin/OpC/opcmsg severity=warning application=\"$opc_appl[$h]\" object=$opc_obj[$h] msg_text=\"$mm $opc_trailer\" $msg_grp=$opc_mg[$h]'";
    }

    if ($debug_opc) { printf("About to execute: %s\n",$cmd) }
    $rc = system($cmd);
    if ($rc != 0)   { printf("Command rc=%s\n",$rc); }
  }
}
#--------------------------------------------------------------------------------
1;
