# -----------------------------------------------------------------------------
sub orantUp
# -----------------------------------------------------------------------------
# Changes:
#   26Jan05 - Added spfile checking
# -----------------------------------------------------------------------------
{
  ($thishost) = @_;
  #
  # Get Instance online data
  #

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  if ($up[$thishost] eq "D")
  {
    logit("(No software download)",$thishost);
    return;
  }

  # Start with a clean slate
  $up[$thishost] = "";

  $must_connect = 1;
  &remsh("$perlpath[$thishost] $probe[$thishost] $orasid[$thishost] up $t_diskwarn[$thishost] $t_diskcrit[$thishost] $t_freespace[$thishost] '$ts_command[$thishost]'",$tmpfl3,$thishost);
  if ($up[$thishost] eq "N")     # Remsh error
  {
    logit("(Connect Error)",$thishost);
    return;
  }

  system("cp $tmpfl3 /tmp/dbamondebug_orant.txt 2>&1");

  $dbstatus = "";
  $total_size = "";
  $total_used = "";
  $pgmflag = 0;

  $total_size = 0;
  $total_free = 0;
  $total_used = 0;
  $total_df   = 0;

  $orantTSStack[$thishost] = "";

  $bufhitratio[$thishost] = -1;
  $bufhitratio_xr[$thishost] = -1;
  $libhitratio[$thishost] = -1;
  $dicthitratio[$thishost] = -1;
  $bufcongets[$thishost] = -1;
  $bufblkgets[$thishost] = -1;
  $num_otrace[$thishost] = "";
  $sql_trace[$thishost] = "";
  $libgets[$thishost] = "";
  $dictgets[$thishost] = "";
  $rollback_wtg[$thishost] = "";
  $cfdrives[$thishost] = ""; 
  $cfdrivecount[$thishost] = ""; 
  $cfcount[$thishost] = ""; 
  $rldrives[$thishost] = ""; 
  $rldrivecount[$thishost] = ""; 
  $rlcount[$thishost] = ""; 

  open(TMPFL3,"$tmpfl3") || &error_msg("Can't open input $tmpfl3 - $!");
  while (<TMPFL3>)
  {
    &parse;
    if ($F1 eq "DBVersion:")    { $sw_version[$thishost] = $F2 }
    if ($F1 eq "OSVer:")        { $os_version[$thishost] = $F2 }
    if ($F1 eq "DBStatus:")     { $dbstatus = $F2 }
    if ($F1 eq "NumCPUs:")      { $hw_processors[$thishost] = $F2 }
    if ($F1 eq "CPUModel:")     { $hw_model[$thishost] = $F2 }
    if ($F1 eq "RAM:")          { $hw_memory[$thishost] = $F2 }
    if ($F1 eq "SpaceAlloc:")   { $total_size = $F2 }
    if ($F1 eq "SpaceUsed:")    { $total_used = $F2 }
    if ($F1 eq "LSNRStatus:")   { $lsnr_status = $F2 }
    if ($F0 =~ /DoneOK/)        { $pgmflag = 1 }
    if ($F1 eq "SESSIONSHWM:")  { $sessionshwm[$thishost] = $F2 }
    if ($F1 eq "BUFHITRATIO:")  { $bufhitratio[$thishost] = $F2 }
    if ($F1 eq "LIBHITRATIO:")  { $libhitratio[$thishost] = $F2 }
    if ($F1 eq "DICTHITRATIO:") { $dicthitratio[$thishost] = $F2 }
    if ($F1 eq "RSHService:")  {  $rsh_service[$thishost] = $F2; }

    #dbamon_orant.pl CFDRIVES: FIL^M
    #dbamon_orant.pl CFDRIVECOUNT: 3^M
    #dbamon_orant.pl CFCOUNT: 3^M
    if ($F2 eq "CFDRIVES:")      {  $cfdrives[$thishost] = $F3; }
    if ($F2 eq "CFDRIVECOUNT:")  {  $cfdrivecount[$thishost] = $F3; }
    if ($F2 eq "CFCOUNT:")       {  $cfcount[$thishost] = $F3; }

    if ($F2 eq "RLDRIVES:")      {  $rldrives[$thishost] = $F3; }
    if ($F2 eq "RLDRIVECOUNT:")  {  $rldrivecount[$thishost] = $F3; }
    if ($F2 eq "RLCOUNT:")       {  $rlcount[$thishost] = $F3; }

    if ($F1 eq "Stack:" && $F2 eq "orantTSStack")
    {
      $orantTSStack[$thishost] .= $F0;
    } 

    #---- Security events - START
    if ($F2 eq "ORAFILEPERM:") 
    {
      $sec_fileperm[$thishost] .= substr($F0,index($F0,"Event:")); 
      $sec_fileperm_cnt[$thishost]++;
    }

    if ($F2 eq "DBAGROUP_GROUP:") 
    {
      $sec_dbagrp_g[$thishost] .= "User=$F3 (/etc/group)\n";
      $sec_dbagrp_g_cnt[$thishost]++;
    }

    if ($F2 eq "DBAGROUP_PASSWD:") 
    {
      $sec_dbagrp_p[$thishost] .= "User=$F3 (/etc/passwd)\n";
      $sec_dbagrp_p_cnt[$thishost]++;
    }
    #---- Security events - END

    if ($F2 eq "NUM_OTRACE:")  { $num_otrace[$thishost] = $F3 }
    if ($F2 eq "SQL_TRACE:")   { $sql_trace[$thishost] = $F3 }

    if ($F2 eq "SGA:") 
    {
      $sga_pct[$thishost] = $F3;
      $sga_size[$thishost] = $F4;
      $sga_free[$thishost] = $F5;
      ##print "$title[$thishost] sga_pct=$sga_pct[$thishost] sga_size=$sga_size[$thishost] sga_free=$sga_free[$thishost]\n";
      $sga_pct[$thishost] = sprintf("%.2f", $sga_pct[$thishost]);
    }

    if ($F2 eq "UPTIME:")  #---- New
    {
      $str_c = $F3;
      $str_n = $F4;
      $end_c = $F5;
      $end_n = $F6;
      &uptimeLog($thishost);
    }

    #---- FUTURE
    #if ($F2 eq "MAXPROCESSES:") 
    #{
    #  $maxprocesses = 1;
    #  $maxprocesscnt = $F3;
    #}

    if ($F2 eq "BUFCONGETS:")     { $bufcongets[$thishost] = $F3; }
    if ($F2 eq "BUFBLKGETS:")     { $bufblkgets[$thishost] = $F3; }
    if ($F2 eq "BUFPHYSREADS:")   { $bufphysreads[$thishost] = $F3; }
    if ($F2 eq "BUFHITRATIO_XR:") { $bufhitratio_xr[$thishost] = sprintf("%.2f", $F3); } 
    if ($F2 eq "BUFHITRATIO:") 
    {
      if ($bufphysreads[$thishost] =~ /^1.844/ && $pool_default_hr[$thishost] > 0)
      {
        $bufhitratio[$thishost] = $pool_default_hr[$thishost];
      }
      else
      {
        $bufhitratio[$thishost] = $F3;
      }
      &histCreate("oraUp()",$thishost,"PER","bufhitratio",$bufhitratio[$thishost]);
    }

    if ($F2 eq "LIBHITRATIO:") 
    {
      $libhitratio[$thishost] = $F3;
      &histCreate("oraUp()",$thishost,"PER","libhitratio",$libhitratio[$thishost]);
    }

    if ($F2 eq "DICTHITRATIO:") 
    {
      $dicthitratio[$thishost] = $F3;
      &histCreate("oraUp()",$thishost,"PER","dicthitratio",$dicthitratio[$thishost]);
    }

    if ($F2 eq "FREE_BUFFERS:")
    { 
      $free_buffers[$thishost] = $F3; 
      ##print "$titleraw[$thishost] fb=$free_buffers[$thishost] F3=$F3\n"; 
    }

    if ($F2 eq "SPFILE:") 
    {
      $spfile[$thishost] = $F3;
      ##print "$titleraw[$thishost] spfile=$spfile[$thishost] F3=$F3\n";
    }

    if ($F2 eq "Rollback_Waits_To_Gets:") { $rollback_wtg[$thishost] = $F3; }
    if ($F2 eq "LIBGETS:")          { $libgets[$thishost] = $F3; }
    if ($F2 eq "DICTGETS:")         { $dictgets[$thishost] = $F3; }
    if ($F2 eq "ASYNCIO:")          { $asyncio[$thishost] = $F3; }
    if ($F2 eq "DB_BLOCK_BUFFERS:") { $db_block_buffers[$thishost] = $F3; }
    if ($F2 eq "DB_BLOCK_SIZE:")    { $db_block_size[$thishost] = $F3; }
    if ($F2 eq "DB_CACHE_SIZE:")    { $db_cache_size[$thishost] = $F3; }
    if ($F2 eq "POOL_DEFAULT_HR:")  { $pool_default_hr[$thishost] = $F3; }
    if ($F2 eq "POOL_RECYCLE_HR:")  { $pool_recycle_hr[$thishost] = $F3; }
    if ($F2 eq "POOL_KEEP_HR:")     { $pool_keep_hr[$thishost] = $F3; }
  }
  close(TMPFL3);

  if ($sw_version[$thishost] lt $ver_oraclent_low  || $ver_oraclent_low eq "" ) { $ver_oraclent_low  = $sw_version[$thishost] }
  if ($sw_version[$thishost] gt $ver_oraclent_high || $ver_oraclent_high eq "") { $ver_oraclent_high = $sw_version[$thishost] }

  $system_size[$thishost] = $total_size / 1000;
  $system_used[$thishost] = $total_used / 1000;
  $grand_total_size += ($total_size / 1000);

  $reason = "";  # Fill in later

  # Check listener
  if ($up[$thishost] ne "N" && $lsnr_status ne "OK")
  {
    $up[$thishost] = "N";
    &event("C",$thishost,"Oracle/NT Listener Not Active - Status=$lsnr_status","LsnrDown","DBA903C",$tmpfl3);
  }

  # Check status
  if ($dbstatus ne "UP")
  {
    $up[$thishost] = "N";
    $download_flag[$thishost] = 0;

    if ($t_mustbeup[$thishost] eq "Y")
    {
      &event("C",$thishost,"Oracle/NT Not Active - Status=$dbstatus","Down","DBA901C",$tmpfl3);
    }
    else
    {
      &event("I",$thishost,"Oracle/NT Not Active - Status=$dbstatus","Down","DBA901I",$tmpfl3);
    }
  }
  else
  {
    $up[$thishost] = "Y";
    $msg = sprintf("OK");
    &logit($msg,$thishost);
  }

  if ($g_spfile eq "Y" && $spfile[$thishost] ne "")
  {
    &event("W",$thishost,"This Oracle instances uses SPFILE - spfile=$spfile[$thishost]","SPFile","DBA399",$tmpfl6);
  }

  #---- Controlfile events
  if ($cfcount[$thishost] && $cfcount[$thishost] > 0 && $cfcount[$thishost] < $df_t_cf_min)
  {
    &event("C",$thishost,"You only have $cfcount[$thishost] controlfile(s) - You should have at least $df_t_cf_min","CF-Count","DBA659");
  }
  if ($cfdrivecount[$thishost] == 1)
  {
    &event("C",$thishost,"All controlfiles are one 1 Drive - They should be spread out to multiple drives","CFs-On-1-Drive","DBA654");
  }

  #---- redo log events
  if ($rlcount[$thishost] && $rlcount[$thishost] > 0 && $rlcount[$thishost] < 2)
  {
    &event("C",$thishost,"You only have $rlcount[$thishost] onlineredologs(s) - You should have at least 2","CF-Count","DBA659");
  }
  if ($rldrivecount[$thishost] == 1)
  {
    &event("C",$thishost,"All OnlineRedoLogs are one 1 Drive - They should be spread out to multiple drives","Redos-On-1-Drive","DBA655");
  }

  &histCreate("orantUp()",$thishost,"STA","sessionshwm",$sessionshwm[$thishost]);
  &histCreate("orantUp()",$thishost,"PER","bufhitratio",$bufhitratio[$thishost]);
  &histCreate("orantUp()",$thishost,"PER","libhitratio",$libhitratio[$thishost]);
  &histCreate("orantUp()",$thishost,"PER","dicthitratio",$dicthitratio[$thishost]);

  &logDetails($thishost,"<h3>Oracle Instance Data</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>");

  &logDetails($thishost,"<tr><td><b>$f_s Oracle Version:<td align=right>$f_s  $sw_version[$thishost]");
  &logDetails($thishost,"<tr><td><b>$f_s ORACLE_SID:<td align=right>$f_s  $orasid[$thishost]");
  &logDetails($thishost,"<tr><td><b>$f_s ORACLE_HOME:<td align=right>$f_s  $orahome[$thishost]");
  &logDetails($thishost,"<tr><td><b>$f_s DB_Block_Size:<td align=right>$f_s  $db_block_size[$thishost]");
  &logDetails($thishost,"<tr><td>$f_s <b>SPFILE:<td align=right>$f_s $spfile[$thishost]");
  #logDetails($thishost,"<tr><td><b>$f_s Concurrent Sessions HWM:<td align=right>$f_s  $sessionshwm[$thishost]");
  #logDetails($thishost,"<tr><td><b>$f_s Buffer Cache Hit Ratio:<td align=right>$f_s  $bufhitratio[$thishost]");
  #logDetails($thishost,"<tr><td><b>$f_s Library Cache Hit Ratio:<td align=right>$f_s  $libhitratio[$thishost]");
  #logDetails($thishost,"<tr><td><b>$f_s Dictionary Cache Hit Ratio:<td align=right>$f_s  $dicthitratio[$thishost]");
  #logDetails($thishost,"<tr><td><b>$f_s ORACLE_HOME Disk % Full:<td align=right>$f_s  $homefull[$thishost]");

  &logDetails($thishost,"<tr><td><b>$f_s Oracle Up?<td align=right>$f_s  $up[$thishost] <td>$f_s (Y or N)");
  &logDetails($thishost,"<tr><td><b>$f_s Controlfile Count<td align=right>$f_s  $cfcount[$thishost] ");
  &logDetails($thishost,"<tr><td><b>$f_s Controlfile Drive List<td align=right>$f_s  $cfdrives[$thishost] ");
  &logDetails($thishost,"<tr><td><b>$f_s Controlfile Drive Count<td align=right>$f_s  $cfdrivecount[$thishost] ");

  &logDetails($thishost,"<tr><td><b>$f_s Online Redo Log Count<td align=right>$f_s  $rlcount[$thishost] ");
  &logDetails($thishost,"<tr><td><b>$f_s Online Redo Log Drive List<td align=right>$f_s  $rldrives[$thishost] ");
  &logDetails($thishost,"<tr><td><b>$f_s Online Redo Log Drive Count<td align=right>$f_s  $rldrivecount[$thishost] ");

  #logDetails($thishost,"<tr><td><b>$f_s Oracle OPS Mode?:<td align=right>$f_s  $ops[$thishost] <td>");
  #logDetails($thishost,"<tr><td><b>$f_s Oracle OPS Instance Number:<td align=right>$f_s  $inst_num[$thishost] <td>");
  #logDetails($thishost,"<tr><td><b>$f_s Oracle Standby Mode?:<td align=right>$f_s  $standby[$thishost] <td>$f_s (CURRENT or STANDBY)");
  &logDetails($thishost,"</table><hr>");

  &logDetails($thishost,"<h3>STAR Data</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>");
  &logDetails($thishost,"<tr><td>$f_s <b>STAR Contacts:<td>$f_s $star_contacts[$thishost] ");
  &logDetails($thishost,"</table><hr>");

  &logDetails($thishost,"<h3>Server Data</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>");
  &logDetails($thishost,"<tr><td><b>$f_s OS Type:<td align=right>$f_s  $os[$thishost] ");
  &logDetails($thishost,"<tr><td><b>$f_s OS Version:<td align=right>$f_s  $os_version[$thishost]");
  &logDetails($thishost,"<tr><td><b>$f_s Server Type:<td align=right>$f_s  $hw_model[$thishost]");
  &logDetails($thishost,"<tr><td><b>$f_s Server Memory (MB):<td align=right>$f_s  $hw_memory[$thishost]");
  &logDetails($thishost,"<tr><td><b>$f_s Server Processor Count:<td align=right>$f_s  $hw_processors[$thishost]");
  &logDetails($thishost,"</table><hr>");

  # Read SWVer data

  #print "DEBUG: t1 ($titleraw[$thishost] $dbmsout[$thishost] $sw_version[$thishost])\n";
  #foreach (@swver_data)
  #{
  #  print "BEFORE: $_\n"; 
  #}

  foreach $swver_rec (@swver_data)
  {
    next if $swver_rec !~ /^$dbmsout[$thishost]/;

    @words = split(' ',$swver_rec);
    $this_family = $words[1];
    $this_minver = $words[2];

    ##print "DEBUG: $titleraw[$thishost] $sw_version[$thishost] - Found this_family=$this_family this_minver=$this_minver\n";

    #---- Continue only if this is OUR family
    next if $sw_version[$thishost] !~ /^$this_family/;

    $z = length($this_minver);

    ##$z1 = $sw_version[$thishost],0,$z;
    ##print "DEBUG: z=$z z1=$z1 this_minver=$this_minver ($titleraw[$thishost])\n";

    if (substr($sw_version[$thishost],0,$z) lt $this_minver)
    {
      &event("U",$thishost,"$dbmsout[$thishost] Version $sw_version[$thishost] is older than the minimum 'good' version ($this_minver) for this family ($this_family)","SWVER-OldVer","DBA652");
    }
  }

  #foreach (@swver_data)
  #{
  #  print "AFTER: $_\n"; 
  #}

  $dblist[$thishost] = $orasid[$thishost] . "\n";
}

# -----------------------------------------------------------------------------
1;
