#-----------------------------------------------------------------------------
#
#  ####   #    #  #####    ####   #####   #####           #####   #
# #       #    #  #    #  #       #    #  #    #          #    #  #
#  ####   #    #  #####    ####   #    #  #####           #    #  #
#      #  #    #  #    #       #  #    #  #    #   ###    #####   #
# #    #  #    #  #    #  #    #  #    #  #    #   ###    #       #
#  ####    ####   #####    ####   #####   #####    ###    #       ######
#
#-----------------------------------------------------------------------------

#------------------------------------------------------------------------------
sub connectDB
#------------------------------------------------------------------------------
{
  use DBI;
  $user = "dbamon";
  $passwd = $oracle_password;
  $data_source = "DBI:Oracle";
  $database = $os;
  %attr = (
    PrintError => 0
  );
  $dbh = DBI->connect("$data_source:$database", $user, $passwd, \%attr) ||
    &error_msg("Cannot CONNECT to Oracle DB - ORACLE_SID=$ENV{'ORACLE_SID'}","","","Y");  # Fatal error
  $dbh->{LongReadLen} = 4000;
  ##print "dbh=$dbh  \n";
}

#-----------------------------------------------------------------------------
sub runSQL
#-----------------------------------------------------------------------------
{
  my ($sqlstmt,$nosqlerror) = @_;
  ##print "dbh=$dbh sqlstmt=$sqlstmt \n";

  if ($use_oracle ne "Y")
  {
    print "Error - should not be here - routine=$routine \n";
    return;
  }

  if (
       $DBI::errstr =~ /ORA-03114/ ||   # no connection
       $DBI::errstr =~ /ORA-01012/ ||   # not logged on
       $DBI::errstr =~ /ORA-00028/      # session killed
     )
  {
    &error_msg("DBAmon Lost ORACLE Connection - SQL Error=$DBI::errstr","","","Y");
  }

  if ($nosqlerror)
  {
    $sqlrc = $dbh->do($sqlstmt);
  }
  else
  {
    $sqlrc = $dbh->do($sqlstmt) || &error_msg("SQL Error=$DBI::errstr SQL Statement=$sqlstmt Failure");
  }
  $sqlerror = $DBI::errstr;
  $sqlcode = $dbh->err;
  $sqlrows = $dbh->rows;
  return $sqlrc;
}

#-----------------------------------------------------------------------------
sub runSQLBind
#-----------------------------------------------------------------------------
{
  ($sqlstmt) = @_;
  ##print "dbh=$dbh sqlstmt=$sqlstmt \n";

  if ($use_oracle ne "Y")
  {
    print "Error - should not be here - routine=$routine \n";
    return;
  }

  if (
       $DBI::errstr =~ /ORA-03114/ ||   # no connection
       $DBI::errstr =~ /ORA-01012/ ||   # not logged on
       $DBI::errstr =~ /ORA-00028/      # session killed
     )
  {
    &error_msg("DBAmon Lost ORACLE Connection - SQL Error=$DBI::errstr","","","Y");
  }

  $sth = $dbh->prepare($sqlstmt) || &error_msg("SQL Error=$DBI::errstr SQL Statement=$sqlstmt Failure");

  $sth->bind_param(1, $bind_1);

  $sqlrc = $sth->execute || &error_msg("SQL Error=$DBI::errstr SQL Statement=$sqlstmt Failure"); 
  
  $sqlerror = $DBI::errstr;
  $sqlcode = $dbh->err;
  $sqlrows = $dbh->rows;
  return $sqlrc;
}

1;
