#-----------------------------------------------------------------------------
sub verifyTables
#-----------------------------------------------------------------------------
{
  &logit("Verifying that all DBAmon repository tables exists");

  #---- Process each table definition in /opt/dbamon/sql
  $table_create_dir = "/opt/dbamon/sql/";
  opendir(IN_DIR, "$table_create_dir") || &error_msg("Cannot opendir $table_create_dir - $!");
  @in_files = readdir IN_DIR;
  closedir(IN_DIR); 
  foreach $verify_file (@in_files)
  {
    if ($verify_file =~ /^table_/)
    {
      $z = length($verify_file) - 10;
      $table = uc substr($verify_file,6,$z);
      ##&logit("  DEBUG Found table definition file=$verify_file table=$table");
      if (&verifyTablesCount("$table") != 1)
      {
        &verifyTablesCreate("$table");
      }
    }
  }
}

#-----------------------------------------------------------------------------
sub verifyTablesCount
#-----------------------------------------------------------------------------
{
  my $this_table = uc $_[0];
  $sql  = "
    select
      count(*)  
    from
      user_tables
    where
      table_name = '$this_table' 
  ";
  ##print "sql=$sql\n";
  $sth = $dbh->prepare($sql) || &error_msg('Select_$what');
  $sth->execute || &error_msg('Failed_on_DB_execute_in_chgEnt');
  $count = -1;
  while (@Data = $sth->fetchrow_array)
  {
    $count = $Data[0];
  }
  ##&logit("  DEBUG Table $this_table count=$count");
  return $count;
}

#-----------------------------------------------------------------------------
sub verifyTablesCreate
#-----------------------------------------------------------------------------
{
  my $this_table = uc $_[0];
  &logit("  Creating table $this_table"); 
  $rc = system("sqlplus dbamon/$oracle_password <<! > $tmpfl3 2>&1
    \@$table_create_dir/$verify_file ; 
    exit
  !");

  #---- Copy output to log
  system("cat $tmpfl3 >> /opt/dbamon/log/verifyTables.log"); 

  if ($rc != 0)
  {
    system("cat $tmpfl3 2>&1"); 
    &error_msg("Error creating table $this_table - $!"); 
  }
}

1;
