create table dbamon.history
  (
    dbamonmode       varchar2(8)                not null,
    instance         varchar2(32)               not null,
    system           varchar2(32)               not null,
    dbms             varchar2(16)               not null,
    category         varchar2(3)                not null,
    parm             varchar2(32)               not null,
    value            number(15,2)               not null,
    value2           number(15,2)               ,
    value3           number(15,2)               ,
    value4           number(15,2)               ,
    ts               date                       default sysdate,
    zdate            char(10)                   default to_char(sysdate,'YYYY/MM/DD')
  );

create unique index 
  dbamon.history_x1 
  on dbamon.history (dbamonmode,zdate,instance,category,parm)
  storage (initial 20m next 10m)  parallel tablespace dbamon_x;
create index 
  dbamon.history_x2 
  on dbamon.history (ts)
  storage (initial 20m next 10m)  parallel tablespace dbamon_x;
create index 
  dbamon.history_x3 
  on dbamon.history (instance,system)
  storage (initial 20m next 10m)  parallel tablespace dbamon_x;
