#***************************************************************************
#*          Copyright 2000 DBAmon Software, All Rights Reserved            *
#***************************************************************************

###############################################################################
#
#  #####   #####     ##    #    #   ####   #    #         ##    #    #  #    #
#  #    #  #    #   #  #   ##  ##  #    #  ##   #        #  #   #    #  #   #
#  #    #  #####   #    #  # ## #  #    #  # #  #       #    #  #    #  ####
#  #    #  #    #  ######  #    #  #    #  #  # #       ######  # ## #  #  #
#  #    #  #    #  #    #  #    #  #    #  #   ##  ###  #    #  ##  ##  #   #
#  #####   #####   #    #  #    #   ####   #    #  ###  #    #  #    #  #    #
#
###############################################################################
#
# (See DBAmon Home Page for change history)
#
###############################################################################

#-------------------------------------------------------------------------------
function sumprint(sum_h,sum_string,sum_flag,sum_size)   
#
# Write lines to the summary, and to Oracle
#
#-------------------------------------------------------------------------------
{
  if (sum_string != "")
  {
    print sum_string >> html_sys_path
  }

  if (use_oracle != "Y") 
  {
    return
  }

  if (sum_h != "")
  {
    ##print "appending to string"
    sum_long = sum_long "" sum_string
  }
  
  if (mode == "")
  {
    summode = "prod" dbamon_tasknum
  }
  else
  {
    summode = mode "" dbamon_tasknum
  }

  if (sum_flag == "S")
  {
    ##print "start of summary - nulling sum_long and deleting oracle data" 
    sum_long = ""
    cmd = pgmdir "/dbamon_ora_sumupdate.pl 'D' '" summode "'"
    rc = system(cmd)
  }
  if (sum_flag == "W")
  {
    gsub("\n"," ",sum_long)
    ##print "write to oracle - sum_long=" sum_long
    cmd = pgmdir "/dbamon_ora_sumupdate.pl 'I' '" summode "' '" hostname[sum_h] "' '" dbmsout[sum_h] "' '" title[sum_h] "' '" sum_size "' '" sum_long "'" 
    rc = system(cmd)
    sum_long = ""
  }
}


#-------------------------------------------------------------------------------
function sumtot(sum_flag,a1,a2,a3,a4)   
#
# Write lines to the summary, and to Oracle
#
#-------------------------------------------------------------------------------
{
  if (use_oracle != "Y") 
  {
    return
  }

  if (mode == "")
  {
    summode = "prod" dbamon_tasknum
  }
  else
  {
    summode = mode "" dbamon_tasknum
  }

  cmd = pgmdir "/dbamon_ora_sumupdate.pl " sum_flag " " summode " '" a1 "' '" a2 "' '" a3 "' '" a4 "'"
  ##print "cmd=" cmd
  rc = system(cmd)
}

#-------------------------------------------------------------------------------
function histCreate(caller,h,c,p,v)   
# Create a row in the Oracle dbamon.history table 
#-------------------------------------------------------------------------------
{
  if (use_oracle != "Y") 
  {
    msg = sprintf("histCreate() Use_Oracle != Y - returning")
    logit(msg,h)
  }

  if (v == "" || v < 0) 
  {
    v = -1   # Hmmmm?????
  }

  if (iter_count == 1 || (iter_count/10 == int(iter_count/10))) 
  {
    rc = system("dbamon_ora_histupdate.pl I " mode " " titlehist[h] " " hostname[h] " " dbmsout[h] " " c " " p " " v " > " tmpfl8 " 2>&1")
    if (rc != 0 && rc != 2)
    {
      msg = sprintf("histCreate() dbamon_ora_histupdate (%s %s %s) Ended with rc=%s",c,p,v,rc)
      logit(msg,h,tmpfl8)
      error_msg(msg,h,tmpfl8)
    }
    else
    {
      if (rc == 2) 
      {
        msghist = "(Duplicate Row)";
      }
      if (rc == 0) 
      {
        msghist = "(Normal Insert)";
      }
      msg = sprintf("histCreate() dbamon_ora_histupdate (%s %s %s) Ended with NORMAL rc=%s %s",c,p,v,rc,msghist)
      logit(msg,h)
    }
  }
  else
  {
    #msg = sprintf("histCreate() Not this iteration (%s) - returning",iter_count)
    #logit(msg,h)
  }
}

#-------------------------------------------------------------------------------
function history_dummy(h)   
#
# Create dummy history data if needed for monitor=n/b instances
#
#-------------------------------------------------------------------------------
{
  # Check to see if  we need to create history data

  "date +%C%y.%m.%d " | getline filedate
  close "date +%C%y.%m.%d "
  "date +%H:%M:%S " | getline filetime
  close "date +%H:%M:%S "
 
  hist_flag = 0
  if (system("grep '" titleraw[h] "' " hstdir "/dbspaces/"filedate" > /dev/null 2>&1") != 0)
  {
    msg = sprintf("Creating tblspace history data")
    logit(msg,h)
    system("rm " tmpflt " > /dev/null 2>&1")
    ts = "DUMMY"
    mbsize = 0
    mbused = 0
    print filedate " " filetime " " title[h] " " ts " .  " mbsize " " mbused " " dbms[h] >> hstdir "/dbspaces/"filedate
  }
}

#-------------------------------------------------------------------------------
function logit(m,h)   
#
# Write a standardized message to stdout
#
{
  "date +%Y/%m/%d-%H:%M:%S" | getline nowdate
  close "date +%Y/%m/%d-%H:%M:%S" 

  z = mode "" dbamon_tasknum

  if (wheretolog == "S")
  {
    if (h == "")
    {
      printf("%s DBAmon %s %3s | %s\n",nowdate,z,iter_count,m) 
    }
    else
    {
      printf("%s DBAmon %s %3s | " title[h] " | %s: %s\n",nowdate,z,iter_count,this_function,m) 
    }
  }
  else
  {
    if (h == "")
    {
      printf("%s DBAmon %s %3s | %s\n",nowdate,z,iter_count,m) >> logfile
    }
    else
    {
      printf("%s DBAmon %s %3s | " title[h] " | %s: %s\n",nowdate,z,iter_count,this_function,m) >> logfile
    }
    close logfile
  }
}

#-------------------------------------------------------------------------------
function check_inhib(h)   
#
# Check to see if checking of any kind is to be inhibited now for this instance
#
{
  "date +%Y/%m/%d" | getline nowdate
  close "date +%Y/%m/%d" 

  "date +%H" | getline nowhour
  close "date +%H" 

  "date +%a" | getline nowday
  close "date +%a" 

  #
  # Check for .dbc inhibit by hours of the day specified
  #

  if (mon_hours[h] != "")
  {
    ##print mon_hours[h] nowhour
    if (index(mon_hours[h],nowhour) == 0)
    {
      msg = sprintf("*** DBAmon checking inhibited Hour=%s Monitor_Hours=%s ***",nowhour,mon_hours[h])
      msgid = "DBA301W"
      logit(msg,h)
    
      info_msg(msg,h)
      m_info[h]++

      return "Y"
    }
  }

  if (mon_days[h] != "")
  {
    ##print mon_days[h] nowday
    if (index(mon_days[h],nowday) == 0)
    {
      msg = sprintf("*** DBAmon checking inhibited Day=%s Monitor_Days=%s ***",nowday,mon_days[h])
      msgid = "DBA301W"
      logit(msg,h)
    
      info_msg(msg,h)
      m_info[h]++

      return "Y"
    }
  }

  if (mon_excl[h] != "")
  {
    dayhour = nowday "-" nowhour
    ##print mon_excl[h] " " dayhour
    if (index(mon_excl[h],dayhour) > 0)
    {
      msg = sprintf("*** DBAmon checking inhibited DayHour=%s Monitor_Excl=%s ***",dayhour,mon_excl[h])
      msgid = "DBA301W"
      logit(msg,h)
    
      info_msg(msg,h)
      m_info[h]++

      return "Y"
    }
  }

  #
  # Check for all dbamon monitoring inhibited
  #

  if (system("grep 'Date=" nowdate  " Hour=" nowhour "' "  inhibdir "/ALL > /dev/null 2>&1") == 0)
  {
    msg = sprintf("*** ALL - DBAmon checking inhibited Date=%s Hour=%s ***",nowdate,nowhour)
    msgid = "DBA301W"
    logit(msg,h)
  
    info_msg(msg,h)
    m_info[h]++

    return "Y"
  }

  #
  # Check inhibit file
  #

  if (system("ll "inhibdir "/" inhibfile[h]" > /dev/null 2>&1") == 0)
  {
    if (system("grep 'Date=" nowdate  " Hour=" nowhour "' "  inhibdir "/" inhibfile[h] " > /dev/null 2>&1") == 0)
    {
      msg = sprintf("*** This Instance - DBAmon checking inhibited Date=%s Hour=%s ***",nowdate,nowhour)
      msgid = "DBA301W"
      logit(msg,h)
  
      info_msg(msg,h)
      m_info[h]++

      return "Y"
    }
  }
  return "N"
}

#-------------------------------------------------------------------------------
function remsh(c,file,h)   
#
# Issue remsh
#
{
  # If we are inhibited, then don't bother
  if (check_inhib(h) == "Y")
  {
    up[h] = "I"
    rc_save = -2
    return
  }

  # Build command including prefix and suffix
  cmdall = cmdpfx[h] c cmdsfx[h]

  # Debug line
  ##print "cmdpfx=" cmdpfx[h]
  ##print "cmdall="cmdall 

  # Clear, delete and init a logfile
  close tmpfl7 
  system("rm " tmpfl7 " > /dev/null 2>&1") 
  print "Command Input:" > tmpfl7
  print cmdall >> tmpfl7
  close tmpfl7

  # Clear and delete remshlog
  close remshlog 
  system("rm " remshlog " 2>/dev/null") 

  remsh_sleep = 30
  remsh_try = 0
  while (remsh_try++ <= remsh_retries)
  {
    # Issue command
    rc = system(cmdall " >" file " 2>" remshlog)
   
    remsherr = ""
    pingflag = ""
    pingable = ""

    # Look for possible NT error
    if (system("grep  'Access Denied' " file) == 0) 
    {
      rc = -1
      system("echo 'Access Denied' >> " remshlog) 
    }

    if (rc == 0)
    {
      if (remsh_try > 1) 
      {
        system("echo ' ' | dbamon_mailer -m -s 'DBAmon Remsh Retry Worked For: " title[h] " " remsh_try "' border@curley.cos.agilent.com")
      }
      must_complete = 0
      return
    }

    # Capture possible error in remsherr var
    "cat " remshlog | getline remsherr
    close "cat " remshlog

    ##print "remshlog="
    ##system("cat " remshlog)

    # It error'd on < the last attempt
    if (rc != 0 && remsh_try <= remsh_retries)
    {
      # Log message
      msg = sprintf("... Remsh Connect Attempt:%s Failed Err=[%s] RC=%i - Will Retry - Sleeping %s ...",remsh_try,remsherr,rc,remsh_sleep)
      logit(msg,h)
      system("sleep " remsh_sleep)
      continue
    }

    # It error'd on what will be the last attempt
    if (rc != 0 && remsh_try > remsh_retries)
    {
      # See if server is pingable
      rc = system("ping " hostname[h] " 64 2 > " pinglog " 2>&1")
      if (rc != 0 || system("grep -i '100% packet loss' " pinglog) == 0)
      {
	pingable = "Is *NOT* Ping-able"
        pingflag = "N"
      }
      else
      {
	pingable = "Is Ping-able"
        pingflag = "Y"
      }
      
      # Log message
      if (remsh_sev == "C" || must_connect)
      {
        short = "Remsh"
	msgid = "DBA290C"

        conshort = "Undiagnosed"
        if (index(remsherr,"Connection refused") > 0)                
        {
          conshort = "ConnRefused"
        }
        if (index(remsherr,"Password for this account expired") > 0) 
        {
          conshort = "PWExpired"
        }
        if (index(remsherr,"Access Denied") > 0)                     
        {
          conshort = "RhostsIssue"
        }
        if (index(remsherr,"Connection timed out") > 0)          
        {
          conshort = "NetTimeout"
        }

	msg = sprintf("!!! Connect Failure: [%s] After %s Attempts - Server %s - Err=[%s] RC=%i !!!",conshort,remsh_try,pingable,remsherr,rc)
	logit(msg,h)
	m_critical[h]++
	crit_msg(msg,h,tmpfl7)
      }
      else
      {
        short = "Remsh"
	msgid = "DBA291W"
	msg = sprintf("*** Connect Failure After %s Attempts - Err=[%s] RC=%i - Server %s ***",remsh_try,remsherr,rc,pingable)
	logit(msg,h)
	m_warning[h]++
	warn_msg(msg,h,tmpfl7)
      }

      # Create report
      printf("Remsh Attempt: %s RC=%s - Error Details:\n",remsh_try,rc) >> tmpfl7
      close tmpfl7
      system("cat " remshlog " >>" tmpfl7)
      system("cat " file "     >>" tmpfl7)
      print "Host: " hostname[h]  >> tmpfl7
      print "remsherr: " remsherr >> tmpfl7
      close tmpfl7

      up[h] = "N"
      short = "Rsh" 
    }
  } # End of retries while loop

  # Set vars
  rc_save = rc
  must_connect = 0
}

#-------------------------------------------------------------------------------
function check_sw()   
#
# Check this version of DBAmon against the most current version 
#
{
  "date +%Y/%m/%d-%H:%M:%S" | getline nowdate
  close "date +%Y/%m/%d-%H:%M:%S"

  msg = "You are running version-release: "verrel 
  logit(msg,thishost)

  if (wsname != "bigdog" && (company == "hp" || company == "agilent"))
  {
    msg = "'Phoning Home' to bigdog.cos.agilent.com (1901) to find the most current revision of DBAmon"
    logit(msg,thishost)
    system("echo " nowdate " " wsnamef " " dbamon_admin " " verrel " " x " | telnet bigdog.cos.agilent.com 1901 >" tmpfl7)
    while (getline < tmpfl7 > 0)
    {
      ##print $0
      if ($1 == "DBAmon")
      {
	sw_newest  = $2
	sw_date    = $3
      }
      if ($1 == "WWW")
      {
	sw_webpage = $2
      }
    }
    close tmpfl7

    msg = "Most Current DBAmon Version: "sw_newest " - Implemented: " sw_date " - DBAmon WWW Page: "sw_webpage
    logit(msg,thishost)

    if (sw_newest > verrel)
    {
      system("echo ' ' | dbamon_mailer -m -s 'monitor--dbamon/upgrade needed' border@curley.cos.agilent.com")
      msg = "NOTE - There is a Newer Version of DBAmon (" sw_newest " " sw_date "). See "sw_webpage" for Upgrade Info."
      error_msg(msg,h)
    }
  }
}


#-------------------------------------------------------------------------------
function check_remsh(r,h)   
#
# Issue rc from remsh
#
{
  if (check_inhib(h) == "Y")
  {
    up[h] = "I"
    rc_save = -2
    return
  }

  if (r != 0)
  {
    msg = sprintf("!!! ERROR - remsh command failed Host=%s rc=%i !!!",title[h],r)
    up[h] = "N"
    short = "Rsh"

    logit(msg,h)

    print "remsh Error Details:"
    system("cat " remshlog)

    if (remsh_sev == "C")
    {
      msgid = "DBA290C"
      m_critical[h]++
      crit_msg(msg,h,tmpfl7)
    }
    else
    {
      msgid = "DBA291W"
      m_warning[h]++
      crit_msg(msg,h,tmpfl7)
    }
  }
  rc_save = r
}


#-------------------------------------------------------------------------------
function begin_stuff()   
#
# Start of iteration stuff
#
{

  system("mv " tmpdir "/dbamon_savemsg_next " tmpdir "/dbamon_savemsg_this > /dev/null 2>&1")
  system("rm " tmpdir "/dbamon_savemsg_next > /dev/null 2>&1")
  system("touch " tmpdir "/dbamon_savemsg_this")
  system("touch " tmpdir "/dbamon_savemsg_next")

  system("rm " html_path)

  # multi-task mode - we don't want to do this
  #system("rm " html_events_dir "/*.new 2>/dev/null")

  i = 1
  while (i <= high_host)
  {
    html_events_flag[i] = 0 
    html_details_flag[i] = 0 
    msgs[i] = ""
    i++ 
  }

  print "<title>DBAmon Event Log</title>" >  html_path
  print "<body bgcolor=white><font face=verdana>" >> html_path

  print "<h3>DBAmon Event Log</h3>" >>  html_path

  print "<h5>DBAmon Version " verrel " Running On System " wsname "</h5>" >>  html_path

  "date " | getline date 
  close "date "

  msgid = "DBA500N"
  log_msg("As of: " date)

  close html_path

  grand_total_size = 0

  s_count = 0

  #
  # Determine detail log file name
  #

  "date +%u" | getline downum
  close "date +%u"

  if (downum == 1) 
  {
    dow = "Mon"
  }
  if (downum == 2) 
  {
    dow = "Tue"
  }
  if (downum == 3) 
  {
    dow = "Wed"
  }
  if (downum == 4) 
  {
    dow = "Thu"
  }
  if (downum == 5) 
  {
    dow = "Fri"
  }
  if (downum == 6) 
  {
    dow = "Sat"
  }
  if (downum == 7) 
  {
    dow = "Sun"
  }

  if (mode == "test")
  {
    logfile = "/opt/dbamon/log/test_"dow
  }
  else    
  {
    logfile = "/opt/dbamon/log/"dow
  }

  msg = sprintf("Monitoring data will be logged to %s",logfile)
  logit(msg)
}


#-------------------------------------------------------------------------------
function end_stuff()   
#
# End of iteration stuff
#
{
  close tmpdir "/dbamon_savemsg_next" 
  close tmpdir "/dbamon_savemsg_this" 

  close log_path

  system("rm " tmpdir "/dbamon_tmp* > /dev/null 2>&1")

  close html_path

  "date " | getline date 
  close "date "

  msgid = "DBA501N"
  log_msg("Iteration End Time: " date )

  system("cp " html_path   " " html_path_perm)

  # multi-task mode - we don't want to do this
  #system("rm " html_events_dir "/*.html")

  i = 1
  ##print "test moving i=" i " high_host=" high_host
  while (i <= high_host)
  {
    if (html_events_flag[i]) 
    {
      print "<hr>" >>  html_events[i]
      close html_events[i]
      system("mv " html_events[i] " " html_events_perm[i])
    }
    if (html_details_flag[i]) 
    {
      close html_details[i]
      system("mv " html_details[i] " " html_details_perm[i])
    }

    i++
  }
}


#-------------------------------------------------------------------------------
function info_msg(m,h,f)   
#
# Send an opc warning
#
{

  #
  # Log message and file
  #

  log_msg(m,h)
  if (f != "")
  {
    log_file(f,h)
  }

  if (short != "")
  {
    msgs[h] = msgs[h] "<font color=cyan>" short " </font>"
    short = ""
  }
}


#-------------------------------------------------------------------------------
function warn_msg(m,h,f)   
#
# Send and opc warning
#
{

  #
  # Log message and file
  #

  log_msg(m,h)
  if (f != "") 
  {
    log_file(f,h)
  }

  #
  # Optionally invoke userexit 
  #
  if (system("test -x /opt/dbamon/bin/userexit/warn_msg") == 0)
  {
    msg = sprintf("Invoking userexit: warn_msg")
    logit(msg)
    system("export D_HOST="title[h]";export D_MSG='"m"';export D_FILE="f";/opt/dbamon/bin/userexit/warn_msg")
  }

  if (short != "")
  {
    msgs[h] = msgs[h] "<font color=yellow>" short " </font>"
    short = ""
  }
  
  if (arg == "test")
  {
    msg = sprintf("Test Mode - NOT sending OpC message")
    logit(msg,h)
    return 0
  }

  #
  # Send opc message warn_msg
  #

  if (opc_appl[h] != "" && opc == "Y")
  {
    mm = m
    rc = sub("\*\*\*","",mm)
    rc = sub("\*\*\*","",mm)
    rc = sub("!!!","",mm)
    rc = sub("!!!","",mm)

    msgtemp = sprintf("Sending OpC Message\n")
    logit(msgtemp,h)

    if (substr(os_version[h],1,1) == "1")
    {
      cmd = "remsh " opc_gw[h] " '/opt/OV/bin/OpC/opcmsg severity=warning application=\"" opc_appl[h] "\" object=" opc_obj[h] " msg_text=\"" mm " " opc_trailer "\" msg_grp=" opc_mg[h]"'"
    }
    else
    {
      cmd = "remsh " opc_gw[h] " '/usr/OV/bin/OpC/opcmsg severity=warning application=\"" opc_appl[h] "\" object=" opc_obj[h] " msg_text=\"" mm " " opc_trailer "\" msg_grp=" opc_mg[h]"'"
    }

    if (debug_opc) printf("About to execute: %s\n",cmd)
    rc = system(cmd) 
    if (rc != 0) printf("Command rc=%s\n",rc)
  }
}

#--------------------------------------------------------------------------------
function logDetails(h,m)   
#
# Write message to log file 
#
{
  if (html_details_flag[h] == 0) 
  {
    if (debug_html) 
    {
      print "in log_msg event title h=" h
    }
    close html_details[h]

    print "<title>DBAmon Instance Details: " h "</title>" >  html_details[h]
    print "<body bgcolor=white><font face=verdana>" >> html_details[h]

    print "<h3>DBAmon " dbmsout[h] " Instance Details: " title[h] "</h3>" >  html_details[h]
    print "<i><font size=1>This page was programatically recreated by DBAmon - " date "</font></i><hr>" >>  html_details[h]
    print "<hr>" >>  html_path
    html_details_flag[h] = 1
  } 
  print m >> html_details[h]
  close html_details[h]
}


#--------------------------------------------------------------------------------
function log_file(f,h)   
#
# Write message to log file 
#
{
  if (log_path == "")
  {
    msg = "ERROR - SYSTEM Section variable log_path is null - exiting"
    error_msg(msg,h)
    exit 1
  }

  system("cat " f " >> " log_path)

  print "<pre>" >> html_path
  print "<pre>" >> html_events[h]
  close html_path
  close html_events[h]

  system("cat " f " >> " html_path)
  system("cat " f " >> " html_events[h])
  close html_path
  close html_events[h]

  print "</pre>" >> html_path
  print "</pre>" >> html_events[h]
  close html_path
  close html_events[h]

  ##print "f=" f " h=" h " html_events=" html_events[h]
  ##print "file f:"
  ##system("cat " f)
  ##print "file h:"
  ##system("cat " html_events[h])
}


#--------------------------------------------------------------------------------
function log_msg(m,h)   
#
# Write header message to log file 
#
{
  if (debug_html) 
  {
    print "in log_msg h=" h
  }

  if (log_path == "")
  {
    msg = "ERROR - SYSTEM Section variable log_path is null - exiting"
    error_msg(msg,thishost)
    exit 1
  }

  "date +%Y/%m/%d-%H:%M:%S" | getline nowdate
  close "date +%Y/%m/%d-%H:%M:%S" 

  print "\n-------" title[h] " - " nowdate " -------" >> log_path
  print m >> log_path

  if (h == "") 
  {
    h = 0
  }

  if (html_events_flag[h] == 0) 
  {
    if (debug_html) 
    {
      print "in log_msg event title h=" h
    }
    close html_events[h]

    print "<title>DBAmon One Instance Event Log</title>" >  html_events[h]
    print "<body bgcolor=white><font face=verdana>" >> html_events[h]

    print "<h3>DBAmon Event Log for Instance: " title[h] "</h3>" >  html_events[h]
    print "<i><font size=1>This page was programatically recreated by DBAmon - " date "</font></i>" >>  html_events[h]
    print "<hr>" >>  html_path
    html_events_flag[h] = 1
  } 
  close html_events[h]

  m = title[h] " " m

  print "<hr>" >>  html_path
  print "<hr>" >>  html_events[h]

  if      (index(m,"***") != 0) 
  {
    print "<img src='img/yellowball-89.gif'> <b> Warning Event"  >>  html_path
    print "<img src='img/yellowball-89.gif'> <b> Warning Event"  >>  html_events[h]
  }
  else if (index(m,"!!!") != 0) 
  {
    print "<img src='img/redball-89.gif'>    <b> Critical Event" >>  html_path
    print "<img src='img/redball-89.gif'>    <b> Critical Event" >>  html_events[h]
  }
  else if (index(m,"---") != 0) 
  {
    print "<img src='img/greenball-89.gif'>  <b> User Event"     >>  html_path
    print "<img src='img/greenball-89.gif'>  <b> User Event"     >>  html_events[h]
  }
  else if (index(m,"...") != 0) 
  {
    print "<img src='img/blueball-89.gif'>   <b> Info Event"     >>  html_path
    print "<img src='img/blueball-89.gif'>   <b> Info Event"     >>  html_events[h]
  }
  else
  {
    print "<img src='img/whiteball-89.gif'>  <b> DBAmon Event"   >>  html_path
    print "<img src='img/whiteball-89.gif'>  <b> DBAmon Event"   >>  html_events[h]
  }

  print "<pre>" >> html_path
  print "[<a HREF=\"" dbamon_home "/errors.shtml#" msgid "\">" msgid "</a>] " m >> html_path
  print "</pre>" >> html_path

  print "<pre>" >> html_events[h]
  print "[<a HREF=\"" dbamon_home "/errors.shtml#" msgid "\">" msgid "</a>] " m >> html_events[h]
  print "</pre>" >> html_events[h]

  #
  # Log to Informix/NT DB
  #
  sev = "?"
  if (index(m,"!!!") > 0) 
  {
    sev = "C"
  }
  if (index(m,"***") > 0) 
  {
    sev = "W"
  }
  if (index(m,"...") > 0) 
  {
    sev = "I"
  }
  if (index(m,"---") > 0) 
  {
    sev = "U"
  }
 
  #
  # Run sql to insert a row into mysql 
  #

  if (hostname[h] != "" && use_repository == "Y" && msgid != "DBA301W")
  {
    close(sqlfil)
    system("rm " sqlfil)

    #mx = sprintf("Writing sql statements for events table -  file: %s",sqlfil )
    #logit(mx)

    gsub("'","\"",text)

    print insertdb > sqlfil
    print "insert into events (dbms,instance,system,sev,source,text,paged)" >> sqlfil
    print "  values ('" dbmsout[h] "','" title[h] "','" hostname[h] "','" sev "','DBAmon" verrel "','" msgid " " msg "','" page_sent "');" >> sqlfil
    ##system("cat " sqlfil)

    if      (use_oracle == "Y") 
    {
      system("/opt/dbamon/bin/dbamon_ora_rsql.pl " sqlfil)
    }
    if      (use_oracle == "Y") 
    {
      system("/opt/dbamon/bin/dbamon_ora_rsql.pl " sqlfil)
    }
    else if (use_mysql  == "Y")
    {
      system("/opt/dbamon/bin/sql/rsql " sqlfil)
    }
  }

  #
  # Return 
  #

  msgid = ""

  close html_path
  close html_events[h]

  if (debug_html) 
  {
    print "===== contents of " html_path
    system("cat " html_path)
    print "===== contents of " html_events[h]
    system("cat " html_events[h])
  }
}


#------------------------------------------------------------------------------
function error_parm_null(sec,var)   
#
# Terminate with error message for missing .dbamonrc parameters
#
{
  printf("*********************************************************************\n",m)
  printf("  Error: %s Section - %s Parameter not specified\n",sec,var)
  printf("  in .dbamonrc parameter file. The format of this file\n")
  printf("  changed for the HOST and HTML section in version 2.00\n")
  printf("  and the system section in version 2.02. Check the\n")
  printf("  comments in the supplied .dbamonrc parameter file (exiting)\n")
  printf("*********************************************************************\n",m)

  tmperr = tmpdir"/dbamon_tmperr"
  close tmperr
  system("rm -fr "tmperr)
  print "--- DBAmon Parameter Error Message Notification ---" > tmperr
  print " " >> tmperr
  printf("  Error: %s Section - %s Parameter not specified\n",sec,var) >> tmperr
  print " " >> tmperr
  close tmperr
  z = "cat " tmperr " | dbamon_mailer -m -s 'DBAmon Fatal Parameter Error - DBAmon Master=" wsname " mode="mode"' " dbamon_admin
  system(z)

  exit 1
}

#------------------------------------------------------------------------------
function error_parm(m)   
#------------------------------------------------------------------------------
#
# Send mail for dbamon parm errors
#
{
  printf("*********************************************************************\n",m)
  printf("%s\n",m)
  printf("*********************************************************************\n",m)
  printf("Mailing DBAmon Parameter Error Message to %s\n",dbamon_admin)

  tmperr = tmpdir"/dbamon_tmperr"
  close tmperr
  system("rm -fr "tmperr)
  print "--- DBAmon Parameter Error Message Notification ---" > tmperr
  print " " >> tmperr
  print m >> tmperr
  print " " >> tmperr

  close tmperr
  z = "cat " tmperr " | dbamon_mailer -m -s 'DBAmon Fatal Parameter Error - mode="mode"' " dbamon_admin
  system(z)
  exit 1
}

#------------------------------------------------------------------------------
function error_msg(m,h,f)   
#------------------------------------------------------------------------------
#
# Send mail for dbamon program error messages 
#
{
  tmperr = tmpdir"/dbamon_tmperr"
  close tmperr
  system("rm -fr "tmperr)

  printf("*********************************************************************\n",m)
  printf("DBAmon Error: %s\n",m)
  printf("*********************************************************************\n",m)
  printf("Mailing DBAmon Program Error Message to %s\n",dbamon_admin)

  msgmod = "DBAmon | " title[h] " | Mode:" modeout " - " m

  ##print "hostnum="h

  # Put messages and "f" in my tmp file
  print "--- DBAmon Program Error Message Notification ---" > tmperr
  print " " >> tmperr
  
  if (f != "")
  {
    print "*********************************************************"
    print "DBAmon Program Error | " title[h] " | " m
    print "Error Details: (from tmp file: " f ")" >> tmperr
    print "Cat'ing file" f " to error output"
    system("cat " f)
    system("cat " f " >> " tmperr)
    print "*********************************************************"
  }

  z = "cat " tmperr " | dbamon_mailer -m -s '" msgmod"' " dbamon_admin
  system(z)

  #
  # Since a possible cause of pgm errors is that the download never
  # occured or the downloaded files were removed, we will now try
  # to re-download the files
  #
  if (h > 0)
  {
    print "Turning off software download flag for host="h
    download_flag[h] = 0
    hn = hostname[h]
    download_host[hn] = 0
  } 
}

#------------------------------------------------------------------------------
function user_msg(m,h,f)   
#
# Send mail for critical messages 
#
{
  msgsave = msgid

  log_msg(m,h)
  if (f != "") 
  {
    log_file(f,h)
  }

  ##print "short="short
  if (short != "")
  {
    msgs[h] = msgs[h] "<font color=lime>" short " </font>"
    short = ""
  }
  
  if (arg == "ztest")
  {
    msgtemp = sprintf("Test Mode - NOT Mailing message")
    logit(msgtemp,h)
    return 0
  }

  #
  # tmpfl5 will contain the header and text of message
  #

  close tmpfl5

  "date " | getline date 
  close "date "

  print "--- DBAmon User Message Notification ---" > tmpfl5
  print "    Instance: " title[h] >> tmpfl5
  print "        Date: " date >> tmpfl5
  print " " >> tmpfl5
  print msg >> tmpfl5

  if (msgsave != "")
  {
    print " " >> tmpfl5
    print "For more information on this error, see:" >> tmpfl5
    print dbamon_home "/errors.shtml#"msgsave >> tmpfl5
    print " " >> tmpfl5
  }

  if (f != "")
  {
    system("cat " f " >> " tmpfl5)
  }

  close tmpfl5

  # 
  # Parse list of userid into indiviual elements
  #

  user_elm[0] = split(userlist[h_userlist[h]],user_elm)
  if (debug_crit) 
  {
    printf("Parse userlist into %s elements\n",user_elm[0])
  }

  i_mail = 1
  for (i_mail=1; i_mail<= user_elm[0]; i_mail++)
  {
    if (debug_crit) 
    {
      printf("Processing i_mail=%s user_elm[i_mail]=%s\n",i_mail,user_elm[i_mail])
    }

    if (substr(user_elm[i_mail],1,1) == "@")
    {
      host = substr(user_elm[i_mail],2)
      msgtemp = sprintf("Sending postnote to host=%s",host)
      logit(msgtemp,h)

      rc = system("cat " tmpfl5 "| " post_dir "/clpostXm " host)
      if (rc != 0) 
      {
        msgtemp = sprintf("Postnote rc=%s",rc)
        logit(msgtemp,h)
      }

      continue
    }

    msgtemp = sprintf("Mailing critical message to user=%s",user_elm[i_mail])
    logit(msgtemp,h)

    msgmod = "DBAmon | " title[h] " | " msg
    cmd = "cat " tmpfl5 "|dbamon_mailer -m -s '" msgmod "' " user_elm[i_mail]
    if (debug_crit) 
    {
      printf("About to execute cmd=%s\n",cmd)
    }
    rc = system(cmd)
    if (debug_crit) 
    {
      printf("Mail rc=%s\n",rc)
    }

    msgmod = "DBAmon | " title[h] " | " msg
  }
}


#------------------------------------------------------------------------------
function crit_msg(m,h,f)   
#
# Send mail for critical messages 
#
{
  msgsave = msgid
  msgmod = "DBAmon|" title[h] "|" m

  if (f != "") 
  {
    log_file(f,h)
  }

  ##print "short="short
  if (short != "")
  {
    msgs[h] = msgs[h] "<font color=red>" short " </font>"
    short = ""
  }
  
  if (arg == "ztest")
  {
    msgtemp = sprintf("Test Mode - NOT Mailing message")
    logit(msgtemp,h)
    return 0
  }

  savemsg = sprintf("host=%s userlist=%s msg=%s", title[h], userlist[h_userlist[h]], msg)
  print savemsg >> tmpdir"/dbamon_savemsg_next"

  #debug start
  ##print "Debug Start======" 
  ##system("cat " tmpdir "/dbamon_savemsg_this")
  ##print "savemsg=" savemsg
  ##print "Debug End========" 
  #debug end

  if (system("grep  '" savemsg "' " tmpdir "/dbamon_savemsg_this") == 0)
  {
    duplicate_flag = 1
  }
  else
  {
    duplicate_flag = 0
  }

  if (pager_flag[h] && duplicate_flag == 0)
  {
    page_sent = "Y"
  }
  else                                    
  {
    page_sent = ""
  }

  log_msg(m,h)
  page_sent = ""

  if (duplicate_flag)
  {
    msgtemp = sprintf("NOT Performing Notification for Consecutive Duplicate Critical Message")
    logit(msgtemp,h)
    return
  }

  # 
  # Send message to pager gateway
  #
  # This section uses the HOSTS section Pager_Email
  # and Pager_Subject values. 
  #

  if (pager_flag[h])
  {
    #
    # Optionally invoke userexit 
    #
    if (system("test -x /opt/dbamon/bin/userexit/pager") == 0)
    {
      mx = sprintf("Invoking userexit: pager")
      logit(mx)
      system("export D_HOST="title[h]";export D_MSG='"m"';export D_FILE="f";/opt/dbamon/bin/userexit/pager")
    }

    mx = sprintf("Sending pager notification Subject=%s EMail=%s",pager_subject[h],pager_email[h])
    logit(mx,h)

    # Customization for HP/Agilent
    if ((company == "hp" || company == "agilent") && pager_subject[h] == "DUMMY")
    {
      mx = sprintf("Invoking page_dbagap for hp/agilent")
      logit(mx,h)
      cmd = "echo \"(DBAmon) " titleraw[h] " " msg "\" | /usr/local/sap/tools/page_dbagap" 
      rc = system(cmd)
      if (debug_crit)
      {
        printf("page_dbagap rc=%s cmd=%s\n",rc,cmd)
      }
    }
    else
    {
      mx = sprintf("Sending EMail to %s",pager_email[h])
      logit(mx,h)

      if (pager_subject[h] == "") 
      {
        pager_subject[h] = "DBAmon Notification"
      }

      cmd = "echo \"(DBAmon) " titleraw[h] "-" msg "\" | dbamon_mailer -m -s '" pager_subject[h] "' " pager_email[h]
      ##print "cmd=" cmd
      rc = system(cmd)
    }
  }

  # 
  # tmpfl5 will contain the header and text of message
  #

  close tmpfl5
  system("rm " tmpfl5 " 2>/dev/null")

  "date " | getline date 
  close "date "

  print "--- DBAmon Critical Message Notification ---" > tmpfl5
  print "    Instance: " title[h] >> tmpfl5
  print "        Date: " date >> tmpfl5
  print " " >> tmpfl5
  print msg >> tmpfl5

  if (msgsave != "") 
  {
    print "    For more information on this error, see:" >> tmpfl5
    print "    " dbamon_home "/errors.shtml#"msgsave >> tmpfl5
    print " " >> tmpfl5
  }

  if (f != "") 
  {
    system("cat " f " >> " tmpfl5)
  }

  close tmpfl5

  # 
  # If this host uses OpC, send opcmsg
  #

  if (opc_appl[h] != "" && opc == "Y")
  {
    msg_fix = msg
    rc = sub("!!!","",msg_fix)
    rc = sub("!!!","",msg_fix)

    msgtemp = sprintf("Sending OpC Message")
    logit(msgtemp,h)

    if (substr(os_version[h],1,1) == "1")
    {
      cmd = "remsh " opc_gw[h] " '/opt/OV/bin/OpC/opcmsg severity=critical application=\"" opc_appl[h] "\" object=" opc_obj[h] " msg_text=\"" msg_fix " " opc_trailer "\" msg_grp=" opc_mg[h]"'"
    }
    else
    {
      cmd = "remsh " opc_gw[h] " '/usr/OV/bin/OpC/opcmsg severity=critical application=\"" opc_appl[h] "\" object=" opc_obj[h] " msg_text=\"" msg_fix " " opc_trailer "\" msg_grp=" opc_mg[h]"'"
    }

    if (debug_opc || debug_crit) 
    {
      printf("About to execute: %s\n",cmd)
    }
    rc = system(cmd) 
    if (rc != 0) 
    {
      printf("Command rc=%s\n",rc)
    }
  }

  # 
  # Parse list of userid into indiviual elements
  #

  user_elm[0] = split(userlist[h_userlist[h]],user_elm)
  if (debug_crit) printf("Parse userlist into %s elements\n",user_elm[0])

  i_mail = 1
  for (i_mail=1; i_mail<= user_elm[0]; i_mail++)
  {

    if (debug_crit)
    {
      printf("Processing i_mail=%s user_elm[i_mail]=%s\n",i_mail,user_elm[i_mail])
    }


    if (substr(user_elm[i_mail],1,1) == "@")
    {
      host = substr(user_elm[i_mail],2)
      msgtemp = sprintf("Sending postnote to host=%s",host)
      logit(msgtemp,h)

      rc = system("cat " tmpfl5 "| " post_dir "/clpostXm " host)
      if (rc != 0) 
      {
        msgtemp = sprintf("Postnote rc=%s",rc)
        logit(msgtemp,h)
      }

      continue
    }

    msgtemp = sprintf("Mailing critical message to user=%s",user_elm[i_mail])
    logit(msgtemp,h)

    close tmpfl5
    cmd = "cat " tmpfl5 "|dbamon_mailer -m -s '" msgmod "' " user_elm[i_mail]

    ##print "cmd=" cmd

    if (debug_crit)
    {
      printf("About to execute cmd=%s\n",cmd)
    }
    rc = system(cmd)
    if (debug_crit) 
    { 
      printf("Mail rc=%s\n",rc)
    }
  }

  #
  # Optionally create BLT ticket 
  #

  if (make_tickets == "Y")
  {
    msgtemp = sprintf("Invoking dbamon_make_ticket.pl to create helpdesk ticket hostfix=%s msgmod=%s",hostfix[h],msgmod)
    logit(msgtemp,h)
    system("export INSTANCE=\"" title[h] "\";" \
           "export ERRFILE=\"" tmpfl5 "\";" \
           "export ERRMSG=\"" msgmod "\";" \
           "export DBMS=\"" dbms[h] "\";" \
           "export HOST=\"" hostfix[h] "\";" \
           "/opt/dbamon/bin/dbamon_make_ticket.pl")
  }

}


#--------------------------------------------------------------------------------
function summarize()   
#
# Create summary
#
{
  #system("rm " html_sys_path)
  sumprint("","","S")

  print "System                             Hardware   OS-Ver    Inf-Ver     Inf-S/N    DBs DBSpcs Tables Aloc Used Maxusers" > rptdir"/instances.txt"
  print "# Informix Instances and Serial Numbers" > rptdir"/instances_sn.txt"

  print "<title>DBAmon Instance Summary</title>" >  html_sys_path


  print "<meta http-equiv=\"Refresh\" content=\"3600\">" >>  html_sys_path
  print "<body bgcolor=white>" >> html_sys_path

  print "<table><tr><td><img src='img/dbamonlogo.jpg'>" >> html_sys_path
  print "<tr bgcolor=wheat><td><font size=5 face=Verdana><center>Instance Summary</center></font>" >> html_sys_path
  print "</table>" >> html_sys_path

  print "<ul><font size=-1>" >> html_sys_path
  print "<li> <a HREF=\"" dbamon_home "\"><b>DBAmon Home Page</a> </b>" >> html_sys_path
  print "<li> <a HREF='index.html'><b>DBAmon WWW Index</a> </b>" >> html_sys_path
  print "</ul></font>" >> html_sys_path

  "date " | getline date 
  close "date "

  print "<font size=-2><i>This page was generated by DBAmon version <b>" verrel " </b> running on system: " wsname " on " date " - Started " strdate "</i></font>" >> html_sys_path

  #
  # Create scoreboard
  #

  g_ok      = 0
  g_inhibit = 0
  g_info    = 0
  g_warning = 0
  g_download= 0
  g_critical= 0
  g_nomon   = 0
  g_bkonly  = 0

  i_rm = 1
  while (i_rm <= high_host) 
  {
    ##print "warning="m_warning[i_rm] " i_rm="i_rm " high_host="high_host

    if ((m_info[i_rm] + m_warning[i_rm] + m_critical[i_rm]) == 0) 
    {
      g_ok  += 1
    }

    if (m_info[i_rm]     > 0) 
    {
      g_info     += 1
    }
    if (m_warning[i_rm]  > 0)
    {
      g_warning  += 1
    }
    if (m_critical[i_rm] > 0) 
    {
      g_critical += 1
    }

    ##print up[i_rm] 

    if (runmon[i_rm] == "N") 
    {
      g_nomon += 1
    }

    if (runmon[i_rm] == "B") 
    {
      g_bkonly += 1
    }

    if (up[i_rm] == "D") 
    {
      g_download += 1
      g_warning  -= 1
    }

    if (up[i_rm] == "I") 
    {
      g_inhibit  += 1
      g_info     -= 1
    }

    i_rm++
  }

  if ((high_host - g_inhibit) == 0)
  {
    health = 0
  }
  else
  {
    health = int( (g_ok / (high_host - g_inhibit) * 100) )
  }

  if (health >= 70) 
  {
    health_c = "lime"
  }
  if (health >= 50 && health < 70) 
  {
    health_c = "yellow"
  }
  if (health < 50)  
  {
    health_c = "red"
  }

  # 
  # Scoreboard
  #

  "perl -e 'print time;'" | getline time_end
  close "perl -e 'print time;'" 

  etime = int((time_end - time_start) / 60)
  time_total = time_end - time_start

  print "<hr>" >> html_sys_path
  ##print "<h4>Scoreboard - Iteration: #" iter_count " - Duration: " etime " Minute(s) (" time_total " Seconds)</h4>" >> html_sys_path
  print "<h4>Scoreboard - Iteration: #" iter_count " - Duration: " etime " Minute(s)</h4>" >> html_sys_path

  print "<table border=1 bgcolor=lightgrey>" >> html_sys_path

  #print "<tr>            " >> html_sys_path
  #print "<tr> <td rowspan=9><h5>Instance<br>Status" >> html_sys_path

  print "<tr bgcolor=slate><th><h5><i>Instance<br>Status<th><h5><i>Instance<br>Count <th><h5><i>Health Index<br>(0-100)" >> html_sys_path

  
  mx = sprintf("Updating DB with instance data")
  logit(mx)

  sumtot("T", "Inhibited -or- Must_Be_Up=N Down",  g_inhibit,  "black"  )
  sumtot("T", "No Events",                         g_ok,       "lime"  )
  sumtot("T", "Info Events",                       g_info,     "cyan" )
  sumtot("T", "Warning Events",                    g_warning,  "yellow" )
  sumtot("T", "Critical Events",                   g_critical, "red" )
  sumtot("T", "Software Download Failed",          g_download, "gray" )
  sumtot("T", "Monitoring Turned Off",             g_nomon,    "white" )
  sumtot("T", "Backup Monitoring Only",            g_bkonly,   "slate" )

  mx = sprintf("Creating WWW Instance Summary html data")
  logit(mx)

  print "<tr>  <td bgcolor=\"black\" ><h5><font color=\"white\">Instance Inhibited -or- Must_Be_Up=N Instance Down" >> html_sys_path
  print " <td align=right> <h5> " g_inhibit  >> html_sys_path
  print " <td rowspan=8 bgcolor=\"" health_c "\"> <center> <h1> " health "</center>" >> html_sys_path
  print "<tr> <td bgcolor=\"lime\"  ><h5>No Events" >> html_sys_path
  print " <td align=right> <h5>" g_ok        >> html_sys_path
  print "<tr> <td bgcolor=\"cyan\"  ><h5>Info Events" >> html_sys_path
  print " <td align=right> <h5>" g_info      >> html_sys_path
  print "<tr> <td bgcolor=\"yellow\"><h5>Warning Events" >> html_sys_path
  print " <td align=right> <h5>" g_warning   >> html_sys_path
  print "<tr> <td bgcolor=\"red\"   ><h5>Critical Events" >> html_sys_path
  print " <td align=right> <h5>" g_critical  >> html_sys_path
  print "<tr> <td bgcolor=\"gray\"  ><h5>Software Download Failed" >> html_sys_path
  print " <td align=right> <h5>" g_download  >> html_sys_path
  print "<tr> <td bgcolor=\"white\" ><h5>Monitoring Turned Off" >> html_sys_path
  print " <td align=right> <h5>" g_nomon     >> html_sys_path
  print "<tr> <td bgcolor=\"slate\" ><h5>Backup Monitoring Only" >> html_sys_path
  print " <td align=right> <h5>" g_bkonly    >> html_sys_path

  num_all = num_oracle + num_informix + num_mssql + num_oracleapps + num_oraclent
  if (num_oracle     == "") 
  {
    num_oracle     = 0 
  }
  if (num_oracleapps == "") 
  {
    num_oracleapps = 0
  }
  if (num_oraclent   == "") 
  {
    num_oraclent   = 0
  }
  if (num_informix   == "") 
  {
    num_informix   = 0
  }
  if (num_mssql      == "") 
  {
    num_mssql      = 0
  }

  if (num_all == 0) 
  {
    num_all = 1   # Prevent divide by 0
  }

  pct_oracleapps = int((num_oracleapps / num_all) * 100)
  pct_oraclent   = int((num_oraclent   / num_all) * 100)
  pct_oracle     = int((num_oracle     / num_all) * 100)
  pct_informix   = int((num_informix   / num_all) * 100)
  pct_mssql      = int((num_mssql      / num_all) * 100)

  sumtot("S",  "Informix-UX" , num_informix   , ver_informix_low,   ver_informix_high )
  sumtot("S",  "OracleDB-UX" , num_oracle     , ver_oracle_low,     ver_oracle_high )
  sumtot("S",  "OracleDB-NT" , num_oraclent   , ver_oraclent_low,   ver_oraclent_high )
  sumtot("S",  "OracleApps " , num_oracleapps , ver_oracleapps_low, ver_oracleapps_high )
  sumtot("S",  "MSSQL      " , num_mssql      , ver_mssql_low,      ver_mssql_high )

  print "</table><p><table border=1 bgcolor=lightgrey>" >> html_sys_path
  print "<tr bgcolor=slate><th><h5><i>DBMS/<br>Application<th><h5><i>Instance Count<th><h5><i>Percent of Total Instances<th><h5><i>Low Version<th><h5><i>High Version" >> html_sys_path
  print "<tr><td><h5><font color=darkblue>Informix   </font><td align=right><h5>" num_informix   " <td align=right><h5>" pct_informix   "%" >> html_sys_path
  print "<td><h5>" ver_informix_low "<td><h5>" ver_informix_high >> html_sys_path
  print "<tr><td><h5><font color=red>     OracleDB-UX</font><td align=right><h5>" num_oracle     " <td align=right><h5>" pct_oracle     "%" >> html_sys_path
  print "<td><h5>" ver_oracle_low   "<td><h5>" ver_oracle_high   >> html_sys_path
  print "<tr><td><h5><font color=ff0090>  OracleDB-NT</font><td align=right><h5>" num_oraclent   " <td align=right><h5>" pct_oraclent   "%" >> html_sys_path
  print "<td><h5>" ver_oraclent_low "<td><h5>" ver_oraclent_high >> html_sys_path
  print "<tr><td><h5><font color=darkred> OracleApps </font><td align=right><h5>" num_oracleapps " <td align=right><h5>" pct_oracleapps "%" >> html_sys_path
  print "<td><h5>" ver_oracleapps_low "<td><h5>" ver_oracleapps_high >> html_sys_path
  print "<tr><td><h5><font color=green>   MSSQL      </font><td align=right><h5>" num_mssql      " <td align=right><h5>" pct_mssql      "%" >> html_sys_path
  print "<td><h5>" ver_mssql_low "<td><h5>" ver_mssql_high >> html_sys_path

  print "</table>" >> html_sys_path

  #
  # Create instance detail
  #

  print "<hr>" >> html_sys_path

  print "<h4> Instance Detail - " high_host " Instance(s) - " int(grand_total_size) " GB Total Size</h5>" >> html_sys_path
  print "<table border=1 bgcolor=lightgrey>" >> html_sys_path

  print "<tr bgcolor=slate>"                       >> html_sys_path
  print "<th colspan=4><h5><i>Status/<br>Instance" >> html_sys_path
  print "<th><h5><i>DBMS/<br>Application"     >> html_sys_path
  print "<th><h5><i><a href='http://dbamon.com/ref/actions.shtml'>Actions</a>" >> html_sys_path
  print "<th><h5><i>Events"                >> html_sys_path
  print "<th><h5><i>Status<br>/CONFIG<br>Flags"       >> html_sys_path
  print "<th><h5><i>DBMS/<br>Package<br>Version"       >> html_sys_path
  print "<th><h5><i>Bkup Method:<br>Hours Since<br>Last Bkup/<br>Threshold<br>(R)erun Cmd" >> html_sys_path
  print "<th><h5><i>CPU<br>Model-CPUs<br>(MB Mem)"           >> html_sys_path
  print "<th><h5><i>O/S<br>Level<br>(Mode)"                  >> html_sys_path
  print "<th><h5><i>Alloc/<br>Used<br>GB"  >> html_sys_path
  print "<th><h5><i>Mon.<br>Dur.<br>Secs.<br>(% Of<br>Total)"  >> html_sys_path
  print "<th><h5><i>Misc."                 >> html_sys_path

  print "</tr>                " >> html_sys_path


  tot_db       = 0
  tot_appldb   = 0
  tot_dbspaces = 0
  tot_tables   = 0
  tot_alloc    = 0
  tot_used     = 0
  tot_disks    = 0
  tot_maxusers = 0

  #
  # Clean instances table for this mode
  #
  if (use_oracle == "Y")
  {
    mx = sprintf("Cleaning out Oracle dbamon.instances table")
    logit(mx)
    close(sqlfil)
    system("rm " sqlfil)
    print "delete from instances where dbamonmode = '" modeout "'" > sqlfil
    close(sqlfil)
    system("/opt/dbamon/bin/dbamon_ora_rsql.pl " sqlfil)
  }
  else if (use_mysql == "Y")
  {
    mx = sprintf("Cleaning out MySql instances table")
    logit(mx)
    close(sqlfil)
    system("rm " sqlfil)
    print insertdb > sqlfil
    print "delete from instances where dbamonmode = '" modeout "'" > sqlfil
    close(sqlfil)
    system("/opt/dbamon/bin/sql/rsql " sqlfil)
  }

  close(sqlfil)
  system("rm " sqlfil)

  i_rm = 1
  while (i_rm <= high_host) 
  {

    printf("%20s %20s %10s %8s %6s %12s %10s %4d %4d %6d %4d %4d %5d\n",hostname[i_rm],title1[i_rm],title2[i_rm],hw_model[i_rm],os_version[i_rm],sw_version[i_rm],sn[i_rm],num_databases[i_rm],num_dbspaces[i_rm],num_tables[i_rm],int(system_size[i_rm]),int(system_used[i_rm]),maxusers[i_rm]) >> rptdir"/instances.txt"

    printf("%20s %15s %15s\n",title[i_rm],sw_version[i_rm],sn[i_rm]) >> rptdir"/instances_sn.txt"

    #
    # Insert row into instances table
    #
    if (hostname[i_rm] != "" && msgid != "DBA301W" && use_repository == "Y")
    {
      print "insert into dbamon.instances (dbamonmode,status,instance,system,model,os,dbms,dbmsver,dbmssn,alloc,used)" >> sqlfil
      print "  values ('"  modeout         "','" \
                           up[i_rm]        "','" \
                           title1[i_rm]    "','" \
                           hostfix[i_rm]   "','" \
                           hw_model[i_rm]  "','" \
              os[i_rm] "-" os_version[i_rm]"','" \
                           dbms[i_rm]      "','" \
                          sw_version[i_rm] "','" \
                          sn[i_rm]         "','" \
                          system_size[i_rm]"','" \
                          system_used[i_rm]"'  " \
                          ");" >> sqlfil
    }

    ##DEBUG## print "up="up[i_rm]" mustbeup="t_mustbeup[i_rm]

    black_flag = 0

    if (bgcolor_flag == 1)
    {
      bgc = "ffffff"
      bgcolor_flag = 0
    }
    else
    {
      bgc = "eeeeee"
      bgcolor_flag = 1
    }
      
    #sumprint(i_rm,"<tr bgcolor=" bgc ">")
    print "<tr bgcolor=" bgc ">" >> html_sys_path

    if      (m_critical[i_rm] > 0) 
    {
      sumprint(i_rm, "<td nowrap bgcolor=\"red\">" )
    }
    else if (runmon[i_rm] == "N")  
    {
      sumprint(i_rm, "<td nowrap bgcolor=\"white\">" )
    }
    else if (runmon[i_rm] == "B")  
    {
      sumprint(i_rm, "<td nowrap bgcolor=\"slate\">" )
    }
    else if (up[i_rm] != "Y" && t_mustbeup[i_rm] == "N")
    {
      sumprint(i_rm, "<td nowrap bgcolor=\"black\">" )
      black_flag = 1
    }
    else if (up[i_rm] == "I")
    {
      sumprint(i_rm, "<td nowrap bgcolor=\"black\">" )
      black_flag = 1
    }
    else if (up[i_rm] == "D")      
    {
      sumprint(i_rm, "<td nowrap bgcolor=\"gray\">" )
    }
    else if (m_warning[i_rm] > 0)  
    {
      sumprint(i_rm, "<td nowrap bgcolor=\"yellow\">" )
    }
    else if (m_info[i_rm] > 0)    
    {
      sumprint(i_rm, "<td nowrap bgcolor=\"cyan\">" )
    }
    else                           
    {
      sumprint(i_rm, "<td nowrap bgcolor=\"lime\">" )
    }

    if (black_flag == 1) 
    {
      fontstr = "<font color=white>"
    }
    else    
    {
      fontstr = "<font color=black>"
    }


    #         
    # Hostname
    #

    if (host_url[i_rm] == "")
    {
      sumprint(i_rm, "<h5>" fontstr hostname[i_rm] )
    }
    else 
    {
      sumprint(i_rm,  "<a HREF=\"" host_url[i_rm] "\"><h5>" fontstr hostname[i_rm] "</a>" )
    }

    sumprint(i_rm, "\n" )

    #         
    # Title1
    #
    sumprint(i_rm,  "<td nowrap>" )
    if (title1url[i_rm] == "")
    { 
      sumprint(i_rm,  "<h5>" title1[i_rm] )
    }
    else 
    {
      sumprint(i_rm,   "<a HREF=\"" title1url[i_rm] "\"> <h5> " title1[i_rm] " </a>" )
    }


    #
    # Title2
    #
    sumprint(i_rm,  "<td nowrap>" )
    if (title2url[i_rm] == "")
    {
      sumprint(i_rm,  "<h5>" title2[i_rm] )
    }
    else
    {
      sumprint(i_rm,   "<a HREF=\"" title2url[i_rm] "\"> <h5> " title2[i_rm] " </a>" )
    }
    sumprint(i_rm,  "\n" )


    #
    # Title3
    #
    sumprint(i_rm,  "<td nowrap><h6>" )
    sumprint(i_rm,  title3[i_rm] )
    sumprint(i_rm,  "\n" )

    #
    # DBMS
    #

    sumprint(i_rm,  "<td nowrap><h5>" )
    sumprint(i_rm,  "<font color=" dbms_color[i_rm] ">" dbmsout[i_rm] )
    sumprint(i_rm,  "</font>" )

    #
    # Buttons
    #

    sumprint(i_rm,  "<td nowrap><h5>" )

    if (userid[i_rm] == "") 
    {
      sumprint(i_rm,  "<a HREF=\"rlogin://" dbamon_userid "@" hostname[i_rm] "\">T</a>" )
    }
    else          
    {
      sumprint(i_rm,  "<a HREF=\"rlogin://" userid[i_rm]  "@" hostname[i_rm] "\">T</a>" )
    }
    sumprint(i_rm,  "-" )

    # Obsolete
    #if (what[i_rm] == "DB") sumprint(i_rm,   "<a HREF=\"" http_rpt_path "#" titleraw[i_rm] "\">D</a>" )
    #else sumprint(i_rm,  "D" )

    if (html_details_flag[i_rm] == 0)
    {
      sumprint(i_rm,"D")
    }
    else
    {  
      z = title[i_rm]
      gsub(" ","",z)
      if (arg == "test") { z2 = "details_test" }
      else               { z2 = "details" }
      sumprint(i_rm,   "<a HREF=\"" z2 "/" z ".html" "\">D</a>" )
    }

    sumprint(i_rm,  "-" )
    sumprint(i_rm,   "<a HREF=\"/cgi-bin/dbamon_inhibit.pl?" inhibfile[i_rm] "\">I</a>" )
    sumprint(i_rm,  "-" )

    # These options only work if mysql=y
    if (use_repository == "Y")
    {
      sumprint(i_rm,   "<a HREF=\"/cgi-bin/dbamon_dbc.pl?" i_rm "-" modeout "\">C</a>" )
      sumprint(i_rm,  "-" )

      if (mode == "test") { sumprint(i_rm,   "<a HREF=\"/cgi-bin/dbamon_hist.pl?" titleraw[i_rm] ",test\">H</a>" ) }
      else                { sumprint(i_rm,   "<a HREF=\"/cgi-bin/dbamon_hist.pl?" titleraw[i_rm] "\">H</a>" ) }

      sumprint(i_rm,  "-" )

      sumprint(i_rm,   "<a HREF=\"/cgi-bin/dbamon_text.pl?" hostname[i_rm] "?" server[i_rm] "\">N</a>" )
      sumprint(i_rm,  "-" )

      if (what[i_rm] == "DB") { sumprint(i_rm,   "<a HREF=\"/cgi-bin/dbamon_ba_inhibit.pl?" titleraw[i_rm] "\">B</a>" ) }
      else                    { sumprint(i_rm,  "B" ) }

      sumprint(i_rm,  "-" )
    }

    if (html_events_flag[i_rm] == 0)
    {
      sumprint(i_rm,   "E" )
    }
    else
    {  
      z = title[i_rm]
      gsub(" ","",z)
      if (arg == "test") { z2 = "events_current_test" }
      else               { z2 = "events_current" }
      sumprint(i_rm,   "<a HREF=\"" z2 "/" z ".html" "\">E</a>" )
    }

    #
    # Event messages
    #
    sumprint(i_rm,  "<td nowrap bgcolor=gray><h5>" )
    sumprint(i_rm,  msgs[i_rm]          )
   
    #
    # Flags
    #

    flagout=""

    if (pager_flag[i_rm] == 1)       { flagout = flagout"PGR " }
    if (t_mustbeup[i_rm] == "N")     { flagout = flagout"MBUN " }
    if (kio[i_rm] == 1)              { flagout = flagout"Kaio " }
    if (ops[i_rm] == "YES")          { flagout = flagout"OPS-N"inst_num[i_rm]" " }
    if (standby[i_rm] == "STANDBY")  { flagout = flagout"Standby " }
    if (asyncio[i_rm] == "Y")        { flagout = flagout"AsyncIO " }
    if (wstats[i_rm] == "1")         { flagout = flagout"WStats " }
    if (segshared[i_rm] == 1)        { flagout = flagout"ShSegs " }
    if (shmmagic[i_rm] == 1)         { flagout = flagout"Magic " }
    if (dr_status[i_rm] == "(Sec)" ) { flagout = flagout"HdrS "  }
    if (dr_status[i_rm] == "(Prim)") { flagout = flagout"HdrP " }
    if (ts_command[i_rm] != "")      { flagout = flagout"TSCmd "  }
    if (comm_method[i_rm] != "")     { flagout = flagout""comm_method[i_rm]  }

    sumprint(i_rm,  "<td nowrap><h6><font color=purple>" )
    sumprint(i_rm,  flagout                        )
    sumprint(i_rm,  "</font>"                     )

    #
    # DBMS version
    #
   
    # Test
    print "Test 2 - "title[i_rm] " " sw_version[i_rm]

    if (sw_version[i_rm] == 0)
    {
      sw_version[i_rm] = ""
      sw_color[i_rm]   = "white"
    }
   
    if (ver_colors == "N")
    {
      sumprint(i_rm,  "<td nowrap><h5>" )
    }
    else
    {
      sumprint(i_rm,  "<td bgcolor="sw_color[i_rm]"><h5>" )
    }
    sumprint(i_rm,  sw_version[i_rm] )

    #
    # Hours since last backup
    #

    if (runmon[i_rm] == "N" || up[i_rm] != "Y" || backup_age[i_rm] == "")
    {
      sumprint(i_rm,  "<td><h5>" backup_method_long[i_rm] )
      if (arclog[i_rm] ne "") { sumprint(i_rm,  "(" arclog[i_rm] ")" ) }
    }
    else
    {
      sumprint(i_rm,  "<td nowrap bgcolor=\"" bckhours_c[i_rm] "\"><h5>" )

      if (bckhours[i_rm] != "" || backup_age[i_rm] != "")
      {
	if (bckhours_c[i_rm] == "black")
	{
	  sumprint(i_rm,  "<font color=white>" )
	}

	sumprint(i_rm,  backup_method_long[i_rm] )
	if (arclog[i_rm] ne "") { sumprint(i_rm,  "(" arclog[i_rm] ")" ) }
	if (backup_method_long[i_rm] ne "") { sumprint(i_rm,  ":" ) }

	sumprint(i_rm,  bckhours[i_rm] )

	if (backup_age[i_rm] != "" && up[i_rm] != "I" && db_status[i_rm] != "R")
	{
	  sumprint(i_rm,  "/" )
	  sumprint(i_rm,  backup_age[i_rm] )
	}

	if (backup_command[i_rm] != "" && up[i_rm] != "I" && db_status[i_rm] != "R")
	{
	  sumprint(i_rm,  "(R)" )
	}

	if (bckhours_c[i_rm] == "black")
	{
	  sumprint(i_rm,  "</font>" )
	}
        sumprint(i_rm,   " " )
      }
    }

    #
    # CPU model 
    #

    sumprint(i_rm,  "<td nowrap><h5>" )
    if (length(hw_model[i_rm]) > 5) 
    { 
      hw_model[i_rm] = substr(hw_model[i_rm],1,5) 
    }
    if (length(hw_model[i_rm]) > 0)
    {
      if (length(hw_memory[i_rm]) > 0)
      {
        sumprint(i_rm,  hw_model[i_rm] "-" hw_processors[i_rm] "(" hw_memory[i_rm] ")" )
      }
      else
      {
        sumprint(i_rm,  hw_model[i_rm] "-" hw_processors[i_rm] )
      }
    }
    sumprint(i_rm,   " " )

    #
    # OS version
    #

    sumprint(i_rm,  "<td nowrap><h5>" )
    z = os[i_rm]  "-" os_version[i_rm] 
 
    if (os_mode[i_rm] != "")
    {
      z = z "(" os_mode[i_rm] ")"
    }
    sumprint(i_rm, z )

    #
    # Informix S/N
    #

    #sumprint(i_rm,  "<td><h5>" )
    #sumprint(i_rm,  sn[i_rm] )
    #print  " " )

    #
    # Db's
    #

    ##sumprint(i_rm,  "<td align=right><h5>" )
    ##sumprint(i_rm,  num_databases[i_rm] )
    ##print  " " )
    tot_db += num_databases[i_rm]

    #
    # Appl Db's
    #

    ##sumprint(i_rm,  "<td align=right><h5>" )
    ##sumprint(i_rm,  num_appldatabases[i_rm] )
    ##print  " " )
    ##
    tot_appldb += num_appldatabases[i_rm]

    #
    # Dbspaces
    #

    ##sumprint(i_rm,  "<td align=right><h5>" )
    ##sumprint(i_rm,  num_dbspaces[i_rm] )
    ##print  " " )
    tot_dbspaces += num_dbspaces[i_rm]

    #
    # Tables
    #

    ##sumprint(i_rm,  "<td align=right><h5>" )
    ##sumprint(i_rm,  num_tables[i_rm] )
    ##print  " " )
    tot_tables += num_tables[i_rm]
    tot_maxusers += maxusers[i_rm]

    #
    # Space alloc/used
    #
    ###if (int(system_size[i_rm]) > 0)
    if (system_size[i_rm] != "")
    {
      z = int(system_size[i_rm]) "/" int(system_used[i_rm])
      sumprint(i_rm,  "<td align=right nowrap><h5>" z )
    }
    else
    {
      sumprint(i_rm,  "<td align=right><h5> "     )
    }
    tot_alloc += int(system_size[i_rm])
    tot_used += int(system_used[i_rm])

    #
    # Duration on this instance
    #
    if (time_total == 0) { time_total = 1 }
    pct = int((instance_duration[i_rm] / time_total) * 100)
    if  (instance_duration[i_rm] > 180) { sumprint(i_rm,  "<td align=right nowrap bgcolor=yellow><h6>"  ) }
    else           sumprint(i_rm,  "<td align=right nowrap><h6>"              )
    sumprint(i_rm,  instance_duration[i_rm] " (" pct "%)" )
    sumprint(i_rm,   " " )
    instance_duration[i_rm]  = ""

    #
    # Misc (was SAP Release)
    #
   
    sumprint(i_rm,  "<td nowrap><h6>" )
    if (sapkern[i_rm] != "")
    {
      sumprint(i_rm,  "SAP:" sapkern[i_rm] "/" saprlse[i_rm] )
     
    }
    if (num_disks[i_rm] != "")
    {
      sumprint(i_rm,  "Disks:" )
      sumprint(i_rm,  num_disks[i_rm] )
      sumprint(i_rm,   " " )
      tot_disks += num_disks[i_rm]
    }

    #
    # Totals
    #

    t_critical[i_rm] += m_critical[i_rm]
    t_warning[i_rm]  += m_warning[i_rm]
    t_info[i_rm]     += m_info[i_rm]

    ##msg = sprintf(  "%6i %6i %6i        %6i %6i %6i\n",t_critical[i_rm],t_warning[i_rm],t_info[i_rm],m_critical[i_rm],m_warning[i_rm],m_info[i_rm])
    ##logit(msg)

    m_critical[i_rm] = 0
    m_warning[i_rm]  = 0
    m_info[i_rm]  = 0

    # End of line for this instance
    sumprint(i_rm,"","W",system_size[i_rm])

    i_rm++
  }

  #
  # Now insert the rows that are in sqlfil
  #
  ##system("cat " sqlfil)

  if (use_oracle == "Y")
  {
    mx = sprintf("Oracle - Inserting rows into dbamon.instances table")
    logit(mx)
    system("/opt/dbamon/bin/dbamon_ora_rsql.pl " sqlfil)
  }
  else if (use_mysql == "Y")
  {
    mx = sprintf("MySql - Inserting rows into instances table")
    logit(mx)
    system("/opt/dbamon/bin/sql/rsql " sqlfil)
  }

  #
  #
  # Report trailer

  print "\n    Total Maxusers: " tot_maxusers >> rptdir"/instances.txt"

  #
  # Create detail total line
  #

  #print "<td colspan=12 align=right bgcolor=lightgrey><h5>Total:" >> html_sys_path
  ##print "<td align=right><h5>" tot_db "</b>" >> html_sys_path
  ##print "<td align=right><h5>" tot_appldb "</b>" >> html_sys_path
  ##print "<td align=right><h5>" tot_dbspaces "</b>" >> html_sys_path
  ##print "<td align=right><h5>" int(tot_tables) "</b>" >> html_sys_path
  #print "<td align=right><h5>" tot_alloc "/" tot_used "</b>" >> html_sys_path
  #print "<td align=right><h5>" tot_disks "</b>" >> html_sys_path

  print "</table>" >> html_sys_path

  print "<hr>" >> html_sys_path

  #
  # Checks summary
  #
  
  print "<h4>Montoring Details</h4>" >> html_sys_path

  print "<table border=1 bgcolor=lightgrey>" >> html_sys_path
  print "<tr> <td rowspan=" s_count + 2 "> <b>Checks:</b>" >> html_sys_path

  print "<tr> <th><h5>Description <th><h5>This<br>Iteration? <th><h5>Duration<br>(Minutes)" >> html_sys_path

  for (i=1; i<= s_count; i++)
  {
    print s_array[i] >> html_sys_path
  }

  print "</table>" >> html_sys_path
  print "<hr>" >> html_sys_path

  print "<b>Note:</b> This page makes use of HTML tables and only looks" >> html_sys_path
  print "correct when using Netscape 1.1+ (or any Web browser that supports HTML-V3)" >> html_sys_path
  print "<hr>" >> html_sys_path

  close html_sys_path
  close rptdir"/instances.txt"
  close rptdir"/instances_sn.txt"
}


#--------------------------------------------------------------------------------
function run_monitor(f)   
#
# Run monitoring functions
#
{
  this_function = f
  wheretolog = "D"
  s_flag = "Y"
  i_rm = 1

  msg = sprintf("---------------------------------------------------")
  logit(msg)

  if (f=="infNFile")
  {
    s_title = "NFile"
    msg = sprintf("Informix - Checking UX NFILE Kernel Parm ...")
    logit(msg)
  }

  if (f=="infLongTX")
  {
    s_title = "LongTx"
    msg = sprintf("Informix - Checking for Long Transactions ...")
    logit(msg)
  }

  if (f=="infChkDup")
  {
    s_title = "Dup"
    msg = sprintf("Informix - Checking for Duplicate ONCONFIG Parms ...")
    logit(msg)
  }

  if (f=="infHDR")
  {
    s_title = "HDR"
    msg = sprintf("Informix - Checking HDR ...")
    logit(msg)
  }

  if (f=="infDBS")
  {
    s_title = "DBSpaces"
    msg = sprintf("Informix - Checking for full DBSpaces ...")
    logit(msg)
  }

  if (f=="infSWVer")
  {
    s_title = "Informix Version Mgmt."
    msg = sprintf("Informix - Checking Version ...")
    logit(msg)
  }

  if (f=="DownloadSW")
  {
    s_title = "Software Download"
    msg = sprintf("(All DBMSs) - Downloading DBAmon Software ...")
    logit(msg)
  }

  if (f=="infUp")
  {
    s_title = "Informix On-Line"
    msg = sprintf("Informix - Instance active ...")
    logit(msg)
  }

  if (f=="infSaveCfg")  
  { 
    s_title = "Save Configuration"
    msg = sprintf("Informix - Saving Configuration Information ...")
    logit(msg)
  }

  if (f=="infLlogs")    
  {
    s_title = "Logical Logs Full"
    msg = sprintf("Informix - Checking for full logical log files ...")
    logit(msg)
  }

  if (f=="infMLog")      
  {
    s_title = "Error onstat -m Messages"
    msg = sprintf("Informix - Checking for log messages ...")
    logit(msg)
  }

  if (f=="infPerf")    
  {
    s_title = "Performance Data"
    msg = sprintf("Informix - Checking performance metrics ...")
    logit(msg)
  }

  if (f=="infChunksDown")  
  {
    s_title = "Down Chunks"
    msg = sprintf("Informix - Checking for down chunks ...")
    logit(msg)
  }

  if (f=="infArc")      
  {
    s_title = "Archive Age"
    msg = sprintf("Informix - Checking archive age ...")
    logit(msg)
  }

  if (f=="infExtents")  
  {
    s_title = "Table Extents"
    msg = sprintf("Informix - Checking table extents ...")
    logit(msg)
  }

  if (f=="infCkpt")  
  {
    s_title = "Informix - Checkpoint Duration"
    msg = sprintf("Informix - Excessive Checkpoint duration ...")
    logit(msg)
  }

  if (f=="infLocks")  
  {
    s_title = "Informix - Locks Used"
    msg = sprintf("Informix - Checking locks used ...")
    logit(msg)
  }

  if (f=="infShmem")  
  {
    s_title = "V Shared Memory"
    msg = sprintf("Informix - Checking Shared Memory V Segments ...")
    logit(msg)
  }

  if (f=="infCleaners")  
  {
    s_title = "CLEANERS"
    msg = sprintf("Informix - Checking CLEANERS ...")
    logit(msg)
  }

  if (f=="orantUp")  
  {
    s_title = "Oracle/NT UP"
    msg = sprintf("Oracle/NT - Up ...")
    logit(msg)
  }

  if (f=="orantArclog")  
  {
    s_title = "Oracle/NT Arclog Disk "
    msg = sprintf("Oracle/NT - Arclog Disk Full ...")
    logit(msg)
  }

  if (f=="orantBkup")  
  {
    s_title = "Oracle/NT Backup Age"
    msg = sprintf("Oracle/NT - Backup Age ...")
    logit(msg)
  }

  if (f=="sqlUp")  
  {
    s_title = "MSSQL UP"
    msg = sprintf("MSSQL - Up ...")
    logit(msg)
  }

  if (f=="sqlBkup")  
  {
    s_title = "MSSQL Backup Age"
    msg = sprintf("MSSQL - Backup Age ...")
    logit(msg)
  }

  if (f=="sqlAlerts")  
  {
    s_title = "MSSQL Alerts"
    msg = sprintf("MSSQL - Alerts ...")
    logit(msg)
  }

  if (f=="oraapUp")  
  {
    s_title = "OracleApps UP"
    msg = sprintf("OracleApps - Up ...")
    logit(msg)
  }

  if (f=="oraUp")  
  {
    s_title = "Oracle UP"
    msg = sprintf("Oracle - Up ...")
    logit(msg)
  }

  if (f=="oraBkup")  
  {
    s_title = "Oracle Bkups"
    msg = sprintf("Oracle - RMAN Backup Age ...")
    logit(msg)
  }

  if (f=="oraArclog")  
  {
    s_title = "Oracle Arclogs"
    msg = sprintf("Oracle - Arclogs ...")
    logit(msg)
  }

  if (f=="oraExtents")  
  {
    s_title = "Oracle Extents"
    msg = sprintf("Oracle - Extents ...")
    logit(msg)
  }

  if (f=="oraAlerts")  
  {
    s_title = "Oracle Alert Log"
    msg = sprintf("Oracle - Alert Log ...")
    logit(msg)
  }

  if (f=="oraLsnr")  
  {
    s_title = "Oracle Listener UP"
    msg = sprintf("Oracle - Listener Up ...")
    logit(msg)
  }

  if (f=="oraDatafiles" || f=="orantDatafiles")  
  {
    s_title = "Oracle Datafile Check"
    msg = sprintf("%s - Checking For OFFLINE Oracle Datafiles ...",f)
    logit(msg)
  }

  if (f=="oraTSFull")  
  {
    s_title = "Oracle Tablespaces Full"
    msg = sprintf("Oracle - Checking Tablespaces (Full) ...")
    logit(msg)
  }

  msg = sprintf("---------------------------------------------------")
  logit(msg)

  "perl -e 'print time'" | getline section_start 
  close "perl -e 'print time'"

  while (i_rm <= high_host) 
  {
    ##print i_rm " " high_host " " runmon[i_rm]

    #
    # If no monitoring for this instance, don't do anything
    #
    if (runmon[i_rm] == "N")   
    {
      history_dummy(i_rm)
      i_rm++
      continue
    }

    # Start timer to track time spend on this instance
    "perl -e 'print time'" | getline instance_start 
    close "perl -e 'print time'"

    #
    # Backup age monitoring only
    #
    if (runmon[i_rm] == "B")   
    {
      if (f=="DownloadSW") { DownloadSW(i_rm) }
      # Oracle
      if (f=="oraUp"      && dbms[i_rm] == "Oracle")   {     oraUp(i_rm) }
      if (f=="oraArclog"  && dbms[i_rm] == "Oracle")   { oraArclog(i_rm) }
      if (f=="oraBkup"    && dbms[i_rm] == "Oracle")   {   oraBkup(i_rm) }
      # Informix
      if (f=="infUp"      && dbms[i_rm] == "Informix") {     infUp(i_rm) }
      if (f=="infLlogs"   && dbms[i_rm] == "Informix") {  infLlogs(i_rm) }
      if (f=="infArc"     && dbms[i_rm] == "Informix") {    infArc(i_rm) }
      # MSSQL
      if (f=="sqlUp"      && dbms[i_rm] == "MSSQL")    {     sqlUp(i_rm) }
      if (f=="sqlBkup"    && dbms[i_rm] == "MSSQL")    {   sqlBkup(i_rm) }
      history_dummy(i_rm)
    }

    #
    # Procs to run 
    #

    if (runmon[i_rm] == "Y")   
    {
      # Non-DBMS specific subroutines
      if (f=="DownloadSW") DownloadSW(i_rm)

      # OraApps subroutines
      if (f=="oraapUp"      && dbms[i_rm] == "OracleApps") {  oraapUp(i_rm) }

      # MSSQL subroutines
      if (f=="sqlUp"      && dbms[i_rm] == "MSSQL") {      sqlUp(i_rm) }
      if (f=="sqlBkup"    && dbms[i_rm] == "MSSQL") {    sqlBkup(i_rm) } 
      if (f=="sqlAlerts"  && dbms[i_rm] == "MSSQL") {  sqlAlerts(i_rm) }

      # Oracle/NT subroutines
      if (f=="orantUp"        && dbms[i_rm] == "OracleNT") {        orantUp(i_rm) }
      if (f=="orantArclog"    && dbms[i_rm] == "OracleNT") {    orantArclog(i_rm) }
      if (f=="orantDatafiles" && dbms[i_rm] == "OracleNT") { orantDatafiles(i_rm) }
      if (f=="orantBkup"      && dbms[i_rm] == "OracleNT") {      orantBkup(i_rm) }

      # Oracle subroutines
      if (f=="oraUp"         && dbms[i_rm] == "Oracle") {        oraUp(i_rm) }
      if (f=="oraDatafiles"  && dbms[i_rm] == "Oracle") { oraDatafiles(i_rm) }
      if (f=="oraLsnr"       && dbms[i_rm] == "Oracle") {      oraLsnr(i_rm) }
      if (f=="oraTSFull"     && dbms[i_rm] == "Oracle") {    oraTSFull(i_rm) }
      if (f=="oraAlerts"     && dbms[i_rm] == "Oracle") {    oraAlerts(i_rm) }
      if (f=="oraExtents"    && dbms[i_rm] == "Oracle") {   oraExtents(i_rm) }
      if (f=="oraArclog"     && dbms[i_rm] == "Oracle") {    oraArclog(i_rm) }
      if (f=="oraBkup"       && dbms[i_rm] == "Oracle") {      oraBkup(i_rm) }

      # Informix subroutines
      if (f=="infLongTX"      && dbms[i_rm] == "Informix") {      infLongTX(i_rm) }
      if (f=="infCleaners"    && dbms[i_rm] == "Informix") {    infCleaners(i_rm) }
      if (f=="infChkDup"      && dbms[i_rm] == "Informix") {      infChkDup(i_rm) }
      if (f=="infHDR"         && dbms[i_rm] == "Informix") {         infHDR(i_rm) }
      if (f=="infDBS"         && dbms[i_rm] == "Informix") {         infDBS(i_rm) }
      if (f=="infSWVer"       && dbms[i_rm] == "Informix") {       infSWVer(i_rm) }
      if (f=="infUp"          && dbms[i_rm] == "Informix") {          infUp(i_rm) }
      if (f=="infSaveCfg"     && dbms[i_rm] == "Informix") {     infSaveCfg(i_rm) }
      if (f=="infMLog"        && dbms[i_rm] == "Informix") {        infMLog(i_rm) }
      if (f=="infLlogs"       && dbms[i_rm] == "Informix") {       infLlogs(i_rm) }
      if (f=="infPerf"        && dbms[i_rm] == "Informix") {        infPerf(i_rm) }
      if (f=="infChunksDown"  && dbms[i_rm] == "Informix") {  infChunksDown(i_rm) }
      if (f=="infArc"         && dbms[i_rm] == "Informix") {         infArc(i_rm) }
      if (f=="infExtents"     && dbms[i_rm] == "Informix") {     infExtents(i_rm) }
      if (f=="infLocks"       && dbms[i_rm] == "Informix") {       infLocks(i_rm) }
      if (f=="infCkpt"        && dbms[i_rm] == "Informix") {        infCkpt(i_rm) }
      if (f=="infShmem"       && dbms[i_rm] == "Informix") {       infShmem(i_rm) }
      if (f=="infNFile"       && dbms[i_rm] == "Informix") {       infNFile(i_rm) }
    }

    # Stop timer to track time spend on this instance
    "perl -e 'print time'" | getline instance_end 
    close "perl -e 'print time'"
    instance_duration[i_rm] += (instance_end - instance_start)

    #
    # Increment host counter
    #
    i_rm++
  }

  "perl -e 'print time'" | getline section_end 
  close "perl -e 'print time'"

  s_time = section_end - section_start
  
  s_array[++s_count] = sprintf("<tr> <td> <h5> %s <td> <h5> %s <td> <h5> %s", s_title, s_flag , int(s_time / 60))

  wheretolog = "S"
  msg = sprintf("Section %s duration: %s seconds",f,s_time)
  logit(msg)
}

#----------------------------------------------------------------------
function read_parm()
#
# This function will read the parm file
#
{
  msg = sprintf("Reading parm file ...")
  logit(msg)

  longest = 0

  i_hosts = 0
  i_users = 0

  #
  # Compile /opt/dbamon/adm/instances/*.dbc and dbamonrc into 1 file
  #

  system("rm "tmpdir"/instances 2>/dev/null")
  system("rm "tmpdir"/dbamonrc 2>/dev/null")

  while (getline < parmfl > 0)
  {
    ##print $0 
    
    # Try to extract Admin_EMail because we will need that for parsing
    # and it may be at the end of the file
    if ($1 == "Admin_EMail:") { dbamon_admin = $2 }

    if ($1 == "Include:")
    {
      system("cat " $2 " > "tmpdir"/instances")
      file = tmpdir"/instances"
      while (getline < file > 0)
      {
        if (dbamon_alpha == "")
        {
	  print $0 >> parmall
        }
        else
        {
          # Get the first letter of the hostname found in each Host: entry
	  if ($1 == "Host:")
	  {
	    z = toupper(substr($2,1,1))
	    ##print "z="z " dbamon_alpha=" dbamon_alpha " 2="$2
	    if (index(dbamon_alpha,z) > 0) 
            { 
              alpha_flag = 1 
	      msg = sprintf("dbamon_alpha=%s Including Host: %s",dbamon_alpha,$2)
	      logit(msg)
            }
            else alpha_flag = 0
            
          }
          if (alpha_flag) { print $0 >> parmall }
        }
      } # end of while getline
      close file
    }
    else # for if include
    {
      print $0 >> parmall
    }
  }
  close parmfl
  close parmall
  close tmpdir"/instances"

  #
  # Process combined parm file
  #

  while (getline < parmall > 0)
  {
    if (substr($1,1,1) != "#" && $1 != "Section")
    {

      if (section == "HOSTS") 
      { 

	if ($1 == "Host:")
        {
          i_hosts++
          hostname[i_hosts] = $2 
	  if (debug_read) { printf("Found Host %s\n",hostname[i_hosts]) }
        }

        # 
        # Write line to mysql table dbcactive
        #

        if ($0 != "")
        {

	  ##print insertdb >> sqlfil # We already did this for the delete
	    print "insert into dbcactive (dbamonmode,i_hosts,text)" >> sqlfil
	    textfix = $0
	    z1 = "\\\\"
	    z2 = "/"
	    ##print "z1=" z1
	    ##print "z2=" z2
	    gsub(z1,z2,textfix)
	    z1 = "&"
	    z2 = "[Ampersand]"
	    ##print "z1=" z1
	    ##print "z2=" z2
	    gsub(z1,z2,textfix)
	    print "  values ('" modeout "','"  i_hosts "','"textfix"');" >> sqlfil

        }

        #
        # Parse data
        #

	if ($1 == "Comm_Method:")      { comm_method[i_hosts]  = $2 }

	if ($1 == "Title1:")           { title1[i_hosts]  = $2 }
	if ($1 == "Title2:")           { title2[i_hosts]  = $2 }
	if ($1 == "Title3:")           { title3[i_hosts]  = $2 }

        z = length(title1[i_hosts])
        if (z > 16)
        {
          msg = "Title1: value: " title1[i_hosts] " length exceeds maximum of 16 - truncated"
          error_msg(msg,i_hosts)
          title1[i_hosts] = substr(title1[i_hosts],1,16)
        }

	if ($1 == "Host_URL:")         { host_url[i_hosts]  = $2 }
 
	if ($1 == "Title1_URL:")       { title1url[i_hosts]  = $2 }
	if ($1 == "Title2_URL:")       { title2url[i_hosts]  = $2 }

	if ($1 == "Userid:")           { userid[i_hosts]   = $2 }
	if ($1 == "UseridApps:")       { useridap[i_hosts]   = $2 }

	if ($1 == "DBMS:")             { dbms[i_hosts] = $2 }
	if ($1 == "SWPackage:")        { dbms[i_hosts] = $2 }

	if ($1 == "Monitor:")          { runmon[i_hosts] = $2 }

	if ($1 == "Monitor_Hours:")    { mon_hours[i_hosts] = $2 }
	if ($1 == "Monitor_Days:")     { mon_days[i_hosts] = $2 }
	if ($1 == "Monitor_Exclude:")  { mon_excl[i_hosts] = $2 }
	##print "mxin=" mon_excl[4] 

	if ($1 == "Perl_Path:")        { perlpath[i_hosts] = $2 }

	if ($1 == "NT_RCP_Bug:")       { ntrcpbug[i_hosts] = $2 }
 
	if ($1 == "ORACLE_HOME:")      { orahome[i_hosts] = $2 }

	if ($1 == "ORACLE_SID:")       
        {
          orasid[i_hosts] = $2
          # This is for the inhib file name
          server[i_hosts] = $2  
        }

        if ($1 == "Config:")
        {
          split($2,w_server,"/")
	  server[i_hosts]   = w_server[1]
	  config[i_hosts]   = w_server[2]
        }

	if ($1 == "Inf_Server:")   { server[i_hosts] = $2 }
	if ($1 == "ON_Config:")    { config[i_hosts] = $2 }
	if ($1 == "SQL_Hosts:")    { sqlhosts[i_hosts] = $2 }

	if ($1 == "Informix_Version:") { infver[i_hosts]   = $2 }
	if ($1 == "Local_Or_Remote:")  { lclrmt[i_hosts]   = $2 }
	if ($1 == "Informix_Dir:")     { infdir[i_hosts]   = $2 }

	##DEBUG##print infdir[i_hosts] " " i_hosts 

        if ($1 == "T_Disk_Full:" || $1 == "T_TS_Full:" || $1 == "T_DBSpace_Full:")
        {
          x = index($2,"/")
	  t_diskwarn[i_hosts] = substr($2,1,x-1)
	  w_diskcrit = substr($2,x+1)
	  t_diskcrit[i_hosts] = w_diskcrit + 0
        }

	if ($1 == "T_TS_Command:") 
        {
          z = index($0,$2)
          ts_command[i_hosts]    = substr($0,z) 
        }
  
        if ($1 == "T_Arclog_Full:")
        {
          x = index($2,"/")
	  t_arclog_w[i_hosts] = substr($2,1,x-1)
	  t_arclog_c[i_hosts] = substr($2,x+1)
          t_arclog_fix[i_hosts] = $3
        }
  
	if ($1 == "T_DBSpace_Free:" || $1 == "T_TS_Free:") { t_freespace[i_hosts] = $2 }

	if ($1 == "T_Read_Hit:")    { t_readhit[i_hosts] = $2 }
	if ($1 == "T_Write_Hit:")   { t_writehit[i_hosts] = $2 }

	if ($1 == "T_Long_Tx:")     { t_longtx[i_hosts] = $2 }

	if ($1 == "T_Extents:")
        {     
          t_extents[i_hosts] = $2
          t_extents_fix[i_hosts] = $3
        }

	if ($1 == "OpC_Application:")  { opc_appl[i_hosts] = $2 " " $3 " " $4 }
	if ($1 == "OpC_Object:")       { opc_obj[i_hosts] = $2  }
	if ($1 == "OpC_Msg_Group:")    { opc_mg[i_hosts] = $2 }
	if ($1 == "OpC_Gateway:")      { opc_gw[i_hosts] = $2 }

	if ($1 == "Must_Be_Up:")       { t_mustbeup[i_hosts] = $2 }

	if ($1 == "Mem_Window:")       { memwin[i_hosts] = $2 }

	if ($1 == "Backup_Age:")       { backup_age[i_hosts] = $2 }
	if ($1 == "Backup_Check_DBs:") { backup_dbs[i_hosts] =  ","tolower($2)"," }

	if ($1 == "Backup_Command:") 
        {
          z = index($0,$2)
          backup_command[i_hosts]    = substr($0,z) 
          backup_rerun_iter[i_hosts] = 9999999
        }

	if ($1 == "L0_Age:")         { l0_age[i_hosts] = $2 }

	if ($1 == "Max_Extents:")    { max_extents[i_hosts] = $2 }

	if ($1 == "Pager_Subject:")  { pager_subject[i_hosts] = $2 }
	if ($1 == "Pager_EMail:")    { pager_email[i_hosts] = $2 " " $3 " " $4 }

 	if ($1 == "Notify_List:")  
        {
          h_userlist[i_hosts] = $2

          z = title1[i_hosts]
          ##print "z before=" z
          gsub("/","_",z)
          ##print "z after=" z
          infname[i_hosts]  = z
	 
	  if (length(hostname[i_hosts] ":" infname[i_hosts]) > longest)
	  {  
	    longest = length(hostname[i_hosts] ":" infname[i_hosts])
	  }

	  m_critical[i_hosts] = 0
	  m_warning[i_hosts]  = 0
	  m_info[i_hosts]  = 0

	  t_critical[i_hosts] = 0
	  t_warning[i_hosts]  = 0
	  t_info[i_hosts]  = 0

	  up[i_hosts]       = " "

          if (userid[i_hosts] != "")
          {
	    tuserid = " -l " userid[i_hosts] " "
          }
          else
          {
	    tuserid = " " 
          }

          # Defaults 

          if (runmon[i_hosts] == "")      { runmon[i_hosts] = "Y"  }
	  if (infver[i_hosts] == "")      { infver[i_hosts] = "7"  }
	  if (lclrmt[i_hosts] == "")      { lclrmt[i_hosts] = "R"  }
          if (t_freespace[i_hosts] == "") { t_freespace[i_hosts] = 999999999 }
          if (dbms[i_hosts] == "")        { dbms[i_hosts] = "Informix" }
          if (t_mustbeup[i_hosts] == "")  { t_mustbeup[i_hosts] = "Y" }
          if (l0_age[i_hosts] == "")      { l0_age[i_hosts] = 30 }
          if (perlpath[i_hosts] == "")    { perlpath[i_hosts] = "perl"  }

          # Evaluate DBMS

          what[i_hosts] = "DB"

          if      (dbms[i_hosts] == "Informix") 
          {
            num_informix++
            if (os[i_hosts] == "") os[i_hosts] = "UX"
          }
          else if (dbms[i_hosts] == "Oracle")   
          {
            num_oracle++
            if (os[i_hosts] == "") os[i_hosts] = "UX"
          }
          else if (dbms[i_hosts] == "OracleApps")   
          {
            what[i_hosts] = "AP"
            num_oracleapps++
            if (os[i_hosts] == "") os[i_hosts] = "UX"
          }
          else if (dbms[i_hosts] == "MSSQL")  
          {
            num_mssql++
            if (os[i_hosts] == "") os[i_hosts] = "NT"
          }
          else if (dbms[i_hosts] == "OracleNT")  
          {
            num_oraclent++
            if (os[i_hosts] == "") os[i_hosts] = "NT"
          }
          else 
          {
            num_unknown++
            if (os[i_hosts] == "") os[i_hosts] = "??"
	    msg = "DBMS: Value: " dbms[i_hosts] " Invalid for Host: " hostname[i_hosts]
	    error_msg(msg,i_hosts)
          }

	  if (debug_read) { printf("Processing Host/Instance %s/%s\n",hostname[i_hosts],infname[i_hosts]) }

          # Prevent errors

	  if (comm_method[i_hosts] == "ssh" && dbms[i_hosts] != "Oracle")
	  {
	    msg = "Comm_Method: ssh is only valid with Dbms: Oracle"
	    error_msg(msg,i_hosts)
	    comm_method[i_hosts] == ""
	  }

          # Create remsh commands

          # Default remsh cmd
          remshcmd[i_hosts] = "remsh"

	  if (infver[i_hosts] == "5" && lclrmt[i_hosts] == "L")
	  {
	    cmdpfx[i_hosts]="export INFORMIXDIR="infdir[i_hosts]";export TBCONFIG="server[i_hosts]";"infdir[i_hosts]"/bin/"
	    cmdsfx[i_hosts]=""
	  }

	  if (infver[i_hosts] == "5" && lclrmt[i_hosts] == "R")
	  {
	    cmdpfx[i_hosts]="remsh "hostname[i_hosts] tuserid " 'export INFORMIXDIR="infdir[i_hosts]";export TBCONFIG="server[i_hosts]";"infdir[i_hosts]"/bin/"
	    cmdsfx[i_hosts]="'"
	  }

	  if (infver[i_hosts] == "6" && lclrmt[i_hosts] == "R" && sqlhosts[i_hosts] == "")
	  {
	    cmdpfx[i_hosts]="remsh "hostname[i_hosts] tuserid " 'export INFORMIXDIR="infdir[i_hosts]";export INFORMIXSERVER="server[i_hosts]";export ONCONFIG="config[i_hosts]";"infdir[i_hosts]"/bin/"
	    cmdsfx[i_hosts]="'"
	  }

	  if (infver[i_hosts] == "6" && lclrmt[i_hosts] == "R" && sqlhosts[i_hosts] != "")
	  {
	    cmdpfx[i_hosts]="remsh "hostname[i_hosts] tuserid " 'export INFORMIXDIR="infdir[i_hosts]";export INFORMIXSERVER="server[i_hosts]";export ONCONFIG="config[i_hosts]";export INFORMIXSQLHOSTS=" sqlhosts[i_hosts]";"infdir[i_hosts]"/bin/"
	    cmdsfx[i_hosts]="'"
	  }

	  if (infver[i_hosts] == "7" && lclrmt[i_hosts] == "R" && sqlhosts[i_hosts] == "")
	  {
	    cmdpfx[i_hosts]="remsh "hostname[i_hosts] tuserid " 'export INFORMIXDIR="infdir[i_hosts]";export INFORMIXSERVER="server[i_hosts]";export ONCONFIG="config[i_hosts]";"infdir[i_hosts]"/bin/"
	    cmdsfx[i_hosts]="'"
	  }

	  if (infver[i_hosts] == "7" && lclrmt[i_hosts] == "R" && sqlhosts[i_hosts] != "")
	  {
	    cmdpfx[i_hosts]="remsh "hostname[i_hosts] tuserid \
              "'export INFORMIXDIR="infdir[i_hosts] \
              ";export INFORMIXSERVER="server[i_hosts] \
              ";export ONCONFIG="config[i_hosts] \
              ";export INFORMIXSQLHOSTS=" sqlhosts[i_hosts] \
              ";" infdir[i_hosts] "/bin/"
	    cmdsfx[i_hosts]="'"
	  }

	  if (dbms[i_hosts] == "Oracle")
	  {
            if (comm_method[i_hosts] == "ssh")
            {
	      cmdpfx[i_hosts]="ssh "hostname[i_hosts] tuserid \
		"'export ORACLE_HOME="orahome[i_hosts] \
		";export ORACLE_SID="orasid[i_hosts] \
		";export PATH=$PATH:"orahome[i_hosts]"/bin;" 
	      cmdsfx[i_hosts]="'"
              remshcmd[i_hosts] = "ssh"
            }
            else
            {
	      cmdpfx[i_hosts]="remsh "hostname[i_hosts] tuserid \
		"'export ORACLE_HOME="orahome[i_hosts] \
		";export ORACLE_SID="orasid[i_hosts] \
		";export PATH=$PATH:"orahome[i_hosts]"/bin;" 
	      cmdsfx[i_hosts]="'"
              remshcmd[i_hosts] = "remsh"
            }
	  }

	  if (dbms[i_hosts] == "OracleApps")
	  {
            if (comm_method[i_hosts] == "ssh")
            {
	      cmdpfx[i_hosts]="ssh "hostname[i_hosts] tuserid \
		"'export ORACLE_HOME="orahome[i_hosts] \
		";export ORACLE_SID="orasid[i_hosts] \
		";export PATH=$PATH:"orahome[i_hosts]"/bin;" 
	      cmdsfx[i_hosts]="'"
              remshcmd[i_hosts] = "ssh"
            }
            else
            {
	      cmdpfx[i_hosts]="remsh "hostname[i_hosts] tuserid "'"
	      cmdsfx[i_hosts]="'"
              remshcmd[i_hosts] = "remsh"
            }
	  }

	  if (dbms[i_hosts] == "MSSQL")
	  {
            cmdpfx[i_hosts]="remsh "hostname[i_hosts] tuserid " '" 
            cmdsfx[i_hosts]="'"
            remshcmd[i_hosts] = "remsh"
	  }

	  if (dbms[i_hosts] == "OracleNT")
	  {
            cmdpfx[i_hosts]="remsh "hostname[i_hosts] tuserid " '" 
            cmdsfx[i_hosts]="'"
            remshcmd[i_hosts] = "remsh"
	  }

          ##print "parm remshcmd=" remshcmd[i_hosts]
	  ##print infver[i_hosts]  lclrmt[i_hosts]  sqlhosts[i_hosts]  memwin[i_hosts] 

	  if (infver[i_hosts] == "7" && lclrmt[i_hosts] == "R" && sqlhosts[i_hosts] == "" && memwin[i_hosts] != "")
	  {
	    cmdpfx[i_hosts]="remsh "hostname[i_hosts] tuserid \
              "'export INFORMIXDIR="infdir[i_hosts] \
              ";export INFORMIXSERVER="server[i_hosts] \
              ";export ONCONFIG="config[i_hosts] \
              ";setmemwindow -i " memwin[i_hosts] " -p $$" \
              ";" infdir[i_hosts] "/bin/"
	    cmdsfx[i_hosts]="'"
            
            print cmdpfx[i_hosts]
	  }

	  if (infver[i_hosts] == "7" && lclrmt[i_hosts] == "R" && sqlhosts[i_hosts] != "" && memwin[i_hosts] != "")
	  {
	    cmdpfx[i_hosts]="remsh "hostname[i_hosts] tuserid \
              "'export INFORMIXDIR="infdir[i_hosts] \
              ";export INFORMIXSERVER="server[i_hosts] \
              ";export ONCONFIG="config[i_hosts] \
              ";export INFORMIXSQLHOSTS=" sqlhosts[i_hosts] \
              ";setmemwindow -i " memwin[i_hosts] " -p $$" \
              ";" infdir[i_hosts] "/bin/"
	    cmdsfx[i_hosts]="'"
            
            print "2 " cmdpfx[i_hosts]
	  }

	  if (debug_read) { printf("cmdpfx=%s\n",cmdpfx[i_hosts]) }

        }   # End of Notify_List if


      }   # End of HOSTS section


      if (section == "USERS") 
      {
        i_users++

        thislist = $1

	templist = $0
	userlist[thislist] = substr(templist,6) 

        ##printf("Processing Userlist/User %s/%s\n",thislist,userlist[thislist])

      }   # End of USERS section

      if (section == "SYSTEM") 
      {
        ##print "rec="$0
	if ($1 == "Sleeptime:")             { sleep_time = $2 }
        else if ($1 == "Iterations:")       { iterations = $2 }
        else if ($1 == "Count_Tables:")     { count_tables = $2 }
        else if ($1 == "Admin_EMail:")      { dbamon_admin = $2 }
        else if ($1 == "Report_EMail:")     { report_email = $2 " " $3 " " $4 " " $5 " " $6 " " $7 " " $8 " " $9 }
        else if ($1 == "Log_Path:")         { log_path = $2 }
        else if ($1 == "Save_Dir:")         { save_dir = $2 }
        else if ($1 == "PN_Dir:")           { post_dir = $2 }
        else if ($1 == "Use_MySQL:")        { use_mysql = $2 }
        else if ($1 == "Use_Oracle:")       { use_oracle = $2 }
        else if ($1 == "Remsh_Sev:")        { remsh_sev = $2 }
        else if ($1 == "Remsh_Retries:")    { remsh_retries = $2 }
        else if ($1 == "HTML_Rpt_Path:")    { report_path = $2 }
        else if ($1 == "HTML_Log_Path:")    { html_path = $2 }
        else if ($1 == "HTML_Sys_Path:")    { html_sys_path = $2 }
        else if ($1 == "HTML_Events_Dir:")  { html_events_dir = $2 }
        else if ($1 == "HTTP_Events_Dir:")  { http_events_dir = $2 }
        else if ($1 == "HTTP_Details_Dir:") { http_details_dir = $2 }
        else if ($1 == "HTTP_Log_Path:")    { http_path = $2 }
        else if ($1 == "HTTP_Rpt_Path:")    { http_rpt_path = $2 }
        else if ($1 == "Images_Dir:")       { images_path = $2 }
        else if ($1 == "OpC_Messages:")     { opc = $2 }
        else if ($1 == "OpC_Trailer:")      { opc_trailer = substr($0,18) }
        else if ($1 == "Ver_Colors:")       { ver_colors = $2 }
        else if ($1 == "Make_Tickets:")     { make_tickets = $2 }
        else if ($1 == "ORACLE_SID:")       { oracle_sid = $2 }
        else if ($1 == "ORACLE_HOME:")      { oracle_home = $2 }
        else if ($1 == "Num_Tasks:")        { num_tasks = $2 }
        else if ($1 == "Task_Cfg_File:")    { task_cfg_file = $2 }
        else
        {
	  msg = sprintf("Error - SYSTEM section parameter %s unknown - exiting - rec=%s\n",$1,$0)
	  error_msg(msg)
          exit 1
        }

        # Defaults
	if (iterations == "*")   { iterations = 999999 }
	if (count_tables == "")  { count_tables = "Y" }
	if (make_tickets == "")  { make_tickets = "N" }
	if (remsh_retries == "") { remsh_retries = 1 }
	if (post_dir == "")      { post_dir = "/usr/local/bin/X11" }
	if (ver_colors == "")    { ver_colors = "N" }
	if (save_dir == "")      { save_dir = "/opt/dbamon/dat/config_save" }
	if (sleep_time == "")    { sleep_time = 30 }
	if (opc == "")           { opc = "N" }

      }   # End of SYSTEM section

    } # End of comment check

    if ($1 == "Section")
    {
      section = $2
      if (debug_read) printf("Now Processing %s Section ...\n",section)
    }

  } # End of getline do

  close parmall

  omsg = ""
  if (http_details_dir != "") { omsg = omsg "Warning - dbamonrc SYSTEM section parm HTTP_Detail_Dir: is obsolete - ignored\n" }
  if (http_rpt_path    != "") { omsg = omsg "Warning - dbamonrc SYSTEM section parm HTTP_Rpt_Path: is obsolete - ignored\n" }
  if (report_path      != "") { omsg = omsg "Warning - dbamonrc SYSTEM section parm HTML_Rpt_Path: is obsolete - ignored\n" }
  if (http_events_dir  != "") { omsg = omsg "Warning - dbamonrc SYSTEM section parm HTTP_Events_Dir: is obsolete - ignored\n" }
  if (http_path        != "") { omsg = omsg "Warning - dbamonrc SYSTEM section parm HTTP_Log_Path: is obsolete - ignored\n" }
  if (http_rpt_path    != "") { omsg = omsg "Warning - dbamonrc SYSTEM section parm HTTP_Rpt_Path: is obsolete - ignored\n" }
  if (html_sys_path    != "") { omsg = omsg "Warning - dbamonrc SYSTEM section parm HTML_Sys_Path: is obsolete - ignored\n" }
  if (html_events_dir  != "") { omsg = omsg "Warning - dbamonrc SYSTEM section parm HTML_Events_Dir: is obsolete - ignored\n" }
  if (html_path        != "") { omsg = omsg "Warning - dbamonrc SYSTEM section parm HTML_Log_Path: is obsolete - ignored\n" }
  if (images_path      != "") { omsg = omsg "Warning - dbamonrc SYSTEM section parm Images_Dir: is obsolete - ignored\n" }
  if (omsg  != "") 
  {
    msg = "Obsolete DBAmon dbamonrc SYSTEM Parameters Found\n" omsg
    error_msg(msg) 
  }

  # Assign values to html_ vars
  if (arg == "test") 
  {
    html_sys_path   = "/opt/dbamon/htm/dbamon_sys_test.html"
    html_events_dir = "/opt/dbamon/htm/events_current_test"
    html_path       = "/opt/dbamon/htm/dbamon_log_test.html"
  }
  else
  {
    html_sys_path   = "/opt/dbamon/htm/dbamon_sys.html"
    html_events_dir = "/opt/dbamon/htm/events_current"
    html_path       = "/opt/dbamon/htm/dbamon_log.html"
  } 
  # 2.03 modification - I will now write to .new path for HTML
  #   documents and will move _path to _path_perm at the end of each iteration
  html_path_perm   = html_path
  html_path        = html_path ".new"
  
  high_host = i_hosts
  high_users = i_users

  # Re-process hosts entries to pad for title with longest length

  spaces = "                                                    "
  i = 1

  while (i <= high_host) 
  {
    split(hostname[i],hostfixwk,".")

    # BB Test to accomodate multiple processes writing to the same log
    longest = 32

    title[i] = substr(hostfixwk[1] ":" infname[i] spaces,1,longest)

    # titleraw was added to have a way to grep for the host-instance
    # name in the dbspace history file to avoid duplicate entries
    # when the length of title shortens (bb 11Dec98)

    hostfix[i] = hostfixwk[1] 

    titleraw[i] = hostfixwk[1] ":" infname[i] 

    inhibfile[i] = hostfixwk[1] "_" server[i]

    titlehist[i] = hostfixwk[1] "_" toupper(infname[i])
    
    if (pager_subject[i] != "" || pager_email[i] != "") { pager_flag[i] = 1; }
    else                                                { pager_flag[i] = 0 }

    # bb 17May00 3.23.A Backup-only monitoring implies MBUN
    ##print "runmon=" runmon[i]
    if (runmon[i] == "B") 
    {
      t_mustbeup[i] = "N"    
      msg = sprintf("Since Monitor: is B then Must_Be_Up: Set to N - %s",title[i])
      logit(msg)
    }

    save_file[i] = save_dir "/config." hostname[i] "_" infname[i] 

    html_events[i] = html_events_dir "/" hostfixwk[1] ":" infname[i] ".html.new"
    ##print "html_events="html_events[i]

    html_events_perm[i] = html_events_dir "/" hostfixwk[1] ":" infname[i] ".html"
    html_events_flag[i] = 0

    if (arg == "test") { z = "/opt/dbamon/htm/details_test/" }
    else               { z = "/opt/dbamon/htm/details/" }

    html_details[i]      = z "" hostfixwk[1] ":" infname[i] ".html.new"
    html_details_perm[i] = z "" hostfixwk[1] ":" infname[i] ".html"
    html_details_flag[i] = 0
    system("mkdir " z " 2>/dev/null")

    if (dbms[i] == "Informix") 
    {
      dbmsout[i] = "Informix-UX"
      dbms_color[i] = "darkblue"
    }
    if (dbms[i] == "Oracle")     
    {
      dbmsout[i] = "OracleDB-UX"
      dbms_color[i] = "red"
    }
    if (dbms[i] == "OracleApps") 
    {
      dbmsout[i] = "OracleApps"
      dbms_color[i] = "darkred"
    }
    if (dbms[i] == "OracleNT")   
    {
      dbmsout[i] = "OracleDB-NT"
      dbms_color[i] = "ff0090"
    }
    if (dbms[i] == "MSSQL")      
    {
      dbmsout[i] = "MSSQL"
      dbms_color[i] = "green"
    }

    i++
  }

  # For info events with no host
  html_events[0] = "/dev/null"
  html_details[0] = "/dev/null"

  # Validate SYSTEM values
  if (iterations == "")    { error_parm_null("SYSTEM","iterations") }
  if (dbamon_admin == "")  { error_parm_null("SYSTEM","dbamon_admin") }
  if (log_path == "")      { error_parm_null("SYSTEM","log_path") }

  if (use_oracle != "" && use_oracle != "N" && use_oracle != "Y") 
  {
    error_parm("SYSTEM Section parameter Use_Oracle: must be null, Y or N")
  }
  if (use_mysql  != "" && use_mysql  != "N" && use_mysql  != "Y") 
  {
    error_parm("SYSTEM Section parameter Use_MySql: must be null, Y or N")
  }
  if (use_mysql  == "Y" && use_oracle == "Y")
  {
    error_parm("SYSTEM Section parameters Use_MySql: and Use_Oracle: are mutually exclusive")
  }
  if (use_oracle == "Y" && (oracle_sid == "" || oracle_home == ""))
  {
    error_parm("SYSTEM Section: If Use_Oracle:=Y, then ORACLE_SID and ORACLE_HOME must be specified")
  }

  if (use_oracle == "Y" || use_mysql == "Y") 
  {
    if (use_oracle == "Y") { z = "Oracle" }
    else                   { z = "MySql" }
    msg = sprintf("%s Data Repository will be used",z)
    logit(msg)
    use_repository = "Y"
  }
  else
  {
    msg = sprintf("Data Repository will not be used")
    logit(msg)
  }

  # Wrapup

  msg = sprintf("Read %s host definitions - longest title=%s",high_host,longest)
  logit(msg)

  msg = sprintf("Read %s userlist definitions",high_users)
  logit(msg)

  #
  # Insert rows into dbcactive
  #

  if (use_oracle == "Y")
  {
    mx = sprintf("Inserting into Oracle dbamon.dbcactive table")
    logit(mx)
    close(sqlfil)
    system("/opt/dbamon/bin/dbamon_ora_rsql.pl " sqlfil)
  }
  else if (use_mysql == "Y")
  {
    mx = sprintf("Deleting old rows and Inserting new rows into MySql dbcactive table - file: %s",sqlfil )
    ##system("cat " sqlfil)
    logit(mx)
    ##print "debug before"
    system("/opt/dbamon/bin/sql/rsql " sqlfil " > /dev/null")
    ##print "debug after"
  }

  return

}

# -----------------------------------------------------------------------------
function DownloadSWNT(thishost)
#
{
  #
  # If we are using ssh, use scp instead of rcp 
  #

  hn = hostname[thishost]
  ##print "NT download_host[hn]=" download_host[hn]
  if (download_host[hn] == 1)
  {
    download_flag[thishost] = 1
    up[thishost] = ""
    hn = hostname[thishost]
    msg = sprintf("Download already done for host: %s",hn)
    logit(msg,thishost)
    return
  }

  #
  # Remove any old /tmp/dbamon* files
  #
  must_connect = 1
  remsh("erase \\temp\\dbamon*.pl",tmpfl2,thishost)

  #
  # Until an rcp bug is fixed we have to remsh to server and then rcp the
  # S/W back to \temp
  #
  # Download pgms from /opt/dbamon/bin/download to temp
  #

  if (dbms[thishost] == "MSSQL")    { filemask = "mssql" }
  if (dbms[thishost] == "OracleNT") { filemask = "orant" }

  if (ntrcpbug[thishost] == "Y")
  {
    cmd = "remsh " hostname[thishost] " 'rcp " wsname "." dbamon_userid ":/opt/dbamon/bin/download/*" filemask "* "filemask "' 2>&1 | grep -v ^$ >" tmpfl2 " 2>&1"
    rc = system(cmd)
    ##print "rc=" rc
    cmd = "remsh " hostname[thishost] " 'move " filemask " \\temp\\dbamon_" filemask ".pl' 2>&1 | grep -v ^$ >>" tmpfl2 " 2>&1"
    rc = system(cmd)
    #print "rc=" rc " cmd=" cmd
  }
  else
  {
    cmd = "remsh " hostname[thishost] " 'rcp " wsname "." dbamon_userid ":/opt/dbamon/bin/download/*" filemask "* temp' 2>&1 | grep -v ^$ >" tmpfl2 " 2>&1"
    rc = system(cmd)
    ##print "rc=" rc
  }

  if (system("test -s " tmpfl2) == 0 && system("grep '1 file(s) moved' " tmpfl2 " > /dev/null") != 0)
  {
    #
    # Check for pw expired error
    #
    if (system("grep -i expired " tmpfl2) == 0)
    {
      msg = sprintf("!!! DownloadSWNT() - rcp error - %s password expired !!!",userid[thishost])
      msgid = "DBA502C"
      logit(msg,thishost)
      short = "Dnld"
      crit_msg(msg,thishost,tmpfl2)
      m_critical[thishost]++
      up[thishost] = "D"
      print "expir hostnum="thishost
      error_msg(msg,thishost)
      return
    }
    else if (system("grep -i disabled " tmpfl2) == 0)
    {
      msg = sprintf("!!! DownloadSWNT() - rcp error - %s account disabled !!!",userid[thishost])
      msgid = "DBA502C"
      logit(msg,thishost)
      short = "Dnld"
      crit_msg(msg,thishost,tmpfl2)
      m_critical[thishost]++
      up[thishost] = "D"
      print "expir hostnum="thishost
      error_msg(msg,thishost)
      return
    }
    else if (system("grep -i incorrect " tmpfl2) == 0)
    {
      msg = sprintf("!!! DownloadSWNT() - rcp error - %s login incorrect !!!",userid[thishost])
      msgid = "DBA502C"
      logit(msg,thishost)
      short = "Dnld"
      crit_msg(msg,thishost,tmpfl2)
      m_critical[thishost]++
      up[thishost] = "D"
      print "expir hostnum="thishost
      error_msg(msg,thishost)
      return
    }
    else
    {
      msg = sprintf("!!! DownloadSWNT() - unknown rcp error !!!")
      msgid = "DBA502C"
      logit(msg,thishost)
      ##system("cat " tmpfl2) 
      short = "Dnld"
      crit_msg(msg,thishost,tmpfl2)
      m_crititcal[thishost]++
      up[thishost] = "D"
      return
    }
  }

  # 
  # Completion Message
  #

  msg = sprintf("OK")
  logit(msg,thishost)
  download_flag[thishost] = 1
  up[thishost] = ""
  hn = hostname[thishost]
  download_host[hn] = 1
  
  function_cleanup()

  #
  # Ensure that /usr/local/bin/perl on the db server points to perl5
  #
  
  ##system(remshcmd[thishost] " " hostname[thishost] " '" perlpath[thishost] " -v'")
  ##if (system(remshcmd[thishost] " " hostname[thishost] " '" perlpath[thishost] " -v' | egrep 'This is perl, version 5|This is perl, v5|perl5' > /dev/null") != 0)

  remsh(perlpath[thishost] " -v",tmpfl2,thishost)
  if (system("egrep 'This is perl, version 5|This is perl, v5|perl5' " tmpfl2 " > /dev/null") != 0)
  {
    if (system("grep 'name specified is not recognized' " tmpfl2 " > /dev/null") == 0)
    { 
      print "Command Not Found - Check Perl_Path: DBC Parameter" > tmpfl3
    }
    else
    {
      print "Undiagnosable Error:" > tmpfl3
      system("cat -v " tmpfl2 " >> " tmpfl3)
    }
    close tmpfl3

    msg = sprintf("!!! DownloadSWNT() - %s Does Not Invoke Perl Version 5 !!!",perlpath[thishost])
    msgid = "DBA503C"
    m_critical[thishost]++
    short = "Perl"
    logit(msg,thishost)
    crit_msg(msg,thishost,tmpfl3)
    up[thishost] = "D"
    return
  }
}     


# -----------------------------------------------------------------------------
function DownloadSW(thishost)
#
{

  if (check_inhib(thishost) == "Y")
  {
    up[thishost] = "I"
    return 
  }  

  # Do this only on the 1st iteration
  if (download_flag[thishost] == 1)
  {
    msg = sprintf("(Already done for this instance)")
    logit(msg,thishost)
    return
  }

  #
  # Download software to each host for use in all iterations
  #

  # See if this hostname has already had its download
  # If yes, then set flag that it has been done for this
  # DB. 

  #
  # If we are using ssh, use scp instead of rcp 
  #
  if (os[thishost] == "NT")
  {
    DownloadSWNT(thishost)
    return
  }

  #
  # If we are using ssh, use scp instead of rcp 
  #
  if (comm_method[thishost] == "ssh")
  {
    rcpcmd = "scp"
  }
  else
  {
    rcpcmd = "rcp"
  }
  ##print "rcpcmd=" rcpcmd " remshcmd=" remshcmd[thishost]

  hn = hostname[thishost]
  ##print "download_host[hn]=" download_host[hn]
  if (download_host[hn] == 1)
  {
    download_flag[thishost] = 1
    up[thishost] = ""
    hn = hostname[thishost]
    msg = sprintf("Download already done for host: %s",hn)
    logit(msg,thishost)
    return
  }

  #
  # Remove any old /tmp/dbamon* files
  #
  must_connect = 1
  remsh("onstat -;rm -f /tmp/dbamon*",tmpfl2,thishost)

  #
  # Download all uncustomized pgms from /opt/dbamon/bin/download to /tmp
  #

  if (system(rcpcmd " /opt/dbamon/bin/download/* " userid[thishost] "@" hostname[thishost] ":/tmp/ 2>" tmpfl2) != 0)
  {
    #
    # Check for pw expired error
    #
    if (system("grep -i expired " tmpfl2) == 0)
    {
      msg = sprintf("!!! DownloadSW() - rcp error - %s password expired !!!",userid[thishost])
      msgid = "DBA502C"
      logit(msg,thishost)
      short = "Dnld"
      crit_msg(msg,thishost)
      m_critical[thishost]++
      up[thishost] = "D"
      print "expir hostnum="thishost
      error_msg(msg,thishost)
      return
    }
    else if (system("grep -i disabled " tmpfl2) == 0)
    {
      msg = sprintf("!!! DownloadSW() - rcp error - %s account disabled !!!",userid[thishost])
      msgid = "DBA502C"
      logit(msg,thishost)
      short = "Dnld"
      crit_msg(msg,thishost)
      m_critical[thishost]++
      up[thishost] = "D"
      print "expir hostnum="thishost
      error_msg(msg,thishost)
      return
    }
    else
    {
      msg = sprintf("!!! DownloadSW() - unknown rcp error !!!")
      msgid = "DBA502C"
      logit(msg,thishost)
      ##system("cat " tmpfl2) 
      short = "Dnld"
      crit_msg(msg,thishost,tmpfl2)
      m_crititcal[thishost]++
      up[thishost] = "D"
      return
    }
  }

  # 
  # Completion Message
  #

  msg = sprintf("OK")
  logit(msg,thishost)
  download_flag[thishost] = 1
  up[thishost] = ""
  hn = hostname[thishost]
  download_host[hn] = 1
  
  function_cleanup()

  #
  # chmod 777 the dbamon files in temp so that subsequent downloads dont fail
  # (hard to fix bug)
  #
  system(remshcmd[thishost] " " hostname[thishost] " -l " userid[thishost] " 'chmod 777 /tmp/dbamon*' 2>/dev/null") 
  
  #
  # Ensure that /usr/local/bin/perl on the db server points to perl5
  #
  
  ##system(remshcmd[thishost] " " hostname[thishost] " -l " userid[thishost] " '/usr/local/bin/perl -v' ") 
  ##if (system(remshcmd[thishost] " " hostname[thishost] " -l " userid[thishost] " '/usr/local/bin/perl -v' 2>&1 | egrep 'This is perl, version 5|This is perl, v5|perl5' > /dev/null") != 0)

  close tmpfl2
  remsh("crud;/usr/local/bin/perl -v",tmpfl2,thishost)
  ##system("cat " tmpfl2)
  if (system("egrep 'This is perl, version 5|This is perl, v5|perl5' " tmpfl2) != 0)
  {
    msg = sprintf("!!! DownloadSW() - /usr/local/bin/perl Does Not Invoke Perl Version 5 !!!")
    msgid = "DBA503C"
    logit(msg,thishost)
    short = "Perl"
    crit_msg(msg,thishost,tmpfl2)
    m_critical[thishost]++
    up[thishost] = "D"
    return
  }
}     

# -----------------------------------------------------------------------------
function oraLsnr(thishost)
# -----------------------------------------------------------------------------
{
  #
  # Ensure that listener is active
  #

  if (check_inhib(thishost) == "Y" || up[thishost] == "I")
  {
    up[thishost] = "I"
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return
  }

  if (up[thishost] == "D")
  {
    msg = sprintf("(No software download)")
    logit(msg,thishost)
    download_flag[thishost] = 0
    return
  }

  remsh("/tmp/dbamon_ora.pl lsnr",tmpfl3,thishost)
  ##system("cat " tmpfl3)

  while (getline < tmpfl3 > 0)
  {
    if ($2 == "NUMLSNR:")  { numlsnr  = $3 }
    if ($2 == "TNSPING:")  { tnsping  = $3 }
  }
  close tmpfl3

  reason = ""
  if (numlsnr <  "1") { reason = reason "(tnslsnr Not Running)" }
  if (tnsping != "1") { reason = reason "(tnsping Failed)" }

  # Add more here

  if (reason != "")
  {
    ##system("cat " tmpfl3)
    msg = sprintf("!!! Listener Not Active: %s (Restart Was Attempted) !!!",reason)
    msgid = "DBA611C"
    m_critical[thishost]++
    short = "Lsnr"
    logit(msg,thishost)
    crit_msg(msg,thishost,tmpfl3)
  }
  else
  {
    msg = sprintf("OK")
    logit(msg,thishost)
  }
}


# -----------------------------------------------------------------------------
function oraTSFull(thishost)
# -----------------------------------------------------------------------------
{
  #
  # Get Instance online data
  #

  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1
  }

  if (check_inhib(thishost) == "Y")
  {
    up[thishost] = "I"
    return
  }

  ##print "up="up[thishost]
  if (up[thishost] == "D")
  {
    msg = sprintf("(No software download)")
    logit(msg,thishost)
    download_flag[thishost] = 0
    return
  }

  # Check to see if  we need to create history data

  "date +%C%y.%m.%d " | getline filedate
  close "date +%C%y.%m.%d "
  "date +%H:%M:%S " | getline filetime
  close "date +%H:%M:%S "

  hist_flag = 0
  if (system("grep '" titleraw[thishost] "' " hstdir "/dbspaces/"filedate" > /dev/null 2>&1") != 0)
  {
    msg = sprintf("Creating tblspace history data")
    logit(msg,thishost)
    system("rm " tmpflt " > /dev/null 2>&1")
    hist_flag = 1
  }

  total_size = 0
  total_free = 0
  total_used = 0
  total_chks = 0

  close tmpfl3
  system("rm -fr " tmpfl3)

  if (ts_command[thishost] != "")
  {
    # invoke with ts_fill {Twarn} {Tcrit} {Tfree}
    parm = "/tmp/dbamon_ora.pl ts_full " \
	   t_diskwarn[thishost] " " \
	   t_diskcrit[thishost] " " \
	   t_freespace[thishost] " " \
           "\"" ts_command[thishost] "\""
  }
  else
  {
    # invoke with ts_fill {Twarn} {Tcrit} {Tfree}
    parm = "/tmp/dbamon_ora.pl ts_full " \
	   t_diskwarn[thishost] " " \
	   t_diskcrit[thishost] " " \
	   t_freespace[thishost] 
  }

  remsh(parm,tmpfl3,thishost)

  ##system("cat " tmpfl3)

  logDetails(thishost,"<h3>Oracle Tablespaces</h3>")
  logDetails(thishost,"<table border=1>")
  logDetails(thishost,"<tr bgcolor=slate><th>Tablespace<th>Size (MB)<th>Used (MB)<th>Free (MB)<th>Percent Full<th>Status:<br>W=Warning<br>C=Critical</tr>")

  while (getline < tmpfl3 > 0)
  {
    if ($1 == "DBAMON_TS_ADD") 
    {
      rc = $2
      ts = $3
      pc = $4
      ad = $5
      if ($2 != "0") 
      {
	msg = sprintf("!!! Add Datafile Command Failed - rc=%s cmd=%s ts=%s pc=%s ad=%s  !!!",$2,ts_command[thishost],ts,pc,ad)
	msgid = "DBA623C"
	m_critical[thishost]++
	short = "TSAddNG"
	logit(msg,thishost)
	crit_msg(msg,thishost,tmpfl3)
      }
      else  # Create user event
      {
	msg = sprintf("--- Added Datafile to TS: %s - Was: %s%% Full - Added: %s MB ---",ts,pc,ad)
	msgid = "DBA624U"
	m_user[thishost]++
	short = "TSAddOK"
	logit(msg,thishost)
	user_msg(msg,thishost,tmpfl3)
      }
    }
    if ($1 == "DBAMON_TS_SIZE") 
    {
      ts    = $2 
      size  = $3 
      used  = $4 
      free  = $5 
      pct   = $6 
      status= $7 

      mbfree = int(free)
      mbsize = int(size)
      mbused = int(used)

      color = "lime"
      if (status == "C") { color = "red" }
      if (status == "W") { color = "yellow" }
      logDetails(thishost,"<tr bgcolor=" color "><td><h5>" ts "<td align=right><h5>" size "<td align=right><h5>" used "<td align=right><h5>" free "<td align=right><h5>" pct "<td><h5>" status )

      short  = ""

      if (status != "") 
      {

        if (status == "C") 
        {
	  ##system("cat " tmpfl3)
	  msg = sprintf("!!! Oracle TS: %s - %s%% Full - Critical (%s MB Free - Threshold: %s%%) !!!",ts,pct,mbfree,t_diskcrit[thishost])
	  msgid = "DBA621C"
	  m_critical[thishost]++
	  short = "TS"
	  logit(msg,thishost)
	  crit_msg(msg,thishost,tmpfl3)
        }
        if (status == "W") 
        {
	  ##system("cat " tmpfl3)
	  msg = sprintf("*** Oracle TS: %s - %s%% Full - Warning (%s MB Free - Threshold: %s%%) ***",ts,pct,mbfree,t_diskwarn[thishost])
	  msgid = "DBA622W"
	  m_warning[thishost]++
	  short = "TS"
	  logit(msg,thishost)
	  warn_msg(msg,thishost,tmpfl3)
        }
      }

      total_size += mbsize
      total_free += mbfree
      total_used += mbused

      #
      # Create hist data line
      #

      if (hist_flag == 1)
      {
	print filedate " " filetime " " title[thishost] " " ts " .  " mbsize " " mbused " " dbms[thishost] >> tmpflt
      }

    }
  }
  close tmpfl3

  if (total_size == 0)
  {
    msg = sprintf("oraTSFull() - %s - Unexpected Output - Zero Divide #15",title[thishost])
    logit(msg,thishost)
    system("cat " tmpfl3 " >> " logfile)
    error_msg(msg,thishost,tmpfl3)
    system("cat " tmpfl3)
    download_flag[thishost] = 0
    return 1
  }

  logDetails(thishost,"<tr bgcolor=slate><td><b>Totals:</b><td align=right><h5>" total_size "<td align=right><h5>" total_used "<td align=right><h5>" total_free)
  logDetails(thishost,"</table><hr>")

  system_size[thishost] = int(total_size / 1000)
  system_used[thishost] = int(total_used / 1000)
  grand_total_size += total_size / 1000

  #
  # Write temp dbspace hist file to this dates file
  #

  if (hist_flag == 1)
  {
    close tmpflt
    system("sort " tmpflt " >> "hstdir "/dbspaces/"filedate)
    msg = sprintf("Creating tablespace history data")
    logit(msg,thishost)
  }
  if (short == "")
  {
    msg = sprintf("OK")
    logit(msg,thishost)
  }
}

# -----------------------------------------------------------------------------
function oraExtents(thishost)
# -----------------------------------------------------------------------------
{
  #
  # Check Oracle object extents
  #

  if (t_extents[thishost] == "")
  {
    msg = sprintf("(Not Selected (T_Extents: is null)")
    logit(msg,thishost)
    return 1
  }

  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1
  }

  if (check_inhib(thishost) == "Y")
  {
    up[thishost] = "I"
    return
  }

  remsh("/tmp/dbamon_ora.pl extents " t_extents[thishost] " " t_extents_fix[thishost],tmpfl3,thishost)
  ##system("cat " tmpfl3)

  okflag = ""
  while (getline < tmpfl3 > 0)
  {
    if ($5 == "OK") 
    {
      okflag = 1
    }
  }
  close tmpfl3

  if (okflag)
  {
    msg = sprintf("OK")
    logit(msg,thishost)
  }
  else
  {
    msg = sprintf("... Object(s) Found With Extents >= %s%% Of Max_Extents ...",t_extents[thishost])
    short = "Extents"
    msgid = "DBA630U"
    logit(msg,thishost)
    user_msg(msg,thishost,tmpfl3)
    m_user[thishost]++
  }
}


# -----------------------------------------------------------------------------
function oraArclog(thishost)
# -----------------------------------------------------------------------------
{
  #
  # Check Oracle to see if arclogs are configured ok and dir not full
  #

  if (t_arclog_w[thishost] == "N")
  {
    msg = sprintf("(Not Selected (T_Arclog_Full: is N)")
    logit(msg,thishost)
    return 1
  }

  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1
  }

  if (check_inhib(thishost) == "Y")
  {
    up[thishost] = "I"
    return
  }

  if (t_arclog_w[thishost] == "") { t_arclog_w[thishost] = "90" }
  if (t_arclog_c[thishost] == "") { t_arclog_c[thishost] = "95" }
  
  remsh("/tmp/dbamon_ora.pl arclogs " t_arclog_w[thishost] " " t_arclog_c[thishost] " " t_arclog_fix[thishost],tmpfl3,thishost)
  ##system("cat " tmpfl3)

  arcdir = ""
  arcdirfull = ""
  arcdesterror = ""

  logDetails(thishost,"<h3>Oracle Archive Log Destination Data</h3>")
  logDetails(thishost,"<table border=1>")

  while (getline < tmpfl3 > 0)
  {
    z = substr($0,1,3)
    if (z == "<tr")
    {
      logDetails(thishost,$0)
    }
    if ($2 == "arcflag:")    {  arclogflag[thishost] = $3 }
    if ($2 == "arcdir:")     {  arcdir = $3 }
    if ($2 == "arcdirfull:") {  arcdirfull = $3 }
    if ($2 == "arcdirraw:")  {  arcdirraw = $3 }
    if ($2 == "arcdesterror:") 
    {
      arcdesterror = $3
      arcdestlist = $4
    }
    if ($2 == "arclogmode:" && $3 == "Archive")
    {
      arclog[thishost] = "ArcLog"
    }
  }
  close tmpfl3

  if (arclogflag[thishost] == "W")
  {
    msg = sprintf("*** Oracle Archive Log Dir: %s FS is %s%% Full - Warning (Threshold: %s%%) ***",arcdir,arcdirfull,t_arclog_w[thishost])
    msgid = "DBA641W"
    m_warning[thishost]++
    short = "ArcLg"
    logit(msg,thishost)
    warn_msg(msg,thishost,tmpfl3)
  }
  if (arclogflag[thishost] == "C")
  {
    msg = sprintf("!!! Oracle Archive Log Dir: %s FS is %s%% Full - Critical (Threshold: %s%%) !!!",arcdir,arcdirfull,t_arclog_c[thishost])
    msgid = "DBA642C"
    m_critical[thishost]++
    short = "ArcLg"
    logit(msg,thishost)
    crit_msg(msg,thishost,tmpfl3)
  }
  if (arclogflag[thishost] == "N")
  {
    msg = sprintf("!!! Oracle Archive Logging is On, But Auto Archiving is Off !!!")
    msgid = "DBA643C"
    m_critical[thishost]++
    short = "ArcLgOff"
    logit(msg,thishost)
    crit_msg(msg,thishost,tmpfl3)
  }
  if (arcdesterror == "Y")
  {
    msg = sprintf("!!! Oracle Archive Log Destination(s): %s in ERROR status !!!",arcdestlist)
    msgid = "DBA646C"
    m_critical[thishost]++
    short = "ArcLgDest"
    logit(msg,thishost)
    crit_msg(msg,thishost,tmpfl3)
  }
  if (arclogflag[thishost] == "")
  {
    msg = sprintf("OK - Arclog Dir %s FS is %s%% Full",arcdir,arcdirfull)
    logit(msg,thishost)
  }

  logDetails(thishost,"</table>")
  logDetails(thishost,"<h3>Oracle Archive Log Status</h3>")
  logDetails(thishost,"<table border=1>")
  logDetails(thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>")
  logDetails(thishost,"<tr><td>Archive Dest:<td>" arcdirraw "<td>(From init.ora)")
  logDetails(thishost,"<tr><td>Archive Directory:<td>" arcdir "<td>")
  logDetails(thishost,"<tr><td>Archive Directory Percent Full:<td>" arcdirfull "<td>")
  logDetails(thishost,"</table><hr>")
}


# -----------------------------------------------------------------------------
function orantArclog(thishost)
# -----------------------------------------------------------------------------
{
  #
  # Check Oracle to see if arclogs are configured ok and dir not full
  #

  if (t_arclog_w[thishost] == "N")
  {
    msg = sprintf("(Not Selected (T_Arclog_Full: is N)")
    logit(msg,thishost)
    return 1
  }

  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1
  }

  if (check_inhib(thishost) == "Y")
  {
    up[thishost] = "I"
    return
  }

  if (t_arclog_w[thishost] == "") { t_arclog_w[thishost] = "90" }
  if (t_arclog_c[thishost] == "") { t_arclog_c[thishost] = "95" }
  
  remsh(perlpath[thishost] " \\temp\\dbamon_orant.pl " orasid[thishost] " " orahome[thishost] " arclogs " t_arclog_w[thishost] " " t_arclog_c[thishost] " " t_arclog_fix[thishost],tmpfl3,thishost)
  ##system("cat " tmpfl3)

  arcdest = ""
  arcdrive = ""
  arcdrivecount = ""
  arcdrivesize  = ""
  arcdrivefree = ""
  arcdriveused = ""
  arcdrivepct = ""

  while (getline < tmpfl3 > 0)
  {
    if ($1 == "Log_Mode:" && $2 == "ARCHIVELOG") { arclog[thishost] = "ArcLog" }
    if ($1 == "Log_Dest:")         { arcdest = $2 }
    if ($1 == "Log_Drive:")        { arcdrive = $2 }
    if ($1 == "Log_Drive_Count:")  { arcdrivecount = $2 }
    if ($1 == "Log_Drive_Size:")   { arcdrivesize = $2 }
    if ($1 == "Log_Drive_Free:")   { arcdrivefree = $2 }
    if ($1 == "Log_Drive_Used:")   { arcdriveused = $2 }
    if ($1 == "Log_Drive_Pct:")    { arcdrivepct = $2 }
    if ($1 == "Log_Flag:")         { arclogflag[thishost] = $2 }
  }
  close tmpfl3

  if (arclogflag[thishost] == "W")
  {
    msg = sprintf("*** Oracle Archive Log Dest. Drive: %s is %s%% Full - Warning (Threshold: %s%%) ***",arcdrive,arcdrivepct,t_arclog_w[thishost])
    msgid = "DBA641W"
    m_warning[thishost]++
    short = "ArcLg"
    logit(msg,thishost)
    warn_msg(msg,thishost,tmpfl3)
  }
  if (arclogflag[thishost] == "S")
  {
    msg = sprintf("*** Either: (1) NT srvinfo Command Did Not Run -or- (2) NT srvinfo Command Did Not Find The ARCLOG Disk -- Something Is Wrong ***")
    msgid = "DBA644W"
    m_warning[thishost]++
    short = "ArcLgRESKIT"
    logit(msg,thishost)
    warn_msg(msg,thishost,tmpfl3)
  }
  if (arclogflag[thishost] == "C")
  {
    msg = sprintf("!!! Oracle Archive Log Dest. Drive: %s is %s%% Full - Critical (Threshold: %s%%) !!!",arcdrive,arcdrivepct,t_arclog_c[thishost])
    msgid = "DBA642C"
    m_critical[thishost]++
    short = "ArcLg"
    logit(msg,thishost)
    crit_msg(msg,thishost,tmpfl3)
  }
  if (arclogflag[thishost] == "N")
  {
    msg = sprintf("!!! Oracle Archive Logging is On, But Auto Archiving is Off !!!")
    msgid = "DBA643C"
    m_warning[thishost]++
    short = "ArcLgOff"
    logit(msg,thishost)
    crit_msg(msg,thishost,tmpfl3)
  }
  if (arclogflag[thishost] == "")
  {
    msg = sprintf("OK - Arclog Drive %s is %s%% Full",arcdrive,arcdrivepct)
    logit(msg,thishost)
  }
}


# -----------------------------------------------------------------------------
function orantDatafiles(thishost)
# -----------------------------------------------------------------------------
{
  #
  # Check for offline datafiles
  #

  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1
  }

  if (check_inhib(thishost) == "Y")
  {
    up[thishost] = "I"
    return
  }

  remsh(perlpath[thishost] " \\temp\\dbamon_orant.pl " orasid[thishost] " " orahome[thishost] " datafiles",tmpfl3,thishost)
  ##system("cat " tmpfl3)

  msgid = ""
  downflag = 0
  pgmflag = 0
  while (getline < tmpfl3 > 0)
  {
    if ($1 == "OfflineDatafile:") { downflag = 1 }
    if ($2 == "DoneOK")           { pgmflag = 1 }
  }
  close tmpfl3

  if (!pgmflag) 
  {
    msg = sprintf("!!! Script Error - orantDatafiles() - Invoked Script dbamon_orant.pl Did Not Finish !!!")
    msgid = "DBA010"
    m_critical[thishost]++
    short = "ScrptErr"
    logit(msg,thishost)
    crit_msg(msg,thishost,tmpfl3)
  }

  if (downflag) 
  {
    msg = sprintf("!!! OFFLINE Datafile(s) Found !!!")
    msgid = "DBA641C"
    m_critical[thishost]++
    short = "OffDFS"
    logit(msg,thishost)
    crit_msg(msg,thishost,tmpfl3)
  } 
  else
  {
    msg = sprintf("OK")
    logit(msg,thishost)
  }
}


# -----------------------------------------------------------------------------
function oraDatafiles(thishost)
# -----------------------------------------------------------------------------
{
  #
  # Check for offline datafiles
  #

  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1
  }

  if (check_inhib(thishost) == "Y")
  {
    up[thishost] = "I"
    return
  }

  remsh("/tmp/dbamon_ora.pl datafiles",tmpfl3,thishost)
  ##system("cat " tmpfl3)

  msgid = ""
  downflag = 0
  while (getline < tmpfl3 > 0)
  {
    if ($2 == "DatafileDown:") { downflag = 1 }
  }
  close tmpfl3

  if (downflag) 
  {
    msg = sprintf("!!! OFFLINE Datafile(s) Found !!!")
    msgid = "DBA641C"
    m_critical[thishost]++
    short = "OffDFS"
    logit(msg,thishost)
    crit_msg(msg,thishost,tmpfl3)
  } 
  else
  {
    msg = sprintf("OK")
    logit(msg,thishost)
  }
}


# -----------------------------------------------------------------------------
function oraAlerts(thishost)
# -----------------------------------------------------------------------------
{
  #
  # Get Instance online data
  #

  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1
  }

  if (check_inhib(thishost) == "Y")
  {
    up[thishost] = "I"
    return
  }

  remsh("/tmp/dbamon_ora.pl alertlog",tmpfl3,thishost)
  ##system("cat " tmpfl3)

  msgid = ""
  while (getline < tmpfl3 > 0)
  {
    if ($2 == "INHIBITED:") 
    {
      msg = sprintf("*** This Instance - DBAmon checking inhibited by ora_dbshut ***",nowdate,nowhour)
      msgid = "DBA301W"
      logit(msg,thishost)

      info_msg(msg,thishost)
      m_info[thishost]++

      up[thishost] = "I"
      return
    }
    if ($3 == "ALERT") 
    {
      msg = sprintf("!!! Critical Messages Found in Oracle Alert Log: %s !!!",reason)
      msgid = "DBA611C"
      m_critical[thishost]++
      short = "CritMsg"
      logit(msg,thishost)
      crit_msg(msg,thishost,tmpfl3)
    } 
  }
  close tmpfl3

  if (msgid == "")
  {
    msg = sprintf("OK")
    logit(msg,thishost)
  }
}

# -----------------------------------------------------------------------------
function sqlAlerts(thishost)
# -----------------------------------------------------------------------------
{
  #
  # Get Instance online data
  #

  ##I don't know why i did this???  up[thishost] = ""

  if (check_inhib(thishost) == "Y")
  {
    up[thishost] = "I"
    return
  }

  if (up[thishost] == "D")
  {
    msg = sprintf("(No software download)")
    logit(msg,thishost)

    #
    # 3.19I Fix for BBN - A condition can occur where the "up" flag is set to
    #  D from a failed download, but the download_flag is set to 1. This is a
    #  place where the code is always executed for every instance, so I am
    #  adding a line to turn off the download_flag which will cause the
    #  download subroutine to retry the download next time. If that succeeds,
    #  the download subroutine will turn off the D value of "up".
    #
    download_flag[thishost] = 0

    return
  }

  remsh(perlpath[thishost] " \\temp\\dbamon_mssql.pl checklog",tmpfl3,thishost)
  ##system("cat " tmpfl3)

  while (getline < tmpfl3 > 0)
  {
    if ($1 == "Event:")  
    {
      alertmsg = substr($0,31)
      msg = sprintf("!!! MSSQL Alert: %s !!!",alertmsg)
      msgid = "DBA650C"
      m_critical[thishost]++
      short = "MSSQLAlert"
      logit(msg,thishost)
      crit_msg(msg,thishost,tmpfl3)
      break
    }
  }
  close tmpfl3
}

# -----------------------------------------------------------------------------
function orantUp(thishost)
# -----------------------------------------------------------------------------
{
  #
  # Get Instance online data
  #

  ##I don't know why i did this???  up[thishost] = ""

  if (check_inhib(thishost) == "Y")
  {
    up[thishost] = "I"
    return
  }

  if (up[thishost] == "D")
  {
    msg = sprintf("(No software download)")
    logit(msg,thishost)

    #
    # 3.19I Fix for BBN - A condition can occur where the "up" flag is set to
    #  D from a failed download, but the download_flag is set to 1. This is a
    #  place where the code is always executed for every instance, so I am
    #  adding a line to turn off the download_flag which will cause the
    #  download subroutine to retry the download next time. If that succeeds,
    #  the download subroutine will turn off the D value of "up".
    #
    download_flag[thishost] = 0
    return
  }

  must_connect = 1
  remsh(perlpath[thishost] " \\temp\\dbamon_orant.pl " orasid[thishost] " " orahome[thishost] " up",tmpfl3,thishost)
  if (up[thishost] == "N")     # Remsh error
  {
    msg = sprintf("(Connect Error)")
    logit(msg,thishost)
    return
  }

  ##system("cat " tmpfl3)

  dbstatus = ""
  total_size = ""
  total_used = ""
  pgmflag = 0

  total_size = 0
  total_free = 0
  total_used = 0
  total_df   = 0

  logDetails(thishost,"<h3>Oracle Tablespaces</h3>")
  logDetails(thishost,"<table border=1>")
  logDetails(thishost,"<tr bgcolor=slate><th>Tablespace<th>Type<th>Status<th>Datafile<br> Count<th>Size (MB)<th>Used (MB)<th>Free (MB)<th>Percent Full</tr>")

  while (getline < tmpfl3 > 0)
  {
    if ($1 == "DBVersion:")    { sw_version[thishost] = $2 }
    if ($1 == "OSVer:")        { os_version[thishost] = $2 }
    if ($1 == "DBStatus:")     { dbstatus = $2 }
    if ($1 == "NumCPUs:")      { hw_processors[thishost] = $2 }
    if ($1 == "CPUModel:")     { hw_model[thishost] = $2 }
    if ($1 == "RAM:")          { hw_memory[thishost] = $2 }
    if ($1 == "SpaceAlloc:")   { total_size = $2 }
    if ($1 == "SpaceUsed:")    { total_used = $2 }
    if ($1 == "LSNRStatus:")   { lsnr_status = $2 }
    if ($2 == "DoneOK")        { pgmflag = 1 }
    if ($1 == "SESSIONSHWM:")  { sessionshwm[thishost] = $2 }
    if ($1 == "BUFHITRATIO:")  { bufhitratio[thishost] = $2 }
    if ($1 == "LIBHITRATIO:")  { libhitratio[thishost] = $2 }
    if ($1 == "DICTHITRATIO:") { dicthitratio[thishost] = $2 }
    if ($1 == "TS:")
    {
      ts    = $2
      type  = $3
      stat  = $4
      numd  = $5
      size  = $6
      used  = $7
      free  = $8
      pct   = $9
      status= $10

      total_size += size
      total_free += free
      total_used += used
      total_df   += numd

      color = "lime"
      if (status == "C") { color = "red" }
      if (status == "W") { color = "yellow" }
      logDetails(thishost,"<tr><td><h5>" ts "<td><h5>" type "<td><h5>" stat  "<td align=right><h5>" numd "<td align=right><h5>" size"<td align=right><h5>" used "<td align=right><h5>" free "<td align=right><h5>" pct "<td><h5>" status )
    } 
  }
  close tmpfl3

  if (sw_version[thishost] < ver_oraclent_low  || ver_oraclent_low == "" ) { ver_oraclent_low  = sw_version[thishost] }
  if (sw_version[thishost] > ver_oraclent_high || ver_oraclent_high == "") { ver_oraclent_high = sw_version[thishost] }

  system_size[thishost] = total_size / 1000
  system_used[thishost] = total_used / 1000
  grand_total_size += (total_size / 1000)

  reason = ""  # Fill in later

  if (!pgmflag) 
  {
    msg = sprintf("!!! Script Error - orantUp() -  Invoked Script dbamon_orant.pl Did Not Finish !!!")
    msgid = "DBA010"
    m_critical[thishost]++
    short = "ScrptErr"
    logit(msg,thishost)
    crit_msg(msg,thishost,tmpfl3)
  }

  z = length(dbstatus)
  ##print "len=" z
  ##print "dbstatus=[" dbstatus "]"

  # Check status
  if (dbstatus != "UP")
  {
    up[thishost] = "N"

    if (t_mustbeup[thishost] == "Y")
    {
      msg = sprintf("!!! Oracle/NT Not Active - Status: %s !!!",dbstatus)
      msgid = "DBA901C"
      m_critical[thishost]++
      short = "Down"
      logit(msg,thishost)
      crit_msg(msg,thishost,tmpfl3)
    }
    else
    {
      msg = sprintf("... Oracle/NT Not Active - Status: %s ...",dbstatus)
      msgid = "DBA902W"
      logit(msg,thishost)
      short = "Down"
      info_msg(msg,thishost,tmpfl3)
      m_info[thishost]++
    }
  }
  else
  {
    up[thishost] = "Y"
    msg = sprintf("OK")
    logit(msg,thishost)
  }

  # Check listener
  if (lsnr_status != "OK")
  {
    up[thishost] = "N"
    msg = sprintf("!!! Oracle/NT Listener Not Active - Status: %s !!!",lsnr_status)
    msgid = "DBA903C"
    m_critical[thishost]++
    short = "LsnrDown"
    logit(msg,thishost)
    crit_msg(msg,thishost,tmpfl3)
    return
  }
  history_dummy(thishost)
  histCreate("orantUp()",thishost,"STA","sessionshwm",sessionshwm[thishost])
  histCreate("orantUp()",thishost,"PER","bufhitratio",bufhitratio[thishost])
  histCreate("orantUp()",thishost,"PER","libhitratio",libhitratio[thishost])
  histCreate("orantUp()",thishost,"PER","dicthitratio",dicthitratio[thishost])

  if (total_size > 0)
  {
    zpct = int(100 * (total_used / total_size))
    logDetails(thishost,"<tr bgcolor=slate><td><b>Totals:</b><td><td><td align=right><h5>" total_df "<td align=right><h5>" total_size "<td align=right><h5>" total_used "<td align=right><h5>" total_free "<td align=right><h5>" zpct)
  }
  logDetails(thishost,"</table><hr>")

  logDetails(thishost,"<h3>Oracle Instance Data</h3>")
  logDetails(thishost,"<table border=1>")
  logDetails(thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>")

  logDetails(thishost,"<tr><td><b>Oracle Version:<td align=right>" sw_version[thishost])
  #logDetails(thishost,"<tr><td><b>Concurrent Sessions HWM:<td align=right>" sessionshwm[thishost])
  #logDetails(thishost,"<tr><td><b>Buffer Cache Hit Ratio:<td align=right>" bufhitratio[thishost])
  #logDetails(thishost,"<tr><td><b>Library Cache Hit Ratio:<td align=right>" libhitratio[thishost])
  #logDetails(thishost,"<tr><td><b>Dictionary Cache Hit Ratio:<td align=right>" dicthitratio[thishost])
  #logDetails(thishost,"<tr><td><b>ORACLE_HOME Disk % Full:<td align=right>" homefull[thishost])
  logDetails(thishost,"<tr><td><b>Oracle Up?<td align=right>" up[thishost] "<td>(Y or N)")
  #logDetails(thishost,"<tr><td><b>Oracle OPS Mode?:<td align=right>" ops[thishost] "<td>")
  #logDetails(thishost,"<tr><td><b>Oracle OPS Instance Number:<td align=right>" inst_num[thishost] "<td>")
  #logDetails(thishost,"<tr><td><b>Oracle Standby Mode?:<td align=right>" standby[thishost] "<td>(CURRENT or STANDBY)")
  logDetails(thishost,"</table><hr>")

  logDetails(thishost,"<h3>Server Data</h3>")
  logDetails(thishost,"<table border=1>")
  logDetails(thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>")
  logDetails(thishost,"<tr><td><b>OS Type:<td align=right>"  os[thishost] " ")
  logDetails(thishost,"<tr><td><b>OS Version:<td align=right>"  os_version[thishost])
  logDetails(thishost,"<tr><td><b>Server Type:<td align=right>"  hw_model[thishost])
  logDetails(thishost,"<tr><td><b>Server Memory (MB):<td align=right>"  hw_memory[thishost])
  logDetails(thishost,"<tr><td><b>Server Processor Count:<td align=right>"  hw_processors[thishost])
  logDetails(thishost,"</table><hr>")
}


# -----------------------------------------------------------------------------
function sqlUp(thishost)
# -----------------------------------------------------------------------------
{
  #
  # Get Instance online data
  #

  ##I don't know why i did this???  up[thishost] = ""

  if (check_inhib(thishost) == "Y")
  {
    up[thishost] = "I"
    return
  }

  if (up[thishost] == "D")
  {
    msg = sprintf("(No software download)")
    logit(msg,thishost)

    #
    # 3.19I Fix for BBN - A condition can occur where the "up" flag is set to
    #  D from a failed download, but the download_flag is set to 1. This is a
    #  place where the code is always executed for every instance, so I am
    #  adding a line to turn off the download_flag which will cause the
    #  download subroutine to retry the download next time. If that succeeds,
    #  the download subroutine will turn off the D value of "up".
    #
    download_flag[thishost] = 0

    return
  }

  must_connect = 1
  remsh(perlpath[thishost] " \\temp\\dbamon_mssql.pl up",tmpfl3,thishost)
  if (up[thishost] == "N")     # Remsh error
  {
    msg = sprintf("(Connect Error)")
    logit(msg,thishost)
    return
  }

  ##system("cat " tmpfl3)

  dbstatus = ""
  total_size = ""
  total_used = ""

  while (getline < tmpfl3 > 0)
  {
    if ($1 == "SQLVer:")      {  sw_version[thishost] = $2 }
    if ($1 == "OSVer:")       {  os_version[thishost] = $2 }
    if ($1 == "DBStatus:")    {  dbstatus = $2 }
    if ($1 == "AgentStatus:") {  agentstatus = $2 }
    if ($1 == "NumCPUs:")     {  hw_processors[thishost] = $2 }
    if ($1 == "CPUModel:")    {  hw_model[thishost] = $2 }
    if ($1 == "RAM:")         {  hw_memory[thishost] = $2 }
    if ($1 == "SpaceAlloc:")  {  total_size = $2 }
    if ($1 == "SpaceUsed:")   {  total_used = $2 }
  }
  close tmpfl3

  if (sw_version[thishost] < ver_mssql_low  || ver_mssql_low == "" ) { ver_mssql_low  = sw_version[thishost] }
  if (sw_version[thishost] > ver_mssql_high || ver_mssql_high == "") { ver_mssql_high = sw_version[thishost] }

  system_size[thishost] = total_size / 1000
  system_used[thishost] = total_used / 1000
  grand_total_size += (total_size / 1000)

  # Check status
  if (dbstatus != "UP")
  {
    up[thishost] = "N"
    ##system("cat " tmpfl3)

    if (t_mustbeup[thishost] == "Y")
    {
      msg = sprintf("!!! MSSQL Not Active: %s !!!",dbstatus)
      msgid = "DBA801C"
      m_critical[thishost]++
      short = "Down"
      logit(msg,thishost)
      crit_msg(msg,thishost,tmpfl3)
    }
    else
    {
      msg = sprintf("... MSSQL Not Active: %s ...",dbstatus)
      msgid = "DBA802W"
      logit(msg,thishost)
      short = "Down"
      info_msg(msg,thishost,tmpfl3)
      m_info[thishost]++
    }
  }
  else
  {
    up[thishost] = "Y"
    msg = sprintf("OK")
    logit(msg,thishost)
    if (agentstatus != "UP")
    {
      msg = sprintf("!!! MSSQL Agent Service Not Active !!!")
      msgid = "DBA803C"
      m_critical[thishost]++
      short = "AgentDown"
      logit(msg,thishost)
      crit_msg(msg,thishost,tmpfl3)
    }
  }
  history_dummy(thishost)
  logDetails(thishost,"<h3>MSSQL Instance Data</h3>")
  logDetails(thishost,"<table border=1>")
  logDetails(thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>")

  logDetails(thishost,"<tr><td><b>MSSQL Version:<td align=right>" sw_version[thishost])
  logDetails(thishost,"<tr><td><b>MSSQL Up?<td align=right>" up[thishost] "<td>(Y or N)")
  logDetails(thishost,"</table><hr>")

  logDetails(thishost,"<h3>Server Data</h3>")
  logDetails(thishost,"<table border=1>")
  logDetails(thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>")
  logDetails(thishost,"<tr><td><b>OS Type:<td align=right>"  os[thishost] " ")
  logDetails(thishost,"<tr><td><b>OS Version:<td align=right>"  os_version[thishost])
  logDetails(thishost,"<tr><td><b>OS Mode:<td align=right>"  os_mode[thishost] "<td>(32, 64 or Blank)")
  logDetails(thishost,"<tr><td><b>Server Type:<td align=right>"  hw_model[thishost])
  logDetails(thishost,"<tr><td><b>Server Memory (MB):<td align=right>"  hw_memory[thishost])
  logDetails(thishost,"<tr><td><b>Server Processor Count:<td align=right>"  hw_processors[thishost])
  logDetails(thishost,"</table><hr>")
}

# -----------------------------------------------------------------------------
function orantBkup(thishost)
# -----------------------------------------------------------------------------
{
  #
  # Get Instance online data
  #

  ##I don't know why i did this???  up[thishost] = ""

  if (check_inhib(thishost) == "Y")
  {
    up[thishost] = "I"
    return
  }

  if (backup_age[thishost] == "")
  {
    msg = sprintf("Backup Aging not requested for this instance")
    logit(msg,thishost)
    return 0 
  }

  if (up[thishost] == "D")
  {
    msg = sprintf("(No software download)")
    logit(msg,thishost)

    #
    # 3.19I Fix for BBN - A condition can occur where the "up" flag is set to
    #  D from a failed download, but the download_flag is set to 1. This is a
    #  place where the code is always executed for every instance, so I am
    #  adding a line to turn off the download_flag which will cause the
    #  download subroutine to retry the download next time. If that succeeds,
    #  the download subroutine will turn off the D value of "up".
    #
    download_flag[thishost] = 0

    return
  }

  if (use_repository == "Y")
  {
    rc = system("/opt/dbamon/bin/dbamon_ba_check.pl " titleraw[thishost])
    if (rc > 0)
    {
      while (getline < "/opt/dbamon/tmp/ba_check.tmp" > 0)
      {
	sts     = $1
	ets     = $2
	ts      = $3
	reason  = $4
      }
      close "/opt/dbamon/tmp/ba_check.tmp"
      system("rm " "/opt/dbamon/tmp/ba_check.tmp")
    
      bainhibit[thihshost] = 1
      bckhours_c[thishost] = "black"
      bckhours[thishost]   = "(I)"
      msg = sprintf("Backup Aging inhibited for this instance - Start: %s End: %s Created: %s Reason: %s",sts,ets,ts,reason)
      logit(msg,thishost)
      return 0 
    }
  }
  else
  {
    msg = sprintf("Backup Aging Inhibit not possible because Use_MySQL != Y and Use_Oracle != Y")
    logit(msg,thishost)
  }

  remsh(perlpath[thishost] " \\temp\\dbamon_orant.pl " orasid[thishost] " " orahome[thishost] " bkup",tmpfl3,thishost)
  ##system("cat " tmpfl3)

  bckhours_c[thishost] = "lime"
  pgmflag = 0

  logDetails(thishost,"<h3>Oracle Backup History</h3>")
  logDetails(thishost,"<table border=1>")
  logDetails(thishost,"<tr bgcolor=slate><th>Backup Details</tr>")

  while (getline < tmpfl3 > 0)
  {
    if ($1 == "BckAge:")
    {
      age = $2  # Use the most recent (last) age that we find
      # Just in case we exceed, set these vars and make report
      rounded1 = int(age / 10)
      rounded1 = rounded1 * 10
      rounded2 = rounded1 + 9

      logDetails(thishost,"<tr><td><h5>" $0)
    }
    if ($2 == "DoneOK") { pgmflag = 1 }
  }
  close tmpfl3

  logDetails(thishost,"</table><hr>")

  if (!pgmflag) 
  {
    msg = sprintf("!!! Script Error - orantBkup() -  Invoked Script dbamon_orant.pl Did Not Finish !!!")
    msgid = "DBA010"
    m_critical[thishost]++
    short = "ScrptErr"
    logit(msg,thishost)
    crit_msg(msg,thishost,tmpfl3)
  }

  if (age == -1)
  {
    msg = sprintf("!!! OracleNT - Backup Never Run - Threshold=%s !!!",backup_age[thishost])
    msgid = "DBA810C"
    short = "BkpNever"
    logit(msg,thishost)
    crit_msg(msg,thishost,tmpfl3)
    m_critical[thishost]++
  }

  if (age > backup_age[thishost])
  {
    msg = sprintf("!!! OracleNT - %s-%s Hours Since Last Good Backup (Threshold=%s) !!!",rounded1,rounded2,backup_age[thishost])
    msgid = "DBA811C"
    short = "BkpAge"
    logit(msg,thishost)
    crit_msg(msg,thishost,tmpfl3)
    m_critical[thishost]++
    bckhours_c[thishost] = "hotpink"
  }

  bckhours[thishost] = age
  if (bckhours[thishost] == -1) 
  {
    bckhours[thishost] = "(Never)"
  }

  if (short == "")
  {
    msg = sprintf("OK (%s/%s)",age,backup_age[thishost])
    logit(msg,thishost)
  }
}


# -----------------------------------------------------------------------------
function sqlBkup(thishost)
# -----------------------------------------------------------------------------
{
  #
  # Get Instance online data
  #

  ##I don't know why i did this???  up[thishost] = ""
  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1
  }

  if (check_inhib(thishost) == "Y")
  {
    up[thishost] = "I"
    return
  }

  if (backup_age[thishost] == "")
  {
    msg = sprintf("Backup Aging not requested for this instance")
    logit(msg,thishost)
    return 0 
  }

  if (up[thishost] == "D")
  {
    msg = sprintf("(No software download)")
    logit(msg,thishost)

    #
    # 3.19I Fix for BBN - A condition can occur where the "up" flag is set to
    #  D from a failed download, but the download_flag is set to 1. This is a
    #  place where the code is always executed for every instance, so I am
    #  adding a line to turn off the download_flag which will cause the
    #  download subroutine to retry the download next time. If that succeeds,
    #  the download subroutine will turn off the D value of "up".
    #
    download_flag[thishost] = 0

    return
  }

  if (use_repository == "Y")
  {
    rc = system("/opt/dbamon/bin/dbamon_ba_check.pl " titleraw[thishost])
    if (rc > 0)
    {
      while (getline < "/opt/dbamon/tmp/ba_check.tmp" > 0)
      {
	sts     = $1
	ets     = $2
	ts      = $3
	reason  = $4
      }
      close "/opt/dbamon/tmp/ba_check.tmp"
      system("rm " "/opt/dbamon/tmp/ba_check.tmp")
    
      bainhibit[thihshost] = 1
      bckhours_c[thishost] = "black"
      bckhours[thishost]   = "(I)"
      msg = sprintf("Backup Aging inhibited for this instance - Start: %s End: %s Created: %s Reason: %s",sts,ets,ts,reason)
      logit(msg,thishost)
      return 0 
    }
  }
  else
  {
    msg = sprintf("Backup Aging Inhibit not possible because Use_MySQL != Y and Use_Oracle != Y")
    logit(msg,thishost)
  }

  remsh(perlpath[thishost] " \\temp\\dbamon_mssql.pl bkup",tmpfl3,thishost)
  ##system("cat " tmpfl3)

  bckhours_c[thishost] = "lime"
  finalage = -999

  while (getline < tmpfl3 > 0)
  {
    if ($1 == "BckAge:" && backup_age[thishost] != "")
    {
      db      = $2 
      age     = $3 
      lstdate = $4
      lsttime = $5
      lsttype = $6

      if (age > finalage) finalage = age
      # Just in case we exceed, set these vars and make report
      rounded1 = int(age / 10)
      rounded1 = rounded1 * 10
      rounded2 = rounded1 + 9

      dbchk = ","db","
      ##print "found db=" db " age="age " bat=" backup_age[thishost] " bcd=" backup_dbs[thishost] " dbchk=" dbchk

      if (index(backup_dbs[thishost],dbchk) > 0 || db == "master" || db == "msdb")
      {
        if (age == -1)
        {
	  msg = sprintf("!!! MSSQL DB=%s - Backup Never Run - Threshold=%s !!!",db,backup_age[thishost])
	  msgid = "DBA810C"
          short = "BkpAge"
	  logit(msg,thishost)
	  crit_msg(msg,thishost)
	  m_critical[thishost]++
	}
        if (age > backup_age[thishost])
        {
	  msg = sprintf("!!! MSSQL DB=%s - %s-%s Hours Since Last Good Backup (Threshold=%s) !!!",db,rounded1,rounded2,backup_age[thishost])
	  msgid = "DBA811C"
          short = "BkpAge"
          close tmpfl6
          print "---------------------------------------------------" > tmpfl6
          printf ("Most recent successful backup of database: %s\n",db) >> tmpfl6
          print "Date: " lstdate >> tmpfl6
          print "Time: " lsttime >> tmpfl6
          print "Type: " lsttype >> tmpfl6
          print "---------------------------------------------------" >> tmpfl6
          print "\nAll Registered Backups For Database: " db >> tmpfl6
          print "<table border=1> " >> tmpfl6
          print "<tr bgcolor=slate><th>Database Name<th>Backup Timestamp<th>Backup Type<th>Age (Hours) " >> tmpfl6
          close tmpfl6
          system("cat "tmpfl3" | grep '<tr>' | grep '" db "' >> "tmpfl6)
          close tmpfl6
          print "</table> " >> tmpfl6
          close tmpfl6
	  logit(msg,thishost)
	  crit_msg(msg,thishost,tmpfl6)
	  m_critical[thishost]++
	  bckhours_c[thishost] = "hotpink"
	}
      }
    }
  }
  close tmpfl3

  bckhours[thishost] = finalage
  if (bckhours[thishost] == -1) { bckhours[thishost] = "(Never)" }

  if (short == "")
  {
    msg = sprintf("OK (%s/%s)",finalage,backup_age[thishost])
    logit(msg,thishost)
  }
}

# -----------------------------------------------------------------------------
function oraapUp(thishost)
# -----------------------------------------------------------------------------
{
  #
  # Get Instance online data
  #

  ##I don't know why i did this???  up[thishost] = ""

  if (check_inhib(thishost) == "Y")
  {
    up[thishost] = "I"
    return
  }

  if (up[thishost] == "D")
  {
    msg = sprintf("(No software download)")
    logit(msg,thishost)

    #
    # 3.19I Fix for BBN - A condition can occur where the "up" flag is set to
    #  D from a failed download, but the download_flag is set to 1. This is a
    #  place where the code is always executed for every instance, so I am
    #  adding a line to turn off the download_flag which will cause the
    #  download subroutine to retry the download next time. If that succeeds,
    #  the download subroutine will turn off the D value of "up".
    #
    download_flag[thishost] = 0

    return
  }

  cmd = "/tmp/dbamon_oraap.pl up "useridap[thishost]
  print "cmd="cmd
  close tmpfl3
  system("rm "tmpfl3" 2>/dev/null")

  must_connect = 1
  remsh(cmd,tmpfl3,thishost)
  if (up[thishost] == "N")     # Remsh error
  {
    msg = sprintf("(Connect Error)")
    logit(msg,thishost)
    return
  }

  ##system("cat " tmpfl3)

  while (getline < tmpfl3 > 0)
  {
    if ($1 == "MODE")              { os_mode[thishost] = $2 }
    if ($1 == "Physical_RAM_MB:")  { hw_memory[thishost] = $2 }
    if ($1 == "Num_Processors:")   { hw_processors[thishost] = $2 }
    if (substr($1,1,4) == "9000")
    {
      split($0,works,"/")
      model = works[3]
      hw_model[thishost] = model
      ##print "model=" model " hw_model=" hw_model[thishost]
    }
    if ($1 == "HP-UX")
    {
      os_version[thishost] = substr($3,3)
    }
    if ($5 == "ErrorProcesses:") 
    {
      errorprocesses = $6 $7 $8 $9 $10 $11 $12 $13 $14 $15
    }
  }
  close tmpfl3

  if (errorprocesses != "")
  {
    up[thishost] = "N"
    if (t_mustbeup[thishost] == "Y")
    {
      msg = sprintf("!!! Critical OracleApps Processes %s Not Active !!!",errorprocesses)
      msgid = "DBA701C"
      m_critical[thishost]++
      short = "Down"
      logit(msg,thishost)
      crit_msg(msg,thishost,tmpfl3)
    }
    else
    {
      msg = sprintf("... Critical OracleApps Processes %s Not Active ...",errorprocesses)
      msgid = "DBA702W"
      logit(msg,thishost)
      short = "Down"
      info_msg(msg,thishost,tmpfl3)
      m_info[thishost]++
    }
  }
  else
  {
    up[thishost] = "Y"
    msg = sprintf("OK")
    logit(msg,thishost)
  }
}


# -----------------------------------------------------------------------------
function oraUp(thishost)
# -----------------------------------------------------------------------------
{
  #
  # Get Instance online data
  #

  ##I don't know why i did this???  up[thishost] = ""

  if (check_inhib(thishost) == "Y")
  {
    up[thishost] = "I"
    return
  }

  if (up[thishost] == "D")
  {
    msg = sprintf("(No software download)")
    logit(msg,thishost)

    #
    # 3.19I Fix for BBN - A condition can occur where the "up" flag is set to
    #  D from a failed download, but the download_flag is set to 1. This is a
    #  place where the code is always executed for every instance, so I am
    #  adding a line to turn off the download_flag which will cause the
    #  download subroutine to retry the download next time. If that succeeds,
    #  the download subroutine will turn off the D value of "up".
    #
    download_flag[thishost] = 0

    return
  }

  close tmpfl3

  must_connect = 1
  remsh("/tmp/dbamon_ora.pl up",tmpfl3,thishost)
  if (up[thishost] == "N")     # Remsh error
  {
    msg = sprintf("(Connect Error)")
    logit(msg,thishost)
    return  
  }

  ##system("cat " tmpfl3)

  sqlworks="?"
  numpmon="?"
  numsmon="?"

  while (getline < tmpfl3 > 0)
  {
    if ($2 == "INHIBITED:") 
    {
      msg = sprintf("*** This Instance - DBAmon checking inhibited by ora_dbshut ***",nowdate,nowhour)
      msgid = "DBA301W"
      short = "InhShut"
      logit(msg,thishost)
      info_msg(msg,thishost,tmpfl3)
      m_info[thishost]++
      up[thishost] = "I"
      return
    }
    if ($2 == "SQLGOOD:")  { sqlworks = $3 }
    if ($2 == "ORAVER:")   { sw_version[thishost] = $3 }
    if ($2 == "NUMPMON:")  { numpmon  = $3 }
    if ($2 == "NUMSMON:")  { numsmon  = $3 }
    if ($2 == "NUMLGWR:")  { numlgwr  = $3 }
    if ($2 == "NUMDBWR:")  { numdbwr  = $3 }
    if ($2 == "LOGINS:")   { logins  = $3 }
    if ($2 == "BKTYPE:")   { backup_method_long[thishost] = $3 }
    if ($2 == "PARALLEL:") 
    {
      ops[thishost] = $3
      inst_num[thishost] = $4
    }
    if ($2 == "STANDBY:") 
    {
      standby[thishost] = $3
    }
    if ($2 == "SESSIONSHWM:") 
    {
      sessionshwm[thishost] = $3
      histCreate("oraUp()",thishost,"STA","sessionshwm",sessionshwm[thishost])
    }
    if ($2 == "BUFHITRATIO:") 
    {
      bufhitratio[thishost] = $3
      histCreate("oraUp()",thishost,"PER","bufhitratio",bufhitratio[thishost])
    }
    if ($2 == "LIBHITRATIO:") 
    {
      libhitratio[thishost] = $3
      histCreate("oraUp()",thishost,"PER","libhitratio",libhitratio[thishost])
    }
    if ($2 == "DICTHITRATIO:") 
    {
      dicthitratio[thishost] = $3
      histCreate("oraUp()",thishost,"PER","dicthitratio",dicthitratio[thishost])
    }
    if ($2 == "ASYNCIO:") 
    {
      asyncio[thishost] = $3
    }

    if ($2 == "HOMEFULL:") 
    {
      homefull[thishost] = $3
      homeflag[thishost] = $4
    }
    if ($1 == "MODE")              { os_mode[thishost] = $2 }
    if ($1 == "Physical_RAM_MB:")  { hw_memory[thishost] = $2 }
    if ($1 == "Num_Processors:")   { hw_processors[thishost] = $2 }
    if ($1 == "Linux")
    {
      os[thishost] = "Linux"
      os_version[thishost] = substr($3,1,3)
      hw_model[thishost] = $12
    }
    if ($1 == "HP-UX")
    {
      os_version[thishost] = substr($3,3)
    }
    if ($2 == "BACKUP_AGE:")
    {
      if ($3 == "ARC")  { mr_age_arc[thishost]  = $4 }
      if ($3 == "LVL0") { mr_age_lvl0[thishost] = $4 }
      if ($3 == "LVL1") { mr_age_lvl1[thishost] = $4 }
      ##print "0="$0
    }
    if ($2 == "BACKUP_AGE_MR:")  { mr_age_lvl[thishost] = $3 }
    if ($2 == "BACKUP_RUNNING:") { backup_running[thishost] = $3 }
    if (substr($1,1,4) == "9000")
    {
      split($0,works,"/")
      model = works[3]
      hw_model[thishost] = model
      ##print "model=" model " hw_model=" hw_model[thishost]
    }
  }
  close tmpfl3

  if (sw_version[thishost] != "")
  {
    if (sw_version[thishost] < ver_oracle_low  || ver_oracle_low == "" ) { ver_oracle_low  = sw_version[thishost] }
    if (sw_version[thishost] > ver_oracle_high || ver_oracle_high == "") { ver_oracle_high = sw_version[thishost] }
  }

  reason = ""

  ##print "sqlworks="sqlworks 
  ##print "numpmon="numpmon
  ##print "numsmon="numsmon

  if (sqlworks != "1") { reason = reason "(SQL Will Not Run)" }
  if (numpmon  != "1") { reason = reason "(PMON Not Running)" }
  if (numsmon  != "1") { reason = reason "(SMON Not Running)" }

  # Add more here

  if (reason != "")
  {
    up[thishost] = "N"
    ##system("cat " tmpfl3)

    if (t_mustbeup[thishost] == "Y")
    {
      msg = sprintf("!!! Oracle Not Active: %s !!!",reason)
      msgid = "DBA601C"
      m_critical[thishost]++
      short = "Down"
      logit(msg,thishost)
      crit_msg(msg,thishost,tmpfl3)
    }
    else
    {
      msg = sprintf("... Oracle Not Active: %s ...",reason)
      msgid = "DBA602W"
      logit(msg,thishost)
      short = "Down"
      info_msg(msg,thishost,tmpfl3)
      m_info[thishost]++
    }
  }
  else
  {
    up[thishost] = "Y"
    msg = sprintf("OK")
    logit(msg,thishost)

    # See if the home dir is full
    if (homeflag[thishost] == "C")
    {
      msg = sprintf("!!! Oracle ORACLE_HOME FS Is Full/Almost Full (%s%%) !!!",homefull[thishost])
      msgid = "DBA640C"
      m_critical[thishost]++
      short = "HomeFull"
      logit(msg,thishost)
      crit_msg(msg,thishost,tmpfl3)
    }
  }

  if (logins == "RESTRICTED")
  {
    msg = sprintf("!!! Oracle In RESTRICTED SESSION Mode: !!!")
    msgid = "DBA631C"
    m_critical[thishost]++
    short = "RestSess"
    logit(msg,thishost)
    crit_msg(msg,thishost,tmpfl3)
  }

  logDetails(thishost,"<h3>Oracle Instance Data</h3>")
  logDetails(thishost,"<table border=1>")
  logDetails(thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>")

  logDetails(thishost,"<tr><td><b>Oracle Version:<td align=right>" sw_version[thishost])
  logDetails(thishost,"<tr><td><b>Concurrent Sessions HWM:<td align=right>" sessionshwm[thishost])
  logDetails(thishost,"<tr><td><b>Buffer Cache Hit Ratio:<td align=right>" bufhitratio[thishost])
  logDetails(thishost,"<tr><td><b>Library Cache Hit Ratio:<td align=right>" libhitratio[thishost])
  logDetails(thishost,"<tr><td><b>Dictionary Cache Hit Ratio:<td align=right>" dicthitratio[thishost])
  logDetails(thishost,"<tr><td><b>ORACLE_HOME File System % Full:<td align=right>" homefull[thishost])
  logDetails(thishost,"<tr><td><b>Oracle Backup Method:<td align=right>" backup_method_long[thishost])
  logDetails(thishost,"<tr><td><b>Oracle Backup Running Now?:<td align=right>" backup_running[thishost])
  logDetails(thishost,"<tr><td><b>Oracle Most Recent Backup Age - ARC Backup:<td align=right>" mr_age_arc[thishost])
  logDetails(thishost,"<tr><td><b>Oracle Most Recent Backup Age - LVL0 Backup:<td align=right>" mr_age_lvl0[thishost])
  logDetails(thishost,"<tr><td><b>Oracle Most Recent Backup Age - LVL1 Backup:<td align=right>" mr_age_lvl1[thishost])
  logDetails(thishost,"<tr><td><b>Oracle Up?<td align=right>" up[thishost] "<td>(Y or N)")
  logDetails(thishost,"<tr><td><b>Oracle OPS Mode?:<td align=right>" ops[thishost] "<td>")
  logDetails(thishost,"<tr><td><b>Oracle OPS Instance Number:<td align=right>" inst_num[thishost] "<td>")
  logDetails(thishost,"<tr><td><b>Oracle Standby Mode?:<td align=right>" standby[thishost] "<td>(CURRENT or STANDBY)")
  logDetails(thishost,"</table><hr>")

  logDetails(thishost,"<h3>Server Data</h3>")
  logDetails(thishost,"<table border=1>")
  logDetails(thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>")
  logDetails(thishost,"<tr><td><b>OS Type:<td align=right>"  os[thishost] " ")
  logDetails(thishost,"<tr><td><b>OS Version:<td align=right>"  os_version[thishost])
  logDetails(thishost,"<tr><td><b>OS Mode:<td align=right>"  os_mode[thishost] "<td>(32, 64 or Blank)")
  logDetails(thishost,"<tr><td><b>Server Type:<td align=right>"  hw_model[thishost])
  logDetails(thishost,"<tr><td><b>Server Memory (MB):<td align=right>"  hw_memory[thishost])
  logDetails(thishost,"<tr><td><b>Server Processor Count:<td align=right>"  hw_processors[thishost])
  logDetails(thishost,"</table><hr>")

  # Test
  print "Test 1 - "title[thishost] " " sw_version[thishost]
}


# -----------------------------------------------------------------------------
function infUp(thishost)
#

{
  #
  # Get Instance online data          
  #

  if (check_inhib(thishost) == "Y")
  {
    up[thishost] = "I"
    return 
  }  

  if (up[thishost] == "D")
  {
    msg = sprintf("(No software download)")
    logit(msg,thishost)

    #
    # 3.19I Fix for BBN - A condition can occur where the "up" flag is set to
    #  D from a failed download, but the download_flag is set to 1. This is a
    #  place where the code is always executed for every instance, so I am
    #  adding a line to turn off the download_flag which will cause the
    #  download subroutine to retry the download next time. If that succeeds,
    #  the download subroutine will turn off the D value of "up".
    #
    download_flag[thishost] = 0

    return 
  }  

  must_connect = 1
  remsh("onstat -;export PATH=$PATH:"infdir[thishost]"/bin;perl /tmp/dbamon_inf.pl status",tmpfl3,thishost)
  if (up[thishost] == "N")     # Remsh error
  {
    msg = sprintf("(Connect Error)")
    logit(msg,thishost)
    return
  }

  ##system("cat " tmpfl3)

  if (system("egrep 'On-Line|Read-Only' " tmpfl3 " > " tmpfl2) != 0)
  {
    up[thishost] = "N"
    system("cat " tmpfl2)

    if (t_mustbeup[thishost] == "Y")
    {
      msg = sprintf("!!! Informix Instance Not On-Line/Read-Only !!!")
      msgid = "DBA260C"
      m_critical[thishost]++
      short = "Down"
      logit(msg,thishost)
      crit_msg(msg,thishost,tmpfl3)
    }
    else
    {
      msg = sprintf("... Informix Instance Not On-Line/Read-Only...")
      msgid = "DBA261W"

      logit(msg,thishost)

      short = "Down"
      info_msg(msg,thishost,tmpfl3)
      m_info[thishost]++
    }

  }
  else 
  {
    up[thishost] = "Y"
    getline < tmpfl2
    close tmpfl2
    
    sw_version[thishost] = $3
    db_status[thishost]  = substr($5,1,1)
    dr_status[thishost]  = $6

    if (sw_version[thishost] == "Version") { sw_version[thishost] = $4 }

    if (sw_version[thishost] == "Server")  # Is this a 7.3 system
    {                                      # Yes.
       sw_version[thishost] = $5           # Format is a bit different
       db_status[thishost]  = substr($7,1,1)
       dr_status[thishost]  = $8
    }
    sw_version1 = substr(sw_version[thishost],1,1)
    sw_version3 = substr(sw_version[thishost],1,3)

    if (substr(sw_version[thishost],6,1) == "F")
    {
      v64bit[thishost] = 1 
    }
    else
    {
      v64bit[thishost] = 0 
    }

    msg = sprintf("OK - Informix Version=%s Status=%s DRStatus=%s",sw_version[thishost],db_status[thishost],dr_status[thishost])
    logit(msg,thishost)

    # Do only if info has not yet been collected

    if (sn[thishost] == "")
    {
      msg = sprintf("(Counting DB Objects)")
      logit(msg,thishost)

      close tmpfl4
      system("rm " tmpfl4 " > /dev/null 2>&1")

      if (count_tables == "Y")
      {
        remsh("onstat -;export PATH=$PATH:"infdir[thishost]"/bin;perl /tmp/dbamon_inf.pl count Y",tmpfl4,thishost)
      }
      else
      {
        print "test3"
        remsh("onstat -;export PATH=$PATH:"infdir[thishost]"/bin;perl /tmp/dbamon_inf.pl count N",tmpfl4,thishost)
        print "test4"
	num_tables[thishost] = -1
      }

      ##system("cat " tmpfl4)

      while (getline < tmpfl4 > 0)
      {
	if ($1 == "tables")          { num_tables[thishost] = $2 }
	if ($1 == "databases")       { num_databases[thishost] = $2 }
	if ($1 == "appldatabases")   { num_appldatabases[thishost] = $2 }
	if ($1 == "dbspaces")        { num_dbspaces[thishost] = $2 }
	if ($1 == "disks")           { num_disks[thishost] = $2 }
	if ($1 == "segshared")       { segshared[thishost] = 1 }
        if ($1 == "INFORMIX-OnLine") { sn[thishost] = $7  }
        if ($1 == "Informix")        { sn[thishost] = $9  }
        if ($1 == "RSAM")            { sn[thishost] = $7  }
        if ($1 == "MODE")            { os_mode[thishost] = $2  }
	if ($1 == "Physical_RAM_MB:") {  hw_memory[thishost] = $2 }
	if ($1 == "Num_Processors:")  {  hw_processors[thishost] = $2 }
        if ($1 == "HP-UX")
        {
          os_version[thishost] = substr($3,3)
        }
        if (substr($1,1,4) == "9000")
        {
          split($0,works,"/")
	  model = works[3]
          hw_model[thishost] = model
          ##print "model=" model " hw_model=" hw_model[thishost]
        }
      }
      close tmpfl4
    }
  }

  logDetails(thishost,"<h3>Informix Instance Data</h3>")
  logDetails(thishost,"<table border=1>")
  logDetails(thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>")

  logDetails(thishost,"<tr><td><b>Informix Version:<td align=right>" sw_version[thishost])
  logDetails(thishost,"<tr><td><b>Informix Serial Number:<td align=right>" sn[thishost])
  logDetails(thishost,"<tr><td><b>Number of Databases:<td align=right>" num_databases[thishost])
  logDetails(thishost,"<tr><td><b>Number of DBSpaces:<td align=right>" num_dbspaces[thishost])
  logDetails(thishost,"<tr><td><b>Number of Tables:<td align=right>" num_tables[thishost] "<td>(-1 if dbamonrc Count_Tables: = N)")
  logDetails(thishost,"<tr><td><b>Number of Disks Containing Informix Data:<td align=right>" num_disks[thishost])
  logDetails(thishost,"<tr><td><b>Number of Informix Shared Memory Segments:<td align=right>" segshared[thishost] "<td>(Shared Segments are BAD)")
  
  logDetails(thishost,"</table><hr>")

  logDetails(thishost,"<h3>Server Data</h3>")
  logDetails(thishost,"<table border=1>")
  logDetails(thishost,"<tr bgcolor=slate><th>Parameter<th>Value<th>Comments</tr>")
  logDetails(thishost,"<tr><td><b>OS Type:<td align=right>"  os[thishost] " ")
  logDetails(thishost,"<tr><td><b>OS Version:<td align=right>"  os_version[thishost])
  logDetails(thishost,"<tr><td><b>OS Mode:<td align=right>"  os_mode[thishost] "<td>(64 or Blank)")
  logDetails(thishost,"<tr><td><b>Server Type:<td align=right>"  hw_model[thishost])
  logDetails(thishost,"<tr><td><b>Server Memory (MB):<td align=right>"  hw_memory[thishost])
  logDetails(thishost,"<tr><td><b>Server Processor Count:<td align=right>"  hw_processors[thishost])
  logDetails(thishost,"</table><hr>")

  if (sw_version[thishost] < ver_informix_low  || ver_informix_low == "" ) { ver_informix_low  = sw_version[thishost] }
  if (sw_version[thishost] > ver_informix_high || ver_informix_high == "") { ver_informix_high = sw_version[thishost] }

  #
  # Write to appl-db's history file if neccessary
  #

  "date +%C%y.%m.%d " | getline filedate 
  close "date +%C%y.%m.%d "

  if (system("grep '" titleraw[thishost] "' " hstdir"/appldb/"filedate" > /dev/null 2>&1") != 0 && num_appldatabases[thishost] != "")
  {
    msg = sprintf("Creating appldb history data")
    logit(msg,thishost)

    "date +%C%y.%m.%d " | getline filedate 
    close "date +%C%y.%m.%d "
    "date +%H:%M:%S " | getline filetime 
    close "date +%H:%M:%S "

    print filedate " " filetime " " title[thishost] " " num_appldatabases[thishost] >> hstdir"/appldb/"filedate
  }

  #
  # Terminate
  #

  function_cleanup()
}     


# -----------------------------------------------------------------------------
function infExtents(thishost)
# -----------------------------------------------------------------------------
{
  # Do this every 10th iteration
  #z = iter_count
  #if (z / 10 != int(z / 10))
  #{
  #  s_flag = "N"
  #  msg = sprintf("(Not this iteration)")
  #  logit(msg,thishost)
  #  return
  #}

  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1 
  }
    
  if (substr(sw_version[thishost],1,1) < "6")
  {
    msg = sprintf("Extent checking only works on Informix version >= 6")
    logit(msg,thishost)
    return 0 
  }

  if (max_extents[thishost] == "")
  {
    msg = sprintf("Extent checking not selected for this instance")
    logit(msg,thishost)
    return 0 
  }

  # bb 29Dec99 - Turned off until it is fixed.
  msg = sprintf("Extent checking temporarily turned off - bb 29Dec99")
  logit(msg,thishost)
  return 0 

  ##print thishost
  ##printf("start time: ")
  ##system("date")

  system("rm " tmpfl4 " " tmpfl6 " > /dev/null 2>&1")

  remsh("onstat -;export PATH=$PATH:"infdir[thishost]"/bin;perl /tmp/dbamon_extents.pl " max_extents[thishost] " html",tmpfl4,thishost)

  ##system("cat " tmpfl4) 
  ##print "wf=" warn_flag " if=" info_flag

  info_flag = 0
  crit_flag = 0

  if (system("grep '200EXTENTS' " tmpfl4 " > /dev/null") == 0)
  {
    #
    # 200 Extents check
    #
    msg = sprintf("!!! Table(s) found with >= 200 extents !!!")
    msgid = "DBA270C"

    logit(msg,thishost)

    m_critical[thishost]++
    save_msg = msg

    close tmpfl4
    close tmpfl6

    msg = sprintf("Details:\n")
    print msg > tmpfl6

    ##DEBUG##system("cat " tmpfl4)
    system("cat " tmpfl4 " | grep -v 'INFORMIX' | grep '<' >> " tmpfl6)

    msg = save_msg
    short = "200Xtnt"
    crit_msg(msg,thishost,tmpfl6)
    crit_flag = 1
  }
  else if (system("grep '<b>' " tmpfl4 " > /dev/null") == 0)
  {
    #
    # Threshold Extents check
    #
    msg = sprintf("... Table(s) found with >= %s extents ...",max_extents[thishost])
    msgid = "DBA271I"

    logit(msg,thishost)

    m_info[thishost]++
    save_msg = msg

    close tmpfl4
    close tmpfl6

    msg = sprintf("Details:\n")
    print msg > tmpfl6

    ##DEBUG##system("cat " tmpfl4)
    system("cat " tmpfl4 " | grep -v 'INFORMIX' | grep '<' >> " tmpfl6)

    msg = save_msg
    short = "Xtnt"
    info_msg(msg,thishost,tmpfl6)
    info_flag = 1
  }

  if (crit_flag == 0 && info_flag == 0)
  {
    msg = sprintf("OK (vs. %s/200 instance/critical threshold)",max_extents[thishost])
    logit(msg,thishost)
  }
}


# -----------------------------------------------------------------------------
function oraBkup(thishost)
# -----------------------------------------------------------------------------
{
  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1 
  }
    
  if (backup_age[thishost] == "")
  {
    msg = sprintf("Backup Aging not requested for this instance")
    logit(msg,thishost)
    return 0 
  }

  #
  # bb 11Oct99 - Check to see if there is a backup age inhibit 
  # entry.
  #

  if (use_repository == "Y")
  {
    rc = system("/opt/dbamon/bin/dbamon_ba_check.pl " titleraw[thishost])
    if (rc > 0)
    {
      while (getline < "/opt/dbamon/tmp/ba_check.tmp" > 0)
      {
	sts     = $1
	ets     = $2
	ts      = $3
	reason  = $4
      }
      close "/opt/dbamon/tmp/ba_check.tmp"
      system("rm " "/opt/dbamon/tmp/ba_check.tmp")
    
      bainhibit[thihshost] = 1
      bckhours_c[thishost] = "black"
      bckhours[thishost]   = "(I)"
      msg = sprintf("Backup Aging inhibited for this instance - Start: %s End: %s Created: %s Reason: %s",sts,ets,ts,reason)
      logit(msg,thishost)
      return 0 
    }
  }
  else
  {
    msg = sprintf("Backup Aging Inhibit not possible because Use_MySQL != Y and Use_Oracle != Y")
    logit(msg,thishost)
  }

  if (backup_method_long[thishost] != "bkRMAN")
  {
    close tmpfl6
    print "Since Backup_Age: is on for this DB, you should be"     >  tmpfl6
    print "running RMAN (ora_backup) backups. Establish RMAN"      >> tmpfl6
    print "backups and run a LVL0 backup to satisfy this check."   >> tmpfl6
    close tmpfl6
    bckhours_c[thishost] = "hotpink"
    bckhours[thishost]   = "?"
    msg = sprintf("!!! Backup Method for this DB is %s - Should be RMAN !!!",backup_method_long[thishost])
    save_msg = msg
    logit(msg,thishost)
    msg = save_msg
    msgid = "DBA513C"
    m_critical[thishost]++
    short = "BkpMethod"
    crit_msg(msg,thishost,tmpfl6)
    return 0 
  }

  #running  = "?"
  this_age = mr_age_lvl[thishost]
  bckhours[thishost] = this_age
  if (bckhours[thishost] == 99999999) 
  {
    bckhours[thishost] = "(Never)"
  }
  bckhours_c[thishost] = "lime"

  #
  # Check age vs. threashold - backup NOT running
  #

  # Just in case we exceed, set these vars and make report
  rounded1 = int(this_age / 10)
  rounded1 = rounded1 * 10
  rounded2 = rounded1 + 9
  close tmpfl6
  msg = sprintf("RMAN Backup Details:\n")
  print msg > tmpfl6
  print "Hours since last LVL0/LVL1 backup: " this_age >> tmpfl6
  print "Threshold for this instance: " backup_age[thishost] >> tmpfl6
  print "Backup Rerun Command for this instance: " backup_command[thishost] >> tmpfl6
  print "Most recent ARC backup age (hours): " mr_age_arc[thishost]   >> tmpfl6
  print "Most recent LVL0 backup age (hours): " mr_age_lvl0[thishost] >> tmpfl6
  print "Most recent LVL1 backup age (hours): " mr_age_lvl1[thishost] >> tmpfl6
  close tmpfl6

  # Check against threshold
  if (this_age > backup_age[thishost])
  {
    if (backup_running[thishost] == "Y")
    {
      running_str = "(Backup IS Running Now)"
      bckhours_c[thishost] = "yellow"
      msg = sprintf("Hours since last backup: %s",this_age)
      logit(msg,thishost)
      msg = sprintf("*** %s-%s Hours since last good ora_backup backup - threshold: %s %s ***",rounded1,rounded2,backup_age[thishost],running_str)
      msgid = "DBA512W"
      logit(msg,thishost)
      m_warning[thishost]++
      save_msg = msg
      msg = save_msg
      short = "BkpAge"
      warn_msg(msg,thishost,tmpfl6)
    }
    else
    {
      #
      # 3.23D 08Jul00 BB
      #   we did not issue the restart on the last iteration
      #   (in which case it should be running now), then issue
      #   the restart command.
      #
      if (backup_command[thishost] != "" && backup_rerun_iter[thishost] != (iter_count - 1) )
      {
        # Issue rerun
        cmd = "/tmp/dbamon_ora.pl bkrun \"" backup_command[thishost] "\""
        ##print "backup rerun cmd="cmd " thishost=" thishost
	remsh(cmd,tmpfl3,thishost)
	##system("cat " tmpfl3)
        backup_rerun_iter[thishost] = iter_count

        # warning event
	running_str = "(Backup Was Rerun)"
	bckhours_c[thishost] = "yellow"
	msg = sprintf("Hours since last backup: %s",this_age)
	logit(msg,thishost)
	msg = sprintf("*** %s-%s Hours since last good ora_backup backup - threshold: %s %s ***",rounded1,rounded2,backup_age[thishost],running_str)
	msgid = "DBA514W"
	logit(msg,thishost)
	m_warning[thishost]++
	save_msg = msg
	msg = save_msg
	short = "BkpAge"
	warn_msg(msg,thishost,tmpfl6)
      }
      else
      {
	running_str = "(Backup IS NOT Running Now)"
	bckhours_c[thishost] = "hotpink"
	msg = sprintf("Hours since last backup: %s",this_age)
	logit(msg,thishost)
	msg = sprintf("!!! %s-%s Hours since last good ora_backup backup - threshold: %s %s !!!",rounded1,rounded2,backup_age[thishost],running_str)
	msgid = "DBA511C"
	logit(msg,thishost)
	m_critical[thishost]++
	save_msg = msg
	msg = save_msg
	short = "BkpAge"
	crit_msg(msg,thishost,tmpfl6)
      }
    }
  }
  else    # Age not exceeded
  {
    msg = sprintf("OK - Age=%s Threshold=%s",this_age,backup_age[thishost])
    logit(msg,thishost)
  }
}


# -----------------------------------------------------------------------------
function infArc(thishost)
# -----------------------------------------------------------------------------
{
  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1 
  }
    
  if (db_status[thishost] == "R")
  {
    msg = sprintf("HDR Secondary Instance - backup age checking not applicable")
    logit(msg,thishost)
    return 1 
  }
    
  if (chunks_ok[thishost] != "Y")
  {
    msg = sprintf("(Chunk(s) down)")
    logit(msg,thishost)
    return 1
  }

  if (backup_age[thishost] == "")
  {
    msg = sprintf("Backup Aging not requested for this instance")
    logit(msg,thishost)
    return 0 
  }

  #
  # bb 11Oct99 - Check to see if there is a backup age inhibit 
  # entry.
  #

  if (use_repository == "Y")
  {
    rc = system("/opt/dbamon/bin/dbamon_ba_check.pl " titleraw[thishost])
    if (rc > 0)
    {
      while (getline < "/opt/dbamon/tmp/ba_check.tmp" > 0)
      {
	sts     = $1
	ets     = $2
	ts      = $3
	reason  = $4
      }
      close "/opt/dbamon/tmp/ba_check.tmp"
      system("rm " "/opt/dbamon/tmp/ba_check.tmp")
    
      bainhibit[thihshost] = 1
      bckhours_c[thishost] = "black"
      bckhours[thishost]   = "(I)"
      msg = sprintf("Backup Aging inhibited for this instance - Start: %s End: %s Created: %s Reason: %s",sts,ets,ts,reason)
      logit(msg,thishost)
      return 0 
    }
  }
  else
  {
    msg = sprintf("Backup Aging Inhibit not possible because Use_MySQL= != Y and Use_Oracle != Y")
    logit(msg,thishost)
  }

  running  = "?"
  arc_type = "?"

  #
  # infLocks fills in backup_method[] with A or T. 
  #

  if (backup_method[thishost] == "A")
  {
    arc_type = "onarch" 
  }

  if (backup_method[thishost] == "T")
  {
    arc_type = "ontape" 
  }
   
  if (arc_type != "ontape" && arc_type != "onarch")
  {
    msg = sprintf("infArc() - %s - Cannot determine backup type - unknown dbaccess error #1\n",title[thishost])
    logit(msg,thishost)
    system("cat "tmpfl4)
    error_msg(msg,thishost)
    download_flag[thishost] = 0
    return
  }

  #
  # ontape backups
  #

  if (arc_type == "ontape")
  {
    msg = sprintf("Archive Type: ontape (no rows in sysmaster:arc_request)",arc_type)
    logit(msg,thishost)

    ##print pgmdir "/dbamon_arc_ontape " hostname[thishost] " " rootpath[thishost] " " rootoffs[thishost] " " userid[thishost] " > " tmpfl4 " 2>&1"

    if (system(pgmdir "/dbamon_arc_ontape " hostname[thishost] " " rootpath[thishost] " " rootoffs[thishost] " " userid[thishost] " > " tmpfl4 " 2>&1") != 0)
    {
      msg = sprintf("infArc() - %s - dbamon_arc_ontape error",title[thishost])
      logit(msg,thishost)
      system("cat "tmpfl4)
      error_msg(msg,thishost)
      return
    }

    found_flag = 0

    ##system("cat " tmpfl4)

    close tmpfl4

    while (getline < tmpfl4 > 0)
    {

      if ($1 == "Backup_running:") 
      {
        running = $2
      }

      if ($1 == "L1_date:") 
      if ($1 == "L0_date:") 
      {
        l0_date = $2
      }

      if ($1 == "L1_date:") 
      {
        l1_date = $2
      }

      if ($1 == "L0_delta:") 
      {
        mrl0days[thishost] = int($2 / 24)
      }

      if ($1 == "Min_delta:") 
      {
        this_age = $2
        bckhours[thishost] = this_age
        bckhours_c[thishost] = "lime"
   
	if (this_age == -1)
	{
          system("cat " tmpfl4)
	  msg = sprintf("!!! No ontape archive data retrieved (No backup ever or DBAmon pgm. error) !!!")
          msgid = "DBA209C"

	  logit(msg,thishost)

          short = "BkpNoDat"
	  crit_msg(msg,thishost)
	  m_critical[thishost]++
	  return
	}
	if (this_age < 0)
	{
	  msg = sprintf("!!! Hours since last backup (%s) is a negative value !!!",this_age)
          msgid = "DBA216C"
          logit(msg,thishost)

	  m_critical[thishost]++
	  save_msg = msg

          close tmpfl4
          close tmpfl6

	  msg = sprintf("Archive Details:\n")
	  print msg > tmpfl6
	  print "Hours since last backup: " this_age >> tmpfl6
	  print "Most recent L0 backup:   " l0_date  >> tmpfl6
	  print "Most recent L1 backup:   " l1_date  >> tmpfl6
	  print "\nRaw Data:\n " >> tmpfl6

	  #system("cat " tmpfl4)
	  system("cat " tmpfl4 " | grep ':' >> " tmpfl6)

	  msg = save_msg
          short = "BkpNeg"
          crit_msg(msg,thishost,tmpfl6)

          break
	}

        found_flag = 1

        #
        # Check age vs. threashold - backup NOT running and backup_rerun command specified
        #

        if (this_age > backup_age[thishost] && running != "Y" && backup_command[thishost] != "" && backup_rerun_iter[thishost] != (iter_count - 1))
        {
          # Issue rerun
	  cmd = "/tmp/dbamon_inf.pl bkrun \"" backup_command[thishost] "\""
	  ##print "backup rerun cmd="cmd " thishost=" thishost
          remsh("onstat -;export PATH=$PATH:"infdir[thishost]"/bin;perl " cmd,tmpfl3,thishost)
	  system("cat " tmpfl3)
	  backup_rerun_iter[thishost] = iter_count

          bckhours_c[thishost] = "yellow"
	  msg = sprintf("(Backup Was Rerun) Hours since last backup: %s",this_age)
          logit(msg,thishost)
          rounded1 = int(this_age / 10)
          rounded1 = rounded1 * 10
          rounded2 = rounded1 + 9
	  msg = sprintf("*** (Backup Was Rerun) %s-%s Hours since last good ontape backup (threshold=%s) ***",rounded1,rounded2,backup_age[thishost])
          msgid = "DBA390W"
          logit(msg,thishost)
	  m_warning[thishost]++
	  save_msg = msg
          close tmpfl4
          close tmpfl6
	  msg = sprintf("Archive Details:\n")
	  #printf("%s\n",msg)
	  print msg > tmpfl6
	  print "Hours since last backup: " this_age >> tmpfl6
	  print "Threshold for this instance: " backup_age[thishost] >> tmpfl6
          print "Backup Rerun Command for this instance: " backup_command[thishost] "\n" >> tmpfl6
	  #system("cat " tmpfl4)
	  system("cat " tmpfl4 " | grep ':' >> " tmpfl6)
	  msg = save_msg
          short = "BkpAge"
          warn_msg(msg,thishost,tmpfl6)
          break
        }

        #
        # Check age vs. threashold - backup NOT running
        #

        if (this_age > backup_age[thishost] && running != "Y")
        {
          bckhours_c[thishost] = "hotpink"

	  msg = sprintf("Hours since last backup: %s",this_age)
          logit(msg,thishost)

          rounded1 = int(this_age / 10)
          rounded1 = rounded1 * 10
          rounded2 = rounded1 + 9
          
	  msg = sprintf("!!! %s-%s Hours since last good ontape backup (threshold=%s) !!!",rounded1,rounded2,backup_age[thishost])
          msgid = "DBA211C"
           
          logit(msg,thishost)

	  m_critical[thishost]++
	  save_msg = msg

          close tmpfl4
          close tmpfl6

	  msg = sprintf("Archive Details:\n")
	  #printf("%s\n",msg)
	  print msg > tmpfl6
	  print "Hours since last backup: " this_age >> tmpfl6
	  print "Threshold for this instance: " backup_age[thishost] >> tmpfl6
          print "Backup Rerun Command for this instance: " backup_command[thishost] "\n" >> tmpfl6

	  #system("cat " tmpfl4)
	  system("cat " tmpfl4 " | grep ':' >> " tmpfl6)

	  msg = save_msg
          short = "BkpAge"
          crit_msg(msg,thishost,tmpfl6)

          break
        }

        if (this_age > backup_age[thishost] && running == "Y")
        {
          bckhours_c[thishost] = "yellow"
	  msg = sprintf("(Backup running now) Hours since last backup: %s",this_age)
          logit(msg,thishost)
          rounded1 = int(this_age / 10)
          rounded1 = rounded1 * 10
          rounded2 = rounded1 + 9
	  msg = sprintf("*** (Backup Running Now) %s-%s Hours since last good ontape backup (threshold=%s) ***",rounded1,rounded2,backup_age[thishost])
          msgid = "DBA390W"
          logit(msg,thishost)
	  m_warning[thishost]++
	  save_msg = msg
          close tmpfl4
          close tmpfl6
	  msg = sprintf("Archive Details:\n")
	  #printf("%s\n",msg)
	  print msg > tmpfl6
	  print "Hours since last backup: " this_age >> tmpfl6
	  print "Threshold for this instance: " backup_age[thishost] >> tmpfl6
          print "Backup Rerun Command for this instance: " backup_command[thishost] "\n" >> tmpfl6
	  #system("cat " tmpfl4)
	  system("cat " tmpfl4 " | grep ':' >> " tmpfl6)
	  msg = save_msg
          short = "BkpAge"
          warn_msg(msg,thishost,tmpfl6)
          break
        }

        if (this_age <= backup_age[thishost])
        {
          msg = sprintf("OK (ontape age=%s recent L0 age=%s days)",this_age,mrl0days[thishost])
          logit(msg,thishost)
          break
        }

      } 
    }  # end of while 

    close tmpfl4

  }

  #
  # onarchive backups
  #

  else  # backup_type: onarch
  {
    msg = sprintf("Archive Type: onarchive (rows found in sysmaster:arc_request)",arc_type)
    logit(msg,thishost)

    reran_flag = 0

    remsh("onstat -;export PATH=$PATH:"infdir[thishost]"/bin;perl /tmp/dbamon_inf.pl onarc",tmpfl4,thishost)
    ##remsh("onstat -;export PATH=$PATH:"infdir[thishost]"/bin;perl /tmp/dbamon_onarc.pl ",tmpfl4,thishost)

    ##system("cat " tmpfl4)

    close tmpfl4

    this_age = -1

    while (getline < tmpfl4 > 0)
    {
      if ($1 == "HOURS:") 
      {
        this_age = $2
        bckhours[thishost] = this_age
        bckhours_c[thishost] = "lime"
      }
      if ($1 == "RUNNING:") 
      {
        running = $2
      }
      if ($1 == "MRL0DSID:") 
      {
        mrl0dsid[thishost] = $2
      }
      if ($1 == "MRL0DAYSAGO:") 
      {
        mrl0days[thishost] = int($2)
      }
    }

    #
    # Check age vs. threashold - backup NOT running and backup_rerun command specified
    #
    if (this_age > backup_age[thishost] && running != "Y" && backup_command[thishost] != "" && backup_rerun_iter[thishost] != (iter_count - 1))
    {
      # Issue rerun
      cmd = "/tmp/dbamon_inf.pl bkrun \"" backup_command[thishost] "\""
      ##print "backup rerun cmd="cmd " thishost=" thishost
      remsh("onstat -;export PATH=$PATH:"infdir[thishost]"/bin;perl " cmd,tmpfl3,thishost)
      system("cat " tmpfl3)
      backup_rerun_iter[thishost] = iter_count
      reran_flag = 1

      bckhours_c[thishost] = "yellow"
      rounded1 = int(this_age / 10)
      rounded1 = rounded1 * 10
      rounded2 = rounded1 + 9
      msg = sprintf("*** %s-%s (Backup Was Rerun) Hours since last good onarchive backup (threshold=%s) ***",rounded1,rounded2,backup_age[thishost])
      msgid = "DBA391W"
      logit(msg,thishost)
      m_warning[thishost]++
      save_msg = msg
      close tmpfl4
      close tmpfl6
      msg = sprintf("Archive Details:\n")
      #printf("%s\n",msg)
      print msg > tmpfl6

      #system("cat " tmpfl4)
      system("cat " tmpfl4 " >> " tmpfl6)

      msg = save_msg
      short = "BkpAge"
      warn_msg(msg,thishost,tmpfl6)
    }

    #
    # Check age vs. threashold - backup NOT running 
    #
    if (this_age > backup_age[thishost] && running != "Y" && reran_flag != 1)
    {
      bckhours_c[thishost] = "hotpink"

      rounded1 = int(this_age / 10)
      rounded1 = rounded1 * 10
      rounded2 = rounded1 + 9
        
      msg = sprintf("!!! (Backup Not Running) %s-%s Hours since last good onarchive backup (threshold=%s) !!!",rounded1,rounded2,backup_age[thishost])
      msgid = "DBA210C"

      logit(msg,thishost)

      m_critical[thishost]++
      save_msg = msg

      close tmpfl4
      close tmpfl6

      msg = sprintf("Archive Details:\n")
      #printf("%s\n",msg)
      print msg > tmpfl6

      #system("cat " tmpfl4)
      system("cat " tmpfl4 " >> " tmpfl6)

      msg = save_msg
      short = "BkpAge"
      crit_msg(msg,thishost,tmpfl6)
    }

    #
    # Check age vs. threashold - backup IS running 
    #
    if (this_age > backup_age[thishost] && running == "Y")
    {
      bckhours_c[thishost] = "yellow"
      rounded1 = int(this_age / 10)
      rounded1 = rounded1 * 10
      rounded2 = rounded1 + 9
      msg = sprintf("*** (Backup Running Now) %s-%s Hours since last good onarchive backup (threshold=%s) ***",rounded1,rounded2,backup_age[thishost])
      msgid = "DBA391W"
      logit(msg,thishost)
      m_warning[thishost]++
      save_msg = msg
      close tmpfl4
      close tmpfl6
      msg = sprintf("Archive Details:\n")
      #printf("%s\n",msg)
      print msg > tmpfl6

      #system("cat " tmpfl4)
      system("cat " tmpfl4 " >> " tmpfl6)

      msg = save_msg
      short = "BkpAge"
      warn_msg(msg,thishost,tmpfl6)
    }

    if (this_age <= backup_age[thishost])
    {
      msg = sprintf("OK (onarchive age=%s most recent L0 age=%s days)",this_age,mrl0days[thishost])
      logit(msg,thishost)
      break
    }
  }

  if (mrl0days[thishost] > l0_age[thishost])
  {
    msg = sprintf("!!! %s Days since last good Level=0 backup (threshold=%s) !!!",mrl0days[thishost],l0_age[thishost])
    msgid = "DBA400C"

    logit(msg,thishost)

    m_critical[thishost]++
    short = "L0Age"
    crit_msg(msg,thishost)
  }

  close tmpfl4
  close tmpfl6

}


# -----------------------------------------------------------------------------
function infPerf(thishost)
# -----------------------------------------------------------------------------

{
  #
  #  Check perf
  #

  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1 
  }
    
  check_remsh(system(cmdpfx[thishost]"onstat -p"cmdsfx[thishost]">" tmpfl4 " 2>" remshlog),thishost)
  if (system("grep -i 'shared memory not' " tmpfl4) == 0) 
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1 
  }

  dsk_flag = 0
  ov_flag = 0
  done_flag = 0
  check_flag = 0

  logDetails(thishost,"<h3>Informix Performance Metrics</h3>")
  logDetails(thishost,"<table border=1>")
  logDetails(thishost,"<tr bgcolor=slate><th>Metric<th>Value")

  while (getline < tmpfl4 > 0 && done_flag == 0)
  {
    if (dsk_flag)
    {

      bufreads = $3
      rh = $4
      wh = $8

      if (rh > 0 && rh < t_readhit[thishost] && bufreads > 10000000 && t_readhit[thishost] != "")
      {
	msg = sprintf("--- Read Hit Ratio %s < Threshold of %s ---",rh,t_readhit[thishost])
        msgid = "DBA240I"

	logit(msg,thishost)

        short = "RHit"
        user_msg(msg,thishost)
        m_user[thishost]++
	check_flag = 1
      }

      if (wh > 0 && wh < t_writehit[thishost] && bufreads > 10000000 && t_writehit[thishost] != "")
      {
	msg = sprintf("--- Write Hit Ratio %s < Threshold of %s ---",wh,t_writehit[thishost])
        msgid = "DBA241I"
	
	logit(msg,thishost)

        short = "WHit"
        user_msg(msg,thishost)
        m_user[thishost]++
	check_flag = 1
      }

      dsk_flag = 0
    }

    if (ov_flag)
    {

      ovtbls = $1
      ovlock = $2
      ovuser = $3
      ovbuff = $4

      if (ovtbls!= 0)
      {
	msg = sprintf("*** ovtbls Non-Zero ***")
        msgid = "DBA212C"

        logit(msg,thishost)

        short = "OVTb"
        warn_msg(msg,thishost)
        m_warning[thishost]++
	check_flag = 1
      }
	
      if (ovlock!= 0)
      {
	msg = sprintf("*** ovlock Value: %s Is Non-Zero ***",ovlock)
        msgid = "DBA213C"

        logit(msg,thishost)

        short = "OVLk"
        warn_msg(msg,thishost)
        m_warning[thishost]++
	check_flag = 1
      }

      if (ovuser!= "0")
      {
	msg = sprintf("*** ovuserthread Non-Zero ***")
        msgid = "DBA214C"
	
        logit(msg,thishost)

        short = "OVUs"
        warn_msg(msg,thishost)
        m_warning[thishost]++
	check_flag = 1
      }

      if (ovbuff!= 0)
      {
	msg = sprintf("*** ovbuff Non-Zero ***")
        msgid = "DBA215C"
	
        logit(msg,thishost)

        short = "OVBf"
        warn_msg(msg,thishost)
        m_warning[thishost]++
	check_flag = 1
      }

      ov_flag = 0
      done_flag = 1

    }

    if ($1 == "dskreads") { dsk_flag = 1 }
    if ($1 == "ovtbls")   { ov_flag = 1 }
  }

  close tmpfl4

  logDetails(thishost,"<tr><th>Read Hit Ratio:<td align=right>" rh)
  logDetails(thishost,"<tr><th>Write Hit Ratio:<td align=right>" wh)
  logDetails(thishost,"<tr><th>Bufreads:<td align=right>" bufreads)
  logDetails(thishost,"<tr><th>Ovbuff:<td align=right>" ovbuff)
  logDetails(thishost,"<tr><th>Ovtbls:<td align=right>" ovtbls)
  logDetails(thishost,"<tr><th>Ovlock:<td align=right>" ovlock)
  logDetails(thishost,"<tr><th>Ovuser:<td align=right>" ovuser)
  logDetails(thishost,"</table><hr>")

  if (check_flag == 0) 
  {
    msg = sprintf("OK")
    logit(msg,thishost)
  }

  function_cleanup()
    
}     
# -----------------------------------------------------------------------------
function infSaveCfg(thishost)
# -----------------------------------------------------------------------------

{
  #
  # Do this only on the 1st iteration
  #

  if ((iter_count != 1) && (rootpath[thishost] != ""))
  {
    s_flag = "N"
    msg = sprintf("(Not this iteration)")
    logit(msg,thishost)
    return
  }

  #
  #  Save the onconfig and onstat -a output for each host
  #

  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1 
  }
    
  close tmpfl3
  remsh("onstat -cdl", tmpfl3, thishost)
  ##system("cat "tmpfl3)

  if (system("grep -i 'shared memory not' " tmpfl3) == 0) 
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1 
  }

  while (getline < tmpfl3 > 0)
  {
    if ($1 == "ROOTPATH")   { rootpath[thishost] = $2  }
    if ($1 == "ROOTOFFSET") { rootoffs[thishost] = $2 / 2 }
  } 
  close tmpfl3

  ##print "rp=" rootpath[thishost] 
  ##print "ro=" rootoffs[thishost]

  if (system("cp " tmpfl3 " " save_file[thishost]) != 0)
  {
    msg = sprintf("Error copying onstat -a file - exiting")
    logit(msg,thishost)
    exit 1
  }

  msg = sprintf("onstat -cdl Output Saved OK")
  logit(msg,thishost)

  if (rootpath[thishost] == "" || rootoffs[thishost] == "")
  {
    msg = sprintf("infSaveCfg() - %s - rootpath / rootoffs blank - ONCONFIG dbamonrc problem",title[thishost])
    logit(msg,thishost)
    system("cat " tmpfl3 " >> " logfile)
    error_msg(msg,thishost)
    system("cat " tmpfl3)
    return 1
  }

  function_cleanup()
}     


# -----------------------------------------------------------------------------
function infChunksDown(thishost)
# -----------------------------------------------------------------------------

{
  #
  #  Check for bad log messages
  #

  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1 
  }
    
  check_remsh(system(cmdpfx[thishost]"onstat -d"cmdsfx[thishost]" | grep '/' | grep -v address >"tmpfl3 " 2>" remshlog),thishost)

  if (system("grep -i 'shared memory not' " tmpfl3) == 0) 
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1 
  }

  # 
  # 3.21C - 64bit informix has a much longer chunk address in the
  #  onstat -d output. So, we need to look in a different place
  #  for 64 bit informix
  #
  
  if (v64bit[thishost])
  {
    where = 63
  }
  else
  {  
    where = 55
  }
  ##print "where=" where

  offline_chunks = 0
  while (getline < tmpfl3 > 0)
  {
    chunk_status = substr($0,where,1) 

    #print "cs=" chunk_status " ds=" db_status[thishost] " " thishost

    if (db_status[thishost] == "O")
    {
      if (chunk_status != "O") { offline_chunks++ }
    }
    else  # Must be R
    {
      if (chunk_status != "O" && chunk_status != "I") { offline_chunks++ }
    }
  }
  close tmpfl3

  if (offline_chunks > 0)
  {
    msg = sprintf("!!! %s Offline Chunk(s) Found !!!",offline_chunks)
    msgid = "DBA280C"

    logit(msg,thishost)

    system("cat "tmpfl3)
    
    short = "OfCk"
    crit_msg(msg,thishost,tmpfl3)

    printf("\n")

    m_critical[thishost]++
    chunks_ok[thishost] = "N"
  }
  else
  {
    msg = sprintf("OK")
    logit(msg,thishost)
    chunks_ok[thishost] = "Y"
  }
    
  function_cleanup()

}     

# -----------------------------------------------------------------------------
function infSWVer(thishost)
# -----------------------------------------------------------------------------

{
  if (ver_colors == "N")
  {
    sw_color[i_rm]   = "white"
    msg = sprintf("(dbamonrc Ver_Colors: = N - Informix version checking disabled)")
    logit(msg,thishost)
    return 1 
  }

  if (sw_version[thishost] == "")
  {
    msg = sprintf("(no Informix version info)")
    logit(msg,thishost)
    return 1 
  }

  ver = sw_version[thishost] 
  ##print "ver="ver

  "date +%C%y.%m.%d " | getline filedate
  close "date +%C%y.%m.%d "
  "date +%H:%M:%S " | getline filetime 
  close "date +%H:%M:%S "

  #
  # Check to see if we've already created today's report
  #

  rpt_file = rptdir"/informix_ver/"filedate
  if (system("ll " rpt_file " > /dev/null 2>&1") != 0)
  {
    msg = sprintf("Creating Informix Version report - "rptfile)
    logit(msg,thishost)
    rpt_flag = 1
    upgrade_count = 0
    printf("%s - %s\n",filedate,filetime) > rpt_file
    printf("\nInformix Version Report - Instances in need of Informix Upgrade\n") >> rpt_file
    printf("\nInstance                        Current Version  Version Status\n") >> rpt_file
    printf  ("------------------------------  ---------------  --------------------------------------------\n") >> rpt_file
  }

  #
  # Determine status
  #

  sw_color[thishost] = "gray"

  if (system("grep _" ver "_ /opt/dbamon/adm/informix_ver/good.txt > /dev/null 2>&1") == 0)
  {
    sw_color[thishost] = "lime"
    msg = sprintf("OK")
    logit(msg,thishost)
    vers = "Good"
  }

  if (system("grep _" ver "_ /opt/dbamon/adm/informix_ver/soso.txt  > /dev/null 2>&1") == 0)
  {
    sw_color[thishost] = "yellow"
    ##msgid = "DBA320I"
    ##m_info[thishost]++
    msg = sprintf("... Running Informix %s - Version designated as SO-SO ...",ver)
    logit(msg,thishost)
    vers = "Known Problems With Workarounds"
    ##info_msg(msg,thishost)
  }

  if (system("grep _" ver "_ /opt/dbamon/adm/informix_ver/bad.txt  > /dev/null 2>&1") == 0)
  {
    sw_color[thishost] = "hotpink"
    ##msgid = "DBA320I"
    ##m_info[thishost]++
    msg = sprintf("... Running Informix %s - Version designated as BAD ...",ver)
    logit(msg,thishost)
    vers = "Known CRITICAL Problems Without Workarounds"
    ##info_msg(msg,thishost)
  }

  if (sw_color[thishost] == "gray")
  {
    ##msgid = "DBA321I"
    ##m_info[thishost]++
    msg = sprintf("... Running Informix %s - Version not being tracked - Status unknown ...",ver)
    logit(msg,thishost)
    vers = "Unknown Informix Version"
    ##info_msg(msg,thishost)
  }

  #
  # Create report - if neccessary
  #

  if (rpt_flag == 1)
  {
    if (sw_color[thishost] == "hotpink" || sw_color[thishost] == "yellow") 
    {
      upgrade_count++
    }
    printf("%-30s  %-15s  %s\n",title[thishost],ver,vers) >> rpt_file
    if (thishost == high_host)
    {
      msg = sprintf("Mailing Informix Version report - "rptfile)
      logit(msg,thishost)
      echo "cat " rpt_file " | dbamon_mailer -m -s 'DBAmon | " upgrade_count " Instances In Need Of Informix Upgrade' " report_email
      system("cat " rpt_file " | dbamon_mailer -m -s 'DBAmon | " upgrade_count " Instances In Need Of Informix Upgrade' " report_email) 
      rpt_flag = 0
    }
  }
}

# -----------------------------------------------------------------------------
function infMLog(thishost)
# -----------------------------------------------------------------------------

{
  #
  #  Check for bad log messages
  #

  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1 
  }
    
  #check_remsh(system(cmdpfx[thishost]"onstat -m"cmdsfx[thishost]">"tmpfl3 " 2>" remshlog),thishost)
  remsh("onstat -m",tmpfl3,thishost)

  if (system("grep -i 'shared memory not' " tmpfl3) == 0) 
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1 
  }

  found_flag = 0

  if (system("grep -if " admdir "/dbamon.msg_warn " tmpfl3 ">" tmpfl4) == 0)
  {
    msg = sprintf("... Warning Log Messages Found ...")
    msgid = "DBA221W"

    logit(msg,thishost)
    system("cat " tmpfl4 " >> " logfile) 

    short = "WarnMsg"
    info_msg(msg,thishost,tmpfl4)
    m_info[thishost]++
    found_flag = 1
  }

  if (system("grep -if " admdir "/dbamon.msg_critical " tmpfl3 " | grep -vif " admdir "/dbamon.msg_critical_bogus >" tmpfl4) == 0)
  {
    msg = sprintf("!!! Critical Log Messages Found !!!")
    msgid = "DBA220C"
    m_critical[thishost]++

    logit(msg,thishost)
    system("cat "tmpfl4)
    printf("\n")

    short = "CritMsg"
    crit_msg(msg,thishost,tmpfl4)

    found_flag = 1
  }
      
  if (found_flag == 0) 
  {
    msg = sprintf("OK")
    logit(msg,thishost)
  }
    
  function_cleanup()

}     

# -----------------------------------------------------------------------------
function infNFile(thishost)
# -----------------------------------------------------------------------------

#
# Note: this subroutine must follow infLocks
#

{
  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1 
  }

  ##print "nf_pct=" nf_pct[thishost] 

  if (nf_pct[thishost] >= 90)
  { 
    msgid = "DBA460W"
    m_warning[thishost]++
    msg = sprintf("*** UX NFILEs %s%% used - current value=%s kernel maximum=%s ***",nf_pct[thishost],nf_cur[thishost],nf_max[thishost])
    logit(msg,thishost)
    short = "NFile"
    warn_msg(msg,thishost)
  }
  else
  {
    msg = sprintf("OK - ckptavg=%s",ckptavg[thishost])
    msg = sprintf("OK - %s / %s %s%%",nf_cur[thishost],nf_max[thishost],nf_pct[thishost])
    logit(msg,thishost)
  }
}


# -----------------------------------------------------------------------------
function infCkpt(thishost)
# -----------------------------------------------------------------------------

#
# Note: this subroutine must follow infLocks
#

{
  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1 
  }

  ##print "ckptavg=" ckptavg[thishost] 

  if (ckptavg[thishost] > 120)
  { 
    msgid = "DBA350I"
    m_info[thishost]++
    msg = sprintf("... Current average checkpoint duration is %s seconds ...",ckptavg[thishost])
    logit(msg,thishost)
    short = "Ckpt"
    info_msg(msg,thishost)
  }
  else
  {
    msg = sprintf("OK - ckptavg=%s",ckptavg[thishost])
    logit(msg,thishost)
  }
}


# -----------------------------------------------------------------------------
function infCleaners(thishost)
# -----------------------------------------------------------------------------

#
# Note: this subroutine must follow check_dbs
#

{
  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1 
  }

  if (num_disks[thishost] == "")
  {
    msg = sprintf("Disk count null - cannot run cleaners check")
    logit(msg,thishost)
    return 0 
  } 

  cleanpct = int(cleaners[thishost] / num_disks[thishost] * 100)
  recnumcl = num_disks[thishost] + 2

  if (recnumcl > 127)
  {
    recnumcl = 127
  }

  if (recnumcl < lrus[thishost])
  {
    recnumcl = lrus[thishost]
  }

  ##print "cl=" cleaners[thishost] 
  ##print "nd=" num_disks[thishost] 
  ##print "lr=" lrus[thishost] 
  ##print "pc=" cleanpct
  ##print "rn=" recnumcl

  if ((cleanpct < 75) || (cleaners[thishost] < (lrus[thishost] / 2) ))
  { 
    #
    # Added code for big instances (boi90) that have 127 CLEANERS)
    #
    if (cleaners[thishost] < 127)
    {
      msgid = "DBA330I"
      m_info[thishost]++
      msg = sprintf("... CLEANERS (%s) must be at least 75%% of the number of disks (%s) and >= (LRUS/2) (%s) ...",cleaners[thishost],num_disks[thishost],lrus[thishost])
      logit(msg,thishost)
      print "Current CLEANERS ONCONFIG value: " cleaners[thishost]   >  tmpfl6
      print "Current LRUS ONCONFIG value:     " lrus[thishost]       >> tmpfl6
      print "Current number of disks:         " num_disks[thishost]  >> tmpfl6
      print "% of disks that have a CLEANER:  " cleanpct             >> tmpfl6
      print "Recommended CLEANERS value:      " recnumcl             >> tmpfl6
      close tmpfl6
      short = "Clnr"
      info_msg(msg,thishost,tmpfl6)
    }
  }
  else
  {
    msg = sprintf("OK - CLEANERS=%s disks=%s (%s percent) of disks",cleaners[thishost],num_disks[thishost],cleanpct)
    logit(msg,thishost)
  }

  #This is temporary 11Jan99
  #return 0


  #
  # Check AIO vp's
  #
  # The var AIORAT is the percentage the last AIOVP totalops is vs. 
  # the first AIOVP. If that is > 10 (meaning that the last is more
  # than 10% as busy as the first) then we need to increase the 
  # number of AIOVP's. The recommendation will be to make it 50% 
  # of cleaners. If this value is not sufficient, then hmmmmm.
  #
  # bb 03Jun99 - changed above 10 number to 40 - if there are too many
  #   aiovps, you can exceed NFILES which causes down chunks.

  aiong = 0

  recaiovp = int(cleaners[thishost] * 0.75)
  if (recaiovp <= numaiovps[thishost])
  {
    recaiovp = int(numaiovps[thishost] * 1.25)
  }
  toadd = recaiovp - numaiovps[thishost] 

  #
  # If the recommended number of aiovps is > 2x cleaners, don't
  # bother trying to increase AIOvps.
  #
  if (recaiovp > (cleaners[thishost] * 2))
  {
    proceed = 0
  }
  else
  {
    proceed = 1
  }

  #
  # If the recommended number of aiovps to add is 0, don't bother
  #
  if (toadd == 0)
  {
    proceed = 0
  }

  #
  # Create events
  # 

  if (kio[thishost] == 1 && numaiovps[thishost] > 2)
  { 
    aiong = 1
    msgid = "DBA360I"
    m_info[thishost]++
    msg = sprintf("... (KAIO on) - NUMAIOVPS value of %s is greater than recommended value of 1 or 2 ...",numaiovps[thishost])
    logit(msg,thishost)

    print "Current NUMAIOVPS ONCONFIG value: " numaiovps[thishost]   >  tmpfl6
    print "Current Number of AIO VPs:        " aiocur[thishost]      >> tmpfl6
    print "Recommended NUMAIOVPS value:      " "2"                   >> tmpfl6
    close tmpfl6

    short = "AIOk"
    info_msg(msg,thishost,tmpfl6)
  }

  if (kio[thishost] != 1 && aiorat[thishost] > 40 && proceed == 1)
  { 
    aiong = 1
    msgid = "DBA370I"
    m_info[thishost]++
    msg = sprintf("... (KAIO off) - AIO Least to <br>Most Ratio %s > Threshold of 40 - NUMAIOVPS value: %s too small ...",aiorat[thishost],numaiovps[thishost])
    logit(msg,thishost)

    print "AIOVP Least to Most Busy TOTALOPS Ratio: " aiorat[thishost]      >  tmpfl6
    print "Current NUMAIOVPS ONCONFIG value:        " numaiovps[thishost]   >> tmpfl6
    print "Current Number of AIO VPs:               " aiocur[thishost]      >> tmpfl6
    print "Current CLEANERS ONCONFIG value:         " cleaners[thishost]    >> tmpfl6
    print "Recommended NUMAIOVPS value:             " recaiovp              >> tmpfl6
    print " "                                                               >> tmpfl6
    print "Note: this could be caused by NUMAIOVPS being configured"        >> tmpfl6
    print "low for KAIO, and the KAIOON environment variable not being"     >> tmpfl6
    print "set to 1 at Informix startup time."                              >> tmpfl6
    print " "                                                               >> tmpfl6
    print "To solve this problem now, dynamically add " toadd " AIO VP's"   >> tmpfl6
    print "by running 'onmode -p +" toadd " aio'. Also remember to change"  >> tmpfl6
    print "the NUMAIOVPS ONCONFIG value to " recaiovp "."                   >> tmpfl6
    close tmpfl6

    short = "AIOr"
    info_msg(msg,thishost,tmpfl6)
  }

  ##print "aiong=" aiong

  if (aiong == 0)
  {
    msg = sprintf("OK - NUMAIOVPS=%s KIO=%s CLEANERS=%s AIORAT=%s",numaiovps[thishost],kio[thishost],cleaners[thishost],aiorat[thishost])
    logit(msg,thishost)
  }
}


# -----------------------------------------------------------------------------
function infShmem(thishost)
# -----------------------------------------------------------------------------

#
# Note: this subroutine must follow infLocks
#

{
  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1 
  }

  if (substr(sw_version[thishost],1,1) < "7")
  {
    msg = sprintf("Shared Memory V Seg checking only works on Informix version >= 7")
    logit(msg,thishost)
    return 0 
  } 

  ## bb 19May98 - Changed percent increase from 10 to 0 ## recsize = int(shmvsiz[thishost] * 1.1 / 1000000) * 1000
  recsize = int(shmvsiz[thishost] * 1.0 / 1000000) * 1000

  ##print shmvseg[thishost] 
  ##print shmvsiz[thishost] 
  ##print recsize

  shmwarn = 4
  shmcrit = 10

  if (shmvsiz[thishost] > 1000000000)
  {
      msg = sprintf("OK - %s V Segments - SHMVIRTSIZE=%s - V Mem > 1GB - No Action Possible",shmvseg[thishost],shmvirtsize[thishost])
      logit(msg,thishost)
      return 
  }

  if (shmvirtsize[thishost] >= recsize && shmvseg[thishost] >= shmwarn)
  {
      msg = sprintf("OK - %s V Segments - SHMVIRTSIZE=%s - ONCONFIG already changed",shmvseg[thishost],shmvirtsize[thishost])
      logit(msg,thishost)
      return 
  }

  if (shmvseg[thishost] >= shmcrit)
  { 
    msgid = "DBA310I"
    m_info[thishost]++
    msg = sprintf("... Instance has %s V shmem segments (critical threshold=%s) ...",shmvseg[thishost],shmcrit)
    logit(msg,thishost)
      
    print "Current number of V segments: " shmvseg[thishost] >  tmpfl6
    print "Current size of V segments: "   shmvsiz[thishost] >> tmpfl6
    print "Recommended SHMVIRTSIZE value: "  recsize         >> tmpfl6
    print "Recommended SHMADD value:       "  int(recsize/8) >> tmpfl6
    close tmpfl6

    short = "Shm"
    info_msg(msg,thishost,tmpfl6)
  }
  else
  {
    if (shmvseg[thishost] >= shmwarn)
    { 
      msgid = "DBA310I"
      m_info[thishost]++
      msg = sprintf("... Instance has %s V shmem segments (warning threshold=%s) ...",shmvseg[thishost],shmwarn)
      logit(msg,thishost)
	
      print "Current number of V segments: " shmvseg[thishost] >  tmpfl6
      print "Current size of V segments: "   shmvsiz[thishost] >> tmpfl6
      print "Recommended SHMVIRTSIZE value: "  recsize         >> tmpfl6
      print "Recommended SHMADD value:       "  int(recsize/8) >> tmpfl6
      close tmpfl6

      short = "Shm"
      info_msg(msg,thishost,tmpfl6)
    }
    else
    {
      msg = sprintf("OK - %s V Segments",shmvseg[thishost])
      logit(msg,thishost)
    }
  } 
}

# -----------------------------------------------------------------------------
function infDBS(thishost)
# -----------------------------------------------------------------------------

{
  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1 
  }

  if (chunks_ok[thishost] != "Y")
  {
    msg = sprintf("(Chunk(s) down)")
    logit(msg,thishost)
    return 1 
  }

  # 3.18 - CLEANERS weren't checked if we don't run this 
  #if (dr_status[i_rm] == "(Sec)" ) 
  #{
  #  msg = sprintf("(DBSpace Check Not Applicable for HDR Secondary)")
  #  logit(msg,thishost)
  #  return 1 
  #}

  ##print os_version[thishost]
  ##print substr(os_version[thishost],1,1) 

  ##if (substr(os_version[thishost],1,1) == "0")
  ##{
  ##  msg = sprintf("Locks Used checking only works on HP-UX version >= 10")
  ##  logit(msg,thishost)
  ##  return 0 
  ##}

  warn_flag = 0
  crit_flag = 0

  warndbs[thishost] = 0
  critdbs[thishost] = 0

  #
  # Run perl pgm to query dbspaces (sysmaster)
  #

  remsh("onstat -;export PATH=$PATH:"infdir[thishost]"/bin;perl /tmp/dbamon_inf.pl dbs",tmpfl2,thishost)
  ##system("cat " tmpfl2)

  #
  # Create Disk Space Report Heading
  #

  logDetails(thishost,"<h3>Informix DBSpaces</h3>")
  logDetails(thishost,"<table border=1>")
  logDetails(thishost,"<tr bgcolor=slate><th>DBSpace<th>Chunks<th>Size (MB)<th>Free (MB)<th>Used (MB)<th>Percent Full<th>Status:<br>W=Warning<br>C=Critical</tr>")

  total_size = 0
  total_free = 0
  total_used = 0
  total_chks = 0

  #  
  # If needed, create DBSPACE History File
  #

  "date +%C%y.%m.%d " | getline filedate 
  close "date +%C%y.%m.%d "
  "date +%H:%M:%S " | getline filetime 
  close "date +%H:%M:%S "
  
  hist_flag = 0

  if (system("grep '" titleraw[thishost] "' " hstdir "/dbspaces/"filedate" > /dev/null 2>&1") != 0)
  {
    msg = sprintf("Creating dbspace history data")
    logit(msg,thishost)
    system("rm " tmpflt " > /dev/null 2>&1")
    hist_flag = 1    
  }

  #
  # Read report
  #

  error_flag = 0
  error_text = ""

  while (getline < tmpfl2 > 0 && stop == 0)
  {

    ##print $0

    if ($1 == "kio")
    {
      kio[thishost] = 1
      ##print "kio=" kio[thishost]
    }

    if ($1 == "WSTATS")
    {
      wstats[thishost] = $2
      ##print "wstats=" wstats[thishost]
    }

    if ($1 == "ERROR:")
    {
      error_flag = 1
      error_text = $0
    }

    if ($1 == "SHMVIRTSIZE")
    {
      shmvirtsize[thishost] = $2
      ##print "shmvirtsize=" shmvirtsize[thishost]
    }

    if ($1 == "LTAPEDEV")
    {
      ltapedev[thishost] = $2
      ##print "ltapedev=" ltapedev[thishost]
    }

    if ($1 == "LRUS")
    {
      lrus[thishost] = $2
      ##print "lrus=" lrus[thishost]
    }

    if ($1 == "CLEANERS")
    {
      cleaners[thishost] = $2
      ##print "cleaners=" cleaners[thishost]
    }

    if ($1 == "NUMAIOVPS")
    {
      numaiovps[thishost] = $2
      ##print "numaiovps=" numaiovps[thishost]
    }

    if ($1 == "AIORAT:")
    {
      aiorat[thishost] = $2
      aiocur[thishost] = $8
      ##print title[thishost] " aiorat=" aiorat[thishost]
    }

    if ($1 == "SAP:")
    {
      sapkern[thishost] = $2
      saprlse[thishost] = $3
      ##print title[thishost] " sapkern=" sapkern[thishost] " saprlse=" saprlse[thishost]
    }

    if ($1 == "normal")
    {
      shmmagic[thishost] = 1
      ##print "shmmagic=" shmmagic[thishost]
    }

    if ($1 == "THIS:")
    {
      dbspace = $2
      nchunks = $3
      dbssize = $4
      dbsfree = $5
      dbsused = $6
      dbspct  = $7 + 0
      dbspre = substr(dbspace,1,4)
      dbspre3 = substr(dbspace,1,3)
 
      #
      # Check vs. threshold
      #

      ##print "dbspct=" dbspct 
      ##print "dbspre=" dbspre 
      ##print "dbspre3=" dbspre3
      ##print "tdcrit=" t_diskcrit[thishost]
      ##print "tdwarn=" t_diskwarn[thishost]
      ##print "tdfree=" t_freespace[thishost]
 
      status = ""
      color = "lime"

      if (dr_status[i_rm] != "(Sec)" && dbspct > t_diskcrit[thishost] && dbsfree < t_freespace[thishost] && dbspre3 != "phy" && dbspre3 != "log" && dbspre != "plog")
      {
        status = "C"
        color = "red"
	msg = sprintf("!!! DBSpace %s (%s%% full %sMB free) exceeds critical threshold of %s !!!",dbspace,dbspct,dbsfree,t_diskcrit[thishost])
	msgid = "DBA250C"
	m_critical[thishost]++

	logit(msg,thishost)

	save_msg = msg

	msg = sprintf(" DBSpace           Chunks   Size (MB)   Free (MB)   Pct Full")
	logit(msg,thishost)

	close tmpfl6
	print msg > tmpfl6

	msg = sprintf(" %-20s  %2s  %10d  %10d    %6.1d%%",dbspace,nchunks,dbssize,dbsfree,dbspct)
	logit(msg,thishost)

	print msg >> tmpfl6
	close tmpfl6

	msg = save_msg

        if (critdbs[thishost] == 0)
        {
          short = "DBS"
          critdbs[thishost] = 1
        }
        else
        {
          short = ""
        }

	crit_msg(msg,thishost,tmpfl6)
	crit_flag=1
      }
      else if (dr_status[i_rm] != "(Sec)" && dbspct > t_diskwarn[thishost] && dbsfree < t_freespace[thishost] && dbspre3 != "phy" && dbspre3 != "log" && dbspre != "plog")
      {
        status = "W"
        color = "yellow"
	msg = sprintf("*** DBSpace %s (%s%% full %sMB free) exceeds warning threshold of %s ***",dbspace,dbspct,dbsfree,t_diskwarn[thishost])
	msgid = "DBA251W"
	
	logit(msg,thishost)
	m_warning[thishost]++
	save_msg = msg

	msg = sprintf(" DBSpace           Chunks   Size (MB)   Free (MB)   Pct Full")
	logit(msg,thishost)

	close tmpfl6
	print msg > tmpfl6

	msg = sprintf(" %-20s  %2s  %10d  %10d    %6.1d%%",dbspace,nchunks,dbssize,dbsfree,dbspct)
	logit(msg,thishost)
	
	print msg >> tmpfl6
	close tmpfl6

	msg = save_msg

        if (warndbs[thishost] == 0)
        {
          short = "DBS"
          warndbs[thishost] = 1
        }
        else
        {
          short = ""
        }

	warn_msg(msg,thishost,tmpfl6)
	warn_flag=1
      }

      logDetails(thishost,"<tr bgcolor=" color "><td><h5>" dbspace "<td align=right><h5>" nchunks "<td align=right><h5>" dbssize "<td align=right><h5>" dbsfree "<td align=right><h5>" dbsused "<td align=right><h5>" dbspct "<td><h5>" status )

      total_size += dbssize
      total_free += dbsfree
      total_used += dbsused
      total_chks += nchunks

      #
      # Create hist data line
      #

      if (hist_flag == 1)
      {
	msg = sprintf(" %-20s  %2s  %9.1d  %9.1d  %9.1d    %6.0f%%",dbspace,nchunks,dbssize,dbsfree,dbsused,dbspct)
	print filedate " " filetime " " title[thishost] " " dbspace " " nchunks " " dbssize " " dbsused >> tmpflt
      }
    }
  }
  close tmpfl2

  #if (substr(sw_version[thishost],1,1) < "7")
  #{
  #  msg = sprintf(" (DBSpace Checking Not Possible With Informix Version < 5)")
  #  print msg >> report_path
  #  msg = sprintf("DBSpace Checking only works on Informix version >= 7")
  #  logit(msg,thishost)
  #  return 0 
  #} 

  if (error_flag)
  {
    msg = sprintf("!!! DBS Reporting Error: %s !!!",error_text)
    msgid = "DBA221C"
    m_critical[thishost]++

    logit(msg,thishost)
    system("cat "tmpfl2)
    printf("\n")

    short = "DBSErr"
    crit_msg(msg,thishost,tmpfl2) 
    return 1
  }

  if (total_size == 0)
  {
    msg = sprintf("infDBS() - %s - zero divide #5",title[thishost])
    logit(msg,thishost)
    system("cat " tmpfl2 " >> " logfile)
    error_msg(msg,thishost)
    system("cat " tmpfl2)
    download_flag[thishost] = 0
    return 1
  }

  totpct = int( 100 * (total_used / total_size))
  logDetails(thishost,"<tr bgcolor=slate><td><b>Totals:</b><td align=right><h5>" total_chks "<td align=right><h5>" total_size "<td align=right><h5>" total_free "<td align=right><h5>" total_used "<td align=right><h5>" totpct)
  logDetails(thishost,"</table><hr>")

  system_size[thishost] = total_size / 1000
  system_used[thishost] = total_used / 1000
  grand_total_size += total_size / 1000

  if (warn_flag == 0 && crit_flag == 0)
  {
    msg = sprintf("OK")
    logit(msg,thishost)
  }

  # 
  # Write temp dbspace hist file to this dates file
  #

  if (hist_flag == 1)
  {
    close tmpflt
    system("sort " tmpflt " >> "hstdir "/dbspaces/"filedate)
  }

  #
  # Go away
  #

  function_cleanup()
}

# -----------------------------------------------------------------------------
function infChkDup(thishost)
# -----------------------------------------------------------------------------

{
  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1 
  }

  #
  # Run script which finds dup ONCONFIG entries
  #

  ##remsh("onstat -;export PATH=$PATH:"infdir[thishost]"/bin;perl /tmp/dbamon_onconfig_dup.pl",tmpfl2,thishost)
  remsh("onstat -;export PATH=$PATH:"infdir[thishost]"/bin;perl /tmp/dbamon_inf.pl dup",tmpfl2,thishost)

  ##system("cat "tmpfl2)

  if (system("grep -q 'Dup:' " tmpfl2) == 0) 
  {
    msg = sprintf("... Duplicate ONCONFIG Parameters Found ...")
    msgid = "DBA340I"
    logit(msg,thishost)
    m_info[thishost]++
    
    short = "DupC"
    info_msg(msg,thishost,tmpfl2)
  }
  else
  {
    msg = sprintf("OK")
    logit(msg,thishost)
  }

  close tmpfl2
  function_cleanup()
}


# -----------------------------------------------------------------------------
function infHDR(thishost)
# -----------------------------------------------------------------------------

{
  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1 
  }

  if (substr(sw_version[thishost],1,1) < "7")
  {
    msg = sprintf("HDR checking only works on Informix version >= 7")
    logit(msg,thishost)
    return 0 
  }

  if (dr_status[thishost] != "(Sec)" && dr_status[thishost] != "(Prim)")
  {
    msg = sprintf("HDR Check N/A - Status = %s",dr_status[thishost])
    logit(msg,thishost)
    return 0 
  }

  msgid = ""

  ##print os_version[thishost]
  ##print substr(os_version[thishost],1,1) 

  if (substr(os_version[thishost],1,1) == "0")
  {
    msg = sprintf("HDR checking only works on HP-UX version >= 10")
    logit(msg,thishost)
    return 0 
  }

  #
  # Run query against sysdri
  #

  remsh("onstat -;export PATH=$PATH:"infdir[thishost]"/bin;perl /tmp/dbamon_inf.pl hdr",tmpfl2,thishost)
  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1 
  }

  locksflag = 0
  shmvseg[thishost] = -1

  while (getline < tmpfl2 > 0 && stop == 0)
  {
    #print $0
    if ($1 == "type")   { hdr_type  = $2 }
    if ($1 == "state")  { hdr_state = $2 }
    if ($1 == "name")   { hdr_name  = $2 }
  }
  close tmpfl2
  
  if ((hdr_type == "Primary" && hdr_state != "On") || (hdr_type == "Secondary" && hdr_state != "Read-Only"))
  {
    msg = sprintf("!!! HDR Not Active - Type=%s State=%s Name=%s !!!",hdr_type,hdr_state,hdr_name)
    msgid = "DBA330C"
    logit(msg,thishost)
    m_critical[thishost]++

    short = "HDR"
    crit_msg(msg,thishost,tmpfl2)
  }

  #
  # 3.20I - 
  # There is a bug in Informix which forces us to run a
  #  dbspaceset=* backup when we have to do the HDR turn-on restore.
  #  We have found that it is difficult to remember to change our backup tool
  #  back to parallel backups after performing one of these special backups.
  #  A new check has been added to the infHDR() routine which will create
  #  a warning event if:
  #    1. The most recent level-0 backup is a dbspaceset=* backup -and-
  #    2. HDR is active
  #

  if (mrl0dsid[thishost] == 0 && hdr_type == "Primary")
  {
    msg = sprintf("*** Normal Backup Schedule Not In Place ***")
    msgid = "DBA380W"

    logit(msg,thishost)

    short = "BkupType"
    warn_msg(msg,thishost)
    m_warning[thishost]++
    check_flag = 1
  }

  if (msgid != "")
  {
    msg = sprintf("OK")
    logit(msg,thishost)
  }

  function_cleanup()
}


# -----------------------------------------------------------------------------
function infLongTX(thishost)
# -----------------------------------------------------------------------------

{
  if (t_longtx[thishost] == "")
  {
    msg = sprintf("Not selected for this instance")
    logit(msg,thishost)
    return 1 
  }

  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1 
  }

  if (substr(sw_version[thishost],1,1) < "7")
  {
    msg = sprintf("Locks Used checking only works on Informix version >= 7")
    logit(msg,thishost)
    return 0 
  }

  ##print os_version[thishost]
  ##print substr(os_version[thishost],1,1) 

  if (substr(os_version[thishost],1,1) == "0")
  {
    msg = sprintf("Locks Used checking only works on HP-UX version >= 10")
    logit(msg,thishost)
    return 0 
  }

  #
  # Run downloaded routine
  #

  close tmpfl2
  remsh("onstat -;export PATH=$PATH:"infdir[thishost]"/bin;perl /tmp/dbamon_inf.pl longtx -sql",tmpfl2,thishost)

  hwmpct = 0
  while (getline < tmpfl2 > 0 && stop == 0)
  {
    ##print $0

    if ($1 == "--")
    {
      hwmpct = $11
    }

    if (hwmpct > t_longtx[thishost])
    {
      msg = sprintf("--- Possible Long TX Detected - HWMPCT: %s (threshold=%s) ---",hwmpct,t_longtx[thishost])
      msgid = "DBA410U"

      logit(msg,thishost)

      m_user[thishost]++

      short = "LngTx"
      user_msg(msg,thishost,tmpfl2)
      return
    }
  }
  close tmpfl2
  msg = sprintf("OK")
  logit(msg,thishost)
}


# -----------------------------------------------------------------------------
function infLocks(thishost)
# -----------------------------------------------------------------------------

{
  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1 
  }

  #if (substr(sw_version[thishost],1,1) < "7")
  #{
  #  msg = sprintf("Locks Used checking only works on Informix version >= 7")
  #  logit(msg,thishost)
  #  return 0 
  #}

  ##print os_version[thishost]
  ##print substr(os_version[thishost],1,1) 

  if (substr(os_version[thishost],1,1) == "0")
  {
    msg = sprintf("Locks Used checking only works on HP-UX version >= 10")
    logit(msg,thishost)
    return 0 
  }

  #
  # Run onstat -l
  #

  remsh("onstat -;export PATH=$PATH:"infdir[thishost]"/bin;perl /tmp/dbamon_inf.pl locks",tmpfl2,thishost)

  locksflag = 0
  shmvseg[thishost] = -1
  backup_method[thishost] = "T"

  while (getline < tmpfl2 > 0 && stop == 0)
  {
    ##print $0

    if ($1 == "CKPTAVG:")
    {
      ckptavg[thishost] = $2
    }

    if ($1 == "MAXUSERS:")
    {
      allusers[thishost] = $2
    }

    if ($1 == "SYSUSERS:")
    {
      sysusers[thishost] = $2
    }

    if ($1 == "ARCTYPE")
    {
      if ($2 > 0)
      {
        backup_method[thishost] = "A"
        backup_method_long[thishost] = "OnArch"
      }
      else
      {
        backup_method[thishost] = "T"
        backup_method_long[thishost] = "OnTape"
      }
    }

    if ($1 == "SHMVSEGCOUNT:")
    {
      shmvseg[thishost] = $2
      shmvsiz[thishost] = $3
    }

    if ($1 == "NFILE:")
    {
      nf_cur[thishost] = $2
      nf_max[thishost] = $3
      nf_pct[thishost] = $4
    }

    if ($1 == "LOCKSPCT:")
    {
      locksflag = 1

      lockspct  = $2
      locksused = $3
      locksmax  = $4

      ##print "lockspct=" lockspct

      if (lockspct > 100)
      {
	msg = sprintf("... Informix BUG Encountered (lockspct > 100) - Used Locks=%s  Max Locks=%s (%s percent) ...",locksused,locksmax,lockspct)
	msgid = "DBA299I"

	logit(msg,thishost)

	m_info[thishost]++

        short = "LockBUG"
	info_msg(msg,thishost,tmpfl2)
      }

      if (lockspct > 80 && lockspct < 101)
      {
	msg = sprintf("!!! Used Locks=%s  Max Locks=%s (%s percent) !!!",locksused,locksmax,lockspct)
	msgid = "DBA300C"

	logit(msg,thishost)

	m_critical[thishost]++

        short = "Lock"
	crit_msg(msg,thishost,tmpfl2)
      }
      else
      {
	msg = sprintf("OK (%s/%s) %s percent",locksused,locksmax,lockspct)
	logit(msg,thishost)
      }
    }

  }
  close tmpfl2

  maxusers[thishost] = allusers[thishost] - sysusers[thishost]
  
  if (locksflag == 0 && substr(sw_version[thishost],1,1) >= "7")
  {
    msg = sprintf("infLocks() - %s - tmpfl2 error",title[thishost])
    logit(msg,thishost)
    system("cat "tmpfl2)
    error_msg(msg,thishost)
    return
  }

  function_cleanup()
}


# -----------------------------------------------------------------------------
function infLlogs(thishost)
# -----------------------------------------------------------------------------

# This routine must follow DBSpaces

{
  if (up[thishost] != "Y")
  {
    msg = sprintf("(down/inhibited)")
    logit(msg,thishost)
    return 1 
  }

  if (db_status[thishost] == "R")
  {
    msg = sprintf("HDR Secondary Instance - llog checking not applicable")
    logit(msg,thishost)
    return 1 
  }
    
  #
  # Check to see if LTAPEDEV is set to /dev/null
  #

  if (ltapedev[thishost] == "/dev/null")
  {
    msg = sprintf("onconfig LTAPEDEV=/dev/null - Log check not applicable")
    logit(msg,thishost)
    return 1 
  }

  #
  # Run onstat -l
  #

  close tmpfl2 
  
  if (sw_version[thishost] > "7.10.UC2")
  {
    #
    # Informix >= V7
    #
    remsh("onstat -;export PATH=$PATH:"infdir[thishost]"/bin;ksh /tmp/dbamon_check_logs.sh",tmpfl2,thishost)
  }
  else
  {
    #
    # Informix < V7
    #
    #check_remsh(system(cmdpfx[thishost]"onstat -l"cmdsfx[thishost]" > "tmpfl2 " 2>" remshlog),thishost)
    remsh("onstat -l",tmpfl2,thishost)

    if (rc_save) { return 1 }
    if (system("grep -i 'shared memory not' " tmpfl2) == 0) 
    {
      msg = sprintf("(down/inhibited)")
      logit(msg,thishost)
      return 1 
    }
  }

  if (system("grep 'Fatal' " tmpfl2) == 0) 
  {
    msg = sprintf("!!! Fatal dbaccess Error Checking Logical Logs !!!")
    msgid = "DBA231C"
    logit(msg,thishost)
    m_critical[thishost]++
    short = "LLogErr"
    crit_msg(msg,thishost,tmpfl2)
    return 1 
  }

  ##system("cat " tmpfl2)

  num_llogs  = 0
  full_llogs = 0

  stop = 0

  while (getline < tmpfl2 > 0 && stop == 0)
  {
    if (NF == 8 && $1 != "address" && length($3) == 7 && $1 != "Buffer")
    {

      llog_flags=$3 
     
      num_llogs++
      if (index(llog_flags,"U") > 0) { full_llogs++ }

    }
  }
  close tmpfl2

  if (num_llogs == 0)
  {
    msg = sprintf("infLlogs() - %s - zero divide #3\n",title[thishost])

    logit(msg,thishost)
    system("cat "tmpfl2)

    error_msg(msg,thishost)
    return
  }

  logpct = (full_llogs / num_llogs) * 100

  if (logpct > 70)
  {
    msg = sprintf("!!! Total llog files=%s  Full llog files=%s (%s percent) !!!",num_llogs,full_llogs,logpct)
    msgid = "DBA230C"

    logit(msg,thishost)

    m_critical[thishost]++

    short = "LLog"
    crit_msg(msg,thishost)
  }
  else
  {
    msg = sprintf("OK (%s/%s) %s percent",full_llogs,num_llogs,logpct)
    logit(msg,thishost)
  }
  
  function_cleanup()
}


# -----------------------------------------------------------------------------
function function_cleanup()
# -----------------------------------------------------------------------------
{
  close(tmpfl1)
  close(tmpfl2)
  close(tmpfl3)
  close(tmpfl4)
  close(tmpfl5)
  close(tmpfl6)
  close(tmpflt)

  system("rm /tmp/dbamon_tmp* > /dev/null 2>&1")
}


# -----------------------------------------------------------------------
# MAIN Logic
# -----------------------------------------------------------------------
{

  #
  # debug flags
  #

  debug      = 0
  debug_html = 0
  debug_read = 0
  debug_opc  = 0
  debug_crit = 0

  #
  # Version and Release
  #

  #version="3.24"
  #release="F"
  #verrel = version "" release
  "cat /opt/dbamon/bin/verrel" | getline verrel
  close "cat /opt/dbamon/bin/verrel" 
  
  dbamon_home = "http://dbamon.com"

  #
  # set other variables
  #

  "date " | getline strdate 
  close "date "

  rc_save = 0

  ##system("ps -ef | grep $$ | grep 'sh -c' | head -1 | awk '{ print $3 }'")
  ##"ps -ef | grep $$ | grep 'sh -c' | head -1 | awk '{ print $3 }'" | getline pid

  "ps -ef | grep dbamon.awk | grep dbamon_tasknum=" dbamon_tasknum " | grep -v grep | head -1 | awk '{ print $2 }'" | getline pid

  # Write my pid and mode to a file
  "perl -e 'print time;'" | getline time_processes
  close "perl -e 'print time;'" 
  "date +%Y/%m/%d-%H:%M:%S" | getline ts_processes
  close "date +%Y/%m/%d-%H:%M:%S" 
  modeout = arg "" dbamon_tasknum
  system("echo '" pid " " modeout " " time_processes " " ts_processes " " dbamon_alpha "' >> /opt/dbamon/adm/processes_" arg ".txt")

  optdir="/opt/dbamon"

  if (arg == "test") 
  {
    tmpdir="/opt/dbamon/tmp/test_" dbamon_tasknum
    system("rm -fr "tmpdir" 2>/dev/null")
    system("mkdir  "tmpdir" 2>/dev/null")
    rptdir="/opt/dbamon/dat/reports/test"
  }
  else
  {
    tmpdir="/opt/dbamon/tmp/prod_" dbamon_tasknum
    system("rm -fr "tmpdir" 2>/dev/null")
    system("mkdir  "tmpdir" 2>/dev/null")
    rptdir="/opt/dbamon/dat/reports"
  }

  pgmdir="/opt/dbamon/bin"
  admdir="/opt/dbamon/adm"
  hstdir="/opt/dbamon/dat/history"
  inhibdir="/opt/dbamon/dat/inhibit"

  remshlog=tmpdir"/remsherr_"dbamon_tasknum
  pinglog=tmpdir"/pingerr_"dbamon_tasknum
  parmall =tmpdir"/dbamonrc_"dbamon_tasknum

  # Cleanup old temp files
  system("rm "tmpdir"/dbamon_tmp*" dbamon_tasknum " > /dev/null 2>&1")

  tmpfl1=tmpdir"/dbamon_tmp1_"dbamon_tasknum
  tmpfl2=tmpdir"/dbamon_tmp2_"dbamon_tasknum
  tmpfl3=tmpdir"/dbamon_tmp3_"dbamon_tasknum
  tmpfl4=tmpdir"/dbamon_tmp4_"dbamon_tasknum
  tmpfl5=tmpdir"/dbamon_tmp5_"dbamon_tasknum
  tmpfl6=tmpdir"/dbamon_tmp6_"dbamon_tasknum
  tmpfl7=tmpdir"/dbamon_tmp7_"dbamon_tasknum
  tmpfl8=tmpdir"/dbamon_tmp8_"dbamon_tasknum
  tmpflt=tmpdir"/dbamon_tmpt_"dbamon_tasknum
  sqlfil=tmpdir"/dbamon_sqlf_"dbamon_tasknum

  tmplcl="/opt/dbamon/tmp/dbamon_arc_sql_"dbamon_tasknum  # dbamon_arch_onarch output
  tmprmt="/tmp/dbamon_arc.sql"    # on monitored system

  logfile="dummy"
  wheretolog="S"

  "hostname" | getline wsname
  close "hostname"

  "nslookup " wsname " | grep Name: | awk '{ print $2 }'" | getline wsnamef
  close wsnamef

  "id -u -n" | getline dbamon_userid
  close "id -u -n"

  x = split(wsnamef,zhname,".")
  x--
  company = zhname[x]

  if (arg == "test")
  {
    mode="test"
    parmfl=optdir"/adm/dbamonrc_test"
    parmdir=optdir"/adm/instances_test"
    insertdb="database dbamon_test;" 
  }
  else
  {
    mode="prod"
    parmfl=optdir"/adm/dbamonrc"
    parmdir=optdir"/adm/instances"
    insertdb="database dbamon;" 
  }

  msg = sprintf("Using Parm File: %s",parmfl )
  logit(msg)

  msg = sprintf("Mode: %s",mode )
  logit(msg)

  read_parm()
  msg = sprintf("SYSTEM values - sleep_time=%s iterations=%s dbamon_admin=%s html_events_dir=%s",sleep_time,iterations,dbamon_admin,html_events_dir)
  logit(msg)

  if (use_oracle == "Y")
  {
    insertdb = "-- connect?"
  }

  system("rm " tmpdir "/dbamon_savemsg_next > /dev/null 2>&1")
  system("rm " tmpdir "/dbamon_savemsg_this > /dev/null 2>&1")

  # Check our license key
  msg = sprintf("Checking license key")
  logit(msg)
  outmode = mode

  if (outmode == "") 
  {
    outmode = "prod"
  }

  dbmslist = ""
  if (num_oracleapps   > 0) { dbmslist = dbmslist "" "OracleApps," }
  if (num_oracle       > 0) { dbmslist = dbmslist "" "OracleDB," }
  if (num_informix     > 0) { dbmslist = dbmslist "" "Informix," }
  if (num_mssql        > 0) { dbmslist = dbmslist "" "MSSQL," }
  if (num_oraclent     > 0) { dbmslist = dbmslist "" "OracleNT," }

  # Write to task table
  if (use_oracle == "Y")
  {
    if (dbamon_alpha == "") { z = "*" }
    else                    { z = dbamon_alpha }
    cmd = pgmdir "/dbamon_ora_sumupdate.pl 'Task' '" modeout "' '" pid "' '" time_processes "' '" ts_processes "' '" z "' '" 0 "' '" 0 "' '" high_host "'"
    rc = system(cmd)
   
    # Nullify html_sys_path
    html_sys_path = "/dev/null"
  }

  # Check license key
  if (system("/opt/dbamon/bin/keychk " high_host " " dbamon_admin " " verrel " " dbmslist " " outmode ) != 0)
  {
    msg = "ERROR - Your license key in /opt/dbamon/adm/key.txt is not valid or expired - see preceeding message"
    error_msg(msg)
    exit 1
  }

  msg = sprintf("Version %s Starting",verrel)
  logit(msg)
  log_msg(msg)
  msg = sprintf("pgmdir=%s arg=%s tmpdir=%s insertdb=%s company=%s pid=%s",pgmdir,arg,tmpdir,insertdb,company,pid)
  logit(msg)
  log_msg(msg)
  msg = sprintf("dbamon_userid=%s dbamon_tasknum=%s dbamon_alpha=%s",dbamon_userid,dbamon_tasknum,dbamon_alpha)
  logit(msg)
  log_msg(msg)

  save_flag = 0

  #
  # Check DBAmon version against latest on dbamon_home
  #
  check_sw()

  msg = sprintf("DBMS/Packages(s) That Will Be Monitored: %s",dbmslist)
  logit(msg)

  for (iter_count = 1; iter_count <= iterations; iter_count++)
  {
    "perl -e 'print time;'" | getline time_start
    close "perl -e 'print time;'" 

    msg = sprintf("Start of Iteration #%s",iter_count)
    logit(msg)

    #
    # Start of iteration housekeeping
    #
    begin_stuff()

    #
    # Download Software
    #
    run_monitor("DownloadSW")

    if (index(dbmslist,"OracleNT") > 0)
    {
      #
      # Check Oracle/NT instance active
      #
      run_monitor("orantUp")

      #
      # Check Oracle extents
      #
      run_monitor("orantArclog")

      #
      # Check Oracle instance active
      #
      run_monitor("orantDatafiles")

      #
      # Check Oracle instance active
      #
      run_monitor("orantBkup")
    }
    else
    {
      msg = "(No OracleNT Instances to Monitor)"
      logit(msg)
    }

    if (index(dbmslist,"MSSQL") > 0)
    {
      #
      # Check MSSQL instance active
      #
      run_monitor("sqlUp")

      #
      # Check MSSQL backup age
      #
      run_monitor("sqlBkup")

      #
      # Check MSSQL alerts 
      #
      run_monitor("sqlAlerts")
    }
    else
    {
      msg = "(No MSSQL Instances to Monitor)"
      logit(msg)
    }

    if (index(dbmslist,"OracleApps") > 0)
    {
      #
      # Check Oracle Apps active
      #
      run_monitor("oraapUp")
    }
    else
    {
      msg = "(No OracleApps Instances to Monitor)"
      logit(msg)
    }

    if (index(dbmslist,"OracleDB") > 0)
    {
      #
      # Check Oracle instance active
      #
      run_monitor("oraUp")

      #
      # Check Oracle instance active
      #
      run_monitor("oraLsnr")

      #
      # Check Oracle instance active
      #
      run_monitor("oraDatafiles")

      #
      # Check Oracle tablespace(s) full
      #
      run_monitor("oraBkup")

      #
      # Check Oracle tablespace(s) full
      #
      run_monitor("oraTSFull")

      #
      # Check Oracle message log
      #
      run_monitor("oraAlerts")

      #
      # Check Oracle extents
      #
      run_monitor("oraExtents")

      #
      # Check Oracle extents
      #
      run_monitor("oraArclog")
    }
    else
    {
      msg = "(No OracleDB Instances to Monitor)"
      logit(msg)
    }

    if (index(dbmslist,"Informix") > 0)
    {
      #
      # Check Informix instance active
      #
      run_monitor("infUp")

      #
      # Check for possible long tx's
      #
      run_monitor("infLongTX")

      #
      # Check for duplicate ONCONFIG parms
      #
      run_monitor("infChkDup")

      #
      # Check for down chunks
      #
      run_monitor("infSWVer")

      #
      # Check for down chunks
      #
      run_monitor("infChunksDown")

      #
      # Save instance config info     	 
      #
      run_monitor("infSaveCfg")

      #
      # Check for lock overflow approaching
      #
      run_monitor("infLocks")

      #
      # Check for NFILE being exceed
      #
      run_monitor("infNFile")

      #
      # Check for long checkpoints
      #
      run_monitor("infCkpt")

      #
      # Check for excessive shared memory v segments
      #
      run_monitor("infShmem")

      #
      # Check for extents > dbamonrc 
      #
      run_monitor("infExtents")

      #
      # Check for full DBSpaces 
      #
      run_monitor("infDBS")

      #
      # Check for CLEANERS too low 
      #
      run_monitor("infCleaners")

      #
      # Check for full logical log files
      #
      run_monitor("infLlogs")

      #
      # Check for archive done recently
      #
      run_monitor("infArc")

      #
      # Check HDR
      #
      run_monitor("infHDR")

      #
      # Check for bad log messages
      #
      run_monitor("infMLog")

      #
      # Check for bad log messages
      #
      run_monitor("infPerf")
    }
    else
    {
      msg = "(No Informix Instances to Monitor)"
      logit(msg)
    }

    #
    # Print Summary
    #
    this_function = ""
    summarize()

    #
    # End of iteration housekeeping
    #
    end_stuff()

    #
    # Calc uteration duration
    #
    "perl -e 'print time;'" | getline time_end
    close "perl -e 'print time;'" 
    dur = time_end - time_start

    # Write to task table
    if (use_oracle == "Y")
    {
      msg = sprintf("Invoking dbamon_ora_sumupdate.pl")
      logit(msg)
      if (dbamon_alpha == "") { z = "*" }
      else                    { z = dbamon_alpha }
      cmd = pgmdir "/dbamon_ora_sumupdate.pl 'Task' '" modeout "' '" pid "' '" time_processes "' '" ts_processes "' '" z "' '" iter_count "' '" dur "' '" high_host "' > " tmpfl8 " 2>&1"
      rc = system(cmd)
      if (rc != 0)
      {
	msg = sprintf("dbamon_ora_sumupdate.pl Error - rc=%s",rc)
	logit(msg,h)
	error_msg(msg,h,tmpfl8)
      }
      # Recreate the summary WWW page for this mode
      msg = sprintf("Invoking dbamon_ora_sumread.pl")
      logit(msg)
      cmd = pgmdir "/dbamon_ora_sumread.pl " mode " > " tmpfl8 " 2>&1"
      rc = system(cmd)
      if (rc != 0 && rc != 2)
      {
	msg = sprintf("dbamon_ora_sumread.pl Error - rc=%s",rc)
	logit(msg,h)
	error_msg(msg,h,tmpfl8)
      }
    }

    #
    # Sleep
    #

    msg = sprintf("------------------------------------------------------------------")
    logit(msg)

    msg = sprintf("End of Iteration %s of %s",iter_count,iterations)
    logit(msg)

    msg = sprintf("Interval Duration: %s Seconds",dur)
    logit(msg)

    msg = sprintf("Sleeping for %s Seconds ...",sleep_time)
    logit(msg)

    msg = sprintf("------------------------------------------------------------------")
    logit(msg)

    if (system("sleep "sleep_time) != 0)
    {
      msg = sprintf("Cancelled")
      logit(msg)
      log_msg(msg)
      system("rm " optdir "/tmp/dbamon_savemsg_next > /dev/null 2>&1")
      system("rm " optdir "/tmp/dbamon_savemsg_this > /dev/null 2>&1")
      exit
    }
  }
}
